






// *** gateway ***


func void fnInfoCM2( i32x iTCPPort, i32x iUDPPort, szx _szDesc, f32x _fVersion, szx _szCreator, i32x _iNumRegistered, i32x _iNumConnected )
{
	var szx szIP;
	var i32x iPort;
	var i32x iGameId;
	var i32x iGameIndex;

	szIP = GetCurrentIP();
	iPort = GetCurrentPort();

	iGameId = Join_FindKeyFromStringData( stGatewayJoins.m_iGame_szIP, szIP );
	if (iGameId==-1)
	{
		// new game
		print("new game\n");

		iGameIndex = Table_AddRow( g_iGatewayDB, stGatewayJoins.m_iGameTable );

		Join_SetStringFromIndex(	stGatewayJoins.m_iGame_szIP,				iGameIndex, szIP );
		Join_SetIntFromIndex(		stGatewayJoins.m_iGame_iPort,				iGameIndex, iTCPPort );
		Join_SetIntFromIndex(		stGatewayJoins.m_iGame_iInRaceServerPort,	iGameIndex, iUDPPort );
		Join_SetStringFromIndex(	stGatewayJoins.m_iGame_szDesc,				iGameIndex, _szDesc );
		Join_SetFloatFromIndex(		stGatewayJoins.m_iGame_fVersion,			iGameIndex, _fVersion );
		Join_SetStringFromIndex(	stGatewayJoins.m_iGame_szCreator,			iGameIndex, _szCreator );
		Join_SetIntFromIndex(		stGatewayJoins.m_iGame_iNumConnected,		iGameIndex, _iNumConnected );
		Join_SetIntFromIndex(		stGatewayJoins.m_iGame_iNumRegistered,		iGameIndex, _iNumRegistered );
		Join_SetFloatFromIndex(		stGatewayJoins.m_iGame_fTimeOut,			iGameIndex, TimeGetTimeInS() );

		// notify clients
		Database_SendSynchronization( g_iGatewayDB );
	}
	else
	{
		// update timeout
		Join_SetFloatFromKey( stGatewayJoins.m_iGame_fTimeOut, iGameId, TimeGetTimeInS() );

		// update ints
		Join_SetIntFromIndex(		stGatewayJoins.m_iGame_iNumConnected,	iGameIndex, _iNumConnected );
		Join_SetIntFromIndex(		stGatewayJoins.m_iGame_iNumRegistered,	iGameIndex, _iNumRegistered );
	}
}

// delete games that have not send a message
func void fnUpdateTimeOut()
{
	var i32x i;
	var i32x iNumGames;
	var f32x fTime;
	var i32x iNumDeleted;
	fTime = TimeGetTimeInS();
	i=0;
	iNumDeleted = 0;
	iNumGames = Join_GetNumRows(stGatewayJoins.m_iGame_szIP);
	while (i<iNumGames)
	{
		if (fTime - Join_GetFloatFromIndex(	stGatewayJoins.m_iGame_fTimeOut, i) > g_fTimeOut)
		{
			print("game time out\n");
			Table_DeleteRowFromIndex( g_iGatewayDB, stGatewayJoins.m_iGameTable, i);
			iNumDeleted = iNumDeleted + 1;
		}
		i=i+1;
	}

	if (iNumDeleted>0)
	{
		Database_DeleteNow( g_iGatewayDB );
		Database_SendSynchronization( g_iGatewayDB );
	}
}

// user connection : send database
func void fnGTUserConnectCB(Net_Client _pClient)
{
	var Gui_Component pthis;
	var Gui_Component pComponent;

	print("user connection\n");
	
	// get this pointer
	pthis = GetThis();

	// new component
	pComponent = NewObject(iGatewayTCPInterface);
	MountComponent(pthis, pComponent);
	NetClient_SetComponent(_pClient, pComponent);


	// send database
	Database_Send(g_iGatewayDB, "GatewayDB", _pClient);
}


func void fnGTUserDisconnectCB(Net_Client _pClient)
{
	print("user disconnection\n");

	var Gui_Component pthis;
	pthis = GetThis();
	g_gcManager << ComponentDestroy(pthis);
}


func void Gateway_Constructor()
{
	var Gui_Component pComponent;

	// create database
	g_iGatewayDB = Database_Constructor("GatewayDB");
	Database_Load( g_iGatewayDB, "Gateway/Gateway.cdb");
	Database_BeginSynchronize(g_iGatewayDB);

	// create joins
	stGatewayJoins.m_iGame_szIP					= Join_Constructor(g_iGatewayDB, "GAT_games.szIP");
	stGatewayJoins.m_iGame_iPort				= Join_Constructor(g_iGatewayDB, "GAT_games.iPort");
	stGatewayJoins.m_iGame_iInRaceServerPort	= Join_Constructor(g_iGatewayDB, "GAT_games.iInRaceServerPort");
	stGatewayJoins.m_iGame_szDesc				= Join_Constructor(g_iGatewayDB, "GAT_games.szDesc");
	stGatewayJoins.m_iGame_fVersion				= Join_Constructor(g_iGatewayDB, "GAT_games.fVersion");
	stGatewayJoins.m_iGame_szCreator			= Join_Constructor(g_iGatewayDB, "GAT_games.szCreator");
	stGatewayJoins.m_iGame_iNumConnected		= Join_Constructor(g_iGatewayDB, "GAT_games.iNumConnected");
	stGatewayJoins.m_iGame_iNumRegistered		= Join_Constructor(g_iGatewayDB, "GAT_games.iNumRegistered");
	stGatewayJoins.m_iGame_fTimeOut				= Join_Constructor(g_iGatewayDB, "GAT_games.fTimeOut");

	stGatewayJoins.m_iGameTable = Table_GetIndexFromName( g_iGatewayDB, "GAT_games");
	
	// Create ancestor component
	g_gcManager = NewObject(iAncestorInterface);
	
	// Set this object as first of all
	ManagerComponent(g_gcManager);

	// create udp server
	pComponent = NewObject(iGatewayUDPInterface);
	MountComponent(g_gcManager, pComponent);
	g_pUDPServer = NetUDPServer_Constructor(g_iGatewayAlivePort,pComponent);
	print("-- udp server online on port " + itoa(g_iGatewayAlivePort) +" --\n");

	// create tcp server
	pComponent = NewObject(iGatewayTCPInterface);
	MountComponent(g_gcManager, pComponent);
	g_pTCPServer = NetServer_Create(g_iGatewayPort,pComponent);
	print("-- tcp server online on port " + itoa(g_iGatewayPort) + " --\n");


	// create refresh timer
	g_iRefreshTimer = CreateTimer( g_fRefreshTime, fnUpdateTimeOut, 1);
}

func void Gateway_Destructor()
{
	// destroy udp server
	NetUDPServer_Destructor(g_pUDPServer);

	// destroy database joins
	Join_Destructor(stGatewayJoins.m_iGame_szIP);
	Join_Destructor(stGatewayJoins.m_iGame_iPort);
	Join_Destructor(stGatewayJoins.m_iGame_iInRaceServerPort);
	Join_Destructor(stGatewayJoins.m_iGame_szDesc);
	Join_Destructor(stGatewayJoins.m_iGame_fVersion);
	Join_Destructor(stGatewayJoins.m_iGame_szCreator);
	Join_Destructor(stGatewayJoins.m_iGame_iNumConnected);
	Join_Destructor(stGatewayJoins.m_iGame_iNumRegistered);
	Join_Destructor(stGatewayJoins.m_iGame_fTimeOut);

	// destroy database
	Database_Destructor( g_iGatewayDB );

	// destroy timer
	DestroyTimer(g_iRefreshTimer);
}

func void GTComponentDestroy(Gui_Component _poComponent)
{
	DeleteComponent(_poComponent);
}

