func i32x Form_GetDynamicDb(Gui_Component _pform)
{
	var Gui_dtForm pdtData;

	pdtData = GetPrimaryData(_pform);

	return pdtData.iDynDbId;
}

func i32x Form_GetSubsetDb(Gui_Component _pform)
{
	var Gui_dtForm pdtData;

	pdtData = GetPrimaryData(_pform);

	return pdtData.iSubsetId;
}
func i32x Form_GetRefTable(Gui_Component _pform)
{
	var Gui_dtForm pdtData;

	pdtData = GetPrimaryData(_pform);

	return pdtData.iRefTableId;
}


func Gui_Component NewForm(i32x _iSubsetId,szx _szRefTable,i32x _bDynTable)
{
	var i32x i,j,iNumTables;
	var Gui_Component composite;
	var Gui_dtForm pdtData;

	composite = NewObject(Gui_iForm);
	// Affect data pointer
	pdtData = new Gui_dtForm;
	SetData(composite,pdtData);

	// Init members
	pdtData.bCanBeSelected = false;
	pdtData.bCaptionAsTitle = false;
	pdtData.bFieldAsTitle = false;
	pdtData.iDefaultFieldColor = 0;
	pdtData.iDefaultFontCaptionColor = MakeARGB(255, 255, 255, 255);
	pdtData.iDefaultFontFieldColor = MakeARGB(255, 255, 255, 255);
	pdtData.iDefaultFieldWidth = 64.0*g_fScreenScaleFactor;
	pdtData.iDefaultMediaWidth = 64.0*g_fScreenScaleFactor;
	pdtData.iDefaultMediaHeight = 64.0*g_fScreenScaleFactor;
	pdtData.iDefaultDecimal = 1;
	pdtData.iDefaultHAlign = e_GUI_HAlign_Left;
	pdtData.iDefaultVAlign = e_GUI_VAlign_Top;
	pdtData.bLocked=true;
	pdtData.szMshKit = "";
	pdtData.szBmpKit = "Gui/Cyclist_photo_msh.msh";		// Kit used for dynamic bitmap
	pdtData.szBmpMaterial = "Cyclist_Photo";	// texture used for dynamic bitmap
	pdtData.iRefTableId = Table_GetIndexFromName(_iSubsetId,_szRefTable);
	pdtData.iDefaultOffset = 0;
	pdtData.smFontCaption = smTrebuchet;
	pdtData.smFontField = smTrebuchet;
	pdtData.iRow = 0;
	pdtData.iRef = ROW_INDEX;
	pdtData.iIsLinked = false;
	pdtData.bDynDB = _bDynTable;
	pdtData.bMajInform = false;
	pdtData.bRecordValid = true;
	pdtData.bCaptionAlign = false;
	pdtData.iCaptionAlign = 0;
	pdtData.iCaption_HAlign = e_GUI_HAlign_Left;
	pdtData.iCaption_VAlign = e_GUI_VAlign_Center;
	pdtData.iBackColor = 0;
	pdtData.iFormatType = g_iConst_FormatNormal;
	pdtData.fFactor = 1.0;


	if(_bDynTable)
	{
		// Create a DB copy of subset
		pdtData.iDynDbId = Database_CopyConstructor("DYN_FORM_DATABASE",_iSubsetId);
	}
	else
	{
		// Direct use the subset
		pdtData.iDynDbId = _iSubsetId;
	}
	pdtData.iDataSourceDbId = pdtData.iDynDbId;
	// Create a subset for filter option
	pdtData.iSubsetId = Subset_Constructor("DYN_FORM_SUBSET",pdtData.iDynDbId);
	// Select all by default
	iNumTables = Database_GetNumTables(pdtData.iDynDbId);
	Database_AddTables(pdtData.iSubsetId,iNumTables);
	i=0;
	while(i<iNumTables)
	{
		Table_SetName(pdtData.iSubsetId, i, Table_GetName(pdtData.iDynDbId,i));
		TableSubset_SelectColumns(pdtData.iSubsetId, i, "*");
		TableSubset_SelectAllRows(pdtData.iSubsetId,i);
		i=i+1;
	}

	// Return form
	return composite;
}
func Gui_Component NewLinkedForm(i32x _iDynDbId,i32x _iSubsetId,i32x _iRefTableId,Gui_dtForm _pdtData)
{
	var i32x i,j,iNumTables;
	var Gui_Component composite;
	var Gui_dtForm pdtData;

	composite = NewObject(Gui_iForm);
	// Affect data pointer
	pdtData = new Gui_dtForm;
	SetData(composite, pdtData);

	// init back color
	pdtData.iBackColor = 0;

	// Keep ListForm data
	pdtData.pdtListFormData = _pdtData;

	// init background
	pdtData.gcBackground = NewBitmap(smWhite, 0);
	SetShadingMode(GetSprite(pdtData.gcBackground), DLC_GouraudMode_ModulateDiffuse, DLC_GouraudMode_ModulateDiffuse);
	SetBlendingMode(GetSprite(pdtData.gcBackground), DLC_Blend_AlphaBlend);
//	SetColor(pdtData.gcBackground, cTableLineBackColor);
	SetAlign(pdtData.gcBackground, e_GUI_HAlign_Zoom, e_GUI_VAlign_Zoom);
	pdtData.gcBackground<<Disable();
	StretchTo(pdtData.gcBackground, 10, 10);
	Clip(pdtData.gcBackground);
	MountComponent(composite, pdtData.gcBackground);

	// Init members
	pdtData.bCanBeSelected = true;
	pdtData.bCaptionAsTitle = _pdtData.bCaptionAsTitle;
	pdtData.bFieldAsTitle = _pdtData.bFieldAsTitle;
	pdtData.bFieldAsTitle = false;
	pdtData.iDefaultFieldColor = 0;
	pdtData.iDefaultFieldWidth = 64.0*g_fScreenScaleFactor;
	pdtData.iDefaultMediaWidth = 64.0*g_fScreenScaleFactor;
	pdtData.iDefaultMediaHeight = 64.0*g_fScreenScaleFactor;
	pdtData.iDefaultDecimal = 1;
	pdtData.iDefaultHAlign = e_GUI_HAlign_Left;
	pdtData.iDefaultVAlign = e_GUI_VAlign_Top;
	pdtData.bLocked=true;
	pdtData.szMshKit = "";
	pdtData.szBmpKit = "Gui/Cyclist_photo_msh.msh";		// Kit used for dynamic bitmap
	pdtData.szBmpMaterial = "Cyclist_Photo";	// texture used for dynamic bitmap
	pdtData.iDynDbId = _iDynDbId;
	pdtData.iSubsetId = _iSubsetId;
	pdtData.iRefTableId = _iRefTableId;
	pdtData.iDefaultOffset = 0;
	pdtData.smFontCaption = smTrebuchet;
	pdtData.smFontField = smTrebuchet;
	pdtData.iRow = 0;
	pdtData.iRef = ROW_INDEX;
	pdtData.iIsLinked = true;
	pdtData.bDynDB = false;
	pdtData.bMajInform = false;
	pdtData.iDataSourceDbId = pdtData.iDynDbId;
	pdtData.bRecordValid = true;

	// Return form
	return composite;
}

func Gui_Component NewListForm(i32x _iSubsetId,szx _szRefTable,i32x _bDynTable)
{
	var i32x i,j,iNumTables;
	var Gui_Component composite;
	var Gui_dtForm pdtData;

	composite = NewObject(Gui_iListForm);
	Transparent(composite);
	// Affect data pointer
	pdtData = new Gui_dtForm;
	SetData(composite, pdtData);

/*
	// Create background
	pdtData.gcBackground = NewBitmap(smWhite,0);
	SetShadingMode(GetSprite(pdtData.gcBackground),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	SetBlendingMode(GetSprite(pdtData.gcBackground),DLC_Blend_AlphaBlend);
	SetColor(pdtData.gcBackground,cEBDisableColor);
	Clip(pdtData.gcBackground);
	SetAlign(pdtData.gcBackground,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(composite,pdtData.gcBackground);
	pdtData.gcBackground<<Hide();
*/

	// Init members
	pdtData.bCanBeSelected = false;
	pdtData.bCaptionAsTitle = false;
	pdtData.bFieldAsTitle = false;
	pdtData.iDefaultFieldWidth = 64.0*g_fScreenScaleFactor;
	pdtData.iDefaultMediaWidth = 64.0*g_fScreenScaleFactor;
	pdtData.iDefaultMediaHeight = 64.0*g_fScreenScaleFactor;
	pdtData.iDefaultDecimal = 1;
	pdtData.iDefaultHAlign = e_GUI_HAlign_Left;
	pdtData.iDefaultVAlign = e_GUI_VAlign_Top;
	pdtData.iRefTableId = Table_GetIndexFromName(_iSubsetId,_szRefTable);
	pdtData.iDefaultOffset = 0;
	pdtData.bLocked=true;
	pdtData.szMshKit = "";
	pdtData.szBmpKit = "Gui/Cyclist_photo_msh.msh";		// Kit used for dynamic bitmap
	pdtData.szBmpMaterial = "Cyclist_Photo";	// texture used for dynamic bitmap
	pdtData.smFontCaption = smTrebuchet;
	pdtData.smFontField = smTrebuchet;
	pdtData.iRow = 0;
	pdtData.iRef = ROW_INDEX;
	pdtData.iIsLinked = false;
	pdtData.bDynDB = _bDynTable;
	pdtData.bMajInform = false;
	pdtData.bRecordValid = true;

	pdtData.iDisplayStartRow = 0;
	pdtData.iDisplayNumRows = -1; // No limits by default


	if(_bDynTable)
	{
		// Create a DB copy of subset
		pdtData.iDynDbId = Database_CopyConstructor("DYN_FORM_DATABASE",_iSubsetId);
	}
	else
	{
		// Direct use the subset
		pdtData.iDynDbId = _iSubsetId;
	}
	pdtData.iDataSourceDbId = pdtData.iDynDbId;
	// Create a subset for filter option
	pdtData.iSubsetId = Subset_Constructor("DYN_FORM_SUBSET_LIST",pdtData.iDynDbId);
	// Select all by default
	iNumTables = Database_GetNumTables(pdtData.iDynDbId);
	Database_AddTables(pdtData.iSubsetId,iNumTables);
	i=0;
	while(i<iNumTables)
	{
		Table_SetName(pdtData.iSubsetId, i, Table_GetName(pdtData.iDynDbId,i));
		TableSubset_SelectColumns(pdtData.iSubsetId, i, "*");
		TableSubset_SelectAllRows(pdtData.iSubsetId,i);
		i=i+1;
	}

	// Return form
	return composite;
}

func void ListForm_Update()
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;
	var Gui_Component pform,pparent;
	var i32x i,iNumComponents,iNumRows,iLastPosY,iSizeX;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);


	// For each row in subset create a form
	iNumRows = Table_GetNumRows(pdtData.iSubsetId,pdtData.iRefTableId);

	if(pdtData.iDisplayNumRows != -1)
	{
		iNumRows = iNumRows - pdtData.iDisplayStartRow;
		if(iNumRows>pdtData.iDisplayNumRows)
		{
			iNumRows = pdtData.iDisplayNumRows;
		}
	}

	var i32x id;
	iNumComponents = GetComponentNumber(pthis);
	iLastPosY = 0;
	iSizeX = 0;
	i=0;
	while(i<iNumRows)
	{
		if(i<iNumComponents)
		{
			pform = GetComponent(pthis,i);
			if(!pform)
			{
				pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
				id = MountComponent(pthis,pform);

				if ((i % 2) == 0) pform<<SetBackColor(cTableEvenRowBackColor);
				else pform<<SetBackColor(cTableOddRowBackColor);

				pthis<<AddForm(pform,i);
			}
			else
			{
				if ((i % 2) == 0) pform<<SetBackColor(cTableEvenRowBackColor);
				else pform<<SetBackColor(cTableOddRowBackColor);
			}
		}
		else
		{
			pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
			id = MountComponent(pthis,pform);

			if ((i % 2) == 0) pform<<SetBackColor(cTableEvenRowBackColor);
			else pform<<SetBackColor(cTableOddRowBackColor);

			pthis<<AddForm(pform,i); 
		}

		pform<<Show();
		pform<<FormSetRef(pdtData.iRef);
		pform<<GoToRecord(i+pdtData.iDisplayStartRow);
		MoveTo(pform,0,iLastPosY);
		iLastPosY = iLastPosY + SizeY(pform) + pdtData.iDefaultOffset;
		if(iSizeX<SizeX(pform))
			iSizeX = SizeX(pform);
		
		i=i+1;
	}

	if(iNumComponents>iNumRows)
	{
		i=iNumRows;
		while(i<iNumComponents)
		{
			pform = GetComponent(pthis,i);
			if(pform)
			{
				pform<<Hide();
			}

			i=i+1;
		}
	}

	// Stretch list to content
	StretchTo(pthis,iSizeX,iLastPosY);

	pparent = GetParent(pthis);	
	if(pparent)
	{
		pparent<<WindowUpdate();
	}
}

// set back color
func void Form_SetBackColor(i32x _iColor)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;
	
	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iBackColor = _iColor;
	SetColor(pdtData.gcBackground, _iColor);
}


func i32x Form_OnDestroy()
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if(pdtData.iIsLinked==false)
	{
		// Delete Database and subset
		Subset_Destructor(pdtData.iSubsetId);
		if(pdtData.bDynDB)
			Database_Destructor(pdtData.iDynDbId);
	}
}

func void FormLinked_ShowSubForm(i32x _iParentJoin,i32x _iChildJoin,Gui_Component _poForm,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield,parent;
	var Gui_dtForm pdtData;
	var Gui_dtFormCheckbox pdtField;
	var i32x iJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create new caption field
	pfield = NewFormSubField(pdtData,_iParentJoin,_iChildJoin,_szCaption,_poForm);
	if(pdtData.bLocked)
	{
		// Lock component
		pfield<<Disable();
	}

	// Mount component into formulaire
	MountComponent(pthis,pfield);
	MoveTo(pfield,_iPosX,_iPosY);

	// Save last field added
	pdtData.gcLastField = pfield;

	// Stretch form to fit content
	if(_iPosX+SizeX(pfield)>SizeX(pthis))
		Stretch(pthis,_iPosX+SizeX(pfield)-SizeX(pthis),0);
	if(_iPosY+SizeY(pfield)>SizeY(pthis))
		Stretch(pthis,0,_iPosY+SizeY(pfield)-SizeY(pthis));

	// Stretch background to fit form
	if(pdtData.gcBackground)
	{
		StretchTo(pdtData.gcBackground,SizeX(pthis),SizeY(pthis));
	}
}


func void FormLinked_AddVariable(i32x _iJoinId,szx _szVariable)
{
	var Gui_Component pthis,pvar;
	var Gui_dtFormField pdtData;
	var Gui_dtFieldVariable pdtVar;
	var i32x iJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pvar = NewVariable(pthis,_iJoinId,_szVariable);

	// Mount component into formulaire
	MountComponent(pthis,pvar);

	// Disable it
	pvar<<Disable();
}
func void FormLinked_ShowFormatField(i32x _iJoinId,i32x _iFormatId,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield,parent;
	var Gui_dtForm pdtData;
	var Gui_dtFormFormatField pdtField;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create new caption field
	pfield = NewFormFormatField(pdtData,
		_iJoinId,
		_iFormatId,
		_szCaption);
	
	// Lock component
	pfield<<Disable();

	// Mount component into formulaire
	MountComponent(pthis,pfield);
	MoveTo(pfield,_iPosX,_iPosY);
	pdtField = GetPrimaryData(pfield);
	if(pdtData.bCaptionAsTitle)
	{
		parent = GetParent(pthis);
		if(parent)
		{
			if(pdtField.gcCaption)
			{
				UnmountComponent(pfield,GetId(pdtField.gcCaption));
				parent<<WindowAddColumnTitle(pdtField.gcCaption,pfield);
			}
		}
	}
	if(pdtField.gcCaption)	Clip(pdtField.gcCaption);

	if(pdtData.bFieldAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcField)
		{
			UnmountComponent(pfield,GetId(pdtField.gcField));
			parent<<WindowAddRowTitle(pdtField.gcField,pfield, pdtData.iBackColor);
		}
	}
	Clip(pdtField.gcField);

	// Save last field added
	pdtData.gcLastField = pfield;

	// Stretch form to fit content
	if(_iPosX+SizeX(pfield)>SizeX(pthis))
		Stretch(pthis,_iPosX+SizeX(pfield)-SizeX(pthis),0);
	if(_iPosY+SizeY(pfield)>SizeY(pthis))
		Stretch(pthis,0,_iPosY+SizeY(pfield)-SizeY(pthis));

	// Stretch background to fit form
	if(pdtData.gcBackground)
	{
		StretchTo(pdtData.gcBackground,SizeX(pthis),SizeY(pthis));
	}
}
func void FormLinked_ShowField(i32x _iJoinId,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield,parent;
	var Gui_dtForm pdtData;
	var Gui_dtFormField pdtField;
	var i32x iJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create new caption field
	pfield = NewFormFieldExt(pdtData,
		_iJoinId,
		_szCaption);
	
	if(pdtData.bLocked)
	{
		// Lock component
		pfield<<Disable();
	}

	// Mount component into formulaire
	MountComponent(pthis,pfield);
	MoveTo(pfield,_iPosX,_iPosY);
	pdtField = GetPrimaryData(pfield);
	if(pdtData.bCaptionAsTitle)
	{
		parent = GetParent(pthis);
		if(parent)
		{
			if(pdtField.gcCaption)
			{
				UnmountComponent(pfield,GetId(pdtField.gcCaption));
				parent<<WindowAddColumnTitle(pdtField.gcCaption,pfield);
			}
		}
	}
	if(pdtField.gcCaption)	Clip(pdtField.gcCaption);

	if(pdtData.bFieldAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcField)
		{
			UnmountComponent(pfield,GetId(pdtField.gcField));
			parent<<WindowAddRowTitle(pdtField.gcField,pfield, pdtData.iBackColor);
		}
	}
	Clip(pdtField.gcField);

	// Save last field added
	pdtData.gcLastField = pfield;

	// Stretch form to fit content
	if(_iPosX+SizeX(pfield)>SizeX(pthis))
		Stretch(pthis,_iPosX+SizeX(pfield)-SizeX(pthis),0);
	if(_iPosY+SizeY(pfield)>SizeY(pthis))
		Stretch(pthis,0,_iPosY+SizeY(pfield)-SizeY(pthis));

	// Stretch background to fit form
	if(pdtData.gcBackground)
	{
		StretchTo(pdtData.gcBackground,SizeX(pthis),SizeY(pthis));
	}
}
func void FormLinked_ShowCheckboxField(i32x _iJoinId,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield,parent;
	var Gui_dtForm pdtData;
	var Gui_dtFormCheckbox pdtField;
	var i32x iJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create new caption field
	pfield = NewFormCheckbox(pdtData,
		_iJoinId,
		_szCaption);
	if(pdtData.bLocked)
	{
		// Lock component
		pfield<<Disable();
	}

	// Mount component into formulaire
	MountComponent(pthis,pfield);
	MoveTo(pfield,_iPosX,_iPosY);
	pdtField = GetPrimaryData(pfield);
	if(pdtData.bCaptionAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcCaption)
		{
			UnmountComponent(pfield,GetId(pdtField.gcCaption));
			parent<<WindowAddColumnTitle(pdtField.gcCaption,pfield);
		}
	}
	if(pdtField.gcCaption)	Clip(pdtField.gcCaption);

	if(pdtData.bFieldAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcField)
		{
			UnmountComponent(pfield,GetId(pdtField.gcField));
			parent<<WindowAddRowTitle(pdtField.gcField,pfield, pdtData.iBackColor);
		}
	}
	Clip(pdtField.gcField);

	// Save last field added
	pdtData.gcLastField = pfield;

	// Stretch form to fit content
	if(_iPosX+SizeX(pfield)>SizeX(pthis))
		Stretch(pthis,_iPosX+SizeX(pfield)-SizeX(pthis),0);
	if(_iPosY+SizeY(pfield)>SizeY(pthis))
		Stretch(pthis,0,_iPosY+SizeY(pfield)-SizeY(pthis));

	// Stretch background to fit form
	if(pdtData.gcBackground)
	{
		StretchTo(pdtData.gcBackground,SizeX(pthis),SizeY(pthis));
	}
}

func void FormLinked_ShowGroupOptionField(i32x _iJoinId,i32x _iDataJoinId,i32x _iCaptionJoinId,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield,parent;
	var Gui_dtForm pdtData;
	var Gui_dtFormGroupOption pdtField;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create group option
	pfield = NewFormGroupOption(pdtData,
		_iJoinId,
		_iDataJoinId,
		_iCaptionJoinId,
		_szCaption
		);
	if(pdtData.bLocked)
	{
		// Lock component
		pfield<<Disable();
	}

	// Save last field added
	pdtData.gcLastField = pfield;

	// Mount component into formulaire
	MountComponent(pthis,pfield);
	MoveTo(pfield,_iPosX,_iPosY);
	pdtField = GetPrimaryData(pfield);
	if(pdtData.bCaptionAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcCaption)
		{
			UnmountComponent(pfield,GetId(pdtField.gcCaption));
			parent<<WindowAddColumnTitle(pdtField.gcCaption,pfield);
		}
	}
	if(pdtField.gcCaption)	Clip(pdtField.gcCaption);

	if(pdtData.bFieldAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcField)
		{
			UnmountComponent(pfield,GetId(pdtField.gcField));
			parent<<WindowAddRowTitle(pdtField.gcField,pfield, pdtData.iBackColor);
		}
	}

	Clip(pdtField.gcField);

	// Stretch form to fit content
	if(_iPosX+SizeX(pfield)>SizeX(pthis))
		Stretch(pthis,_iPosX+SizeX(pfield)-SizeX(pthis),0);
	if(_iPosY+SizeY(pfield)>SizeY(pthis))
		Stretch(pthis,0,_iPosY+SizeY(pfield)-SizeY(pthis));

	// Stretch background to fit form
	if(pdtData.gcBackground)
	{
		StretchTo(pdtData.gcBackground,SizeX(pthis),SizeY(pthis));
	}
}
func void FormLinked_ShowListBoxField(i32x _iJoinId,i32x _iDataJoinId,i32x _iCaptionJoinId,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield,parent;
	var Gui_dtForm pdtData;
	var Gui_dtFormListBox pdtField;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create group option
	pfield = NewFormListBox(pdtData,
		_iJoinId,
		_iDataJoinId,
		_iCaptionJoinId,
		_szCaption
		);
	if(pdtData.bLocked)
	{
		// Lock component
		pfield<<Disable();
	}

	// Mount component into formulaire
	MountComponent(pthis,pfield);
	MoveTo(pfield,_iPosX,_iPosY);
	pdtField = GetPrimaryData(pfield);
	if(pdtData.bCaptionAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcCaption)
		{
			UnmountComponent(pfield,GetId(pdtField.gcCaption));
			parent<<WindowAddColumnTitle(pdtField.gcCaption,pfield);
		}
	}

	if(pdtField.gcCaption)	Clip(pdtField.gcCaption);

	if(pdtData.bFieldAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcField)
		{
			UnmountComponent(pfield,GetId(pdtField.gcField));
			parent<<WindowAddRowTitle(pdtField.gcField,pfield, pdtData.iBackColor);
		}
	}

	Clip(pdtField.gcField);
	// Save last field added
	pdtData.gcLastField = pfield;

	// Stretch form to fit content
	if(_iPosX+SizeX(pfield)>SizeX(pthis))
		Stretch(pthis,_iPosX+SizeX(pfield)-SizeX(pthis),0);
	if(_iPosY+SizeY(pfield)>SizeY(pthis))
		Stretch(pthis,0,_iPosY+SizeY(pfield)-SizeY(pthis));

	// Stretch background to fit form
	if(pdtData.gcBackground)
	{
		StretchTo(pdtData.gcBackground,SizeX(pthis),SizeY(pthis));
	}
}

func void FormLinked_ShowBitmapField(i32x _iJoinId,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield,parent;
	var Gui_dtForm pdtData;
	var Gui_dtFormBitmap pdtField;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create group option
	pfield = NewFormBitmap(pdtData,	_iJoinId,	_szCaption	);
	if(pdtData.bLocked)
	{
		// Lock component
		pfield<<Disable();
	}

	// Mount component into formulaire
	MountComponent(pthis,pfield);
	MoveTo(pfield,_iPosX,_iPosY);
	pdtField = GetPrimaryData(pfield);
	if(pdtData.bCaptionAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcCaption)
		{
			UnmountComponent(pfield,GetId(pdtField.gcCaption));
			parent<<WindowAddColumnTitle(pdtField.gcCaption,pfield);
		}
	}

	if(pdtField.gcCaption)	Clip(pdtField.gcCaption);

	if(pdtData.bFieldAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcField)
		{
			UnmountComponent(pfield,GetId(pdtField.gcField));
			parent<<WindowAddRowTitle(pdtField.gcField,pfield, pdtData.iBackColor);
		}
	}

	Clip(pdtField.gcField);

	// Save last field added
	pdtData.gcLastField = pfield;
	// Stretch form to fit content
	if(_iPosX+SizeX(pfield)>SizeX(pthis))
		Stretch(pthis,_iPosX+SizeX(pfield)-SizeX(pthis),0);
	if(_iPosY+SizeY(pfield)>SizeY(pthis))
		Stretch(pthis,0,_iPosY+SizeY(pfield)-SizeY(pthis));

	// Stretch background to fit form
	if(pdtData.gcBackground)
	{
		StretchTo(pdtData.gcBackground,SizeX(pthis),SizeY(pthis));
	}
}

func void FormLinked_ShowGaugeVField(i32x _iJoinId,szx _szCaption,i32x _iPosX,i32x _iPosY,f32x _fMinValue,f32x _fMaxValue,f32x _fIncrement)
{
	var Gui_Component pthis,pfield,parent;
	var Gui_dtForm pdtData;
	var Gui_dtFormGauge pdtField;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create Gauge
	pfield = NewFormGaugeV(pdtData,_iJoinId,_szCaption,_fMinValue,_fMaxValue,_fIncrement);
	if(pdtData.bLocked)
	{
		// Lock component
		pfield<<Disable();
	}

	// Mount component into formulaire
	MountComponent(pthis,pfield);
	MoveTo(pfield,_iPosX,_iPosY);
	pdtField = GetPrimaryData(pfield);
	if(pdtData.bCaptionAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcCaption)
		{
			UnmountComponent(pfield,GetId(pdtField.gcCaption));
			parent<<WindowAddColumnTitle(pdtField.gcCaption,pfield);
		}
	}

	if(pdtField.gcCaption)	Clip(pdtField.gcCaption);

	if(pdtData.bFieldAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcField)
		{
			UnmountComponent(pfield,GetId(pdtField.gcField));
			parent<<WindowAddRowTitle(pdtField.gcField,pfield, pdtData.iBackColor);
		}
	}

	Clip(pdtField.gcField);

	// Save last field added
	pdtData.gcLastField = pfield;
	// Stretch form to fit content
	if(_iPosX+SizeX(pfield)>SizeX(pthis))
		Stretch(pthis,_iPosX+SizeX(pfield)-SizeX(pthis),0);
	if(_iPosY+SizeY(pfield)>SizeY(pthis))
		Stretch(pthis,0,_iPosY+SizeY(pfield)-SizeY(pthis));

	// Stretch background to fit form
	if(pdtData.gcBackground)
	{
		StretchTo(pdtData.gcBackground,SizeX(pthis),SizeY(pthis));
	}

}

func void FormLinked_ShowGaugeHField(i32x _iJoinId,szx _szCaption,i32x _iPosX,i32x _iPosY,f32x _fMinValue,f32x _fMaxValue,f32x _fIncrement)
{
	var Gui_Component pthis,pfield,parent;
	var Gui_dtForm pdtData;
	var Gui_dtFormGauge pdtField;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create Gauge
	pfield = NewFormGaugeH(pdtData,_iJoinId,_szCaption,_fMinValue,_fMaxValue,_fIncrement);

	if(pdtData.bLocked)
	{
		// Lock component
		pfield<<Disable();
	}

	// Mount component into formulaire
	MountComponent(pthis,pfield);
	MoveTo(pfield,_iPosX,_iPosY);
	pdtField = GetPrimaryData(pfield);
	if(pdtData.bCaptionAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcCaption)
		{
			UnmountComponent(pfield,GetId(pdtField.gcCaption));
			parent<<WindowAddColumnTitle(pdtField.gcCaption,pfield);
		}
	}

	if(pdtField.gcCaption)	Clip(pdtField.gcCaption);

	if(pdtData.bFieldAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcField)
		{
			UnmountComponent(pfield,GetId(pdtField.gcField));
			parent<<WindowAddRowTitle(pdtField.gcField,pfield, pdtData.iBackColor);
		}
	}

	Clip(pdtField.gcField);

	// Save last field added
	pdtData.gcLastField = pfield;
	// Stretch form to fit content
	if(_iPosX+SizeX(pfield)>SizeX(pthis))
		Stretch(pthis,_iPosX+SizeX(pfield)-SizeX(pthis),0);
	if(_iPosY+SizeY(pfield)>SizeY(pthis))
		Stretch(pthis,0,_iPosY+SizeY(pfield)-SizeY(pthis));

	// Stretch background to fit form
	if(pdtData.gcBackground)
	{
		StretchTo(pdtData.gcBackground,SizeX(pthis),SizeY(pthis));
	}

}

func void FormLinked_ShowMeshField(i32x _iJoinId,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield,parent;
	var Gui_dtForm pdtData;
	var Gui_dtFormMesh pdtField;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create Mesh field
	pfield = NewFormMesh(pdtData,_iJoinId,_szCaption);
	if(pdtData.bLocked)
	{
		// Lock component
		//pfield<<Disable();
	}

	// Mount component into formulaire
	MountComponent(pthis,pfield);
	MoveTo(pfield,_iPosX,_iPosY);
	pdtField = GetPrimaryData(pfield);
	if(pdtData.bCaptionAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcCaption)
		{
			UnmountComponent(pfield,GetId(pdtField.gcCaption));
			parent<<WindowAddColumnTitle(pdtField.gcCaption,pfield);
		}
	}

	if(pdtField.gcCaption)	Clip(pdtField.gcCaption);

	if(pdtData.bFieldAsTitle)
	{
		parent = GetParent(pthis);
		if(parent&&pdtField.gcField)
		{
			UnmountComponent(pfield,GetId(pdtField.gcField));
			parent<<WindowAddRowTitle(pdtField.gcField,pfield, pdtData.iBackColor);
		}
	}

	if(pdtField.gcField) Clip(pdtField.gcField);

	// Save last field added
	pdtData.gcLastField = pfield;
	// Stretch form to fit content
	if(_iPosX+SizeX(pfield)>SizeX(pthis))
		Stretch(pthis,_iPosX+SizeX(pfield)-SizeX(pthis),0);
	if(_iPosY+SizeY(pfield)>SizeY(pthis))
		Stretch(pthis,0,_iPosY+SizeY(pfield)-SizeY(pthis));

	// Stretch background to fit form
	if(pdtData.gcBackground)
	{
		StretchTo(pdtData.gcBackground,SizeX(pthis),SizeY(pthis));
	}

}


// Form join constructor
func i32x Form_GetJoin(szx _szJoin,Gui_dtForm _pdtData,i32x _iInSubset)
{
	var Gui_dtForm pdtListData;
	var i32x iJoinId,i,bfound;
	var i32x iSubsetId;

	if(_iInSubset)
	{
		iSubsetId = _pdtData.iSubsetId;
	}
	else
	{
		iSubsetId = _pdtData.iDataSourceDbId;
	}

	if(!_pdtData.iIsLinked)
	{
		// Create join
		iJoinId = Join_Constructor(iSubsetId,_szJoin);
	}
	else
	{
		// Find precedly created join
		pdtListData = _pdtData.pdtListFormData;
		i=pdtListData.iStartJoinId;
		bfound = false;
		if(pdtListData.iStartJoinId>0)
		{
			while((i<=pdtListData.iLastJoinId)&&(!bfound))
			{
				if(!strcmp(Join_GetDesc(i),_szJoin))
				{
					bfound = true;
					iJoinId = i;
				}
				i=i+1;
			}
		}
		if(!bfound)
		{
			// Create join
			iJoinId = Join_Constructor(iSubsetId,_szJoin);
			pdtListData.iLastJoinId = iJoinId;
		}
		if(pdtListData.iStartJoinId==0)
			pdtListData.iStartJoinId = iJoinId;
	}
	return iJoinId;
}

// Field parameter
func void Form_AddVariable(szx _szJoin,szx _szVariable)
{
	var Gui_Component pthis,pfield;
	var Gui_dtForm pdtData;
	var i32x iJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create join
	iJoinId = Form_GetJoin(_szJoin,pdtData,true);

	// Create new variable
	FormLinked_AddVariable(iJoinId,_szVariable);
}

// Show field
func void Form_ShowFormatField(szx _szJoin,i32x _iFormatId,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield;
	var Gui_dtForm pdtData;
	var i32x iJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create join
	iJoinId = Form_GetJoin(_szJoin,pdtData,true);

	// Create new caption field
	FormLinked_ShowFormatField(iJoinId,_iFormatId,_szCaption,_iPosX,_iPosY);
}

func void Form_ShowField(szx _szJoin,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield;
	var Gui_dtForm pdtData;
	var i32x iJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create join
	iJoinId = Form_GetJoin(_szJoin,pdtData,true);

	// Create new caption field
	FormLinked_ShowField(iJoinId,_szCaption,_iPosX,_iPosY);
}
func void Form_ShowSubForm(szx _szParentJoin,szx _szChildJoin,Gui_Component _poForm,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield;
	var Gui_dtForm pdtData;
	var i32x iJoinParentId,iJoinChildId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create join
	iJoinParentId = Form_GetJoin(_szParentJoin,pdtData,true);
	iJoinChildId = Form_GetJoin(_szChildJoin,pdtData,true);

	// Create new caption field
	FormLinked_ShowSubForm(iJoinParentId,iJoinChildId,_poForm,_szCaption,_iPosX,_iPosY);
}

func void Form_ShowCheckboxField(szx _szJoin,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield;
	var Gui_dtForm pdtData;
	var i32x iJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create join
	iJoinId = Form_GetJoin(_szJoin,pdtData,true);

	// Create new caption field
	FormLinked_ShowCheckboxField(iJoinId,_szCaption,_iPosX,_iPosY);
}

func void Form_ShowGroupOptionField(szx _szJoin,szx _szDataJoin,szx _szCaptionJoin,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield;
	var Gui_dtForm pdtData;
	var i32x iJoinId,iDataJoinId,iCaptionJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create join
	iJoinId = Form_GetJoin(_szJoin,pdtData,true);
	iDataJoinId = Form_GetJoin(_szDataJoin,pdtData,false);
	iCaptionJoinId = Form_GetJoin(_szCaptionJoin,pdtData,false);

	// Create group option
	FormLinked_ShowGroupOptionField(iJoinId,iDataJoinId,iCaptionJoinId,_szCaption,_iPosX,_iPosY);
}
func void Form_ShowBitmapField(szx _szJoin,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield;
	var Gui_dtForm pdtData;
	var i32x iJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create join
	iJoinId = Form_GetJoin(_szJoin,pdtData,true);

	// Create new bitmap field
	FormLinked_ShowBitmapField(iJoinId,_szCaption,_iPosX,_iPosY);
}

func void Form_ShowMeshField(szx _szJoin,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield;
	var Gui_dtForm pdtData;
	var i32x iJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create join
	iJoinId = Form_GetJoin(_szJoin,pdtData,true);

	// Create new mesh field
	FormLinked_ShowMeshField(iJoinId,_szCaption,_iPosX,_iPosY);
}

func void Form_ShowGaugeVField(szx _szJoin,szx _szCaption,i32x _iPosX,i32x _iPosY,f32x _fMinValue,f32x _fMaxValue,f32x _fIncrement)
{
	var Gui_Component pthis,pfield;
	var Gui_dtForm pdtData;
	var i32x iJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create join
	iJoinId = Form_GetJoin(_szJoin,pdtData,true);

	// Create new gauge
	FormLinked_ShowGaugeVField(iJoinId,_szCaption,_iPosX,_iPosY,_fMinValue,_fMaxValue,_fIncrement);
}

func void Form_ShowGaugeHField(szx _szJoin,szx _szCaption,i32x _iPosX,i32x _iPosY,f32x _fMinValue,f32x _fMaxValue,f32x _fIncrement)
{
	var Gui_Component pthis,pfield;
	var Gui_dtForm pdtData;
	var i32x iJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create join
	iJoinId = Form_GetJoin(_szJoin,pdtData,true);

	// Create new gauge
	FormLinked_ShowGaugeHField(iJoinId,_szCaption,_iPosX,_iPosY,_fMinValue,_fMaxValue,_fIncrement);
}

func void Form_ShowListBoxField(szx _szJoin,szx _szDataJoin,szx _szCaptionJoin,szx _szCaption,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield;
	var Gui_dtForm pdtData;
	var i32x iJoinId,iDataJoinId,iCaptionJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create join
	iJoinId = Form_GetJoin(_szJoin,pdtData,true);
	iDataJoinId = Form_GetJoin(_szDataJoin,pdtData,false);
	iCaptionJoinId = Form_GetJoin(_szCaptionJoin,pdtData,false);

	// Create group option
	FormLinked_ShowListBoxField(iJoinId,iDataJoinId,iCaptionJoinId,_szCaption,_iPosX,_iPosY);
}
func void Form_AddField(Gui_Component _poField,i32x _iPosX,i32x _iPosY)
{
	var Gui_Component pthis,pfield;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Mount component into formulaire
	MountComponent(pthis,_poField);
	MoveTo(_poField,_iPosX,_iPosY);

	// Stretch form to fit content
	if(_iPosX+SizeX(_poField)>SizeX(pthis))
		Stretch(pthis,_iPosX+SizeX(_poField)-SizeX(pthis),0);
	if(_iPosY+SizeY(_poField)>SizeY(pthis))
		Stretch(pthis,0,_iPosY+SizeY(_poField)-SizeY(pthis));

}
func void Form_SetFont(Menu_Material _smCaption,Menu_Material _smField)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.smFontCaption = _smCaption;
	pdtData.smFontField = _smField;
}
func void Form_SetFontColor(i32x _iCaptionColor, i32x _iFieldColor)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iDefaultFontCaptionColor	= _iCaptionColor;
	pdtData.iDefaultFontFieldColor		= _iFieldColor;
}

func void Form_SetOffset(i32x _iOffset)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iDefaultOffset = _iOffset;
}

func void Form_SetDecimal(i32x _iDecimal)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iDefaultDecimal = _iDecimal;
}

func void Form_SetAlign(i32x _eHAlign,i32x _eVAlign)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iDefaultHAlign = _eHAlign;
	pdtData.iDefaultVAlign = _eVAlign;
}
func void Form_SetWidth(i32x _iWidth)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iDefaultFieldWidth = _iWidth;
}
func void Form_SetMediaSize(i32x _iWidth,i32x _iHeight)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iDefaultMediaWidth = _iWidth;
	pdtData.iDefaultMediaHeight = _iHeight;
}
func void Form_SetLocked(i32x _bLocked)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.bLocked = _bLocked;
}
func void Form_SetColor(i32x _iColor)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iDefaultFieldColor = _iColor;
}
func void Form_SetTitle(i32x _bCaption,i32x _bField)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.bCaptionAsTitle = _bCaption;
	pdtData.bFieldAsTitle = _bField;
}

// Record
func void Form_NextRecord()
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	Form_GoToRecord(pdtData.iRow + 1);
}
func void Form_PreviousRecord()
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	Form_GoToRecord(pdtData.iRow - 1);
}
func void Form_LastRecord()
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	Form_GoToRecord(Table_GetNumRows(pdtData.iSubsetId,pdtData.iRefTableId)-1);
}
func void Form_FirstRecord()
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	Form_GoToRecord(0);
}
func void Form_GoToRecord(i32x _iRecord)
{
	var Gui_Component pthis,pchild,parent;
	var Gui_dtForm pdtData;
	var i32x i,iNumRows,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	//print("_iRecord:"+itoa(_iRecord)+"\n");
	//print("Table_GetNumRows:"+itoa(Table_GetNumRows(pdtData.iSubsetId,pdtData.iRefTableId))+"\n");

	if((pdtData.iRef==ROW_KEY)||((_iRecord>=0)&&(_iRecord<Table_GetNumRows(pdtData.iSubsetId,pdtData.iRefTableId))))
	{
		pdtData.bRecordValid = true;
		pthis<<Show();
		pdtData.iRow = _iRecord;
	
		// Send update to each field
		iNumComponents = GetComponentNumber(pthis);
		i=0;
		while(i<iNumComponents)
		{
			pchild = GetComponent(pthis,i);
			if(pchild)
			{
				if(pdtData.iRef == ROW_INDEX)
				{
					pchild<<FormSelectIndex(pdtData.iRow);
				}
				else if(pdtData.iRef == ROW_SORT)
				{
					pchild<<FormSelectSIndex(pdtData.iRow);
				}
				else if(pdtData.iRef == ROW_KEY)
				{
					pchild<<FormSelectKey(pdtData.iRow);
				}
			}
			i=i+1;
		}

		if(pdtData.bMajInform)
		{
			// Inform parent about record change
			parent = GetParent(pthis);

			if(parent)
			{
				var i32x iKey;
				iKey = Table_GetRow(pdtData.iSubsetId,pdtData.iRefTableId,pdtData.iRow,pdtData.iRef,ROW_KEY);
				parent<<FormGainFocus(pthis,iKey);
			}
		}
	}
	else
	{
		print("UnvalidRecord\n");
		pdtData.bRecordValid = false;
		pthis<<Hide();
	}
}
func void Form_AddRecord()
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumRows,iRow,iNumTables,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Add a new record to ref table in Dyn database
	iRow = Table_AddRow(pdtData.iSubsetId, pdtData.iRefTableId);

	// Notify himself
	pthis<<FormMaJNewRecord(pdtData.iSubsetId,iRow);

	// Switch to Index mode
	pdtData.iRef = ROW_INDEX;

	// Select it
	pthis<<GoToRecord(iRow);
}
func void Form_DeleteRecord()
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Delete current record to ref table in Dyn database
	Table_DeleteRowFromIndex(pdtData.iSubsetId, pdtData.iRefTableId, pdtData.iRow);
	Database_DeleteNow(pdtData.iSubsetId);

	// Go to previous record first
	Form_PreviousRecord();
}
func void Form_Save()
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if(pdtData.bRecordValid)
	{
		// Send update to each field
		iNumComponents = GetComponentNumber(pthis);
		//print("iNumComponents:"+itoa(iNumComponents)+"\n");
		i=0;
		while(i<iNumComponents)
		{
			pchild = GetComponent(pthis,i);
			if(pchild)
			{
				pchild<<SaveRecord();
			}
			i=i+1;
		}
	}
	else
	{
		print("InvalidRecord\n");
	}
}

func void ListForm_RazFilter()
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;
	var Gui_Component pform;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	iNumComponents = GetComponentNumber(pthis);
	if(iNumComponents>0)
	{
		// Send filter message to first form
		pform = GetComponent(pthis,0);
		if(pform)
			pform<<FormLinkQuery(0);
	}
	else
	{
		// Create one form
		pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
		MountComponent(pthis,pform);
		pform<<SetBackColor(cTableEvenRowBackColor);
		pthis<<AddForm(pform,0); 
		pform<<FormLinkQuery(0);
	}
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}

func void ListForm_Save()
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	//print("ListForm_SAve\n");

	if(pdtData.bRecordValid)
	{
		// Send update to each field
		iNumComponents = GetComponentNumber(pthis);
		//print("iNumComponents:"+itoa(iNumComponents)+"\n");
		i=0;
		while(i<iNumComponents)
		{
			pchild = GetComponent(pthis,i);
			if(pchild)
			{
				pchild<<SaveRecord();
			}
			i=i+1;
		}
	}
	else
	{
		print("InvalidRecord\n");
	}
}

func void Form_Send(Net_Client _poServer,szx _szName)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents,iSubsetId,iNumTables,iKey;
	var szx szColumnName,szTableName,szJoin;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if(pdtData.bRecordValid)
	{

		// Send save to each field
		iNumComponents = GetComponentNumber(pthis);
		i=0;
		while(i<iNumComponents)
		{
			pchild = GetComponent(pthis,i);
			if(pchild)
			{
				pchild<<SaveRecord();
			}
			i=i+1;
		}

		// Create a subset with the current row;
		iSubsetId = Subset_Constructor(_szName,pdtData.iSubsetId);
		// Add all column
		iNumTables = Database_GetNumTables(pdtData.iSubsetId);
		Database_AddTables(iSubsetId,iNumTables);
		i=0;
		while(i<iNumTables)
		{
			Table_SetName(iSubsetId, i, Table_GetName(pdtData.iSubsetId,i));
			TableSubset_SelectColumns(iSubsetId, i, "*");
			//TableSubset_SelectAllRows(iSubsetId,i);
			i=i+1;
		}

		// Get selected row key
		// Key table
		szTableName = Table_GetName(pdtData.iSubsetId, pdtData.iRefTableId);

		// Key column
		szColumnName = Column_GetName(pdtData.iSubsetId, pdtData.iRefTableId, 0);

		// Get join name
		szJoin = szTableName+"."+szColumnName;


		// Retrieve key
		iKey = Database_GetIntData(pdtData.iSubsetId,szJoin, pdtData.iRef, pdtData.iRow);

		// Create query to get only selected record
		Query_Create(0,iSubsetId);
		// Allways select ref table
		Query_SelectTable(0,szTableName);
		i=0;
		while(i<iNumComponents)
		{
			pchild = GetComponent(pthis,i);
			if(pchild)
			{
				// Sub field linked rows
				pchild<<FormLinkRows(iSubsetId);
				// Other field link table
				pchild<<FormLinkQuery(0);
			}
			i=i+1;
		}
		Query_SelectWhereIntEqual(0,szJoin, iKey);
		Query_Execute(0);

		// To debug sending
		//print("DatabasePrint\n");
		//Database_HTMLDebugPrint(iSubsetId);

		// Send subset to server
		Database_Send(iSubsetId,_szName,_poServer);

		// Destroy generated subset
		Subset_Destructor(iSubsetId);
	}
	else
	{
		print("Can't send unvalid record\n");

	}
}


// Filter
func szx Form_GetJoinTable(szx _szJoin)
{
	// Retrieve join table
	var i32x i,iLength;
	var szx szPoint,szJoinTable;
	iLength = strlen(_szJoin);
	i = iLength-1;
	szPoint = "a";
	while((i>=0)&&(strcmp(szPoint,".")))
	{
		szPoint = strncpy(_szJoin,i,1);
		i=i-1;
	}
	szJoinTable = strncpy(_szJoin,0,i+1);

	return szJoinTable;
}

func void ListForm_FilterByIntEqual(szx _szJoin,i32x _iValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;
	var Gui_Component pform;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	iNumComponents = GetComponentNumber(pthis);
	if(iNumComponents>0)
	{
		// Send filter message to first form
		pform = GetComponent(pthis,0);
		if(pform)
			pform<<FormLinkQuery(0);
	}
	else
	{
		// Create one form
		pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
		MountComponent(pthis,pform);
		pform<<SetBackColor(cTableEvenRowBackColor);
		pthis<<AddForm(pform,0); 
		pform<<FormLinkQuery(0);
	}
	Query_SelectWhereIntEqual(0,_szJoin, _iValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}

func void Form_FilterByIntEqual(szx _szJoin,i32x _iValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			pchild<<FormLinkQuery(0);
			pchild<<FormLinkFilter(0);
		}
		i=i+1;
	}
	Query_SelectWhereIntEqual(0,_szJoin, _iValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();

	// Select the first record
	pthis<<FirstRecord();
}
func void ListForm_FilterByIntLess(szx _szJoin,i32x _iValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;
	var Gui_Component pform;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	iNumComponents = GetComponentNumber(pthis);
	if(iNumComponents>0)
	{
		// Send filter message to first form
		pform = GetComponent(pthis,0);
		if(pform)
			pform<<FormLinkQuery(0);
	}
	else
	{
		// Create one form
		pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
		MountComponent(pthis,pform);
		pform<<SetBackColor(cTableEvenRowBackColor);
		pthis<<AddForm(pform,0); 
		pform<<FormLinkQuery(0);
	}
	Query_SelectWhereIntLessThan(0,_szJoin, _iValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}
func void Form_FilterByIntLess(szx _szJoin,i32x _iValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			pchild<<FormLinkQuery(0);
			pchild<<FormLinkFilter(0);
		}
		i=i+1;
	}
	Query_SelectWhereIntLessThan(0,_szJoin, _iValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}
func void ListForm_FilterByIntGreater(szx _szJoin,i32x _iValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;
	var Gui_Component pform;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	iNumComponents = GetComponentNumber(pthis);
	if(iNumComponents>0)
	{
		// Send filter message to first form
		pform = GetComponent(pthis,0);
		if(pform)
			pform<<FormLinkQuery(0);
	}
	else
	{
		// Create one form
		pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
		MountComponent(pthis,pform);
		pform<<SetBackColor(cTableEvenRowBackColor);
		pthis<<AddForm(pform,0); 
		pform<<FormLinkQuery(0);
	}
	Query_SelectWhereIntGreaterThan(0,_szJoin, _iValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}
func void Form_FilterByIntGreater(szx _szJoin,i32x _iValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	Query_SelectWhereIntGreaterThan(0,_szJoin, _iValue);
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			pchild<<FormLinkQuery(0);
			pchild<<FormLinkFilter(0);
		}
		i=i+1;
	}
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}

func void ListForm_FilterByIntDifferent(szx _szJoin,i32x _iValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;
	var Gui_Component pform;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));

	iNumComponents = GetComponentNumber(pthis);
	if(iNumComponents>0)
	{
		// Send filter message to first form
		pform = GetComponent(pthis,0);
		if(pform)
			pform<<FormLinkQuery(0);
	}
	else
	{
		// Create one form
		pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
		MountComponent(pthis,pform);
		pform<<SetBackColor(cTableEvenRowBackColor);
		pthis<<AddForm(pform,0); 
		pform<<FormLinkQuery(0);
	}
	Query_SelectWhereIntDifferent(0,_szJoin, _iValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}
func void Form_FilterByIntDifferent(szx _szJoin,i32x _iValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			pchild<<FormLinkQuery(0);
		//	pchild<<FormLinkFilter(0);
		}
		i=i+1;
	}
	Query_SelectWhereIntDifferent(0,_szJoin, _iValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}

func void ListForm_FilterByFloatEqual(szx _szJoin,f32x _fValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x iNumComponents;
	var Gui_Component pform;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));

	iNumComponents = GetComponentNumber(pthis);
	if(iNumComponents>0)
	{
		// Send filter message to first form
		pform = GetComponent(pthis,0);
		if(pform)
			pform<<FormLinkQuery(0);
	}
	else
	{
		// Create one form
		pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
		MountComponent(pthis,pform);
		pform<<SetBackColor(cTableEvenRowBackColor);
		pthis<<AddForm(pform,0); 
		pform<<FormLinkQuery(0);
	}
	Query_SelectWhereFloatEqual(0,_szJoin, _fValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}
func void Form_FilterByFloatEqual(szx _szJoin,f32x _fValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	Query_SelectWhereFloatEqual(0,_szJoin, _fValue);
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			pchild<<FormLinkQuery(0);
			pchild<<FormLinkFilter(0);
		}
		i=i+1;
	}
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}
func void ListForm_FilterByFloatLess(szx _szJoin,f32x _fValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x iNumComponents;
	var Gui_Component pform;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	iNumComponents = GetComponentNumber(pthis);
	if(iNumComponents>0)
	{
		// Send filter message to first form
		pform = GetComponent(pthis,0);
		if(pform)
			pform<<FormLinkQuery(0);
	}
	else
	{
		// Create one form
		pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
		MountComponent(pthis,pform);
		pform<<SetBackColor(cTableEvenRowBackColor);
		pthis<<AddForm(pform,0); 
		pform<<FormLinkQuery(0);
	}
	Query_SelectWhereFloatLessThan(0,_szJoin, _fValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}

func void Form_FilterByFloatLess(szx _szJoin,f32x _fValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	Query_SelectWhereFloatLessThan(0,_szJoin, _fValue);
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			pchild<<FormLinkQuery(0);
			pchild<<FormLinkFilter(0);
		}
		i=i+1;
	}
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}
func void ListForm_FilterByFloatGreater(szx _szJoin,f32x _fValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x iNumComponents;
	var Gui_Component pform;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	iNumComponents = GetComponentNumber(pthis);
	if(iNumComponents>0)
	{
		// Send filter message to first form
		pform = GetComponent(pthis,0);
		if(pform)
			pform<<FormLinkQuery(0);
	}
	else
	{
		// Create one form
		pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
		MountComponent(pthis,pform);
		pform<<SetBackColor(cTableEvenRowBackColor);
		pthis<<AddForm(pform,0); 
		pform<<FormLinkQuery(0);
	}
	Query_SelectWhereFloatGreaterThan(0,_szJoin, _fValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}

func void Form_FilterByFloatGreater(szx _szJoin,f32x _fValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	Query_SelectWhereFloatGreaterThan(0,_szJoin, _fValue);
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			pchild<<FormLinkQuery(0);
			pchild<<FormLinkFilter(0);
		}
		i=i+1;
	}
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}
func void ListForm_FilterByFloatDifferent(szx _szJoin,f32x _fValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;
	var Gui_Component pform;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	iNumComponents = GetComponentNumber(pthis);
	if(iNumComponents>0)
	{
		// Send filter message to first form
		pform = GetComponent(pthis,0);
		if(pform)
			pform<<FormLinkQuery(0);
	}
	else
	{
		// Create one form
		pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
		MountComponent(pthis,pform);
		pform<<SetBackColor(cTableEvenRowBackColor);
		pthis<<AddForm(pform,0); 
		pform<<FormLinkQuery(0);
	}
	Query_SelectWhereFloatDifferent(0,_szJoin, _fValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}

func void Form_FilterByFloatDifferent(szx _szJoin,f32x _fValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	Query_SelectWhereFloatDifferent(0,_szJoin, _fValue);
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			pchild<<FormLinkQuery(0);
			pchild<<FormLinkFilter(0);
		}
		i=i+1;
	}
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}
func void ListForm_FilterByStringEqual(szx _szJoin,szx _szValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x iNumComponents;
	var Gui_Component pform;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	iNumComponents = GetComponentNumber(pthis);
	if(iNumComponents>0)
	{
		// Send filter message to first form
		pform = GetComponent(pthis,0);
		if(pform)
			pform<<FormLinkQuery(0);
	}
	else
	{
		// Create one form
		pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
		MountComponent(pthis,pform);
		pform<<SetBackColor(cTableEvenRowBackColor);
		pthis<<AddForm(pform,0); 
		pform<<FormLinkQuery(0);
	}
	Query_SelectWhereStringEqual(0,_szJoin, _szValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}

func void Form_FilterByStringEqual(szx _szJoin,szx _szValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	Query_SelectWhereStringEqual(0,_szJoin, _szValue);
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			pchild<<FormLinkQuery(0);
			pchild<<FormLinkFilter(0);
		}
		i=i+1;
	}
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}
func void ListForm_FilterByStringLess(szx _szJoin,szx _szValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x iNumComponents;
	var Gui_Component pform;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	iNumComponents = GetComponentNumber(pthis);
	if(iNumComponents>0)
	{
		// Send filter message to first form
		pform = GetComponent(pthis,0);
		if(pform)
			pform<<FormLinkQuery(0);
	}
	else
	{
		// Create one form
		pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
		MountComponent(pthis,pform);
		pform<<SetBackColor(cTableEvenRowBackColor);
		pthis<<AddForm(pform,0); 
		pform<<FormLinkQuery(0);
	}
	Query_SelectWhereStringLessThan(0,_szJoin, _szValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}

func void Form_FilterByStringLess(szx _szJoin,szx _szValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	Query_SelectWhereStringLessThan(0,_szJoin, _szValue);
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			pchild<<FormLinkQuery(0);
			pchild<<FormLinkFilter(0);
		}
		i=i+1;
	}
	Query_Execute(0);


	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}
func void ListForm_FilterByStringGreater(szx _szJoin,szx _szValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x iNumComponents;
	var Gui_Component pform;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	iNumComponents = GetComponentNumber(pthis);
	if(iNumComponents>0)
	{
		// Send filter message to first form
		pform = GetComponent(pthis,0);
		if(pform)
			pform<<FormLinkQuery(0);
	}
	else
	{
		// Create one form
		pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
		MountComponent(pthis,pform);
		pform<<SetBackColor(cTableEvenRowBackColor);
		pthis<<AddForm(pform,0); 
		pform<<FormLinkQuery(0);
	}
	Query_SelectWhereStringGreaterThan(0,_szJoin, _szValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}

func void Form_FilterByStringGreater(szx _szJoin,szx _szValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	Query_SelectWhereStringGreaterThan(0,_szJoin, _szValue);
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			pchild<<FormLinkQuery(0);
			pchild<<FormLinkFilter(0);
		}
		i=i+1;
	}
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}
func void ListForm_FilterByStringDifferent(szx _szJoin,szx _szValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x iNumComponents;
	var Gui_Component pform;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	iNumComponents = GetComponentNumber(pthis);
	if(iNumComponents>0)
	{
		// Send filter message to first form
		pform = GetComponent(pthis,0);
		if(pform)
			pform<<FormLinkQuery(0);
	}
	else
	{
		// Create one form
		pform = NewLinkedForm(pdtData.iDynDbId,pdtData.iSubsetId,pdtData.iRefTableId,pdtData);
		MountComponent(pthis,pform);
		pform<<SetBackColor(cTableEvenRowBackColor);
		pthis<<AddForm(pform,0); 
		pform<<FormLinkQuery(0);
	}
	Query_SelectWhereStringDifferent(0,_szJoin, _szValue);
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}

func void Form_FilterByStringDifferent(szx _szJoin,szx _szValue)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);

	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	Query_SelectTable(	0,  Form_GetJoinTable(_szJoin));
	Query_SelectWhereStringDifferent(0,_szJoin, _szValue);
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			pchild<<FormLinkQuery(0);
			pchild<<FormLinkFilter(0);
		}
		i=i+1;
	}
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}
func void Form_RazFilter()
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// create query to fill the subset
	DatabaseSubset_Clear(pdtData.iSubsetId);
	// Compute field filter (AND)
	Query_Create(0,pdtData.iSubsetId);
	Query_SelectTable(	0, Table_GetName(pdtData.iSubsetId,pdtData.iRefTableId));
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			pchild<<FormLinkFilter(0);
		}
		i=i+1;
	}
	Query_Execute(0);

	// Update form
	pthis<<FormUpdate();
	// Select the first record
	pthis<<FirstRecord();
}

func void Form_Sort(szx _szJoin,i32x _iDir)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;
	var i32x iJoinId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Create join
	iJoinId = Join_Constructor(pdtData.iSubsetId,_szJoin);

	// Call ById func
	Form_SortById(iJoinId,_iDir);

	// Delete Join
	Join_Destructor(iJoinId);
}
func void Form_SortById(i32x _iJoinId,i32x _iDir)
{
	var Gui_Component pthis,parent;
	var Gui_dtForm pdtData;
	var i32x iRowSort,iCurrentIndex;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if(pdtData.iIsLinked)
	{
		// Send message to parent list form
		parent = GetParent(pthis);

		if(parent) parent<<FormSortById(_iJoinId,_iDir);
	}
	else
	{
		// get current selelected row
		if(pdtData.bRecordValid)
			iCurrentIndex = Join_GetRow(_iJoinId, pdtData.iRow, pdtData.iRef, ROW_INDEX );

		// Sort by join index
		Join_Sort(_iJoinId,_iDir);

		// Set reference to sort index
		pdtData.iRef = ROW_SORT;

		// Find current row in sorted index
		if(pdtData.bRecordValid)
			pdtData.iRow = Join_GetRow(_iJoinId, iCurrentIndex, ROW_INDEX, ROW_SORT );

		// Update form
		pthis<<FormUpdate();
	}
}
func void Form_SetRef(i32x _iRef)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRef = _iRef;
}

func void Form_DeleteJoin(i32x _iJoinId)
{
	var Gui_Component pthis,pchild,parent;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if(pdtData.iIsLinked == 0)
	{
		Join_Destructor(_iJoinId);
	}
	else
	{
		parent = GetParent(pthis);
		if(parent)
		{
			if(GetId(pthis)==0)
			{
				parent<<FormDeleteJoin(_iJoinId);
			}
		}
	}
}

func Gui_Component GetLastField(Gui_Component _gcForm)
{
	var Gui_dtForm pdtData;

	// Get primary form data
	pdtData = GetPrimaryData(_gcForm);

	// Return last added field
	return pdtData.gcLastField;
}

func i32x Form_OnGainFocus()
{
	var Gui_Component pthis, parent;
	var Gui_dtForm pdtData;
	var i32x iKey;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if(pdtData.bCanBeSelected)
	{
		parent = GetParent(pthis);
		if(parent)
		{
			iKey = Table_GetRow(pdtData.iSubsetId,pdtData.iRefTableId,pdtData.iRow,pdtData.iRef,ROW_KEY);
			if(pdtData.iIsLinked)
			{
				parent<<FormGainFocus(parent,iKey);
			}
			else
			{
				parent<<FormGainFocus(pthis,iKey);
			}
		}
		if (pdtData.gcBackground) SetColor(pdtData.gcBackground, cTableSelectColor);

		if(parent)
		{
			parent<<WindowUpdate();
		}
		
		return 1;
	}
	return 0;
}
func i32x Form_OnLoseFocus()
{
	var Gui_Component pthis, parent;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if(pdtData.bCanBeSelected)
	{
		if (pdtData.gcBackground) SetColor(pdtData.gcBackground, pdtData.iBackColor);

		parent = GetParent(pthis);
		if(parent)
		{
			parent<<WindowUpdate();
		}
	
		return 1;
	}
	return 0;
}


func i32x Form_OnMouseDblClick(i32x _iX,i32x _iY,i32x _iButton)
{
	var Gui_Component pthis,parent;
	var Gui_dtForm pdtData;
	var i32x iKey;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	parent = GetParent(pthis);
	if(parent)
	{
		if(pdtData.bRecordValid)
		{
			iKey = Table_GetRow(pdtData.iSubsetId,pdtData.iRefTableId,pdtData.iRow,pdtData.iRef,ROW_KEY);
			if(pdtData.iIsLinked)
			{
				parent<<FormDoubleClick(parent,iKey);
			}
			else
			{
				parent<<FormDoubleClick(pthis,iKey);
			}
		}
	}
}
func void Form_SetMaJInform(i32x _bMajInform)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.bMajInform = _bMajInform;
}
func void Form_SetDataSource(i32x _iDbId)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iDataSourceDbId = _iDbId;
}
func void Form_RestoreDataSource()
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iDataSourceDbId = pdtData.iDynDbId;
}


func void Form_CaptionAlignSetWidth	(i32x _iCaptionAlign)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtData.bCaptionAlign = true;
	pdtData.iCaptionAlign = _iCaptionAlign;
}


func void Form_CaptionAlign(i32x _eHAlign, i32x _eVAlign)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtData.iCaption_HAlign = _eHAlign;
	pdtData.iCaption_VAlign = _eVAlign;
}


func void Form_CaptionUnAlign()
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtData.bCaptionAlign = false;
	//pdtData.iCaptionAlign = 0;
}



func void ListForm_SendDatabase(Net_Client _poServer,szx _szName)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Retrieve sub form number
	iNumComponents = GetComponentNumber(pthis);

	if(iNumComponents>0)
	{
		// Send message to first form
		pchild = GetComponent(pthis,0);
		if(pchild)
		{
			pchild<<SendDatabase(_poServer,_szName);
		}
	}
	else
	{
		print("ListForm : Can't send database if no sub form are valid !\n");
	}
}
func void Form_LinkQuery(i32x _iQueryId)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			// Other field link table
			pchild<<FormLinkQuery(_iQueryId);
		}
		i=i+1;
	}
}


func void Form_SendDatabase(Net_Client _poServer,szx _szName)
{
	var Gui_Component pthis,pchild;
	var Gui_dtForm pdtData;
	var i32x i,iNumComponents,iSubsetId,iNumTables;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	//print("SendDatabase\n");
	// Create a subset with all field of form;
	iSubsetId = Subset_Constructor(_szName,pdtData.iDynDbId);
	// Add all column
	iNumTables = Database_GetNumTables(pdtData.iDynDbId);
	Database_AddTables(iSubsetId,iNumTables);
	i=0;
	while(i<iNumTables)
	{
		Table_SetName(iSubsetId, i, Table_GetName(pdtData.iDynDbId,i));
		TableSubset_SelectColumns(iSubsetId, i, "*");
		//TableSubset_SelectAllRows(iSubsetId,i);
		i=i+1;
	}

	// Create query to get only valid link record
	Query_Create(0,iSubsetId);
	// Allway select ref table
	Query_SelectTable(0,Table_GetName(iSubsetId,pdtData.iRefTableId));
	i=0;
	iNumComponents = GetComponentNumber(pthis);
	while(i<iNumComponents)
	{
		pchild = GetComponent(pthis,i);
		if(pchild)
		{
			// Sub field linked rows
			pchild<<FormLinkRows(iSubsetId);
			// Other field link table
			pchild<<FormLinkQuery(0);
		}
		i=i+1;
	}
	Query_Execute(0);

	// To debug sending
//	Database_HTMLDebugPrint(iSubsetId);

	// Send subset to server
	Database_Send(iSubsetId,_szName,_poServer);

	// Destroy generated subset
	Subset_Destructor(iSubsetId);
}

func void Form_SetLinked(i32x _iLinked)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iIsLinked = _iLinked;
}

func void Form_SetMeshKit(szx _szMeshKit)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.szMshKit = _szMeshKit;
}

func void Form_SetFormatType(i32x _iType,f32x _fFactor)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iFormatType = _iType;
	pdtData.fFactor = _fFactor;
}

func void ListForm_SetLimiter(i32x _iStartRow,i32x _iNumRows)
{
	var Gui_Component pthis;
	var Gui_dtForm pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iDisplayStartRow = _iStartRow;
	pdtData.iDisplayNumRows = _iNumRows;
}


