func Gui_Component NewFormBitmap(Gui_dtForm _pdtForm,i32x _iJoinId,szx _szCaption)
{
	var Gui_Component composite;
	var Gui_dtFormBitmap pdtData;
	var i32x sx,sy;

	// Create an object that will contain Dynamic bitmap + caption
	composite = NewObject(Gui_iFormBitmap);
	// Affect data pointer
	pdtData = new Gui_dtFormBitmap;
	SetData(composite,pdtData);

	// Three component in composite select
	SetComponentNumber(composite,2);

	// Create caption if wanted
	sx = 0;
	sy = 0;
	if(_pdtForm.smFontCaption)
	{
		pdtData.gcCaption = NewCaption(_pdtForm.smFontCaption,_szCaption);
		SetColor(pdtData.gcCaption, _pdtForm.iDefaultFontCaptionColor);
		sx = SizeX(pdtData.gcCaption);
		sy = SizeY(pdtData.gcCaption);
		pdtData.gcCaption<<Disable();
		MountComponent(composite,pdtData.gcCaption);
	}

	// Create join
	pdtData.iJoinId = _iJoinId;

	// Create Dynamic bitmap
	pdtData.gcField = NewDynBitmap(_pdtForm.szBmpKit,_pdtForm.szBmpMaterial);
	Clip(pdtData.gcField);
	SetAlign(pdtData.gcField,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcField,_pdtForm.iDefaultMediaWidth,_pdtForm.iDefaultMediaHeight);
	pdtData.gcField<<Disable();
	MountComponent(composite,pdtData.gcField);

	// Move field to correct pos
	if(_pdtForm.bCaptionAlign)
	{
		// align caption to _pdtform.iCaptionAlign and align field to _pdtform.iDefaultHAlign and iDefaultVAlign
		if(pdtData.gcCaption)
		{
			// set caption width
			StretchTo(pdtData.gcCaption, _pdtForm.iCaptionAlign, SizeY(pdtData.gcField));
			// move caption
			SetAlign(pdtData.gcCaption, _pdtForm.iCaption_HAlign, _pdtForm.iCaption_VAlign);
			//MoveTo(pdtData.gcCaption, -SizeX(pdtData.gcCaption), 0);
			MoveTo(pdtData.gcCaption, -(_pdtForm.iCaptionAlign+_pdtForm.iDefaultOffset), 0);
		}		
	}
	else
	{
		if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Left)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Max))
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Right,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,-_pdtForm.iDefaultOffset-SizeX(pdtData.gcCaption),0);
			}
		}
		else if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Center)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Zoom))
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,_pdtForm.iDefaultFieldWidth,SizeY(pdtData.gcCaption));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Center,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,0,-(sy + _pdtForm.iDefaultOffset));
			}
		}
		else if(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Right)
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Left,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,sx + _pdtForm.iDefaultOffset + _pdtForm.iDefaultMediaWidth,0);
			}
		}
	}


	// Stretch
	StretchTo(composite,SizeX(pdtData.gcField),SizeY(pdtData.gcField));
	
	return composite;
}
/* *************************************************
 * BITMAP FIELD
 *************************************************** */
func i32x FormBitmap_OnDestroy()
{
	var Gui_Component pthis,parent;
	var Gui_dtFormBitmap pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Destroy join
	parent = GetParent(pthis);
	if(parent)
	{
		parent<<FormDeleteJoin(pdtData.iJoinId);
	}
}
func void FormBitmap_OnSelectKey(i32x _iKey)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormBitmap pdtData;
	var i32x iTgaId;
	var szx szTexture;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iKey;
	pdtData.iRef = ROW_KEY;

	// Retrieve data from db
	if(Join_GetDataType(pdtData.iJoinId)==STRING_DATA)
		szTexture = Join_GetStringFromKey(pdtData.iJoinId,_iKey);
	else if(Join_GetDataType(pdtData.iJoinId)==INT_DATA)
	{
		iTgaId = Join_GetIntFromKey(pdtData.iJoinId,_iKey);
		szTexture="./"+Join_GetStringFromKey(g_oLocalJoins.m_iTga_szDirectory,iTgaId);
		szTexture=szTexture+"/"+Join_GetStringFromKey(g_oLocalJoins.m_iTga_szName,iTgaId);
	}
	else
		szTexture = "Bad type";

	// change dyn bitmap
	pdtData.gcField<<SetBitmap(szTexture);
	pdtData.szTxt = szTexture;
}
func void FormBitmap_OnSelectIndex(i32x _iIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormBitmap pdtData;
	var i32x iTgaId;
	var szx szTexture,szTest1,szTest2;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iIndex;
	pdtData.iRef = ROW_INDEX;

	// Retrieve data from db
	if(Join_GetDataType(pdtData.iJoinId)==STRING_DATA)
		szTexture = Join_GetStringFromIndex(pdtData.iJoinId,_iIndex);
	else if(Join_GetDataType(pdtData.iJoinId)==INT_DATA)
	{
		iTgaId = Join_GetIntFromIndex(pdtData.iJoinId,_iIndex);
		szTest1 = Join_GetStringFromKey(g_oLocalJoins.m_iTga_szDirectory,iTgaId);
		szTest2 = Join_GetStringFromKey(g_oLocalJoins.m_iTga_szName,iTgaId);
		if((strlen(szTest1) + strlen(szTest2))==0)
		{
			print("Warning : key("+itoa(iTgaId)+") not found in STA_TGA !\n");
			szTexture = "Null.tga";
		}
		else
		{
			szTexture="./"+szTest1+"/"+szTest2;
		}
	}
	else
		szTexture = "Bad type";

	// change dyn bitmap
	pdtData.gcField<<SetBitmap(szTexture);
	pdtData.szTxt = szTexture;
}
func void FormBitmap_OnSelectSIndex(i32x _iSIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormBitmap pdtData;
	var i32x iTgaId;
	var szx szTexture;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iSIndex;
	pdtData.iRef = ROW_SORT;

	// Retrieve data from db
	if(Join_GetDataType(pdtData.iJoinId)==STRING_DATA)
		szTexture = Join_GetStringFromSortedIndex(pdtData.iJoinId,_iSIndex);
	else if(Join_GetDataType(pdtData.iJoinId)==INT_DATA)
	{
		iTgaId = Join_GetIntFromSortedIndex(pdtData.iJoinId,_iSIndex);
		szTexture="./"+Join_GetStringFromKey(g_oLocalJoins.m_iTga_szDirectory,iTgaId);
		szTexture=szTexture+"/"+Join_GetStringFromKey(g_oLocalJoins.m_iTga_szName,iTgaId);
	}
	else
		szTexture = "Bad type";

	// change dyn bitmap
	pdtData.gcField<<SetBitmap(szTexture);
	pdtData.szTxt = szTexture;
}
func void FormBitmap_OnSave()
{
	var Gui_Component pthis;
	var Gui_dtFormBitmap pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);
	// Todo
}

