func Gui_Component NewFormCheckbox(Gui_dtForm _pdtForm,i32x _iJoinId,szx _szCaption)
{
	var Gui_Component composite;
	var Gui_dtFormCheckbox pdtData;
	var i32x sx,sy;
	var szx szHeader;

	// Create an object that will contain Editbox + caption
	composite = NewObject(Gui_iFormCheckbox);
	// Affect data pointer
	pdtData = new Gui_dtFormCheckbox;
	SetData(composite,pdtData);

	// Three component in composite select
	SetComponentNumber(composite,2);

	// Create caption if wanted
	sx = 0;
	sy = 0;
	if(_pdtForm.smFontCaption)
	{
		pdtData.gcCaption = NewCaption(_pdtForm.smFontCaption,_szCaption);
		SetColor(pdtData.gcCaption, _pdtForm.iDefaultFontCaptionColor);
		sx = SizeX(pdtData.gcCaption);
		sy = SizeY(pdtData.gcCaption);
		pdtData.gcCaption<<Disable();
		MountComponent(composite,pdtData.gcCaption);
	}

	// Create join
	pdtData.iJoinId = _iJoinId;

	// Members init
	pdtData.bChecked = 0;
	pdtData.iFilterOp = g_iFilterOp_None;
	pdtData.bMajInform = _pdtForm.bMajInform;


	// Create checkbox
	pdtData.gcField = NewCheckbox(smLedGreen);
	MountComponent(composite,pdtData.gcField);

	// Move caption to correct pos
	if(_pdtForm.bCaptionAlign)
	{
		// align caption to _pdtform.iCaptionAlign and align field to _pdtform.iDefaultHAlign and iDefaultVAlign
		if(pdtData.gcCaption)
		{
			// set caption width
			StretchTo(pdtData.gcCaption, _pdtForm.iCaptionAlign, SizeY(pdtData.gcField));
			// move caption
			SetAlign(pdtData.gcCaption, _pdtForm.iCaption_HAlign, _pdtForm.iCaption_VAlign);
			//MoveTo(pdtData.gcCaption, -SizeX(pdtData.gcCaption), 0);
			MoveTo(pdtData.gcCaption, -(_pdtForm.iCaptionAlign+_pdtForm.iDefaultOffset), 0);
		}		
	}
	else
	if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Left)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Max))
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Right,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,-_pdtForm.iDefaultOffset-SizeX(pdtData.gcCaption),0);
		}
	}
	else if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Center)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Zoom))
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,_pdtForm.iDefaultFieldWidth,SizeY(pdtData.gcCaption));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Center,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,0,-(sy + _pdtForm.iDefaultOffset));
		}
	}
	else if(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Right)
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Left,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,sx + _pdtForm.iDefaultOffset + _pdtForm.iDefaultFieldWidth,0);
		}
	}


	// Stretch
	StretchTo(composite,SizeX(pdtData.gcField),SizeY(pdtData.gcField));
	
	return composite;
}
/* *************************************************
 * CHECK BOX FIELD
 *************************************************** */
func i32x FormCheckbox_OnDestroy()
{
	var Gui_Component pthis,parent;
	var Gui_dtFormCheckbox pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Destroy join
	parent = GetParent(pthis);
	if(parent)
	{
		parent<<FormDeleteJoin(pdtData.iJoinId);
	}
}

func void FormCheckbox_OnCheck(Gui_Component _pSender)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormCheckbox pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.bChecked = 1;

	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJCheckbox(pthis,pdtData.bChecked,true);

}

func void FormCheckbox_OnUncheck(Gui_Component _pSender)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormCheckbox pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.bChecked = 0;

	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJCheckbox(pthis,pdtData.bChecked,true);
}

func void FormCheckbox_OnSelectKey(i32x _iKey)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormCheckbox pdtData;
	var i32x iDataType,iRowIndex;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iKey;
	pdtData.iRef = ROW_KEY;
	iRowIndex = Join_GetRow(pdtData.iJoinId,pdtData.iRow,pdtData.iRef,ROW_INDEX);

	// Retrieve data from db
	// Retrieve data from db
	iDataType = Join_GetDataType(pdtData.iJoinId);
	if(iDataType == INT_DATA)
	{
		pdtData.bChecked = Join_GetIntFromIndex(pdtData.iJoinId,iRowIndex);
	}
	else
	{
		print("Bad checkbox type.\n");
	}

	// change check box
	if(pdtData.bChecked)
	{
		pdtData.gcField<<QuietCheck();
	}
	else
	{
		pdtData.gcField<<QuietUncheck();
	}

	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJCheckbox(pthis,pdtData.bChecked,false);
}
func void FormCheckbox_OnSelectIndex(i32x _iIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormCheckbox pdtData;
	var i32x iDataType;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iIndex;
	pdtData.iRef = ROW_INDEX;

	// Retrieve data from db
	iDataType = Join_GetDataType(pdtData.iJoinId);
	if(iDataType == INT_DATA)
	{
		pdtData.bChecked = Join_GetIntFromIndex(pdtData.iJoinId,_iIndex);
	}
	else
	{
		print("Bad checkbox type.\n");
	}

	// change check box
	if(pdtData.bChecked)
	{
		pdtData.gcField<<QuietCheck();
	}
	else
	{
		pdtData.gcField<<QuietUncheck();
	}

	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJCheckbox(pthis,pdtData.bChecked,false);
}
func void FormCheckbox_OnSelectSIndex(i32x _iSIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormCheckbox pdtData;
	var i32x iDataType,iRowIndex;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iSIndex;
	pdtData.iRef = ROW_SORT;
	iRowIndex = Join_GetRow(pdtData.iJoinId,pdtData.iRow,pdtData.iRef,ROW_INDEX);

	// Retrieve data from db
	iDataType = Join_GetDataType(pdtData.iJoinId);
	if(iDataType == INT_DATA)
	{
		pdtData.bChecked = Join_GetIntFromIndex(pdtData.iJoinId,iRowIndex);
	}
	else
	{
		print("Bad checkbox type.\n");
	}

	// change check box
	if(pdtData.bChecked)
	{
		pdtData.gcField<<QuietCheck();
	}
	else
	{
		pdtData.gcField<<QuietUncheck();
	}

	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJCheckbox(pthis,pdtData.bChecked,false);
}
func void FormCheckbox_OnSave()
{
	var Gui_Component pthis;
	var Gui_dtFormCheckbox pdtData;
	var i32x iDataType,iRetId,iRowIndex;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if((!IsHidden(pthis))&&(IsEnabled(pthis)))
	{
		iDataType = Join_GetDataType(pdtData.iJoinId);

		iRowIndex = Join_GetRow(pdtData.iJoinId,pdtData.iRow,pdtData.iRef,ROW_INDEX);

		if(iDataType == INT_DATA)
		{
			Join_SetIntFromIndex(pdtData.iJoinId,iRowIndex,pdtData.bChecked);
		}
		else
		{
			print("Can't save : Bad checkbox type.\n");
		}
	}
}
func void FormCheckbox_LinkQuery(i32x _iQueryId)
{
	var Gui_Component pthis;
	var Gui_dtFormCheckbox pdtData;
	var i32x iLength,iLength2;
	var szx szJoin;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Retrieve join table
	szJoin = Join_GetDesc(pdtData.iJoinId);
	iLength2 = strlen(szJoin);
	iLength = strlen(Join_GetDataDesc(pdtData.iJoinId));
	iLength = iLength2-iLength;
	szJoin = strncpy(szJoin,0,iLength-1);

	// Add join table
	Query_SelectTable(_iQueryId,szJoin);
}

func void FormCheckbox_LinkFilter(i32x _iQueryId)
{
	var Gui_Component pthis;
	var Gui_dtFormCheckbox pdtData;
	var szx szJoin;
	var i32x iDataType;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Retrieve join table
	szJoin = Join_GetDesc(pdtData.iJoinId);
	iDataType = Join_GetDataType(pdtData.iJoinId);

	// Add join table
	FormCheckbox_LinkQuery(_iQueryId);
	if(iDataType == INT_DATA)
	{
		if(pdtData.iFilterOp == g_iFilterOp_Less)
		{
			Query_SelectWhereIntLessThan(_iQueryId,szJoin, pdtData.bFChecked);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Equal)
		{
			Query_SelectWhereIntEqual(_iQueryId,szJoin, pdtData.bFChecked);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Greater)
		{
			Query_SelectWhereIntGreaterThan(_iQueryId,szJoin, pdtData.bFChecked);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Different)
		{
			Query_SelectWhereIntDifferent(0,szJoin, pdtData.bFChecked);
		}
	}
}

func void FormCheckbox_FilterByInt(i32x _iOp,i32x _iValue)
{
	var Gui_Component pthis;
	var Gui_dtFormCheckbox pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iFilterOp = _iOp;
	pdtData.bFChecked = _iValue;
}
