func Gui_Component NewFormFieldExt(Gui_dtForm _pdtForm,i32x _iJoinId,szx _szCaption)
{
	var Gui_Component composite;
	var Gui_dtFormField pdtData;
	var i32x sx,sy;
	var szx szHeader;

	// Create an object that will contain Editbox + caption
	composite = NewObject(Gui_iFormField);
	// Affect data pointer
	pdtData = new Gui_dtFormField;
	SetData(composite,pdtData);

	// Three component in composite select
	SetComponentNumber(composite,2);

	// Create caption if wanted
	sx = 0;
	sy = 0;
	if((_pdtForm.smFontCaption)&&(strlen(_szCaption)>0))
	{
		pdtData.gcCaption = NewCaption(_pdtForm.smFontCaption,_szCaption);
		SetColor(pdtData.gcCaption, _pdtForm.iDefaultFontCaptionColor);
		sx = SizeX(pdtData.gcCaption);
		sy = SizeY(pdtData.gcCaption);
		// Make caption transparent to Title message (see windows)
		Transparent(pdtData.gcCaption);
		MountComponent(composite,pdtData.gcCaption);
	}

	pdtData.iFilterOp = g_iFilterOp_None;
	pdtData.bMajInform = _pdtForm.bMajInform;

	pdtData.iFormatType = _pdtForm.iFormatType;// HMS display or factor display
	pdtData.fFactor = _pdtForm.fFactor;// factor display

	// Create join
	pdtData.iJoinId = _iJoinId;

	// Text init
	szHeader = strncpy(Join_GetDataDesc(pdtData.iJoinId),0,10);
	if(!strcmp(szHeader,"gene_strID"))
	{
		pdtData.iLocalized = 1;
	}
	else
	{
		pdtData.iLocalized = 0;
		szHeader = strncpy(Join_GetDataDesc(pdtData.iJoinId),0,12);
		if(!strcmp(szHeader,"fkIDformated"))
		{
			pdtData.iFormated = 1;
		}
		else
		{
			pdtData.iFormated = 0;
		}
	}

	pdtData.szTxt = "";
	pdtData.iDecimal = _pdtForm.iDefaultDecimal;

	// Create EditBox
	pdtData.gcField = NewEditBox(_pdtForm.smFontField,_pdtForm.iDefaultFieldColor);
	pdtData.gcField<<EbCResize(_pdtForm.iDefaultFieldWidth,GetAreaHeight(_pdtForm.smFontField,13));
	MountComponent(composite,pdtData.gcField);

	if(Join_GetDataType(pdtData.iJoinId) != STRING_DATA)
	{
		// Set edit box to numeric only
		pdtData.gcField<<EbCChangeType(e_GUI_EditBox_Numeric);
	}

	// Move field to correct pos
	pdtData.gcField<<EbCAlign(_pdtForm.iDefaultHAlign,_pdtForm.iDefaultVAlign);
	if(_pdtForm.bCaptionAlign)
	{
		// align caption to _pdtform.iCaptionAlign and align field to _pdtform.iDefaultHAlign and iDefaultVAlign
		if(pdtData.gcCaption)
		{
			// set caption width
			StretchTo(pdtData.gcCaption, _pdtForm.iCaptionAlign, SizeY(pdtData.gcField));
			// move caption
			SetAlign(pdtData.gcCaption, _pdtForm.iCaption_HAlign, _pdtForm.iCaption_VAlign);
			//MoveTo(pdtData.gcCaption, -SizeX(pdtData.gcCaption), 0);
			MoveTo(pdtData.gcCaption, -(_pdtForm.iCaptionAlign+_pdtForm.iDefaultOffset), 0);
		}		
	}
	else
	{
		if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Left)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Max))
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Right,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,-_pdtForm.iDefaultOffset-SizeX(pdtData.gcCaption),0);
			}
		}
		else if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Center)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Zoom))
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,_pdtForm.iDefaultFieldWidth,SizeY(pdtData.gcCaption));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Center,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,0,-(sy + _pdtForm.iDefaultOffset));
			}
		}
		else if(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Right)
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Left,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,sx + _pdtForm.iDefaultOffset + _pdtForm.iDefaultFieldWidth,0);
			}
		}
	}

	// Stretch
	StretchTo(composite,SizeX(pdtData.gcField),SizeY(pdtData.gcField));
	
	return composite;
}
func i32x FormField_OnDestroy()
{
	var Gui_Component pthis,parent;
	var Gui_dtFormField pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Destroy join
	parent = GetParent(pthis);
	if(parent)
	{
		parent<<FormDeleteJoin(pdtData.iJoinId);
	}
}
func i32x FormField_OnEnable()
{
	var Gui_Component pthis,parent;
	var Gui_dtFormField pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Disable field
	pdtData.gcField<<Enable();

}
func i32x FormField_OnDisable()
{
	var Gui_Component pthis,parent;
	var Gui_dtFormField pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Disable field
	pdtData.gcField<<Disable();
}

func void FormField_CaptionClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pform;
	var Gui_dtFormField pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if(_pComponent == pdtData.gcCaption)
	{
		if((pdtData.iSortDir == 0)||(pdtData.iSortDir == -1))
		{
			pdtData.iSortDir = 1;
		}
		else
		{
			pdtData.iSortDir = -1;

		}
		// Send sort message to form
		pform = GetParent(pthis);
		if(pform) pform<<FormSortById(pdtData.iJoinId,pdtData.iSortDir);
	}
}

func void FormField_OnSelectKey(i32x _iKey)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormField pdtData;
	var szx szValue;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iKey;
	pdtData.iRef = ROW_KEY;
	// get form
	parent = GetParent(pthis);

	// Retrieve data from db
	if(Join_GetDataType(pdtData.iJoinId)==STRING_DATA)
	{
		szValue = Join_GetStringFromKey(pdtData.iJoinId,_iKey);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJString(pthis,pdtData.szTxt,false);
	}
	else if(Join_GetDataType(pdtData.iJoinId)==INT_DATA)
	{
		var i32x iValue;
		iValue = Join_GetIntFromKey(pdtData.iJoinId,_iKey);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJInt(pthis,iValue,false);

		if(pdtData.iLocalized==0)
		{
			if(pdtData.iFormated==1)
			{
				szValue = GetFormatedStringFromKey(iValue);
				szValue = EvalFormatedString(szValue, 256);
			}
			else
			{
				szValue = itoa(iValue);
			}
		}
		else
			szValue = GetLocalizedFromKey(iValue);
	}
	else if(Join_GetDataType(pdtData.iJoinId)==FLOAT_DATA)
	{
		var f32x fValue;
		fValue = Join_GetFloatFromKey(pdtData.iJoinId,_iKey);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJFloat(pthis,fValue,false);

		if(pdtData.iFormatType == g_iConst_FormatNormal)
		{
			szValue = Formattedftoa(fValue,3,pdtData.iDecimal);
		}
		else if(pdtData.iFormatType == g_iConst_FormatHMS)
		{
			szValue = GetHMS(fValue);
		}
		else if(pdtData.iFormatType == g_iConst_FormatFactor)
		{
			szValue = Formattedftoa(fValue*pdtData.fFactor,3,pdtData.iDecimal);
		}
		else if(pdtData.iFormatType== g_iConst_FormatHMSOffset)
		{
			if(fValue==0.0)
				szValue = "NC";
			else
			{
				if(fValue != pdtData.fFactor)
					fValue = fValue - pdtData.fFactor;
				szValue = GetHMS(fValue);
			}
		}
	}
	else if(Join_GetDataType(pdtData.iJoinId)==LISTFLOAT_DATA)
	{
		var i32x i,iNumValues;
		var f32x fValue;
		var szx szTmp;
		szValue = "";
		iNumValues = Join_GetListSizeFromKey(pdtData.iJoinId,_iKey);

		if(pdtData.bMajInform)
		{
			if(iNumValues>0)
			{
				fValue = Join_GetListFloatDataFromKey(pdtData.iJoinId,_iKey,0);
				if(parent)
					parent<<FormMaJFloat(pthis,fValue,false);
			}
		}
		i=0;
		while(i<iNumValues)
		{
			fValue = Join_GetListFloatDataFromKey(pdtData.iJoinId,_iKey,i);

			if(pdtData.iFormatType == g_iConst_FormatNormal)
			{
				szTmp = Formattedftoa(fValue,3,pdtData.iDecimal);
			}
			else if(pdtData.iFormatType == g_iConst_FormatHMS)
			{
				szTmp = GetHMS(fValue);
			}
			else if(pdtData.iFormatType == g_iConst_FormatFactor)
			{
				szTmp = Formattedftoa(fValue*pdtData.fFactor,3,pdtData.iDecimal);
			}
			else if(pdtData.iFormatType== g_iConst_FormatHMSOffset)
			{
				if(fValue==0.0)
					szTmp = "NC";
				else
				{
					if(fValue != pdtData.fFactor)
						fValue = fValue - pdtData.fFactor;
					szTmp = GetHMS(fValue);
				}
			}
			if(i>0)
				szValue = szValue + ", " + szTmp;
			else 
				szValue = szTmp;
			i=i+1;
		}
	}
	else if(Join_GetDataType(pdtData.iJoinId)==LISTINTDATA)
	{
		var i32x i,iNumValues;
		var i32x iValue;
		var szx szTmp;
		szValue = "";
		iNumValues = Join_GetListSizeFromKey(pdtData.iJoinId,_iKey);

		if(pdtData.bMajInform)
		{
			if(iNumValues>0)
			{
				iValue = Join_GetListIntDataFromKey(pdtData.iJoinId,_iKey,0);
				if(parent)
					parent<<FormMaJInt(pthis,iValue,false);
			}
		}
		i=0;
		while(i<iNumValues)
		{
			iValue = Join_GetListIntDataFromKey(pdtData.iJoinId,_iKey,i);
			szTmp = itoa(iValue);
			if(i>0)
				szValue = szValue + ", " + szTmp;
			else 
				szValue = szTmp;
			i=i+1;
		}
	}
	else
		szValue = "Bad type";

	// change editbox
	pdtData.gcField<<EbCText(szValue);
	pdtData.szTxt = szValue;
}
func void FormField_OnSelectIndex(i32x _iIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormField pdtData;
	var szx szValue;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iIndex;
	pdtData.iRef = ROW_INDEX;
	// get form
	parent = GetParent(pthis);

	// Retrieve data from db
	if(Join_GetDataType(pdtData.iJoinId)==STRING_DATA)
	{
		szValue = Join_GetStringFromIndex(pdtData.iJoinId,_iIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJString(pthis,pdtData.szTxt,false);
	}
	else if(Join_GetDataType(pdtData.iJoinId)==INT_DATA)
	{
		var i32x iValue;
		iValue = Join_GetIntFromIndex(pdtData.iJoinId,_iIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJInt(pthis,iValue,false);
		if(pdtData.iLocalized==0)
		{
			if(pdtData.iFormated==1)
			{
				szValue = GetFormatedStringFromKey(iValue);
				szValue = EvalFormatedString(szValue, 256);
			}
			else
			{
				szValue = itoa(iValue);
			}
		}
		else
			szValue = GetLocalizedFromKey(iValue);
	}
	else if(Join_GetDataType(pdtData.iJoinId)==FLOAT_DATA)
	{
		var f32x fValue;
		fValue = Join_GetFloatFromIndex(pdtData.iJoinId,_iIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJFloat(pthis,fValue,false);
		if(pdtData.iFormatType == g_iConst_FormatNormal)
		{
			szValue = Formattedftoa(fValue,3,pdtData.iDecimal);
		}
		else if(pdtData.iFormatType == g_iConst_FormatHMS)
		{
			szValue = GetHMS(fValue);
		}
		else if(pdtData.iFormatType == g_iConst_FormatFactor)
		{
			szValue = Formattedftoa(fValue*pdtData.fFactor,3,pdtData.iDecimal);
		}
		else if(pdtData.iFormatType== g_iConst_FormatHMSOffset)
		{
			if(fValue==0.0)
				szValue = "NC";
			else
			{
				if(fValue != pdtData.fFactor)
					fValue = fValue - pdtData.fFactor;
				szValue = GetHMS(fValue);
			}
		}
	}
	else if(Join_GetDataType(pdtData.iJoinId)==LISTFLOAT_DATA)
	{
		var i32x i,iNumValues;
		var f32x fValue;
		var szx szTmp;
		szValue = "";
		iNumValues = Join_GetListSizeFromIndex(pdtData.iJoinId,_iIndex);

		if(pdtData.bMajInform)
		{
			if(iNumValues>0)
			{
				fValue = Join_GetListFloatDataFromIndex(pdtData.iJoinId,_iIndex,0);
				if(parent)
					parent<<FormMaJFloat(pthis,fValue,false);
			}
		}
		i=0;
		while(i<iNumValues)
		{
			fValue = Join_GetListFloatDataFromIndex(pdtData.iJoinId,_iIndex,i);

			if(pdtData.iFormatType == g_iConst_FormatNormal)
			{
				szTmp = Formattedftoa(fValue,3,pdtData.iDecimal);
			}
			else if(pdtData.iFormatType == g_iConst_FormatHMS)
			{
				szTmp = GetHMS(fValue);
			}
			else if(pdtData.iFormatType == g_iConst_FormatFactor)
			{
				szTmp = Formattedftoa(fValue*pdtData.fFactor,3,pdtData.iDecimal);
			}
			else if(pdtData.iFormatType== g_iConst_FormatHMSOffset)
			{
				if(fValue==0.0)
					szTmp = "NC";
				else
				{
					if(fValue != pdtData.fFactor)
						fValue = fValue - pdtData.fFactor;
					szTmp = GetHMS(fValue);
				}
			}
			if(i>0)
				szValue = szValue + ", " + szTmp;
			else 
				szValue = szTmp;

			i=i+1;
		}
	}
	else if(Join_GetDataType(pdtData.iJoinId)==LISTINTDATA)
	{
		var i32x i,iNumValues;
		var i32x iValue;
		var szx szTmp;
		szValue = "";
		iNumValues = Join_GetListSizeFromIndex(pdtData.iJoinId,_iIndex);

		if(pdtData.bMajInform)
		{
			if(iNumValues>0)
			{
				iValue = Join_GetListIntDataFromIndex(pdtData.iJoinId,_iIndex,0);
				if(parent)
					parent<<FormMaJInt(pthis,iValue,false);
			}
		}
		i=0;
		while(i<iNumValues)
		{
			iValue = Join_GetListIntDataFromIndex(pdtData.iJoinId,_iIndex,i);
			szTmp = itoa(iValue);
			if(i>0)
				szValue = szValue + ", " + szTmp;
			else 
				szValue = szTmp;
			i=i+1;
		}
	}
	else
		szValue = "Bad type";

	// change editbox
	pdtData.gcField<<EbCText(szValue);
	pdtData.szTxt = szValue;
}
func void FormField_OnSelectSIndex(i32x _iSIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormField pdtData;
	var szx szValue;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iSIndex;
	pdtData.iRef = ROW_SORT;
	// get form
	parent = GetParent(pthis);

	// Retrieve data from db
	if(Join_GetDataType(pdtData.iJoinId)==STRING_DATA)
	{
		szValue = Join_GetStringFromSortedIndex(pdtData.iJoinId,_iSIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJString(pthis,pdtData.szTxt,false);
	}
	else if(Join_GetDataType(pdtData.iJoinId)==INT_DATA)
	{
		var i32x iValue;
		iValue = Join_GetIntFromSortedIndex(pdtData.iJoinId,_iSIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJInt(pthis,iValue,false);
		if(pdtData.iLocalized==0)
		{
			if(pdtData.iFormated==1)
			{
				szValue = GetFormatedStringFromKey(iValue);
				szValue = EvalFormatedString(szValue, 256);
			}
			else
			{
				szValue = itoa(iValue);
			}
		}
		else
			szValue = GetLocalizedFromKey(iValue);
	}
	else if(Join_GetDataType(pdtData.iJoinId)==FLOAT_DATA)
	{
		var f32x fValue;
		fValue = Join_GetFloatFromSortedIndex(pdtData.iJoinId,_iSIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJFloat(pthis,fValue,false);
		if(pdtData.iFormatType == g_iConst_FormatNormal)
		{
			szValue = Formattedftoa(fValue,3,pdtData.iDecimal);
		}
		else if(pdtData.iFormatType == g_iConst_FormatHMS)
		{
			szValue = GetHMS(fValue);
		}
		else if(pdtData.iFormatType == g_iConst_FormatFactor)
		{
			szValue = Formattedftoa(fValue*pdtData.fFactor,3,pdtData.iDecimal);
		}
		else if(pdtData.iFormatType== g_iConst_FormatHMSOffset)
		{
			if(fValue==0.0)
				szValue = "NC";
			else
			{
				if(fValue != pdtData.fFactor)
					fValue = fValue - pdtData.fFactor;
				szValue = GetHMS(fValue);
			}
		}
	}
	else if(Join_GetDataType(pdtData.iJoinId)==LISTFLOAT_DATA)
	{
		var i32x iRowIndex;
		var i32x i,iNumValues;
		var f32x fValue;
		var szx szTmp;
		szValue = "";
		iRowIndex = Join_GetRow(pdtData.iJoinId,_iSIndex,ROW_SORT,ROW_INDEX);
		iNumValues = Join_GetListSizeFromIndex(pdtData.iJoinId,iRowIndex);

		if(pdtData.bMajInform)
		{
			if(iNumValues>0)
			{
				fValue = Join_GetListFloatDataFromIndex(pdtData.iJoinId,iRowIndex,0);
				if(parent)
					parent<<FormMaJFloat(pthis,fValue,false);
			}
		}
		i=0;
		while(i<iNumValues)
		{
			fValue = Join_GetListFloatDataFromIndex(pdtData.iJoinId,iRowIndex,i);

			if(pdtData.iFormatType == g_iConst_FormatNormal)
			{
				szTmp = Formattedftoa(fValue,3,pdtData.iDecimal);
			}
			else if(pdtData.iFormatType == g_iConst_FormatHMS)
			{
				szTmp = GetHMS(fValue);
			}
			else if(pdtData.iFormatType == g_iConst_FormatFactor)
			{
				szTmp = Formattedftoa(fValue*pdtData.fFactor,3,pdtData.iDecimal);
			}
			else if(pdtData.iFormatType== g_iConst_FormatHMSOffset)
			{
				if(fValue==0.0)
					szTmp = "NC";
				else
				{
					if(fValue != pdtData.fFactor)
						fValue = fValue - pdtData.fFactor;
					szTmp = GetHMS(fValue);
				}
			}
			if(i>0)
				szValue = szValue + ", " + szTmp;
			else 
				szValue = szTmp;
			i=i+1;
		}
	}
	else if(Join_GetDataType(pdtData.iJoinId)==LISTINTDATA)
	{
		var i32x iRowIndex;
		var i32x i,iNumValues;
		var i32x iValue;
		var szx szTmp;
		szValue = "";
		iRowIndex = Join_GetRow(pdtData.iJoinId,_iSIndex,ROW_SORT,ROW_INDEX);
		iNumValues = Join_GetListSizeFromIndex(pdtData.iJoinId,iRowIndex);

		if(pdtData.bMajInform)
		{
			if(iNumValues>0)
			{
				iValue = Join_GetListIntDataFromIndex(pdtData.iJoinId,iRowIndex,0);
				if(parent)
					parent<<FormMaJInt(pthis,iValue,false);
			}
		}
		i=0;
		while(i<iNumValues)
		{
			iValue = Join_GetListIntDataFromIndex(pdtData.iJoinId,iRowIndex,i);
			szTmp = itoa(iValue);
			if(i>0)
				szValue = szValue + ", " + szTmp;
			else 
				szValue = szTmp;
			i=i+1;
		}
	}
	else
		szValue = "Bad type";

	// change editbox
	pdtData.gcField<<EbCText(szValue);
	pdtData.szTxt = szValue;
}
func void FormField_OnEbSaveData(Gui_Component _pComponent, szx _szTxt, i32x _iChangeBox)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormField pdtData;
	var i32x iDataType,iValue;
	var f32x fValue;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);
	if(pdtData.gcField == _pComponent)
	{
		// get form
		parent = GetParent(pthis);
		iDataType = Join_GetDataType(pdtData.iJoinId);
		if(iDataType==STRING_DATA)
		{
			pdtData.szTxt = _szTxt;
			if(parent&&pdtData.bMajInform)
				parent<<FormMaJString(pthis,pdtData.szTxt,true);
		}
		else if(iDataType==INT_DATA)
		{
			iValue = atoi(_szTxt); 
			if(parent&&pdtData.bMajInform)
				parent<<FormMaJInt(pthis,iValue,true);
			pdtData.szTxt = itoa(iValue);
			pdtData.gcField<<EbCText(pdtData.szTxt);
		}
		else if(iDataType==FLOAT_DATA)
		{
			fValue = atof(_szTxt);
			if(parent&&pdtData.bMajInform)
				parent<<FormMaJFloat(pthis,fValue,true);

			if(pdtData.iFormatType == g_iConst_FormatNormal)
			{
				pdtData.szTxt = Formattedftoa(fValue,3,pdtData.iDecimal);
			}
			else if(pdtData.iFormatType == g_iConst_FormatHMS)
			{
				pdtData.szTxt = GetHMS(fValue);
			}
			else if(pdtData.iFormatType == g_iConst_FormatFactor)
			{
				pdtData.szTxt = Formattedftoa(fValue*pdtData.fFactor,3,pdtData.iDecimal);
			}
			pdtData.gcField<<EbCText(pdtData.szTxt);
		}
	}
}

func void FormField_OnSave()
{
	var Gui_Component pthis;
	var Gui_dtFormField pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if((!IsHidden(pthis))&&(IsEnabled(pthis)))
	{
		if(pdtData.iRef == ROW_INDEX)
		{
			// Retrieve data from db
			if(Join_GetDataType(pdtData.iJoinId)==STRING_DATA)
				Join_SetStringFromIndex(pdtData.iJoinId,pdtData.iRow,pdtData.szTxt);
			else if(Join_GetDataType(pdtData.iJoinId)==INT_DATA)
				Join_SetIntFromIndex(pdtData.iJoinId,pdtData.iRow,atoi(pdtData.szTxt));
			else if(Join_GetDataType(pdtData.iJoinId)==FLOAT_DATA)
			{
				var f32x fValue;
				fValue = atof(pdtData.szTxt);
				if(pdtData.iFormatType == g_iConst_FormatNormal)
				{
					Join_SetFloatFromIndex(pdtData.iJoinId,pdtData.iRow,fValue);
				}
				else if(pdtData.iFormatType == g_iConst_FormatHMS)
				{
					print("Warning : HMS->f32x not implemented\n");
					Join_SetFloatFromIndex(pdtData.iJoinId,pdtData.iRow,fValue);
				}
				else if(pdtData.iFormatType == g_iConst_FormatFactor)
				{
					if(pdtData.fFactor!=0.0)
						Join_SetFloatFromIndex(pdtData.iJoinId,pdtData.iRow,fValue/pdtData.fFactor);
					else
					{
						print("Warning : Null factor\n");
						Join_SetFloatFromIndex(pdtData.iJoinId,pdtData.iRow,fValue);
					}
				}
			}
		}
		else if(pdtData.iRef == ROW_KEY)
		{
			// Retrieve data from db
			if(Join_GetDataType(pdtData.iJoinId)==STRING_DATA)
				Join_SetStringFromKey(pdtData.iJoinId,pdtData.iRow,pdtData.szTxt);
			else if(Join_GetDataType(pdtData.iJoinId)==INT_DATA)
				Join_SetIntFromKey(pdtData.iJoinId,pdtData.iRow,atoi(pdtData.szTxt));
			else if(Join_GetDataType(pdtData.iJoinId)==FLOAT_DATA)
			{
				var f32x fValue;
				fValue = atof(pdtData.szTxt);
				if(pdtData.iFormatType == g_iConst_FormatNormal)
				{
					Join_SetFloatFromKey(pdtData.iJoinId,pdtData.iRow,fValue);
				}
				else if(pdtData.iFormatType == g_iConst_FormatHMS)
				{
					print("Warning : HMS->f32x not implemented\n");
					Join_SetFloatFromKey(pdtData.iJoinId,pdtData.iRow,fValue);
				}
				else if(pdtData.iFormatType == g_iConst_FormatFactor)
				{
					if(pdtData.fFactor!=0.0)
						Join_SetFloatFromKey(pdtData.iJoinId,pdtData.iRow,fValue/pdtData.fFactor);
					else
					{
						print("Warning : Null factor\n");
						Join_SetFloatFromKey(pdtData.iJoinId,pdtData.iRow,fValue);
					}
				}
			}
		}
		else if(pdtData.iRef == ROW_SORT)
		{
			var i32x iRow;
			iRow = Join_GetRow(pdtData.iJoinId, pdtData.iRow, ROW_SORT, ROW_INDEX );
			if(Join_GetDataType(pdtData.iJoinId)==STRING_DATA)
				Join_SetStringFromIndex(pdtData.iJoinId,iRow,pdtData.szTxt);
			else if(Join_GetDataType(pdtData.iJoinId)==INT_DATA)
				Join_SetIntFromIndex(pdtData.iJoinId,iRow,atoi(pdtData.szTxt));
			else if(Join_GetDataType(pdtData.iJoinId)==FLOAT_DATA)
			{
				var f32x fValue;
				fValue = atof(pdtData.szTxt);
				if(pdtData.iFormatType == g_iConst_FormatNormal)
				{
					Join_SetFloatFromIndex(pdtData.iJoinId,iRow,fValue);
				}
				else if(pdtData.iFormatType == g_iConst_FormatHMS)
				{
					print("Warning : HMS->f32x not implemented\n");
					Join_SetFloatFromIndex(pdtData.iJoinId,iRow,fValue);
				}
				else if(pdtData.iFormatType == g_iConst_FormatFactor)
				{
					if(pdtData.fFactor!=0.0)
						Join_SetFloatFromIndex(pdtData.iJoinId,iRow,fValue/pdtData.fFactor);
					else
					{
						print("Warning : Null factor\n");
						Join_SetFloatFromIndex(pdtData.iJoinId,iRow,fValue);
					}
				}
			}
		}
	}
}
func void FormField_LinkQuery(i32x _iQueryId)
{
	var Gui_Component pthis;
	var Gui_dtFormField pdtData;
	var i32x iLength,iLength2;
	var szx szJoin;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Retrieve join table
	szJoin = Join_GetDesc(pdtData.iJoinId);
	iLength2 = strlen(szJoin);
	iLength = strlen(Join_GetDataDesc(pdtData.iJoinId));
	iLength = iLength2-iLength;
	szJoin = strncpy(szJoin,0,iLength-1);

	// Add join table
	Query_SelectTable(_iQueryId,szJoin);
}
func void FormField_LinkFilter(i32x _iQueryId)
{
	var Gui_Component pthis;
	var Gui_dtFormField pdtData;
	var szx szJoin;
	var i32x iDataType;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Retrieve join table
	szJoin = Join_GetDesc(pdtData.iJoinId);
	iDataType = Join_GetDataType(pdtData.iJoinId);

	// Add join table
	FormField_LinkQuery(_iQueryId);
	if(iDataType == INT_DATA)
	{
		if(pdtData.iFilterOp == g_iFilterOp_Less)
		{
			Query_SelectWhereIntLessThan(_iQueryId,szJoin, pdtData.iFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Equal)
		{
			Query_SelectWhereIntEqual(_iQueryId,szJoin, pdtData.iFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Greater)
		{
			Query_SelectWhereIntGreaterThan(_iQueryId,szJoin, pdtData.iFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Different)
		{
			Query_SelectWhereIntDifferent(0,szJoin, pdtData.iFValue);
		}
	}
	else if(iDataType == FLOAT_DATA)
	{
		if(pdtData.iFilterOp == g_iFilterOp_Less)
		{
			Query_SelectWhereFloatLessThan(_iQueryId,szJoin, pdtData.fFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Equal)
		{
			Query_SelectWhereFloatEqual(_iQueryId,szJoin, pdtData.fFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Greater)
		{
			Query_SelectWhereFloatGreaterThan(_iQueryId,szJoin, pdtData.fFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Different)
		{
			Query_SelectWhereFloatDifferent(0,szJoin, pdtData.fFValue);
		}
	}
	else if(iDataType == STRING_DATA)
	{
		if(pdtData.iFilterOp == g_iFilterOp_Less)
		{
			Query_SelectWhereStringLessThan(_iQueryId,szJoin, pdtData.szFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Equal)
		{
			Query_SelectWhereStringEqual(_iQueryId,szJoin, pdtData.szFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Greater)
		{
			Query_SelectWhereStringGreaterThan(_iQueryId,szJoin, pdtData.szFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Different)
		{
			Query_SelectWhereStringDifferent(0,szJoin, pdtData.szFValue);
		}
	}
}

func void FormField_FilterByInt(i32x _iOp,i32x _iValue)
{
	var Gui_Component pthis;
	var Gui_dtFormField pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iFilterOp = _iOp;
	pdtData.iFValue = _iValue;
}
func void FormField_FilterByFloat(i32x _iOp,f32x _fValue)
{
	var Gui_Component pthis;
	var Gui_dtFormField pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iFilterOp = _iOp;
	pdtData.fFValue = _fValue;
}
func void FormField_FilterByString(i32x _iOp,szx _szValue)
{
	var Gui_Component pthis;
	var Gui_dtFormField pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iFilterOp = _iOp;
	pdtData.szFValue = _szValue;
}

func void FormField_SetCaption(szx _szCaption)
{
	var Gui_Component pthis;
	var Gui_dtFormField pdtData;
	var i32x iDataType,iValue;
	var f32x fValue;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	iDataType = Join_GetDataType(pdtData.iJoinId);
	if(iDataType==STRING_DATA)
	{
		pdtData.szTxt = _szCaption;
	}
	else if(iDataType==INT_DATA)
	{
		iValue = atoi(_szCaption); 
		pdtData.szTxt = itoa(iValue);
		pdtData.gcField<<EbCText(pdtData.szTxt);
	}
	else if(iDataType==FLOAT_DATA)
	{
		fValue = atof(_szCaption);
		pdtData.szTxt = ftoa(fValue);
		pdtData.gcField<<EbCText(pdtData.szTxt);
	}
}

// Format field
func Gui_Component NewFormFormatField(Gui_dtForm _pdtForm,i32x _iJoinId,i32x _iFormatId,szx _szCaption)
{
	var Gui_Component composite;
	var Gui_dtFormFormatField pdtData;
	var i32x sx,sy;
	var szx szHeader;

	// Create an object that will contain Editbox + caption
	composite = NewObject(Gui_iFormFormatField);
	// Affect data pointer
	pdtData = new Gui_dtFormFormatField;
	SetData(composite,pdtData);

	pdtData.iFormatedId = _iFormatId;
	pdtData.iJoinId = _iJoinId;

	// Three component in composite select
	SetComponentNumber(composite,2);

	// Create caption if wanted
	sx = 0;
	sy = 0;
	if((_pdtForm.smFontCaption)&&(strlen(_szCaption)>0))
	{
		pdtData.gcCaption = NewCaption(_pdtForm.smFontCaption,_szCaption);
		sx = SizeX(pdtData.gcCaption);
		sy = SizeY(pdtData.gcCaption);
		// Make caption transparent to Title message (see windows)
		Transparent(pdtData.gcCaption);
		MountComponent(composite,pdtData.gcCaption);
	}

	// Create EditBox
	pdtData.gcField = NewEditBox(_pdtForm.smFontField,_pdtForm.iDefaultFieldColor);
	pdtData.gcField<<EbCResize(_pdtForm.iDefaultFieldWidth,GetAreaHeight(_pdtForm.smFontField,13));
	MountComponent(composite,pdtData.gcField);

	// Move field to correct pos
	pdtData.gcField<<EbCAlign(_pdtForm.iDefaultHAlign,_pdtForm.iDefaultVAlign);
	if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Left)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Max))
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Right,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,-_pdtForm.iDefaultOffset-SizeX(pdtData.gcCaption),0);
		}
	}
	else if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Center)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Zoom))
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,_pdtForm.iDefaultFieldWidth,SizeY(pdtData.gcCaption));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Center,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,0,-(sy + _pdtForm.iDefaultOffset));
		}
	}
	else if(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Right)
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Left,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,sx + _pdtForm.iDefaultOffset + _pdtForm.iDefaultFieldWidth,0);
		}
	}

	// Stretch
	StretchTo(composite,SizeX(pdtData.gcField),SizeY(pdtData.gcField));
	
	return composite;
}

func void FormFormatField_OnSelectRow(i32x _iIndex)
{
	var Gui_Component pthis;
	var Gui_dtFormFormatField pdtData;
	var szx szValue;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Eval formated string
	szValue = GetFormatedStringFromKey(pdtData.iFormatedId);
	szValue = EvalFormatedString(szValue, 256);

	// change editbox
	pdtData.gcField<<EbCText(szValue);
}
func i32x FormFormatField_OnDestroy()
{
	var Gui_Component pthis,parent;
	var Gui_dtFormFormatField pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Destroy join
	parent = GetParent(pthis);
	if(parent)
	{
		parent<<FormDeleteJoin(pdtData.iJoinId);
	}
}
func void FormFormatField_CaptionClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pform;
	var Gui_dtFormFormatField pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if(_pComponent == pdtData.gcCaption)
	{
		if((pdtData.iSortDir == 0)||(pdtData.iSortDir == -1))
		{
			pdtData.iSortDir = 1;
		}
		else
		{
			pdtData.iSortDir = -1;

		}
		// Send sort message to form
		pform = GetParent(pthis);
		if(pform) pform<<FormSortById(pdtData.iJoinId,pdtData.iSortDir);
	}
}

