func Gui_Component NewFormGaugeV(Gui_dtForm _pdtForm,i32x _iJoinId,szx _szCaption,f32x _fMinValue,f32x _fMaxValue,f32x _fIncrement)
{
	var Gui_Component composite;
	var Gui_dtFormGauge pdtData;
	var Gui_dtGaugeComposite pdtField;
	var i32x sx,sy;
	var szx szHeader;

	// Create an object that will contain Gauge + caption
	composite = NewObject(Gui_iFormGauge);
	// Affect data pointer
	pdtData = new Gui_dtFormGauge;
	SetData(composite,pdtData);

	// Three component in composite select
	SetComponentNumber(composite,2);

	// Create caption if wanted
	sx = 0;
	sy = 0;
	if(_pdtForm.smFontCaption)
	{
		pdtData.gcCaption = NewCaption(_pdtForm.smFontCaption,_szCaption);
		SetColor(pdtData.gcCaption, _pdtForm.iDefaultFontCaptionColor);
		sx = SizeX(pdtData.gcCaption);
		sy = SizeY(pdtData.gcCaption);
		pdtData.gcCaption<<Disable();
		MountComponent(composite,pdtData.gcCaption);
	}

	// Create join
	pdtData.iJoinId = _iJoinId;

	// Members init
	pdtData.fValue = 0;
	pdtData.iFilterOp = g_iFilterOp_None;
	pdtData.bMajInform = _pdtForm.bMajInform;

	// Create gauge
	pdtData.gcField = NewDefaultGaugeCompositeV(_pdtForm.iDefaultMediaHeight);
	pdtData.gcField<<GaugeCompositeParam(_fMinValue,_fMaxValue,_fIncrement);

	pdtField=GetData(pdtData.gcField);
	pdtField.gcGauge<<GaugeColor(_pdtForm.iDefaultFieldColor);

	MountComponent(composite,pdtData.gcField);
	Clip(pdtData.gcField);

	// Move caption to correct pos
	if(_pdtForm.bCaptionAlign)
	{
		// align caption to _pdtform.iCaptionAlign and align field to _pdtform.iDefaultHAlign and iDefaultVAlign
		if(pdtData.gcCaption)
		{
			// set caption width
			StretchTo(pdtData.gcCaption, _pdtForm.iCaptionAlign, SizeY(pdtData.gcField));
			// move caption
			SetAlign(pdtData.gcCaption, _pdtForm.iCaption_HAlign, _pdtForm.iCaption_VAlign);
			//MoveTo(pdtData.gcCaption, -SizeX(pdtData.gcCaption), 0);
			MoveTo(pdtData.gcCaption, -(_pdtForm.iCaptionAlign+_pdtForm.iDefaultOffset), 0);
		}		
	}
	else
	if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Left)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Max))
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,0,SizeY(pdtData.gcField));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Right,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,-_pdtForm.iDefaultOffset,0);
		}
	}
	else if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Center)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Zoom))
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,_pdtForm.iDefaultFieldWidth,SizeY(pdtData.gcCaption));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Center,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,0,-(sy + _pdtForm.iDefaultOffset));
		}
	}
	else if(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Right)
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Left,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,sx + _pdtForm.iDefaultOffset + _pdtForm.iDefaultFieldWidth,0);
		}
	}


	// Stretch
	StretchTo(composite,SizeX(pdtData.gcField),SizeY(pdtData.gcField));
	
	return composite;
}


func Gui_Component NewFormGaugeH(Gui_dtForm _pdtForm,i32x _iJoinId,szx _szCaption,f32x _fMinValue,f32x _fMaxValue,f32x _fIncrement)
{
	var Gui_Component composite;
	var Gui_dtFormGauge pdtData;
	var Gui_dtGaugeComposite pdtField;
	var i32x sx,sy;
	var szx szHeader;

	// Create an object that will contain Gauge + caption
	composite = NewObject(Gui_iFormGauge);
	// Affect data pointer
	pdtData = new Gui_dtFormGauge;
	SetData(composite,pdtData);

	// Three component in composite select
	SetComponentNumber(composite,2);

	// Create caption if wanted
	sx = 0;
	sy = 0;
	if(_pdtForm.smFontCaption)
	{
		pdtData.gcCaption = NewCaption(_pdtForm.smFontCaption,_szCaption);
		sx = SizeX(pdtData.gcCaption);
		sy = SizeY(pdtData.gcCaption);
		pdtData.gcCaption<<Disable();
		MountComponent(composite,pdtData.gcCaption);
	}

	// Create join
	pdtData.iJoinId = _iJoinId;

	// Members init
	pdtData.fValue = 0;
	pdtData.iFilterOp = g_iFilterOp_None;
	pdtData.bMajInform = _pdtForm.bMajInform;

	// Create gauge
	pdtData.gcField = NewDefaultGaugeCompositeH(_pdtForm.iDefaultFieldWidth);
	pdtData.gcField<<GaugeCompositeParam(_fMinValue,_fMaxValue,_fIncrement);

	pdtField=GetData(pdtData.gcField);
	pdtField.gcGauge<<GaugeColor(_pdtForm.iDefaultFieldColor);

	MountComponent(composite,pdtData.gcField);
	Clip(pdtData.gcField);

	// Move caption to correct pos
	if(_pdtForm.bCaptionAlign)
	{
		// align caption to _pdtform.iCaptionAlign and align field to _pdtform.iDefaultHAlign and iDefaultVAlign
		if(pdtData.gcCaption)
		{
			// set caption width
			StretchTo(pdtData.gcCaption, _pdtForm.iCaptionAlign, SizeY(pdtData.gcField));
			// move caption
			SetAlign(pdtData.gcCaption, _pdtForm.iCaption_HAlign, _pdtForm.iCaption_VAlign);
			//MoveTo(pdtData.gcCaption, -SizeX(pdtData.gcCaption), 0);
			MoveTo(pdtData.gcCaption, -(_pdtForm.iCaptionAlign+_pdtForm.iDefaultOffset), 0);
		}		
	}
	else
	{
		if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Left)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Max))
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Right,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,-_pdtForm.iDefaultOffset-SizeX(pdtData.gcCaption),0);
			}
		}
		else if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Center)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Zoom))
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,_pdtForm.iDefaultFieldWidth,SizeY(pdtData.gcCaption));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Center,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,0,-(sy + _pdtForm.iDefaultOffset));
			}
		}
		else if(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Right)
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Left,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,sx + _pdtForm.iDefaultOffset + _pdtForm.iDefaultFieldWidth,0);
			}
		}
	}

	// Stretch
	StretchTo(composite,SizeX(pdtData.gcField),SizeY(pdtData.gcField));
	
	return composite;
}


//	pdtData.gcField = NewDefaultGaugeCompositeH(_pdtForm.iDefaultFieldWidth);


/*func void InitFormGaugeCommon(Gui_dtForm _pdtForm,i32x _iJoinId,szx _szCaption,f32x _fMinValue,f32x _fMaxValue,f32x _fIncrement)
{
	// Create an object that will contain Gauge + caption
	composite = NewObject(Gui_iFormGauge);
	// Affect data pointer
	pdtData = new Gui_dtFormGauge;
	SetData(composite,pdtData);

	// Three component in composite select
	SetComponentNumber(composite,2);

	// Create caption if wanted
	sx = 0;
	sy = 0;
	if(_pdtForm.smFontCaption)
	{
		pdtData.gcCaption = NewCaption(_pdtForm.smFontCaption,_szCaption);
		sx = SizeX(pdtData.gcCaption);
		sy = SizeY(pdtData.gcCaption);
		pdtData.gcCaption<<Disable();
		MountComponent(composite,pdtData.gcCaption);
	}

	// Create join
	pdtData.iJoinId = _iJoinId;

	// Members init
	pdtData.fValue = 0;

	// Create gauge
	pdtData.gcField<<GaugeCompositeParam(_fMinValue,_fMaxValue,_fIncrement);

	pdtField=GetData(pdtData.gcField);
	pdtField.gcGauge<<GaugeColor(_pdtForm.iDefaultFieldColor);

	MountComponent(composite,pdtData.gcField);
	Clip(pdtData.gcField);

	// Move caption to correct pos
	if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Left)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Max))
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,0,SizeY(pdtData.gcField));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Right,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,-_pdtForm.iDefaultOffset,0);
		}
	}
	else if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Center)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Zoom))
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,_pdtForm.iDefaultFieldWidth,SizeY(pdtData.gcCaption));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Center,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,0,-(sy + _pdtForm.iDefaultOffset));
		}
	}
	else if(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Right)
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Left,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,sx + _pdtForm.iDefaultOffset + _pdtForm.iDefaultFieldWidth,0);
		}
	}

	// Stretch
	StretchTo(composite,SizeX(pdtData.gcField),SizeY(pdtData.gcField));
	
	return composite;
}*/

func i32x FormGauge_OnDestroy()
{
	var Gui_Component pthis,parent;
	var Gui_dtFormCheckbox pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Destroy join
	parent = GetParent(pthis);
	if(parent)
	{
		parent<<FormDeleteJoin(pdtData.iJoinId);
	}
}

func void FormGauge_OnSelectKey(i32x _iKey)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormGauge pdtData;
	var i32x iDataType,iRowIndex;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iKey;
	pdtData.iRef = ROW_KEY;
	iRowIndex = Join_GetRow(pdtData.iJoinId,pdtData.iRow,pdtData.iRef,ROW_INDEX);

	// Retrieve data from db
	iDataType = Join_GetDataType(pdtData.iJoinId);
	if(iDataType == FLOAT_DATA)
	{
		pdtData.fValue = Join_GetFloatFromIndex(pdtData.iJoinId,iRowIndex);
	}
	else if(iDataType == INT_DATA)
	{
		pdtData.fValue = Join_GetIntFromIndex(pdtData.iJoinId,iRowIndex);
	}
	else
	{
		print("Bad gauge type.\n");
	}

	// change gauge
	pdtData.gcField<<GaugeValue(pdtData.fValue);

	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJFloat(pthis,pdtData.fValue,false);
}
func void FormGauge_OnSelectIndex(i32x _iIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormGauge pdtData;
	var i32x iDataType;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iIndex;
	pdtData.iRef = ROW_INDEX;

	// Retrieve data from db
	iDataType = Join_GetDataType(pdtData.iJoinId);
	if(iDataType == FLOAT_DATA)
	{
		pdtData.fValue = Join_GetFloatFromIndex(pdtData.iJoinId,_iIndex);
	}
	else if(iDataType == INT_DATA)
	{
		pdtData.fValue = Join_GetIntFromIndex(pdtData.iJoinId,_iIndex);
	}
	else
	{
		print("Bad gauge type.\n");
	}

	// change gauge
//	print("AssignValueTogauge:"+ftoa(pdtData.fValue)+"\n");
	pdtData.gcField<<GaugeValue(pdtData.fValue);

	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJFloat(pthis,pdtData.fValue,false);
}
func void FormGauge_OnSelectSIndex(i32x _iSIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormGauge pdtData;
	var i32x iDataType,iRowIndex;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iSIndex;
	pdtData.iRef = ROW_SORT;
	iRowIndex = Join_GetRow(pdtData.iJoinId,pdtData.iRow,pdtData.iRef,ROW_INDEX);

	// Retrieve data from db
	iDataType = Join_GetDataType(pdtData.iJoinId);
	if(iDataType == FLOAT_DATA)
	{
		pdtData.fValue = Join_GetFloatFromIndex(pdtData.iJoinId,iRowIndex);
	}
	else if(iDataType == INT_DATA)
	{
		pdtData.fValue = Join_GetIntFromIndex(pdtData.iJoinId,iRowIndex);
	}
	else
	{
		print("Bad gauge type.\n");
	}

	// change gauge
	pdtData.gcField<<GaugeValue(pdtData.fValue);

	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJFloat(pthis,pdtData.fValue,false);
}
func void FormGauge_OnSave()
{
	var Gui_Component pthis;
	var Gui_dtFormGauge pdtData;
	var i32x iDataType,iRetId,iRowIndex;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if((!IsHidden(pthis))&&(IsEnabled(pthis)))
	{
		iDataType = Join_GetDataType(pdtData.iJoinId);

		iRowIndex = Join_GetRow(pdtData.iJoinId,pdtData.iRow,pdtData.iRef,ROW_INDEX);

		if(iDataType == FLOAT_DATA)
		{
			Join_SetFloatFromIndex(pdtData.iJoinId,iRowIndex,pdtData.fValue);
		}
		else if(iDataType == INT_DATA)
		{
			Join_SetIntFromIndex(pdtData.iJoinId,iRowIndex,pdtData.fValue+0.5);
		}
		else
		{
			print("Can't save : Bad gauge type.\n");
		}
	}
}
func void FormGauge_LinkQuery(i32x _iQueryId)
{
	var Gui_Component pthis;
	var Gui_dtFormGauge pdtData;
	var i32x iLength,iLength2;
	var szx szJoin;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Retrieve join table
	szJoin = Join_GetDesc(pdtData.iJoinId);
	iLength2 = strlen(szJoin);
	iLength = strlen(Join_GetDataDesc(pdtData.iJoinId));
	iLength = iLength2-iLength;
	szJoin = strncpy(szJoin,0,iLength-1);

	// Add join table
	Query_SelectTable(_iQueryId,szJoin);
}

func void FormGauge_LinkFilter(i32x _iQueryId)
{
	var Gui_Component pthis;
	var Gui_dtFormGauge pdtData;
	var szx szJoin;
	var i32x iDataType;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Retrieve join table
	szJoin = Join_GetDesc(pdtData.iJoinId);
	iDataType = Join_GetDataType(pdtData.iJoinId);

	// Add join table
	FormGauge_LinkQuery(_iQueryId);
	if(iDataType == INT_DATA)
	{
		if(pdtData.iFilterOp == g_iFilterOp_Less)
		{
			Query_SelectWhereIntLessThan(_iQueryId,szJoin, pdtData.fFValue+0.5);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Equal)
		{
			Query_SelectWhereIntEqual(_iQueryId,szJoin, pdtData.fFValue+0.5);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Greater)
		{
			Query_SelectWhereIntGreaterThan(_iQueryId,szJoin, pdtData.fFValue+0.5);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Different)
		{
			Query_SelectWhereIntDifferent(0,szJoin, pdtData.fFValue+0.5);
		}
	}
	else if(iDataType == FLOAT_DATA)
	{
		if(pdtData.iFilterOp == g_iFilterOp_Less)
		{
			Query_SelectWhereFloatLessThan(_iQueryId,szJoin, pdtData.fFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Equal)
		{
			Query_SelectWhereFloatEqual(_iQueryId,szJoin, pdtData.fFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Greater)
		{
			Query_SelectWhereFloatGreaterThan(_iQueryId,szJoin, pdtData.fFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Different)
		{
			Query_SelectWhereFloatDifferent(0,szJoin, pdtData.fFValue);
		}
	}
}

func void FormGauge_FilterByInt(i32x _iOp,i32x _iValue)
{
	var Gui_Component pthis;
	var Gui_dtFormGauge pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iFilterOp = _iOp;
	pdtData.fFValue = _iValue;
}
func void FormGauge_FilterByFloat(i32x _iOp,f32x _fValue)
{
	var Gui_Component pthis;
	var Gui_dtFormGauge pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iFilterOp = _iOp;
	pdtData.fFValue = _fValue;
}

func void FormGauge_OnSldChange(Gui_Component _psource, f32x _fValue)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormGauge pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtData.fValue = _fValue;

	// get form
	if(pdtData.bMajInform)
	{
		parent = GetParent(pthis);
		if(parent)
		{
			parent<<FormMaJFloat(pthis,pdtData.fValue,true);
		}
	}
	
}
func void FormGauge_SetValue(f32x _fValue)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormGauge pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	// Update gauge
	pdtData.fValue = _fValue;
	pdtData.gcField<<GaugeValue(_fValue);
}
