func Gui_Component NewFormGroupOption(Gui_dtForm _pdtForm,i32x _iSourceJoinId,i32x _iDataJoinId,i32x _iCaptionJoinId,szx _szCaption)
{
	var Gui_Component composite,option;
	var Gui_dtFormGroupOption pdtData;
	var i32x sx,sy,i,iNumOptions,iLocalized;
	var szx szHeader;

	// Create an object that will contain Group option + caption
	composite = NewObject(Gui_iFormGroupOption);
	// Affect data pointer
	pdtData = new Gui_dtFormGroupOption;
	SetData(composite,pdtData);

	// 2 component in composite group option
	SetComponentNumber(composite,2);

	// Create caption if wanted
	sx = 0;
	sy = 0;
	if(_pdtForm.smFontCaption)
	{
		pdtData.gcCaption = NewCaption(_pdtForm.smFontCaption,_szCaption);
		SetColor(pdtData.gcCaption, _pdtForm.iDefaultFontCaptionColor);
		sx = SizeX(pdtData.gcCaption);
		sy = SizeY(pdtData.gcCaption);
		pdtData.gcCaption<<Disable();
		MountComponent(composite,pdtData.gcCaption);
	}

	// Create join
	pdtData.iJoinId = _iSourceJoinId;
	pdtData.iJoinDataId = _iDataJoinId;
	pdtData.iJoinCaptionId = _iCaptionJoinId;

	// Check if caption are localized
	szHeader = strncpy(Join_GetDataDesc(pdtData.iJoinCaptionId),0,10);
	if(!strcmp(szHeader,"gene_strID"))
	{
		iLocalized = 1;
	}
	else
	{
		iLocalized = 0;
	}

	// Member init
	pdtData.iValue = 0;
	pdtData.iFilterOp = g_iFilterOp_None;
	pdtData.bMajInform = _pdtForm.bMajInform;

	// Create Group option
	pdtData.gcField = NewGroupOptionExt(_pdtForm.iDefaultFieldWidth,_pdtForm.iDefaultOffset,_pdtForm.iDefaultOffset);
	MountComponent(composite,pdtData.gcField);
	
	// Add each option

	iNumOptions = Join_GetNumRows(pdtData.iJoinDataId);
	i=0;
	while(i<iNumOptions)
	{
		if(iLocalized==1)
		{
			option = NewRadioButton_Text(
				smLedBlue,
				_pdtForm.smFontField,
				GetLocalizedFromKey(Join_GetIntFromIndex(pdtData.iJoinCaptionId,i)),
				Join_GetIntFromIndex(pdtData.iJoinDataId,i)
			);
		}
		else
		{
			option = NewRadioButton_Text(
				smLedBlue,
				_pdtForm.smFontField,
				Join_GetStringFromIndex(pdtData.iJoinCaptionId,i),
				Join_GetIntFromIndex(pdtData.iJoinDataId,i)
			);
		}
		pdtData.gcField<<AddOption(option);
		i=i+1;
	}

	// Move field to correct pos
	if(_pdtForm.bCaptionAlign)
	{
		// align caption to _pdtform.iCaptionAlign and align field to _pdtform.iDefaultHAlign and iDefaultVAlign
		if(pdtData.gcCaption)
		{
			// set caption width
			StretchTo(pdtData.gcCaption, _pdtForm.iCaptionAlign, SizeY(pdtData.gcField));
			// move caption
			SetAlign(pdtData.gcCaption, _pdtForm.iCaption_HAlign, _pdtForm.iCaption_VAlign);
			//MoveTo(pdtData.gcCaption, -SizeX(pdtData.gcCaption), 0);
			MoveTo(pdtData.gcCaption, -(_pdtForm.iCaptionAlign+_pdtForm.iDefaultOffset), 0);
		}		
	}
	else
	if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Left)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Max))
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Right,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,-_pdtForm.iDefaultOffset-SizeX(pdtData.gcCaption),0);
		}
	}
	else if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Center)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Zoom))
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,_pdtForm.iDefaultFieldWidth,SizeY(pdtData.gcCaption));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Center,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,0,-(sy + _pdtForm.iDefaultOffset));
		}
	}
	else if(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Right)
	{
		// Set caption align to right
		if(pdtData.gcCaption)
		{
			StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
			SetAlign(pdtData.gcCaption,e_GUI_HAlign_Left,_pdtForm.iDefaultVAlign);
			MoveTo(pdtData.gcCaption,sx + _pdtForm.iDefaultOffset + _pdtForm.iDefaultFieldWidth,0);
		}
	}


	// Stretch
	StretchTo(composite,SizeX(pdtData.gcField),SizeY(pdtData.gcField));
	
	return composite;
}
func i32x FormGroupOption_OnDestroy()
{
	var Gui_Component pthis,parent;
	var Gui_dtFormGroupOption pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Destroy join
	parent = GetParent(pthis);
	if(parent)
	{
		parent<<FormDeleteJoin(pdtData.iJoinId);
		parent<<FormDeleteJoin(pdtData.iJoinDataId);
		parent<<FormDeleteJoin(pdtData.iJoinCaptionId);
	}
}
func void FormGroupOption_OnSelectKey(i32x _iKey)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormGroupOption pdtData;
	var i32x iValue;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iKey;
	pdtData.iRef = ROW_KEY;

	// Retrieve data from db
	iValue = Join_GetIntFromKey(pdtData.iJoinId,_iKey);

	// change Group option
	pdtData.gcField<<QuietRadioCheck(iValue);
	pdtData.iValue = iValue;

	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJInt(pthis,pdtData.iValue,false);
}
func void FormGroupOption_OnSelectIndex(i32x _iIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormGroupOption pdtData;
	var i32x iValue;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iIndex;
	pdtData.iRef = ROW_INDEX;

	// Retrieve data from db
	iValue = Join_GetIntFromIndex(pdtData.iJoinId,_iIndex);

	// change Group option
	pdtData.gcField<<SelectOption(iValue);
	pdtData.iValue = iValue;

	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJInt(pthis,pdtData.iValue,false);
}
func void FormGroupOption_OnSelectSIndex(i32x _iSIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormGroupOption pdtData;
	var i32x iValue;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iSIndex;
	pdtData.iRef = ROW_SORT;

	// Retrieve data from db
	iValue = Join_GetIntFromSortedIndex(pdtData.iJoinId,_iSIndex);

	// change Group option
	pdtData.gcField<<QuietRadioCheck(iValue);
	pdtData.iValue = iValue;

	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJInt(pthis,pdtData.iValue,false);
}
func void FormGroupOption_OnRadioCheck(Gui_Component _pComponent,i32x _iValue)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormGroupOption pdtData;
	var i32x iValue;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Update internal value
	pdtData.iValue = _iValue;

	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJInt(pthis,pdtData.iValue,true);
}
func void FormGroupOption_OnSave()
{
	var Gui_Component pthis;
	var Gui_dtFormGroupOption pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if((!IsHidden(pthis))&&(IsEnabled(pthis)))
	{
		if(pdtData.iRef == ROW_INDEX)
		{
			Join_SetIntFromIndex(pdtData.iJoinId,pdtData.iRow,pdtData.iValue);
		}
		else if(pdtData.iRef == ROW_KEY)
		{
			Join_SetIntFromKey(pdtData.iJoinId,pdtData.iRow,pdtData.iValue);
		}
		else if(pdtData.iRef == ROW_SORT)
		{
			var i32x iRow;
			iRow = Join_GetRow(pdtData.iJoinId, pdtData.iRow, ROW_SORT, ROW_INDEX );
			Join_SetIntFromIndex(pdtData.iJoinId,pdtData.iRow,pdtData.iValue);
		}
	}
}
func void FormGroupOption_LinkQuery(i32x _iQueryId)
{
	var Gui_Component pthis;
	var Gui_dtFormGroupOption pdtData;
	var i32x iLength,iLength2;
	var szx szJoin;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Retrieve join table
	szJoin = Join_GetDesc(pdtData.iJoinId);
	iLength2 = strlen(szJoin);
	iLength = strlen(Join_GetDataDesc(pdtData.iJoinId));
	iLength = iLength2-iLength;
	szJoin = strncpy(szJoin,0,iLength-1);

	// Add join table
	Query_SelectTable(_iQueryId,szJoin);
}

func void FormGroupOption_LinkFilter(i32x _iQueryId)
{
	var Gui_Component pthis;
	var Gui_dtFormGroupOption pdtData;
	var szx szJoin;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Retrieve join table
	szJoin = Join_GetDesc(pdtData.iJoinId);

	// Add join table
	FormGroupOption_LinkQuery(_iQueryId);
	if(pdtData.iFilterOp == g_iFilterOp_Less)
	{
		Query_SelectWhereIntLessThan(_iQueryId,szJoin, pdtData.iFValue);
	}
	else if(pdtData.iFilterOp == g_iFilterOp_Equal)
	{
		Query_SelectWhereIntEqual(_iQueryId,szJoin, pdtData.iFValue);
	}
	else if(pdtData.iFilterOp == g_iFilterOp_Greater)
	{
		Query_SelectWhereIntGreaterThan(_iQueryId,szJoin, pdtData.iFValue);
	}
	else if(pdtData.iFilterOp == g_iFilterOp_Different)
	{
		Query_SelectWhereIntDifferent(0,szJoin, pdtData.iFValue);
	}
}

func void FormGroupOption_FilterByInt(i32x _iOp,i32x _iValue)
{
	var Gui_Component pthis;
	var Gui_dtFormGroupOption pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iFilterOp = _iOp;
	pdtData.iFValue = _iValue;
}


