// Field Constructor
func Gui_Component NewFormListBox(Gui_dtForm _pdtForm,i32x _iSourceJoinId,i32x _iDataJoinId,i32x _iCaptionJoinId,szx _szCaption)
{
	var Gui_Component composite,option;
	var Gui_dtFormListBox pdtData;
	var i32x sx,sy,i,iNumOptions,iLocalized;
	var szx szHeader;

	// Create an object that will contain Group option + caption
	composite = NewObject(Gui_iFormListBox);
	// Affect data pointer
	pdtData = new Gui_dtFormListBox;
	SetData(composite,pdtData);

	// 2 component in composite group option
	SetComponentNumber(composite,2);

	// Create caption if wanted
	sx = 0;
	sy = 0;
	if(_pdtForm.smFontCaption)
	{
		pdtData.gcCaption = NewCaption(_pdtForm.smFontCaption,_szCaption);
		SetColor(pdtData.gcCaption, _pdtForm.iDefaultFontCaptionColor);
		sx = SizeX(pdtData.gcCaption);
		sy = SizeY(pdtData.gcCaption);
		pdtData.gcCaption<<Disable();
		MountComponent(composite,pdtData.gcCaption);
	}

	// Create join
	pdtData.iJoinId = _iSourceJoinId;
	pdtData.iJoinDataId = _iDataJoinId;
	pdtData.iJoinCaptionId = _iCaptionJoinId;

	// Member init
	pdtData.iFilterOp = g_iFilterOp_None;
	pdtData.iValue = 0;	
	pdtData.fValue = 0.0;
	pdtData.szValue="";
	pdtData.szFValue = "";
	pdtData.bMajInform = _pdtForm.bMajInform;

	// Create List box
	pdtData.gcField = NewSelectExt(_pdtForm.smFontField, _pdtForm.iDefaultFieldWidth, 150, pdtData.iJoinCaptionId,pdtData.iJoinDataId,0,1,1,_pdtForm.iDefaultHAlign,_pdtForm.iDefaultVAlign, 1.0/g_fScreenScaleFactor);
	MountComponent(composite,pdtData.gcField);
	
	// Move field to correct pos
	if(_pdtForm.bCaptionAlign)
	{
		// align caption to _pdtform.iCaptionAlign and align field to _pdtform.iDefaultHAlign and iDefaultVAlign
		if(pdtData.gcCaption)
		{
			// set caption width
			StretchTo(pdtData.gcCaption, _pdtForm.iCaptionAlign, SizeY(pdtData.gcField));
			// move caption
			SetAlign(pdtData.gcCaption, _pdtForm.iCaption_HAlign, _pdtForm.iCaption_VAlign);
			//MoveTo(pdtData.gcCaption, -SizeX(pdtData.gcCaption), 0);
			MoveTo(pdtData.gcCaption, -(_pdtForm.iCaptionAlign+_pdtForm.iDefaultOffset), 0);
		}		
	}
	else
	{
		if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Left)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Max))
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Right,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,-_pdtForm.iDefaultOffset-SizeX(pdtData.gcCaption),0);
			}
		}
		else if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Center)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Zoom))
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,_pdtForm.iDefaultFieldWidth,SizeY(pdtData.gcCaption));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Center,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,0,-(sy + _pdtForm.iDefaultOffset));
			}
		}
		else if(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Right)
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(pdtData.gcField));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Left,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,sx + _pdtForm.iDefaultOffset + _pdtForm.iDefaultFieldWidth,0);
			}
		}
	}


	// Stretch
	StretchTo(composite,SizeX(pdtData.gcField),SizeY(pdtData.gcField));
	
	return composite;
}
/* *************************************************
 * LIST BOX FIELD
 *************************************************** */
func i32x FormListBox_OnDestroy()
{
	var Gui_Component pthis,parent;
	var Gui_dtFormListBox pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Destroy join
	parent = GetParent(pthis);
	if(parent)
	{
		parent<<FormDeleteJoin(pdtData.iJoinId);
		parent<<FormDeleteJoin(pdtData.iJoinDataId);
		parent<<FormDeleteJoin(pdtData.iJoinCaptionId);
	}
}

func void FormListBox_OnWindowUpdate()
{
	var Gui_Component pthis;
	var Gui_dtFormListBox pdtData;
	var i32x iDataType,iRowIndex;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Stretch
	StretchTo(pthis,SizeX(pdtData.gcField),SizeY(pdtData.gcField));
}

func void FormListBox_OnSelectKey(i32x _iKey)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormListBox pdtData;
	var i32x iDataType,iRowIndex,iSelectedRow;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iKey;
	pdtData.iRef = ROW_KEY;
	iRowIndex = Join_GetRow(pdtData.iJoinId,pdtData.iRow,pdtData.iRef,ROW_INDEX);
	iSelectedRow=0;

	// get form
	parent = GetParent(pthis);

	// Retrieve data from db
	iDataType = Join_GetDataType(pdtData.iJoinId);
	if(iDataType == INT_DATA)
	{
		pdtData.iValue = Join_GetIntFromIndex(pdtData.iJoinId,iRowIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJInt(pthis,pdtData.iValue,false);
		iSelectedRow = Join_FindIndexFromIntData(pdtData.iJoinDataId,pdtData.iValue);
	}
	else if(iDataType == FLOAT_DATA)
	{
		pdtData.fValue = Join_GetFloatFromIndex(pdtData.iJoinId,iRowIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJFloat(pthis,pdtData.fValue,false);
		iSelectedRow = Join_FindIndexFromFloatData(pdtData.iJoinDataId,pdtData.fValue);
	}
	else if(iDataType == STRING_DATA)
	{
		pdtData.szValue = Join_GetStringFromIndex(pdtData.iJoinId,iRowIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJString(pthis,pdtData.szValue,false);
		iSelectedRow = Join_FindIndexFromStringData(pdtData.iJoinDataId,pdtData.szValue);
	}

	// change list box
	if(iSelectedRow>=0)
	{
		pdtData.gcField<<QuietSelectIndex(pthis,iSelectedRow);
	}
	else
	{
		pdtData.gcField<<SelectNone(" ");
		print(Join_GetDataDesc(pdtData.iJoinId)+" NotFound:"+itoa(pdtData.iValue)+"\n");
	}
}
func void FormListBox_OnSelectIndex(i32x _iIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormListBox pdtData;
	var i32x iDataType,iSelectedRow;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// get form
	parent = GetParent(pthis);

	pdtData.iRow = _iIndex;
	pdtData.iRef = ROW_INDEX;

	iSelectedRow=0;
	// Retrieve data from db
	iDataType = Join_GetDataType(pdtData.iJoinId);

	if(iDataType == INT_DATA)
	{
		pdtData.iValue = Join_GetIntFromIndex(pdtData.iJoinId,_iIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJInt(pthis,pdtData.iValue,false);
		iSelectedRow = Join_FindIndexFromIntData(pdtData.iJoinDataId,pdtData.iValue);
	}
	else if(iDataType == FLOAT_DATA)
	{
		pdtData.fValue = Join_GetFloatFromIndex(pdtData.iJoinId,_iIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJFloat(pthis,pdtData.fValue,false);
		iSelectedRow = Join_FindIndexFromFloatData(pdtData.iJoinDataId,pdtData.fValue);
	}
	else if(iDataType == STRING_DATA)
	{
		pdtData.szValue = Join_GetStringFromIndex(pdtData.iJoinId,_iIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJString(pthis,pdtData.szValue,false);
		iSelectedRow = Join_FindIndexFromStringData(pdtData.iJoinDataId,pdtData.szValue);
	}

	// change list box
	if(iSelectedRow>=0)
	{
		pdtData.gcField<<QuietSelectIndex(pthis,iSelectedRow);
	}
	else
	{
		pdtData.gcField<<SelectNone(" ");
		print(Join_GetDataDesc(pdtData.iJoinId)+" NotFound:"+itoa(pdtData.iValue)+"\n");
	}
}
func void FormListBox_OnSelectSIndex(i32x _iSIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormListBox pdtData;
	var i32x iDataType,iRowIndex,iSelectedRow;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iSIndex;
	pdtData.iRef = ROW_SORT;
	iRowIndex = Join_GetRow(pdtData.iJoinId,pdtData.iRow,pdtData.iRef,ROW_INDEX);
	iSelectedRow=0;

	// get form
	parent = GetParent(pthis);

	// Retrieve data from db
	iDataType = Join_GetDataType(pdtData.iJoinId);
	if(iDataType == INT_DATA)
	{
		pdtData.iValue = Join_GetIntFromIndex(pdtData.iJoinId,iRowIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJInt(pthis,pdtData.iValue,false);
		iSelectedRow = Join_FindIndexFromIntData(pdtData.iJoinDataId,pdtData.iValue);
	}
	else if(iDataType == FLOAT_DATA)
	{
		pdtData.fValue = Join_GetFloatFromIndex(pdtData.iJoinId,iRowIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJFloat(pthis,pdtData.fValue,false);
		iSelectedRow = Join_FindIndexFromFloatData(pdtData.iJoinDataId,pdtData.fValue);
	}
	else if(iDataType == STRING_DATA)
	{
		pdtData.szValue = Join_GetStringFromIndex(pdtData.iJoinId,iRowIndex);
		if(pdtData.bMajInform)
			if(parent) parent<<FormMaJString(pthis,pdtData.szValue,false);
		iSelectedRow = Join_FindIndexFromStringData(pdtData.iJoinDataId,pdtData.szValue);
	}

	// change list box
	if(iSelectedRow>=0)
	{
		pdtData.gcField<<QuietSelectIndex(pthis,iSelectedRow);
	}
	else
	{
		pdtData.gcField<<SelectNone(" ");
		print(Join_GetDataDesc(pdtData.iJoinId)+" NotFound:"+itoa(pdtData.iValue)+"\n");
	}
}
func void FormListBox_OnSelectInt(Gui_Component _pSender,i32x _iValue)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormListBox pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iValue = _iValue;

	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
	{
		if(parent)
		{
			parent<<FormMaJInt(pthis,pdtData.iValue,true);
		}
	}
}
func void FormListBox_OnSelectFloat(Gui_Component _pSender,f32x _fValue)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormListBox pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.fValue = _fValue;
	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJFloat(pthis,pdtData.fValue,true);
}
func void FormListBox_OnSelectString(Gui_Component _pSender,szx _szValue)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormListBox pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.szValue = _szValue;
	// get form
	parent = GetParent(pthis);
	if(pdtData.bMajInform)
		if(parent) parent<<FormMaJString(pthis,pdtData.szValue,true);
}
func void FormListBox_OnSave()
{
	var Gui_Component pthis;
	var Gui_dtFormListBox pdtData;
	var i32x iDataType,iRetId,iRowIndex;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if((!IsHidden(pthis))&&(IsEnabled(pthis)))
	{
		iDataType = Join_GetDataType(pdtData.iJoinId);
		iRetId = Join_GetDataType(pdtData.iJoinDataId);
		iRowIndex = Join_GetRow(pdtData.iJoinId,pdtData.iRow,pdtData.iRef,ROW_INDEX);

		if(iDataType == INT_DATA)
		{
			if(iRetId == FLOAT_DATA)
			{
				pdtData.iValue = pdtData.fValue+0.5;
			}
			else if(iRetId == STRING_DATA)
			{
				pdtData.iValue = atoi(pdtData.szValue);
			}
			Join_SetIntFromIndex(pdtData.iJoinId,iRowIndex,pdtData.iValue);
		}
		else if(iDataType == FLOAT_DATA)
		{
			if(iRetId == INT_DATA)
			{
				pdtData.fValue = pdtData.iValue;
			}
			else if(iRetId == STRING_DATA)
			{
				pdtData.fValue = atof(pdtData.szValue);
			}
			Join_SetFloatFromIndex(pdtData.iJoinId,iRowIndex,pdtData.fValue);
		}
		else if(iDataType == STRING_DATA)
		{
			if(iRetId == INT_DATA)
			{
				pdtData.szValue = itoa(pdtData.iValue);
			}
			else if(iRetId == FLOAT_DATA)
			{
				pdtData.szValue = ftoa(pdtData.fValue);
			}
			Join_SetStringFromIndex(pdtData.iJoinId,iRowIndex,pdtData.szValue);
		}
	}
}
func void FormListBox_LinkQuery(i32x _iQueryId)
{
	var Gui_Component pthis;
	var Gui_dtFormListBox pdtData;
	var i32x iLength,iLength2;
	var szx szJoin;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Retrieve join table
	szJoin = Join_GetDesc(pdtData.iJoinId);
	iLength2 = strlen(szJoin);
	iLength = strlen(Join_GetDataDesc(pdtData.iJoinId));
	iLength = iLength2-iLength;
	szJoin = strncpy(szJoin,0,iLength-1);

	// Add join table
	Query_SelectTable(_iQueryId,szJoin);
}

func void FormListBox_LinkFilter(i32x _iQueryId)
{
	var Gui_Component pthis;
	var Gui_dtFormListBox pdtData;
	var szx szJoin;
	var i32x iDataType;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Retrieve join table
	szJoin = Join_GetDesc(pdtData.iJoinId);
	iDataType = Join_GetDataType(pdtData.iJoinId);

	// Add join table
	FormListBox_LinkQuery(_iQueryId);
	if(iDataType == INT_DATA)
	{
		if(pdtData.iFilterOp == g_iFilterOp_Less)
		{
			Query_SelectWhereIntLessThan(_iQueryId,szJoin, pdtData.iFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Equal)
		{
			Query_SelectWhereIntEqual(_iQueryId,szJoin, pdtData.iFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Greater)
		{
			Query_SelectWhereIntGreaterThan(_iQueryId,szJoin, pdtData.iFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Different)
		{
			Query_SelectWhereIntDifferent(0,szJoin, pdtData.iFValue);
		}
	}
	else if(iDataType == FLOAT_DATA)
	{
		if(pdtData.iFilterOp == g_iFilterOp_Less)
		{
			Query_SelectWhereFloatLessThan(_iQueryId,szJoin, pdtData.fFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Equal)
		{
			Query_SelectWhereFloatEqual(_iQueryId,szJoin, pdtData.fFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Greater)
		{
			Query_SelectWhereFloatGreaterThan(_iQueryId,szJoin, pdtData.fFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Different)
		{
			Query_SelectWhereFloatDifferent(0,szJoin, pdtData.fFValue);
		}
	}
	else if(iDataType == STRING_DATA)
	{
		if(pdtData.iFilterOp == g_iFilterOp_Less)
		{
			Query_SelectWhereStringLessThan(_iQueryId,szJoin, pdtData.szFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Equal)
		{
			Query_SelectWhereStringEqual(_iQueryId,szJoin, pdtData.szFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Greater)
		{
			Query_SelectWhereStringGreaterThan(_iQueryId,szJoin, pdtData.szFValue);
		}
		else if(pdtData.iFilterOp == g_iFilterOp_Different)
		{
			Query_SelectWhereStringDifferent(0,szJoin, pdtData.szFValue);
		}
	}
}

func void FormListBox_FilterByInt(i32x _iOp,i32x _iValue)
{
	var Gui_Component pthis;
	var Gui_dtFormListBox pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iFilterOp = _iOp;
	pdtData.iFValue = _iValue;
}
func void FormListBox_FilterByFloat(i32x _iOp,f32x _fValue)
{
	var Gui_Component pthis;
	var Gui_dtFormListBox pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iFilterOp = _iOp;
	pdtData.fFValue = _fValue;
}
func void FormListBox_FilterByString(i32x _iOp,szx _szValue)
{
	var Gui_Component pthis;
	var Gui_dtFormListBox pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iFilterOp = _iOp;
	pdtData.szFValue = _szValue;
}

