func Gui_Component NewFormMesh(Gui_dtForm _pdtForm,i32x _iJoinId,szx _szCaption)
{
	var Gui_Component composite;
	var Gui_dtFormMesh pdtData;
	var i32x sx,sy;
	var szx szHeader;

	// Create an object that will contain Dynamic bitmap + caption
	composite = NewObject(Gui_iFormMesh);
	// Affect data pointer
	pdtData = new Gui_dtFormMesh;
	SetData(composite,pdtData);

	// Three component in composite select
	SetComponentNumber(composite,2);

	// Create caption if wanted
	sx = 0;
	sy = 0;
	if(_pdtForm.smFontCaption)
	{
		pdtData.gcCaption = NewCaption(_pdtForm.smFontCaption,_szCaption);
		SetColor(pdtData.gcCaption, _pdtForm.iDefaultFontCaptionColor);
		sx = SizeX(pdtData.gcCaption);
		sy = SizeY(pdtData.gcCaption);
		pdtData.gcCaption<<Disable();
		MountComponent(composite,pdtData.gcCaption);
	}

	// Create join
	pdtData.iJoinId = _iJoinId;


	// Get join type
	szHeader = strncpy(Join_GetDataDesc(pdtData.iJoinId),0,10);
	if(!strcmp(szHeader,"game_mshID"))
	{
		pdtData.iSwapMesh = 1;
	}
	else
	{
		pdtData.iSwapMesh = 0;
		// Load Mesh kit
		pdtData.mkKit = LoadMeshKit(_pdtForm.szMshKit);
		LoadKit(pdtData.mkKit);
	}
	// Keep width for scaling mesh
	pdtData.iWidth =_pdtForm.iDefaultMediaWidth;
	pdtData.iHeight = _pdtForm.iDefaultMediaHeight;
	pdtData.iHAlign =_pdtForm.iDefaultHAlign;
	pdtData.iVAlign = _pdtForm.iDefaultVAlign;

	// Move field to correct pos
	if(_pdtForm.bCaptionAlign)
	{
		// align caption to _pdtform.iCaptionAlign and align field to _pdtform.iDefaultHAlign and iDefaultVAlign
		if(pdtData.gcCaption)
		{
			// set caption width
			StretchTo(pdtData.gcCaption, _pdtForm.iCaptionAlign, SizeY(pdtData.gcField));
			// move caption
			SetAlign(pdtData.gcCaption, _pdtForm.iCaption_HAlign, _pdtForm.iCaption_VAlign);
			//MoveTo(pdtData.gcCaption, -SizeX(pdtData.gcCaption), 0);
			MoveTo(pdtData.gcCaption, -(_pdtForm.iCaptionAlign+_pdtForm.iDefaultOffset), 0);
		}		
	}
	else
	{
		if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Left)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Max))
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Right,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,-_pdtForm.iDefaultOffset-SizeX(pdtData.gcCaption),0);
			}
		}
		else if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Center)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Zoom))
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,_pdtForm.iDefaultFieldWidth,SizeY(pdtData.gcCaption));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Center,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,0,-(sy + _pdtForm.iDefaultOffset));
			}
		}
		else if(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Right)
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),_pdtForm.iDefaultMediaHeight);
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Left,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,sx + _pdtForm.iDefaultOffset + _pdtForm.iDefaultFieldWidth,0);
			}
		}
	}


	// Stretch
	StretchTo(composite,_pdtForm.iDefaultMediaWidth,_pdtForm.iDefaultMediaHeight);
	
	return composite;
}
/* *************************************************
 * MESH FIELD
 *************************************************** */
func i32x FormMesh_OnDestroy()
{
	var Gui_Component pthis,parent;
	var Gui_dtFormMesh pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Release kit
	/*
	if(pdtData.mkKit)
	{
		ReleaseKit(pdtData.mkKit);
		DeleteKit(pdtData.mkKit);
	}
	*/

	// Destroy join
	parent = GetParent(pthis);
	if(parent)
	{
		parent<<FormDeleteJoin(pdtData.iJoinId);
	}
}
func void FormMesh_OnSelectKey(i32x _iKey)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormMesh pdtData;
	var i32x iMshId,iDirId,bKitToDelete;
	var f32x fWidth,fScale;
	var szx szKit,szMesh;
	var Menu_Kit pKitToDelete;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iKey;
	pdtData.iRef = ROW_KEY;
	bKitToDelete = false;

	if(pdtData.iSwapMesh == 1)
	{
		if(pdtData.mkKit)
		{
			bKitToDelete = true;
			pKitToDelete = pdtData.mkKit;
		}
		// Swap mesh mode m_iDirectory_szName
		iMshId = Join_GetIntFromKey(pdtData.iJoinId,_iKey);
		iDirId = Join_GetIntFromKey(g_oMenuJoins.m_iMsh_iDirectoryId,iMshId);
		szKit="./"+Join_GetStringFromKey(g_oMenuJoins.m_iDirectory_szName,iDirId);
		szKit=szKit+"/"+Join_GetStringFromKey(g_oMenuJoins.m_iMsh_szFilename,iMshId);
		pdtData.mkKit = LoadMeshKit(szKit);
		LoadKit(pdtData.mkKit);
		// Always get first mesh
		if(GetNumMeshes(pdtData.mkKit)>0)
		{
			pdtData.smMesh = GetMeshIndex(pdtData.mkKit,0);
		}
		else
		{
			bKitToDelete = false;
		}
		pdtData.szTxt = szKit;
	}
	else
	{
		szMesh = Join_GetStringFromKey(pdtData.iJoinId,_iKey);
		print("FindMesh:"+szMesh+"\n");
		pdtData.smMesh = FindMesh(pdtData.mkKit,szMesh); // Find mesh in kit
		pdtData.szTxt = szMesh;
	}

	if(pdtData.smMesh)
	{
		// Update mesh
		SetMesh(pdtData.gcField,pdtData.smMesh);
		if(!pdtData.gcField)
		{
			// Create mesh
			pdtData.gcField = NewMesh(pdtData.smMesh);
			Add_Viewer3D(pdtData.gcField,0.0,MATH_2PI,0.0,MATH_2PI,0.0,0.00015);
			SetAlign(pdtData.gcField,pdtData.iHAlign,pdtData.iVAlign);
			StretchTo(pdtData.gcField,pdtData.iWidth,pdtData.iHeight);
			MountComponent(pthis,pdtData.gcField);
		}
		else
		{
			// Update mesh
			SetMesh(GetSprite(pdtData.gcField),pdtData.smMesh);
		}
		// Change scale display
		fWidth = pdtData.iWidth;
		fScale = fWidth*3/(GetMeshWidth(pdtData.smMesh)+GetMeshHeight(pdtData.smMesh)+GetMeshDepth(pdtData.smMesh));
		println("Scale:"+ftoa(fScale));
		SetScale(pdtData.gcField,fScale);
	}
	// Delete old kit if needed
	if(bKitToDelete)
	{
		// Release old kit
		ReleaseKit(pKitToDelete);
		DeleteKit(pKitToDelete);
	}
}
func void FormMesh_OnSelectIndex(i32x _iIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormMesh pdtData;
	var i32x iMshId,iDirId,bKitToDelete;
	var f32x fWidth,fScale;
	var szx szKit,szMesh;
	var Menu_Kit pKitToDelete;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iIndex;
	pdtData.iRef = ROW_INDEX;
	bKitToDelete = false;
	if(pdtData.iSwapMesh == 1)
	{
		// Swap mesh mode
		iMshId = Join_GetIntFromIndex(pdtData.iJoinId,_iIndex);
		iDirId = Join_GetIntFromKey(g_oMenuJoins.m_iMsh_iDirectoryId,iMshId);
		szKit="./"+Join_GetStringFromKey(g_oMenuJoins.m_iDirectory_szName,iDirId);
		szKit=szKit+"/"+Join_GetStringFromKey(g_oMenuJoins.m_iMsh_szFilename,iMshId);

		if(strcmp(pdtData.szTxt,szKit)!=0)
		{
			if(pdtData.mkKit)
			{
				bKitToDelete = true;
				pKitToDelete = pdtData.mkKit;
			}

			pdtData.mkKit = LoadMeshKit(szKit);
			LoadKit(pdtData.mkKit);
			// Always get first mesh
			if(GetNumMeshes(pdtData.mkKit)>0)
			{
				pdtData.smMesh = GetMeshIndex(pdtData.mkKit,0);
			}
			else
			{
				bKitToDelete = false;
			}
			pdtData.szTxt = szKit;
		}
	}
	else
	{
		szMesh = Join_GetStringFromIndex(pdtData.iJoinId,_iIndex);
		print("FindMesh:"+szMesh+"\n");
		pdtData.smMesh = FindMesh(pdtData.mkKit,szMesh); // Find mesh in kit
		pdtData.szTxt = szMesh;
	}

	if(pdtData.smMesh)
	{
		if(!pdtData.gcField)
		{
			// Create mesh
			pdtData.gcField = NewMesh(pdtData.smMesh);
			Add_Viewer3D(pdtData.gcField,0.0,MATH_2PI,0.0,MATH_2PI,0.0,0.00015);
			SetAlign(pdtData.gcField,pdtData.iHAlign,pdtData.iVAlign);
			StretchTo(pdtData.gcField,pdtData.iWidth,pdtData.iHeight);
			MountComponent(pthis,pdtData.gcField);
		}
		else
		{
			// Update mesh
			SetMesh(GetSprite(pdtData.gcField),pdtData.smMesh);
		}
		// Change scale display
		fWidth = pdtData.iWidth;
		fScale = fWidth*3/(GetMeshWidth(pdtData.smMesh)+GetMeshHeight(pdtData.smMesh)+GetMeshDepth(pdtData.smMesh));
		println("Scale:"+ftoa(fScale));
		SetScale(pdtData.gcField,fScale);
	}
	// Delete old kit if needed
	if(bKitToDelete)
	{
		// Release old kit
		ReleaseKit(pKitToDelete);
		DeleteKit(pKitToDelete);
	}
	
}
func void FormMesh_OnSelectSIndex(i32x _iSIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormMesh pdtData;
	var i32x iMshId,iDirId,bKitToDelete;
	var f32x fWidth,fScale;
	var szx szKit,szMesh;
	var Menu_Kit pKitToDelete;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iSIndex;
	pdtData.iRef = ROW_SORT;
	bKitToDelete = false;

	if(pdtData.iSwapMesh == 1)
	{
		if(pdtData.mkKit)
		{
			bKitToDelete = true;
			pKitToDelete = pdtData.mkKit;
		}
		// Swap mesh mode
		iMshId = Join_GetIntFromSortedIndex(pdtData.iJoinId,_iSIndex);
		iDirId = Join_GetIntFromKey(g_oMenuJoins.m_iMsh_iDirectoryId,iMshId);
		szKit="./"+Join_GetStringFromKey(g_oMenuJoins.m_iDirectory_szName,iDirId);
		szKit=szKit+"/"+Join_GetStringFromKey(g_oMenuJoins.m_iMsh_szFilename,iMshId);
		pdtData.mkKit = LoadMeshKit(szKit);
		LoadKit(pdtData.mkKit);
		// Always get first mesh
		if(GetNumMeshes(pdtData.mkKit)>0)
		{
			pdtData.smMesh = GetMeshIndex(pdtData.mkKit,0);
		}
		else
		{
			bKitToDelete = false;
		}
		pdtData.szTxt = szKit;
	}
	else
	{
		szMesh = Join_GetStringFromSortedIndex(pdtData.iJoinId,_iSIndex);
		print("FindMesh:"+szMesh+"\n");
		pdtData.smMesh = FindMesh(pdtData.mkKit,szMesh); // Find mesh in kit
		pdtData.szTxt = szMesh;
	}
	
	if(pdtData.smMesh)
	{
		if(!pdtData.gcField)
		{
			// Create mesh
			pdtData.gcField = NewMesh(pdtData.smMesh);
			Add_Viewer3D(pdtData.gcField,0.0,MATH_2PI,0.0,MATH_2PI,0.0,0.00015);
			SetAlign(pdtData.gcField,pdtData.iHAlign,pdtData.iVAlign);
			StretchTo(pdtData.gcField,pdtData.iWidth,pdtData.iHeight);
			MountComponent(pthis,pdtData.gcField);
		}
		else
		{
			// Update mesh
			SetMesh(GetSprite(pdtData.gcField),pdtData.smMesh);
		}
		// Change scale display
		fWidth = pdtData.iWidth;
		fScale = fWidth*3/(GetMeshWidth(pdtData.smMesh)+GetMeshHeight(pdtData.smMesh)+GetMeshDepth(pdtData.smMesh));
		println("Scale:"+ftoa(fScale));
		SetScale(pdtData.gcField,fScale);
	}
	// Delete old kit if needed
	if(bKitToDelete)
	{
		// Release old kit
		ReleaseKit(pKitToDelete);
		DeleteKit(pKitToDelete);
	}

}
func void FormMesh_OnSave()
{
	var Gui_Component pthis;
	var Gui_dtFormBitmap pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);
	// Todo
}
