// Field Constructor
func Gui_Component NewFormSubField(Gui_dtForm _pdtForm,i32x _iParentJoinId,i32x _iChildJoinId,szx _szCaption,Gui_Component _pSubForm)
{
	var Gui_Component composite,window;
	var Gui_dtFormSubField pdtData;
	var i32x sx,sy,i,iNumOptions,iLocalized;
	var szx szHeader;

	// Create an object that will contain Sub form + caption
	composite = NewObject(Gui_iFormSubField);
	// Affect data pointer
	pdtData = new Gui_dtFormSubField;
	SetData(composite,pdtData);

	// 2 component in composite group option
	SetComponentNumber(composite,2);

	// Create caption if wanted
	sx = 0;
	sy = 0;
	if(_pdtForm.smFontCaption)
	{
		pdtData.gcCaption = NewCaption(_pdtForm.smFontCaption,_szCaption);
		sx = SizeX(pdtData.gcCaption);
		sy = SizeY(pdtData.gcCaption);
		pdtData.gcCaption<<Disable();
		MountComponent(composite,pdtData.gcCaption);
	}

	// Create join
	pdtData.iJoinId = _iParentJoinId;
	pdtData.iJoinChild = _iChildJoinId;

	// Member init
	pdtData.iFilterOp = g_iFilterOp_None;
	pdtData.iValue = 0;	
	pdtData.bMajInform = _pdtForm.bMajInform;

	// Mount sub form into window
	pdtData.gcSubForm = _pSubForm;
	window = NewWindow(_pdtForm.iDefaultMediaWidth,_pdtForm.iDefaultMediaHeight);
	window<<WindowMount(_pSubForm);
	MountComponent(composite,window);
	// Keep pointer on form !
	pdtData.gcField = _pSubForm;
	
	// Move field to correct pos
	if(_pdtForm.bCaptionAlign)
	{
		// align caption to _pdtform.iCaptionAlign and align field to _pdtform.iDefaultHAlign and iDefaultVAlign
		if(pdtData.gcCaption)
		{
			// set caption width
			StretchTo(pdtData.gcCaption, _pdtForm.iCaptionAlign, SizeY(pdtData.gcField));
			// move caption
			SetAlign(pdtData.gcCaption, _pdtForm.iCaption_HAlign, _pdtForm.iCaption_VAlign);
			//MoveTo(pdtData.gcCaption, -SizeX(pdtData.gcCaption), 0);
			MoveTo(pdtData.gcCaption, -(_pdtForm.iCaptionAlign+_pdtForm.iDefaultOffset), 0);
		}		
	}
	else
	{
		if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Left)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Max))
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(window));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Right,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,-_pdtForm.iDefaultOffset-SizeX(pdtData.gcCaption),0);
			}
		}
		else if((_pdtForm.iDefaultHAlign == e_GUI_HAlign_Center)||(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Zoom))
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,_pdtForm.iDefaultFieldWidth,SizeY(pdtData.gcCaption));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Center,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,0,-(sy + _pdtForm.iDefaultOffset));
			}
		}
		else if(_pdtForm.iDefaultHAlign == e_GUI_HAlign_Right)
		{
			// Set caption align to right
			if(pdtData.gcCaption)
			{
				StretchTo(pdtData.gcCaption,SizeX(pdtData.gcCaption),SizeY(window));
				SetAlign(pdtData.gcCaption,e_GUI_HAlign_Left,_pdtForm.iDefaultVAlign);
				MoveTo(pdtData.gcCaption,sx + _pdtForm.iDefaultOffset + _pdtForm.iDefaultFieldWidth,0);
			}
		}
	}


	// Stretch
	StretchTo(composite,SizeX(window),SizeY(window));
	
	CatchEvent(composite,e_GUI_Event_Mouse_Move);
	return composite;
}
/* *************************************************
 * SUB FIELD
 *************************************************** */
func i32x FormSubField_OnDestroy()
{
	var Gui_Component pthis,parent;
	var Gui_dtFormSubField pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Destroy join
	parent = GetParent(pthis);
	if(parent)
	{
		parent<<FormDeleteJoin(pdtData.iJoinId);
		parent<<FormDeleteJoin(pdtData.iJoinChild);
	}
}


func void FormSubField_OnSelectKey(i32x _iKey)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormSubField pdtData;
	var i32x iDataType,iRowIndex;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iKey;
	pdtData.iRef = ROW_KEY;
	iRowIndex = Join_GetRow(pdtData.iJoinId,pdtData.iRow,pdtData.iRef,ROW_INDEX);

	// get form
	parent = GetParent(pthis);

	// Retrieve data from db
	iDataType = Join_GetDataType(pdtData.iJoinId);
	if(Join_GetDataType(pdtData.iJoinChild) == iDataType)
	{
		if(iDataType == INT_DATA)
		{
			pdtData.iValue = Join_GetIntFromIndex(pdtData.iJoinId,iRowIndex);
			if(pdtData.bMajInform)
			{
				if(parent) parent<<FormMaJInt(pthis,pdtData.iValue,false);
			}
			pdtData.gcField<<FormFilterByIntEqual(Join_GetDesc(pdtData.iJoinChild),pdtData.iValue);
		}
		else if(iDataType == FLOAT_DATA)
		{
			pdtData.fValue = Join_GetFloatFromIndex(pdtData.iJoinId,iRowIndex);
			if(pdtData.bMajInform)
			{
				if(parent) parent<<FormMaJFloat(pthis,pdtData.fValue,false);
			}
			pdtData.gcField<<FormFilterByFloatEqual(Join_GetDesc(pdtData.iJoinChild),pdtData.fValue);
		}
		else if(iDataType == STRING_DATA)
		{
			pdtData.szValue = Join_GetStringFromIndex(pdtData.iJoinId,iRowIndex);
			if(pdtData.bMajInform)
			{
				if(parent) parent<<FormMaJString(pthis,pdtData.szValue,false);
			}
			pdtData.gcField<<FormFilterByStringEqual(Join_GetDesc(pdtData.iJoinChild),pdtData.szValue);
		}
	}
	else
	{
		print("SubForm Warning: bad linked join !\n");
	}
}
func void FormSubField_OnSelectIndex(i32x _iIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormSubField pdtData;
	var i32x iDataType,iRowIndex;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iIndex;
	pdtData.iRef = ROW_INDEX;
	iRowIndex = _iIndex;

	// get form
	parent = GetParent(pthis);

	// Retrieve data from db
	iDataType = Join_GetDataType(pdtData.iJoinId);
	if(Join_GetDataType(pdtData.iJoinChild) == iDataType)
	{
		if(iDataType == INT_DATA)
		{
			pdtData.iValue = Join_GetIntFromIndex(pdtData.iJoinId,iRowIndex);
			if(pdtData.bMajInform)
			{
				if(parent) parent<<FormMaJInt(pthis,pdtData.iValue,false);
			}
			pdtData.gcField<<FormFilterByIntEqual(Join_GetDesc(pdtData.iJoinChild),pdtData.iValue);
		}
		else if(iDataType == FLOAT_DATA)
		{
			pdtData.fValue = Join_GetFloatFromIndex(pdtData.iJoinId,iRowIndex);
			if(pdtData.bMajInform)
			{
				if(parent) parent<<FormMaJFloat(pthis,pdtData.fValue,false);
			}
			pdtData.gcField<<FormFilterByFloatEqual(Join_GetDesc(pdtData.iJoinChild),pdtData.fValue);
		}
		else if(iDataType == STRING_DATA)
		{
			pdtData.szValue = Join_GetStringFromIndex(pdtData.iJoinId,iRowIndex);
			if(pdtData.bMajInform)
			{
				if(parent) parent<<FormMaJString(pthis,pdtData.szValue,false);
			}
			pdtData.gcField<<FormFilterByStringEqual(Join_GetDesc(pdtData.iJoinChild),pdtData.szValue);
		}
	}
	else
	{
		print("SubForm Warning: bad linked join !\n");
	}
}
func void FormSubField_OnSelectSIndex(i32x _iSIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFormSubField pdtData;
	var i32x iDataType,iRowIndex;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iSIndex;
	pdtData.iRef = ROW_SORT;
	iRowIndex = Join_GetRow(pdtData.iJoinId,pdtData.iRow,pdtData.iRef,ROW_SORT);

	// get form
	parent = GetParent(pthis);

	// Retrieve data from db
	iDataType = Join_GetDataType(pdtData.iJoinId);
	if(Join_GetDataType(pdtData.iJoinChild) == iDataType)
	{
		if(iDataType == INT_DATA)
		{
			pdtData.iValue = Join_GetIntFromIndex(pdtData.iJoinId,iRowIndex);
			if(pdtData.bMajInform)
			{
				if(parent) parent<<FormMaJInt(pthis,pdtData.iValue,false);
			}
			pdtData.gcField<<FormFilterByIntEqual(Join_GetDesc(pdtData.iJoinChild),pdtData.iValue);
		}
		else if(iDataType == FLOAT_DATA)
		{
			pdtData.fValue = Join_GetFloatFromIndex(pdtData.iJoinId,iRowIndex);
			if(pdtData.bMajInform)
			{
				if(parent) parent<<FormMaJFloat(pthis,pdtData.fValue,false);
			}
			pdtData.gcField<<FormFilterByFloatEqual(Join_GetDesc(pdtData.iJoinChild),pdtData.fValue);
		}
		else if(iDataType == STRING_DATA)
		{
			pdtData.szValue = Join_GetStringFromIndex(pdtData.iJoinId,iRowIndex);
			if(pdtData.bMajInform)
			{
				if(parent) parent<<FormMaJString(pthis,pdtData.szValue,false);
			}
			pdtData.gcField<<FormFilterByStringEqual(Join_GetDesc(pdtData.iJoinChild),pdtData.szValue);
		}
	}
	else
	{
		print("SubForm Warning: bad linked join !\n");
	}
}

func void FormSubField_OnSave()
{
	var Gui_Component pthis;
	var Gui_dtFormSubField pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	if((!IsHidden(pthis))&&(IsEnabled(pthis)))
	{
		pdtData.gcSubForm<<SaveRecord();
	}
}

func void FormSubField_OnLinkRows(i32x _iSubsetId)
{
	var Gui_Component pthis;
	var Gui_dtFormSubField pdtData;
	var i32x iRefTable;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Select all row form sub form table
	iRefTable = Form_GetRefTable(pdtData.gcSubForm);
	TableSubset_SelectAllRows(_iSubsetId,iRefTable);

}

