func Gui_Component NewVariable(Gui_dtForm _pdtForm,i32x _iJoinId,szx _szVariable)
{
	var Gui_Component composite;
	var Gui_dtFieldVariable pdtData;
	var szx szHeader;

	// Create an object that will store environment variable join
	composite = NewObject(Gui_iFormVariable);

	// Affect data pointer
	pdtData = new Gui_dtFieldVariable;
	SetData(composite,pdtData);

	// Init members
	pdtData.iJoinId = _iJoinId;
	pdtData.szVariable = _szVariable;
	pdtData.iDecimal = _pdtForm.iDefaultDecimal;

	// Text init
	szHeader = strncpy(Join_GetDataDesc(pdtData.iJoinId),0,10);
	if(!strcmp(szHeader,"gene_strID"))
	{
		pdtData.iLocalized = 1;
	}
	else
	{
		pdtData.iLocalized = 0;
	}

	return composite;
}


func i32x FormVariable_OnDestroy()
{
	var Gui_Component pthis,parent;
	var Gui_dtFieldVariable pdtData;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Destroy join
	parent = GetParent(pthis);
	if(parent)
	{
		parent<<FormDeleteJoin(pdtData.iJoinId);
	}
}
func void FormVariable_OnSelectKey(i32x _iKey)
{
	var Gui_Component pthis,parent;
	var Gui_dtFieldVariable pdtData;
	var szx szValue;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iKey;
	pdtData.iRef = ROW_KEY;

	// Retrieve data from db
	if(Join_GetDataType(pdtData.iJoinId)==STRING_DATA)
	{
		szValue = Join_GetStringFromKey(pdtData.iJoinId,_iKey);
	}
	else if(Join_GetDataType(pdtData.iJoinId)==INT_DATA)
	{
		if(pdtData.iLocalized)
		{
			szValue = GetLocalizedFromKey(Join_GetIntFromKey(pdtData.iJoinId,_iKey));
		}
		else
		{
			szValue = itoa(Join_GetIntFromKey(pdtData.iJoinId,_iKey));
		}
	}
	else if(Join_GetDataType(pdtData.iJoinId)==FLOAT_DATA)
	{
		szValue = Formattedftoa(Join_GetFloatFromKey(pdtData.iJoinId,_iKey),3,pdtData.iDecimal);
	}
	else
		szValue = "Bad type";

	// change variable
	SetEnvironmentVariable(pdtData.szVariable,szValue);
}
func void FormVariable_OnSelectIndex(i32x _iIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFieldVariable pdtData;
	var szx szValue;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iIndex;
	pdtData.iRef = ROW_INDEX;

	// Retrieve data from db
	if(Join_GetDataType(pdtData.iJoinId)==STRING_DATA)
	{
		szValue = Join_GetStringFromIndex(pdtData.iJoinId,_iIndex);
	}
	else if(Join_GetDataType(pdtData.iJoinId)==INT_DATA)
	{
		if(pdtData.iLocalized)
		{
			szValue = GetLocalizedFromKey(Join_GetIntFromIndex(pdtData.iJoinId,_iIndex));
		}
		else
		{
			szValue = itoa(Join_GetIntFromIndex(pdtData.iJoinId,_iIndex));
		}
	}
	else if(Join_GetDataType(pdtData.iJoinId)==FLOAT_DATA)
	{
		szValue = Formattedftoa(Join_GetFloatFromIndex(pdtData.iJoinId,_iIndex),3,pdtData.iDecimal);
	}
	else
		szValue = "Bad type";

	// change variable
	SetEnvironmentVariable(pdtData.szVariable,szValue);
}
func void FormVariable_OnSelectSIndex(i32x _iSIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtFieldVariable pdtData;
	var szx szValue;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	pdtData.iRow = _iSIndex;
	pdtData.iRef = ROW_SORT;

	// Retrieve data from db
	if(Join_GetDataType(pdtData.iJoinId)==STRING_DATA)
	{
		szValue = Join_GetStringFromSortedIndex(pdtData.iJoinId,_iSIndex);
	}
	else if(Join_GetDataType(pdtData.iJoinId)==INT_DATA)
	{
		if(pdtData.iLocalized)
		{
			szValue = GetLocalizedFromKey(Join_GetIntFromSortedIndex(pdtData.iJoinId,_iSIndex));
		}
		else
		{
			szValue = itoa(Join_GetIntFromSortedIndex(pdtData.iJoinId,_iSIndex));
		}
	}
	else if(Join_GetDataType(pdtData.iJoinId)==FLOAT_DATA)
	{
		szValue = Formattedftoa(Join_GetFloatFromSortedIndex(pdtData.iJoinId,_iSIndex),3,pdtData.iDecimal);
	}
	else
		szValue = "Bad type";

	// change variable
	SetEnvironmentVariable(pdtData.szVariable,szValue);
}

func void FormVariable_LinkQuery(i32x _iQueryId)
{
	var Gui_Component pthis;
	var Gui_dtFieldVariable pdtData;
	var i32x iLength,iLength2;
	var szx szJoin;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	// Retrieve join table
	szJoin = Join_GetDesc(pdtData.iJoinId);
	iLength2 = strlen(szJoin);
	iLength = strlen(Join_GetDataDesc(pdtData.iJoinId));
	iLength = iLength2-iLength;
	szJoin = strncpy(szJoin,0,iLength-1);

	// Add join table
	Query_SelectTable(_iQueryId,szJoin);
}
