func void vDestroyLocalDatabaseJoins();
func void vStartFinance();
func void vStartCyclistList();
func void vStartPropositionCyclist(i32x _iCyclistID);
func void vStartPropositionList();
func void vStartSponsorList();
func void vStartPropositionSponsor(i32x _iSponsorID);

///////////////////////////////


func void SendEvent_Null(i32x _iEventType,i32x _iPreRaceCyclistIndex,i32x _iParam1,i32x _iParam2,szx _szParam)
{
}
func void CSendInterface_Null(i32x _iCyclistIndexInTeam,f32x _fEffortSliderValue,f32x _fEffortMaxSliderValue)
{
}

//----------------------------------------------------------------------------------------------------------------//
//----------------------------------------------------------------------------------------------------------------//
// Local Database joins
//----------------------------------------------------------------------------------------------------------------//
//----------------------------------------------------------------------------------------------------------------//



func void vCreateLocalDatabaseJoins()
{
	var i32x iLanguage;
	var szx szColumnName;

	DATABASE_LOCAL = Database_Constructor("LocalDB");
	Database_Load(DATABASE_LOCAL, "Database/Local.cdb");


	// Create global join
	iLanguage = LANGUAGE_ENGLISH;
	szColumnName = "gene_sz_";

	if(iLanguage==LANGUAGE_ENGLISH)
		szColumnName = strcat(szColumnName,"english");
	if(iLanguage==LANGUAGE_FRENCH)
		szColumnName = strcat(szColumnName,"french");
	if(iLanguage==LANGUAGE_DUTCH)
		szColumnName = strcat(szColumnName,"dutch");
	if(iLanguage==LANGUAGE_SPANISH)
		szColumnName = strcat(szColumnName,"spanish");
	if(iLanguage==LANGUAGE_ITALIAN)
		szColumnName = strcat(szColumnName,"italian");
	if(iLanguage==LANGUAGE_GERMAN)
		szColumnName = strcat(szColumnName,"german");
	
	// Destroy old join
	if(g_oLocalJoins.m_iGameMenuString>0)
		Join_Destructor(g_oLocalJoins.m_iGameMenuString);
	if(g_oLocalJoins.m_iLocalizedString>0)
		Join_Destructor(g_oLocalJoins.m_iLocalizedString);
	if(g_oLocalJoins.m_iFormattedString>0)
		Join_Destructor(g_oLocalJoins.m_iFormattedString);
	
	g_oLocalJoins.m_iUser_szName		= Join_Constructor(DATABASE_LOCAL,"DYN_config.user_sz_name");
	g_oLocalJoins.m_iUser_szPassword	= Join_Constructor(DATABASE_LOCAL,"DYN_config.user_sz_password");

	g_oLocalJoins.m_iGameMenuString		= Join_Constructor(DATABASE_LOCAL,strcat("STA_game_menu.game_strID_text.STA_localized_string.",szColumnName));
	g_oLocalJoins.m_iLocalizedString	= Join_Constructor(DATABASE_LOCAL,strcat("STA_localized_string.",szColumnName));
	g_oLocalJoins.m_iFormattedString	= Join_Constructor(DATABASE_LOCAL,strcat("STA_formated_string.",szColumnName));

	// gateway join
	g_oLocalJoins.m_iGateway_iId		= Join_Constructor(DATABASE_LOCAL,"GAM_gateway.IDgateway");
	g_oLocalJoins.m_iGateway_szIp		= Join_Constructor(DATABASE_LOCAL,"GAM_gateway.gene_sz_ip");

	// Game player Slot join
	g_oLocalJoins.m_iSSlot_iId			= Join_Constructor(DATABASE_LOCAL,"GAM_slot.IDslot");
	g_oLocalJoins.m_iSSlot_iDate		= Join_Constructor(DATABASE_LOCAL,"GAM_slot.gene_i_date");
	g_oLocalJoins.m_iSSlot_iGameMode	= Join_Constructor(DATABASE_LOCAL,"GAM_slot.fkIDgamemode");
	g_oLocalJoins.m_iSSlot_iStageId		= Join_Constructor(DATABASE_LOCAL,"GAM_slot.fkIDstage");
	g_oLocalJoins.m_iSSlot_szDatabase	= Join_Constructor(DATABASE_LOCAL,"GAM_slot.gene_sz_database");
	g_oLocalJoins.m_iSSlot_bFirstLaunch = Join_Constructor(DATABASE_LOCAL,"GAM_slot.gene_b_firstlaunch");
	g_oLocalJoins.m_iSSlot_bGameOver	= Join_Constructor(DATABASE_LOCAL,"GAM_slot.gene_b_gameover");

	// Stage join 
	g_oLocalJoins.m_iStage_iId			= Join_Constructor(DATABASE_LOCAL,"STA_stage.IDstage");
	g_oLocalJoins.m_iStage_szRelief		= Join_Constructor(DATABASE_LOCAL,"STA_stage.gene_sz_relief");
	g_oLocalJoins.m_iStage_iType		= Join_Constructor(DATABASE_LOCAL,"STA_stage.gene_i_time_trial");
	g_oLocalJoins.m_iStage_iNameId		= Join_Constructor(DATABASE_LOCAL,"STA_stage.gene_strID_stage_name");
	g_oLocalJoins.m_iStage_iRaceId		= Join_Constructor(DATABASE_LOCAL,"STA_stage.fkIDrace");
	g_oLocalJoins.m_iStage_iRaceNameId	= Join_Constructor(DATABASE_LOCAL,"STA_stage.fkIDrace.STA_race.gene_strID_race_name");
	g_oLocalJoins.m_iStage_fLength		= Join_Constructor(DATABASE_LOCAL,"STA_stage.gene_f_distance");
	g_oLocalJoins.m_iStage_iDay			= Join_Constructor(DATABASE_LOCAL,"STA_stage.fkIDday");
	g_oLocalJoins.m_iStage_iNumber		= Join_Constructor(DATABASE_LOCAL,"STA_stage.gene_i_stage_number");

	// Race join
	g_oLocalJoins.m_iRace_iId			= Join_Constructor(DATABASE_LOCAL,"STA_race.IDrace");
	g_oLocalJoins.m_iRace_iNameId		= Join_Constructor(DATABASE_LOCAL,"STA_race.gene_strID_race_name");
	g_oLocalJoins.m_iRace_iStageNumber	= Join_Constructor(DATABASE_LOCAL,"STA_race.gene_i_number_stages");
	g_oLocalJoins.m_iRace_iCountryId	= Join_Constructor(DATABASE_LOCAL,"STA_race.fkIDcountry");
	g_oLocalJoins.m_iRace_iUciClassStrId= Join_Constructor(DATABASE_LOCAL,"STA_race.fkIDUCI_class.STA_UCI_class.gene_strID_UCI_class");
	g_oLocalJoins.m_iRace_iClassSlotId[0] = Join_Constructor(DATABASE_LOCAL,"STA_race.fkIDclassification_time");
	g_oLocalJoins.m_iRace_iClassSlotId[1] = Join_Constructor(DATABASE_LOCAL,"STA_race.fkIDclassification_mountain");
	g_oLocalJoins.m_iRace_iClassSlotId[2] = Join_Constructor(DATABASE_LOCAL,"STA_race.fkIDclassification_points");
	g_oLocalJoins.m_iRace_iClassSlotId[3] = Join_Constructor(DATABASE_LOCAL,"STA_race.fkIDclassification_team");
	g_oLocalJoins.m_iRace_iClassSlotId[4] = Join_Constructor(DATABASE_LOCAL,"STA_race.fkIDclassification_specific1");
	g_oLocalJoins.m_iRace_iClassSlotId[5] = Join_Constructor(DATABASE_LOCAL,"STA_race.fkIDclassification_specific2");
	g_oLocalJoins.m_iRace_iClassSlotId[6] = Join_Constructor(DATABASE_LOCAL,"STA_race.fkIDclassification_specific3");

	// Country join
	g_oLocalJoins.m_iCountry_iTgaId		= Join_Constructor(DATABASE_LOCAL,"STA_country.gene_tgaID_flag");
	// Tga join
	g_oLocalJoins.m_iTga_szDirectory	= Join_Constructor(DATABASE_LOCAL,"STA_TGA.fkIDdirectory.STA_directory.game_sz_directory");
	g_oLocalJoins.m_iTga_szName			= Join_Constructor(DATABASE_LOCAL,"STA_TGA.gene_sz_TGA");
}

func void vDestroyLocalDatabaseJoins()
{
	// Race join
	if(g_oMenuJoins.m_jCyclist_szLastName>0)
	{
		Join_Destructor(g_oMenuJoins.m_jCyclist_szLastName);
		g_oMenuJoins.m_jCyclist_szLastName = 0;
	}
	if(g_oMenuJoins.m_jCyclist_szFirstName>0)
	{
		Join_Destructor(g_oMenuJoins.m_jCyclist_szFirstName);
		g_oMenuJoins.m_jCyclist_szFirstName = 0;
	}
	if(g_oMenuJoins.m_jCyclist_iTgaPhotoID>0)
	{
		Join_Destructor(g_oMenuJoins.m_jCyclist_iTgaPhotoID);
		g_oMenuJoins.m_jCyclist_iTgaPhotoID = 0;
	}	
	var i32x i;
	i=0;
	while(i<7)
	{
		if(g_oMenuJoins.m_jStageClassification[i]>0)
		{
			Join_Destructor(g_oMenuJoins.m_jStageClassification[i]);
			Join_Destructor(g_oMenuJoins.m_jRaceClassification[i]);
			g_oMenuJoins.m_jStageClassification[i] = 0;
			g_oMenuJoins.m_jRaceClassification[i] = 0;
		}
		i=i+1;
	}

	// Tga  join
	if(g_oLocalJoins.m_iTga_szDirectory>0)
	{
		Join_Destructor(g_oLocalJoins.m_iTga_szDirectory);
		g_oLocalJoins.m_iTga_szDirectory = 0;
	}
	if(g_oLocalJoins.m_iTga_szName>0)
	{
		Join_Destructor(g_oLocalJoins.m_iTga_szName);
		g_oLocalJoins.m_iTga_szName = 0;
	}
	// Localized string join
	if(g_oLocalJoins.m_iGameMenuString>0)
	{
		Join_Destructor(g_oLocalJoins.m_iGameMenuString);
		g_oLocalJoins.m_iGameMenuString = 0;
	}
	if(g_oLocalJoins.m_iLocalizedString>0)
	{
		Join_Destructor(g_oLocalJoins.m_iLocalizedString);
		g_oLocalJoins.m_iLocalizedString = 0;
	}
	if(g_oLocalJoins.m_iFormattedString>0)
	{
		Join_Destructor(g_oLocalJoins.m_iFormattedString);
		g_oLocalJoins.m_iFormattedString = 0;
	}

	if(g_oLocalJoins.m_iUser_szName>0)
	{
		Join_Destructor(g_oLocalJoins.m_iUser_szName);
		g_oLocalJoins.m_iUser_szName = 0;
	}

	if(g_oLocalJoins.m_iUser_szPassword>0)
	{
		Join_Destructor(g_oLocalJoins.m_iUser_szPassword);
		g_oLocalJoins.m_iUser_szPassword = 0;
	}

	// gateway join
	if(g_oLocalJoins.m_iGateway_iId>0)
	{
		Join_Destructor(g_oLocalJoins.m_iGateway_iId);
		g_oLocalJoins.m_iGateway_iId = 0;
	}
	if(g_oLocalJoins.m_iGateway_szIp>0)
	{
		Join_Destructor(g_oLocalJoins.m_iGateway_szIp);
		g_oLocalJoins.m_iGateway_szIp = 0;
	}

	// Single player slot
	if(g_oLocalJoins.m_iSSlot_iId>0)
	{
		Join_Destructor(g_oLocalJoins.m_iSSlot_iId);
		g_oLocalJoins.m_iSSlot_iId = 0;
	}
	if(g_oLocalJoins.m_iSSlot_iDate>0)
	{
		Join_Destructor(g_oLocalJoins.m_iSSlot_iDate);
		g_oLocalJoins.m_iSSlot_iDate = 0;
	}
	if(g_oLocalJoins.m_iSSlot_iGameMode>0)
	{
		Join_Destructor(g_oLocalJoins.m_iSSlot_iGameMode);
		g_oLocalJoins.m_iSSlot_iGameMode = 0;
	}
	if(g_oLocalJoins.m_iSSlot_iStageId>0)
	{
		Join_Destructor(g_oLocalJoins.m_iSSlot_iStageId);
		g_oLocalJoins.m_iSSlot_iStageId = 0;
	}
	if(g_oLocalJoins.m_iSSlot_szDatabase>0)
	{
		Join_Destructor(g_oLocalJoins.m_iSSlot_szDatabase);
		g_oLocalJoins.m_iSSlot_szDatabase = 0;
	}
	if(g_oLocalJoins.m_iSSlot_bFirstLaunch>0)
	{
		Join_Destructor(g_oLocalJoins.m_iSSlot_bFirstLaunch);
		g_oLocalJoins.m_iSSlot_bFirstLaunch = 0;
	}
	if(g_oLocalJoins.m_iSSlot_bGameOver)
	{
		Join_Destructor(g_oLocalJoins.m_iSSlot_bGameOver);
		g_oLocalJoins.m_iSSlot_bGameOver = 0;
	}


	// Stage join
	if(g_oLocalJoins.m_iStage_szRelief>0)
	{
		Join_Destructor(g_oLocalJoins.m_iStage_szRelief);
		g_oLocalJoins.m_iStage_szRelief = 0;
	}
	if(g_oLocalJoins.m_iStage_iId>0)
	{
		Join_Destructor(g_oLocalJoins.m_iStage_iId);
		g_oLocalJoins.m_iStage_iId = 0;
	}
	if(g_oLocalJoins.m_iStage_iType>0)
	{
		Join_Destructor(g_oLocalJoins.m_iStage_iType);
		g_oLocalJoins.m_iStage_iType = 0;
	}
	if (g_oLocalJoins.m_iStage_iNameId)
	{
		Join_Destructor(g_oLocalJoins.m_iStage_iNameId);
		g_oLocalJoins.m_iStage_iNameId = 0;
	}
	if (g_oLocalJoins.m_iStage_iRaceId)
	{
		Join_Destructor(g_oLocalJoins.m_iStage_iRaceId);
		g_oLocalJoins.m_iStage_iRaceId = 0;
	}
	if (g_oLocalJoins.m_iStage_iRaceNameId)
	{
		Join_Destructor(g_oLocalJoins.m_iStage_iRaceNameId);
		g_oLocalJoins.m_iStage_iRaceNameId = 0;
	}
	if (g_oLocalJoins.m_iStage_fLength)
	{
		Join_Destructor(g_oLocalJoins.m_iStage_fLength);
		g_oLocalJoins.m_iStage_fLength = 0;
	}
	if (g_oLocalJoins.m_iStage_iDay)
	{
		Join_Destructor(g_oLocalJoins.m_iStage_iDay);
		g_oLocalJoins.m_iStage_iDay = 0;
	}
	if (g_oLocalJoins.m_iStage_iNumber)
	{
		Join_Destructor(g_oLocalJoins.m_iStage_iNumber);
		g_oLocalJoins.m_iStage_iNumber = 0;
	}
	// Country join
	if (g_oLocalJoins.m_iCountry_iTgaId)
	{
		Join_Destructor(g_oLocalJoins.m_iCountry_iTgaId);
		g_oLocalJoins.m_iCountry_iTgaId = 0;
	}

	// Race join 
	if(g_oLocalJoins.m_iRace_iId>0)
	{
		Join_Destructor(g_oLocalJoins.m_iRace_iId);
		g_oLocalJoins.m_iRace_iId = 0;
	}
	if(g_oLocalJoins.m_iRace_iNameId>0)
	{
		Join_Destructor(g_oLocalJoins.m_iRace_iNameId);
		g_oLocalJoins.m_iRace_iNameId = 0;
	}
	if(g_oLocalJoins.m_iRace_iStageNumber>0)
	{
		Join_Destructor(g_oLocalJoins.m_iRace_iStageNumber);
		g_oLocalJoins.m_iRace_iStageNumber = 0;
	}
	if(g_oLocalJoins.m_iRace_iCountryId>0)
	{
		Join_Destructor(g_oLocalJoins.m_iRace_iCountryId);
		g_oLocalJoins.m_iRace_iCountryId = 0;
	}
	if(g_oLocalJoins.m_iRace_iUciClassStrId>0)
	{
		Join_Destructor(g_oLocalJoins.m_iRace_iUciClassStrId);
		g_oLocalJoins.m_iRace_iUciClassStrId = 0;
	}

	i=0;
	while(i<7)
	{
		if(g_oLocalJoins.m_iRace_iClassSlotId[i])
		{
			Join_Destructor(g_oLocalJoins.m_iRace_iClassSlotId[i]);
			g_oLocalJoins.m_iRace_iClassSlotId[i] = 0;
		}
		i=i+1;
	}

	if (DATABASE_LOCAL)
	{
		Database_Destructor(DATABASE_LOCAL);
	}
	DATABASE_LOCAL = 0;
}




func void init ()
{
	// MenuServer settings
	g_oMenuServer.m_szIP = "127.0.0.1";

	// Create local DB join
	vCreateLocalDatabaseJoins();
}

func void InitInternet(szx szIP, i32x iPort, i32x iServer, szx szLogin, szx szPassword)
{
	g_oGameConfig.m_iSinglePlayer = 0;
	g_oGameConfig.m_iInternet = 1;
	g_oMenuServer.m_iPort = iPort;
	
	if (iServer==0)	
	{
		g_oMenuServer.m_szIP = szIP;

		// connect to menu server
		g_pMenuServerSocket = NetClient_Create( g_oMenuServer.m_szIP, g_oMenuServer.m_iPort, g_gcManager);
	}
}
func void InitNoInternet()
{
	println("Cycling Manager Demo Version " + ftoa(getCMversion()));

	var Gui_Component pComponent;

	g_oGameConfig.m_iInternet = 0;
	g_oGameConfig.m_iSinglePlayer = 1;

	// Load Gui Material Kits
	g_MapKits_Load();

	// load graphic chart
	g_Chart_Load();

	// Load Texture of common kits
	LoadKit(mkTools);
	LoadKit(mkFonts);
	LoadKit(mkInterface3D);

	// Screen resolution
	g_iScreenWidth = GetViewportWidth();
	g_iScreenHeight = GetViewportHeight();
	g_iScreenWidthDiv2 = g_iScreenWidth/2;
	g_iScreenHeightDiv2 = g_iScreenHeight/2;
	// Compute resolution scale factor
	g_fScreenScaleFactor = g_iScreenWidth;
	g_fScreenScaleFactor = g_fScreenScaleFactor / 800.0;
	g_iScreenBottomOffset = 20;
	g_iScreenTopOffset = 20;
	g_iScreenLeftOffset = 20;
	g_iScreenRightOffset = 20;

	// Update mouse
	SetMouseMaterial(smMouse);

	// Create an object
	g_gcManager = NewObject(Gui_iPage_System);
	// Set this object as first of all
	ManagerComponent(g_gcManager);

	// Set debug component
	DebugComponent(NewDebugObject());

	// Create
	g_gcManager<<Create();

	// tutu debug : gateway connection
	// new component
	//pComponent = NewObject(iUserGatewayInterface);
	//MountComponent(g_gcManager, pComponent);
	//g_pGatewaySocket = NetClient_Create( "Mura", g_iGatewayPort, pComponent);


	//SetRasterDisplayStatus(0,1);
	//SetRasterDisplayStatus(3,1);
	//SetRasterTextDisplayStatus(3,1);
	//SetRasterDisplayStatus(4,1);
}

func void exit()
{
	print("Exit");
	
	if (g_pMenuServerSocket)
	{
		NetClient_Disconnect(g_pMenuServerSocket);
		g_pMenuServerSocket = G_pNullClient;
	}

	// Destroy local MS
	DestroyMenuServer();
	// Destroy global joins
	DestroyGlobalJoin();
	// Destroy local joins
	vDestroyLocalDatabaseJoins();
}

