
// *********************************************
// * connection/disconnection callbacks
// *********************************************


// connection callback
func void fnGatewayConnectCB( Net_Client _pClient )
{
	print("<< Gateway connection\n");

	// login
	g_oLobby.m_oServer<< mGateway_UserLogin( g_oUser.m_szLogin, g_oUser.m_szPass,g_szInternetConfig);
}

// connection callback
func void fnGatewaySimpleConnectCB( Net_Client _pClient )
{
	print("<< Gateway connection\n");

	// login
	if(g_oGameConfig.m_iSinglePlayer)
	{
		g_oLobby.m_oServer << mGateway_UserSimpleLogin( "Cyanide" );
	}
	else
	{
		g_oLobby.m_oServer << mGateway_UserSimpleLogin( g_oUser.m_szLogin );
	}
}

// disconnection callback
func void fnGatewayDisconnectCB( Net_Client _pClient )
{
	print("<< Gateway disconnection\n");

	// delete gateway client
	g_oLobby.m_oServer = G_pNullClient;
}

// *********************************************
// * incomming messages
// *********************************************

// database reception
func void fnGatewayDatabase_Data(szx _szDatabaseName)
{
	print(_szDatabaseName + " database from gateway received\n" );
	if (QUERY_GAME_SERVERS)
	{
		println("** tutu debug : game servers DB **");
		Database_Destructor(QUERY_GAME_SERVERS);
	}

	print(_szDatabaseName + " database from gateway received\n" );
	QUERY_GAME_SERVERS = Database_Constructor(_szDatabaseName);
	Database_Receive(QUERY_GAME_SERVERS,_szDatabaseName,g_oLobby.m_oServer);
}

// login confirmation
func void fnGatewayLoginOK()
{
	// store login
	print("<< Gateway login ok\n");

	// game servers query
	print("tutu debug : no game server query\n");
	//g_oLobby.m_oServer << mQueryDatabase("game servers"); // fnGameServersQueryOK
}

// duplicate login : confirmation or cancel
func void DuplicateLogin_MessageBoxCallback(i32x iResult)
{
	// ok
	if (iResult==0)
	{
		// reset connection
		g_oLobby.m_oServer<< mGateway_UserResetConnection();
	}
}

// duplicate login : ask for confirmation
func void fnGatewayLoginDuplicated()
{
	print("Already connected\n");
	DuplicateLogin_MessageBoxCallback(1);
}


// game servers query confirmation
func void fnGameServersQueryOK()
{
	print("<< Received Game servers\n");
}




func void fnGatewayAuthorizationOK(szx _szAuthorization,szx _szIP,i32x _iPort)
{
	// ** lan **
	if (g_oGameConfig.m_iInternet==0)
	{
		g_oMenuServer.m_szIP = g_oLobby.m_szIP;
	}
	else
	{
		g_oMenuServer.m_szIP = _szIP;
	}
	g_oMenuServer.m_iPort = _iPort;

	print("connecting to game at ");
	print(g_oMenuServer.m_szIP);
	print(":");
	print(itoa(g_oMenuServer.m_iPort));
	print("with authorization ");
	println(_szAuthorization);

	// store authorization
	g_oUser.m_szGatewayAuthorization  = _szAuthorization;

	// connect to game
	g_pMenuServerSocket = NetClient_Create(
		g_oMenuServer.m_szIP,
		g_oMenuServer.m_iPort, 
		g_gcManager
	);
}

func void fnGatewayAuthorizationFailed()
{
	print("gateway authorization failed.\n");
}

func void fnGatewayNotifyNewGame(szx szGame, szx szAdmin, i32x iGameMode, i32x bHasPassword)
{
	var i32x iTableGame, iNewRow;
	iTableGame = Table_GetIndexFromName(QUERY_GAME_SERVERS,"Games");
	iNewRow =	Table_AddRow(QUERY_GAME_SERVERS,iTableGame);

	Join_SetStringFromIndex(	g_oGatewayJoins.m_iGame_szDescJoin, iNewRow, szGame);
	Join_SetStringFromIndex(	g_oGatewayJoins.szAdmin,			iNewRow, szAdmin);
	Join_SetIntFromIndex(		g_oGatewayJoins.iGameMode,			iNewRow, iGameMode);
	Join_SetIntFromIndex(		g_oGatewayJoins.bHasPassword,		iNewRow, bHasPassword);
}
func void fnGatewayNotifyDelGame(szx szGame)
{
	var i32x iTableGame, iKey;
	iKey = Join_FindKeyFromStringData(g_oGatewayJoins.m_iGame_szDescJoin,szGame);
	if (iKey>0)
	{
		iTableGame = Table_GetIndexFromName(QUERY_GAME_SERVERS,"Games");
		Table_DeleteRowFromKey(QUERY_GAME_SERVERS,iTableGame,iKey);
		Database_DeleteNow(QUERY_GAME_SERVERS);
	}
}




// *********************************************
// * functions
// *********************************************

func void LoginFailed_MessageBoxCallback(i32x _iResult)
{
}


