func Gui_Component NewStageInfoForm2()
{
	var Gui_Component pform;
	pform= NewForm(DATABASE_CLIENT,"STA_stage",false);

	pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	pform<<FormSetOffset(20);
	pform<<FormSetWidth(512);
	pform<<FormSetLocked(true);

	pform<<FormSetFont(smImpact,smBauer);
	pform<<FormShowField("STA_stage.fkIDrace.STA_race.gene_strID_race_name","",0,0);
	pform<<FormShowField("STA_stage.gene_strID_stage_name","",0,32);

	return pform;
}

func szx GetClassSlotName(i32x _iSlot)
{
	var szx szSlot;
	if(_iSlot==RACE_SLOT_TIME)
		szSlot = "gene_f_time"; 
	else if(_iSlot==RACE_SLOT_MOUNTAIN)
		szSlot = "gene_f_mountain"; 
	else if(_iSlot==RACE_SLOT_POINT)
		szSlot = "gene_f_point"; 
	else if(_iSlot==RACE_SLOT_TEAM)
		szSlot = "gene_f_time"; 
	else if(_iSlot==RACE_SLOT_SPEC1)
		szSlot = "gene_f_spec1"; 
	else if(_iSlot==RACE_SLOT_SPEC2)
		szSlot = "gene_f_spec2"; 
	else
		szSlot = "gene_f_spec3"; 

	return szSlot;
}

func void SortClassSlot(i32x _iClassificationId,i32x _iJoinId)
{
	var i32x iCriteriumType;

	iCriteriumType = GetClassificationType(_iClassificationId);

	if(iCriteriumType==0)
	{
		// More point is best
		Join_Sort(_iJoinId,-1);
	}
	else
	{
		// less time is best
		Join_Sort(_iJoinId,1);
	}
}
func i32x GetClassificationType(i32x _iClassificationId)
{
	var i32x iCriteriumType;

	iCriteriumType = Join_GetIntFromKey(g_oMenuJoins.m_iClass_Criterium,_iClassificationId);

	return iCriteriumType;
}

func i32x GetRaceClassId(i32x _iRaceId,i32x _iSlot)
{
	var i32x iClassificationId;

	iClassificationId = Join_GetIntFromKey(g_oLocalJoins.m_iRace_iClassSlotId[_iSlot],_iRaceId);

	return iClassificationId;
}

func void Classification_OnInitData()
{
	var Gui_Component pthis,pcaption,pwindow;
	var Gui_dtPage_Classification pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_Classification;
	SetData(pthis,pdtData);
}

func i32x Classification_OnCreate()
{
	var Gui_Component pthis,pcaption,pwindow,poption;
	var Gui_dtPage_Classification pdtData;
	var i32x iStageId,iRaceId;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = GetData(pthis);

	// Caption
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszClassement));
	MountComponent(pthis,pcaption);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetColor(pcaption, cPageTitleColor);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// Race form
	pdtData.gcStageForm = NewStageInfoForm2();
	MountComponent(pthis,pdtData.gcStageForm);
	MoveTo(pdtData.gcStageForm,0,g_iScreenTopOffset+10);

	// Onglet selector
	pdtData.gcOption = NewGroupOption(700.0*g_fScreenScaleFactor);
	MountComponent(pthis,pdtData.gcOption);
	MoveTo(pdtData.gcOption,10,g_iScreenTopOffset+75);

	// Tab selector
	pdtData.gcControlTab = NewTabControl();
	MountComponent(pthis,pdtData.gcControlTab);
	MoveTo(pdtData.gcControlTab,g_iScreenLeftOffset,g_iScreenTopOffset+125);

	// Onglet selector
	poption = NewTextRadioButton(smBauer,GetLocalizedFromKey(iszSaison),0);
	Stretch(poption,10,0);
	pdtData.gcOption<<AddOption(poption);
	poption = NewTextRadioButton(smBauer,GetLocalizedFromKey(iszCourse),1);
	Stretch(poption,10,0);
	pdtData.gcOption<<AddOption(poption);
	poption = NewTextRadioButton(smBauer,GetLocalizedFromKey(iszEtape),2);
	Stretch(poption,10,0);
	pdtData.gcOption<<AddOption(poption);

	pdtData.m_iCurrentOnglet = 0;

	iStageId = Join_GetIntFromIndex(g_oMenuJoins.m_iConfig_iLastStageId,0);
	iRaceId = Join_GetIntFromKey(g_oLocalJoins.m_iStage_iRaceId,iStageId);
	// Class list form
	// Create subset for form
	pdtData.m_iRaceSubset = Subset_Constructor("SUBSET_RACE_CLASS",DATABASE_CLIENT);
	Database_AddTables(pdtData.m_iRaceSubset,4);
	Table_SetName(pdtData.m_iRaceSubset, 0, "DYN_classification_race");
	TableSubset_SelectColumns(pdtData.m_iRaceSubset, 0, "*");
	Table_SetName(pdtData.m_iRaceSubset, 1, "DYN_cyclist");
	TableSubset_SelectColumns(pdtData.m_iRaceSubset, 1, "fkIDcharacteristic");
	Table_SetName(pdtData.m_iRaceSubset, 2, "DYN_team");
	TableSubset_SelectColumns(pdtData.m_iRaceSubset, 2, "*");
	Table_SetName(pdtData.m_iRaceSubset, 3, "DYN_characteristic");
	TableSubset_SelectColumns(pdtData.m_iRaceSubset, 3, "*");

	pdtData.m_iStageSubset = Subset_Constructor("SUBSET_STAGE_CLASS",DATABASE_CLIENT);
	Database_AddTables(pdtData.m_iStageSubset,4);
	Table_SetName(pdtData.m_iStageSubset, 0, "DYN_classification_stage");
	TableSubset_SelectColumns(pdtData.m_iStageSubset, 0, "*");
	Table_SetName(pdtData.m_iStageSubset, 1, "DYN_cyclist");
	TableSubset_SelectColumns(pdtData.m_iStageSubset, 1, "fkIDcharacteristic");
	Table_SetName(pdtData.m_iStageSubset, 2, "DYN_team");
	TableSubset_SelectColumns(pdtData.m_iStageSubset, 2, "*");
	Table_SetName(pdtData.m_iStageSubset, 3, "DYN_characteristic");
	TableSubset_SelectColumns(pdtData.m_iStageSubset, 3, "*");

	// Simul Database sync
	Classification_OnDatabaseSync();

	// Season
	pdtData.gcSeasonClassListForm = NewSeasonClassificationListForm(DATABASE_CLIENT);
	pwindow = NewWindow(650,300);
	pwindow<<WindowMount(pdtData.gcSeasonClassListForm);
	pdtData.gcControlTab<<AddTab(pwindow);
	
	// Race
	pdtData.gcRaceClassListForm = NewRaceClassificationListForm(pdtData.m_iRaceSubset,25);
	pwindow = NewWindow(650,300);
	pwindow<<WindowMount(pdtData.gcRaceClassListForm);
	pdtData.gcControlTab<<AddTab(pwindow);

	// Stage
	pdtData.gcStageClassListForm = NewStageClassificationListForm(pdtData.m_iStageSubset);
	pwindow = NewWindow(650,300);
	pwindow<<WindowMount(pdtData.gcStageClassListForm);
	pdtData.gcControlTab<<AddTab(pwindow);

	// Resimul Database sync
	Classification_OnDatabaseSync();

	// Show season tab by default
	pdtData.gcControlTab<<ShowTab(pdtData.m_iCurrentOnglet);

	// navigation bar
	pdtData.gcNavBar = NewNavBar();
	MountComponent(pthis, pdtData.gcNavBar);
	MoveTo(pdtData.gcNavBar, g_iScreenWidth-SizeX(pdtData.gcNavBar)-g_iScreenRightOffset, g_iScreenHeight-SizeY(pdtData.gcNavBar)-g_iScreenBottomOffset);
	pdtData.gcNavBar<<SetReload(false);
	pdtData.gcNavBar<<SetApply(false);

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func void Classification_OnDatabaseSync()
{
	var Gui_Component pthis,pcaption,pwindow;
	var Gui_dtPage_Classification pdtData;
	var i32x iStageId,iRaceId;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = GetData(pthis);

	iStageId = Join_GetIntFromIndex(g_oMenuJoins.m_iConfig_iLastStageId,0);
	iRaceId = Join_GetIntFromKey(g_oLocalJoins.m_iStage_iRaceId,iStageId);
	// Select classification of current race 
	Query_Create(0,pdtData.m_iRaceSubset);
	Query_SelectTable(	0, "DYN_classification_race");
	Query_SelectTable(	0, "DYN_classification_race.fkIDcyclist.DYN_cyclist");
	Query_SelectTable(	0, "DYN_classification_race.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_classification_race.fkIDteam.DYN_team");
	Query_SelectWhereIntEqual(0,"DYN_classification_race.fkIDrace", iRaceId);
	Query_SelectWhereIntEqual(0,"DYN_classification_race.fkIDcyclist.DYN_cyclist.race_b_withdrawal", 0);
	Query_Execute(0);

	// Select classification of current race 
	Query_Create(0,pdtData.m_iStageSubset);
	Query_SelectTable(	0, "DYN_classification_stage");
	Query_SelectTable(	0, "DYN_classification_stage.fkIDcyclist.DYN_cyclist");
	Query_SelectTable(	0, "DYN_classification_stage.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_classification_stage.fkIDteam.DYN_team");
	Query_SelectWhereIntEqual(0,"DYN_classification_stage.fkIDstage", iStageId);
	Query_SelectWhereIntEqual(0,"DYN_classification_stage.fkIDcyclist.DYN_cyclist.race_b_withdrawal", 0);
	Query_Execute(0);


	// Update formulaire
	if(pdtData.m_iCurrentOnglet==1)
	{
		if(pdtData.gcRaceClassListForm)
			pdtData.gcRaceClassListForm<<FormFilterByIntDifferent("DYN_classification_race.fkIDcyclist",0);
	}
	else if(pdtData.m_iCurrentOnglet==2)
	{
		if(pdtData.gcStageClassListForm)
			pdtData.gcStageClassListForm<<FormFilterByIntDifferent("DYN_classification_stage.fkIDcyclist",0);
	}
	else if(pdtData.m_iCurrentOnglet==0)
	{
		if(pdtData.gcSeasonClassListForm)
			pdtData.gcSeasonClassListForm<<FormFilterByIntDifferent("DYN_classification_season.fkIDcyclist",0);
	}
	if(pdtData.gcStageForm)
		pdtData.gcStageForm<<FormFilterByIntEqual("STA_stage.IDstage",iStageId);
}

func void Classification_OnRadioCheck(Gui_Component _pComponent,i32x _iValue)
{
	var Gui_Component pthis,ptmp;
	var Gui_dtPage_Classification pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	if(_pComponent == pdtData.gcOption)
	{
		pdtData.m_iCurrentOnglet = 	_iValue;
		// Update formulaire
		if(pdtData.m_iCurrentOnglet==1)
		{
			if(pdtData.gcRaceClassListForm)
				pdtData.gcRaceClassListForm<<FormFilterByIntDifferent("DYN_classification_race.fkIDcyclist",0);
		}
		else if(pdtData.m_iCurrentOnglet==2)
		{
			if(pdtData.gcStageClassListForm)
				pdtData.gcStageClassListForm<<FormFilterByIntDifferent("DYN_classification_stage.fkIDcyclist",0);
		}
		else if(pdtData.m_iCurrentOnglet==0)
		{
			if(pdtData.gcSeasonClassListForm)
				pdtData.gcSeasonClassListForm<<FormFilterByIntDifferent("DYN_classification_season.fkIDcyclist",0);
		}
		// Show correspondant tab
		pdtData.gcControlTab<<ShowTab(_iValue);
	}
}

func void  Classification_OnRelease()
{
	var Gui_Component pthis,ptmp;
	var i32x i,iNumComponents;
	var Gui_dtPage_Classification pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	iNumComponents = GetComponentNumber(pthis);
	i=0;
	while(i<iNumComponents)
	{
		ptmp = GetComponent(pthis,i);
		if(ptmp)
		{
			DeleteComponent(ptmp);
		}
		i=i+1;
	}

	pdtData.gcRaceClassListForm = NULL;
	pdtData.gcStageClassListForm = NULL;
	pdtData.gcSeasonClassListForm = NULL;

	// Destroy subset if needed
	if(pdtData.m_iRaceSubset)
	{
		Subset_Destructor(pdtData.m_iRaceSubset);
		pdtData.m_iRaceSubset = 0;
	}
	if(pdtData.m_iStageSubset)
	{
		Subset_Destructor(pdtData.m_iStageSubset);
		pdtData.m_iStageSubset = 0;
	}
}

func i32x  Classification_OnDestroy()
{
	var Gui_Component pthis,pcaption,pwindow;
	var Gui_dtPage_Classification pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = GetData(pthis);

	if(pdtData)
	{
		// Destroy subset if needed
		if(pdtData.m_iRaceSubset)
		{
			Subset_Destructor(pdtData.m_iRaceSubset);
			pdtData.m_iRaceSubset = 0;
		}
		if(pdtData.m_iStageSubset)
		{
			Subset_Destructor(pdtData.m_iStageSubset);
			pdtData.m_iStageSubset = 0;
		}
	}
}

func void  Classification_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_Classification pdtData;
	// get this pointer
	pthis = GetThis();
	// Get Data pointer
	pdtData = GetData(pthis);
}

//
func void Classification_NavBack()
{
	var Gui_Component pthis, pparent;
	var Gui_dtPage_Palmares pdtData;
	pthis = GetThis();
	pdtData = GetData(pthis);

	// go back
	pparent = GetParent(pthis);
	pparent<<GoBack();
}

//
func Gui_Component NewRaceClassificationListForm(i32x _iSubsetId,i32x _iRaceId)
{
	var Gui_Component pform;
	var Gui_dtForm_RaceClassificationList pdtData;
	var i32x iClassId,iStrId,szCaption,i,iNumRows,iJoinId;
	var f32x fTime;

	pdtData = new Gui_dtForm_RaceClassificationList;

	pdtData.fFirstTime = 0.0;
	pdtData.fFirstSpec1 = 0.0;
	pdtData.fFirstSpec2 = 0.0;
	pdtData.fFirstSpec3 = 0.0;

	// Get classification name
	iClassId = GetRaceClassId(_iRaceId,0);
	if(iClassId>0)
	{
		pdtData.iTimeSlot = iClassId;
		iStrId = Join_GetIntFromKey(g_oMenuJoins.m_iClass_iStrId,iClassId);
		pdtData.szTimeSlot = GetLocalizedFromKey(iStrId);

		// Get first time classification
		iJoinId = Join_Constructor(_iSubsetId,"DYN_classification_race.gene_f_time");
		SortClassSlot(iClassId,iJoinId);
		iNumRows = Join_GetNumRows(iJoinId);
		i=0;
		while(i<iNumRows)
		{
			fTime = Join_GetFloatFromSortedIndex(iJoinId,i);
			if(fTime!= 0.0)
			{
				pdtData.fFirstTime = fTime;
				i = iNumRows;
			}
			i=i+1;
		}
		
	}

	iClassId = GetRaceClassId(_iRaceId,1);
	if(iClassId>0)
	{
		pdtData.iMountainSlot = iClassId;
		iStrId = Join_GetIntFromKey(g_oMenuJoins.m_iClass_iStrId,iClassId);
		pdtData.szMountainSlot = GetLocalizedFromKey(iStrId);
	}

	iClassId = GetRaceClassId(_iRaceId,2);
	if(iClassId>0)
	{
		pdtData.iPointSlot = iClassId;
		iStrId = Join_GetIntFromKey(g_oMenuJoins.m_iClass_iStrId,iClassId);
		pdtData.szPointSlot = GetLocalizedFromKey(iStrId);
	}

	iClassId = GetRaceClassId(_iRaceId,4);
	if(iClassId>0)
	{
		pdtData.iSpec1Slot = iClassId;
		iStrId = Join_GetIntFromKey(g_oMenuJoins.m_iClass_iStrId,iClassId);
		pdtData.szSpec1Slot = GetLocalizedFromKey(iStrId);

		if(GetClassificationType(iClassId)==1)
		{
			// Get spec 1 time classification
			iJoinId = Join_Constructor(_iSubsetId,"DYN_classification_race.gene_f_spec1");
			SortClassSlot(iClassId,iJoinId);
			iNumRows = Join_GetNumRows(iJoinId);
			i=0;
			while(i<iNumRows)
			{
				fTime = Join_GetFloatFromSortedIndex(iJoinId,i);
				if(fTime!= 0.0)
				{
					pdtData.fFirstSpec1 = fTime;
					i = iNumRows;
				}
				i=i+1;
			}
		}
	}

	iClassId = GetRaceClassId(_iRaceId,5);
	if(iClassId>0)
	{
		pdtData.iSpec2Slot = iClassId;
		iStrId = Join_GetIntFromKey(g_oMenuJoins.m_iClass_iStrId,iClassId);
		pdtData.szSpec2Slot = GetLocalizedFromKey(iStrId);
		if(GetClassificationType(iClassId)==1)
		{
			// Get spec 2 time classification
			iJoinId = Join_Constructor(_iSubsetId,"DYN_classification_race.gene_f_spec2");
			SortClassSlot(iClassId,iJoinId);
			iNumRows = Join_GetNumRows(iJoinId);
			i=0;
			while(i<iNumRows)
			{
				fTime = Join_GetFloatFromSortedIndex(iJoinId,i);
				if(fTime!= 0.0)
				{
					pdtData.fFirstSpec2 = fTime;
					i = iNumRows;
				}
				i=i+1;
			}
		}
	}

	iClassId = GetRaceClassId(_iRaceId,6);
	if(iClassId>0)
	{
		pdtData.iSpec3Slot = iClassId;
		iStrId = Join_GetIntFromKey(g_oMenuJoins.m_iClass_iStrId,iClassId);
		pdtData.szSpec3Slot = GetLocalizedFromKey(iStrId);
		if(GetClassificationType(iClassId)==1)
		{
			// Get spec 3 time classification
			iJoinId = Join_Constructor(_iSubsetId,"DYN_classification_race.gene_f_spec3");
			SortClassSlot(iClassId,iJoinId);
			iNumRows = Join_GetNumRows(iJoinId);
			i=0;
			while(i<iNumRows)
			{
				fTime = Join_GetFloatFromSortedIndex(iJoinId,i);
				if(fTime!= 0.0)
				{
					pdtData.fFirstSpec3 = fTime;
					i = iNumRows;
				}
				i=i+1;
			}
		}
	}
	
	// New list form
	pform = NewListForm(_iSubsetId,"DYN_classification_race",false);
	pform<<FormSetOffset(4);

	AddInterface(pform,Gui_iForm_RaceClassificationList,pdtData);

	return pform;
}
func void RaceClassificationListForm_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var Gui_Component pform;
	var Gui_dtForm_RaceClassificationList pdtData;
	var i32x i,iPosX;
	var szx szTxt;

	pform = GetThis();
	pdtData = GetData(pform);

	iPosX = 0;
	_pform<<FormSetDecimal(0);
	_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	_pform<<FormSetWidth(128);
	_pform<<FormSetOffset(0);

	_pform<<FormAddVariable("DYN_classification_race.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname","CYCLISTNAME");
	_pform<<FormAddVariable("DYN_classification_race.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_firstname","CYCLISTFIRSTNAME");
	if(_iIndex==0)
	{
		_pform<<FormSetTitle(true,true);
		_pform<<FormShowFormatField("DYN_classification_race.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",39,"",iPosX,0);
		_pform<<FormSetTitle(true,false);

		_pform<<FormSetWidth(128);
		_pform<<FormSetFont(smTrebuchet,smTrebuchet);
		if(pdtData.iTimeSlot)
		{
			_pform<<FormSetFormatType(g_iConst_FormatHMSOffset,pdtData.fFirstTime);
			_pform<<FormShowField("DYN_classification_race.gene_f_time",pdtData.szTimeSlot,iPosX,0);
			_pform<<FormSetFormatType(g_iConst_FormatNormal,1.0);
			iPosX = iPosX +128;
		}
		if(pdtData.iPointSlot)
		{
			_pform<<FormShowField("DYN_classification_race.gene_f_point",pdtData.szPointSlot,iPosX,0);
			iPosX = iPosX +128;
		}
		if(pdtData.iMountainSlot)
		{
			_pform<<FormShowField("DYN_classification_race.gene_f_mountain",pdtData.szMountainSlot,iPosX,0);
			iPosX = iPosX +128;
		}
		if(pdtData.iSpec1Slot)
		{
			if(GetClassificationType(pdtData.iSpec1Slot)==1)
				_pform<<FormSetFormatType(g_iConst_FormatHMSOffset,pdtData.fFirstSpec1);
			_pform<<FormShowField("DYN_classification_race.gene_f_spec1",pdtData.szSpec1Slot,iPosX,0);
			iPosX = iPosX +128;
			_pform<<FormSetFormatType(g_iConst_FormatNormal,1.0);
		}
		if(pdtData.iSpec2Slot)
		{
			if(GetClassificationType(pdtData.iSpec1Slot)==1)
				_pform<<FormSetFormatType(g_iConst_FormatHMSOffset,pdtData.fFirstSpec2);
			_pform<<FormShowField("DYN_classification_race.gene_f_spec2",pdtData.szSpec2Slot,iPosX,0);
			iPosX = iPosX +128;
			_pform<<FormSetFormatType(g_iConst_FormatNormal,1.0);
		}
		if(pdtData.iSpec3Slot)
		{
			if(GetClassificationType(pdtData.iSpec1Slot)==1)
				_pform<<FormSetFormatType(g_iConst_FormatHMSOffset,pdtData.fFirstSpec3);
			_pform<<FormShowField("DYN_classification_race.gene_f_spec3",pdtData.szSpec3Slot,iPosX,0);
			iPosX = iPosX +128;
		}
	}
	else
	{
		_pform<<FormSetTitle(false,true);
		_pform<<FormShowFormatField("DYN_classification_race.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",39,"",iPosX,0);
		_pform<<FormSetTitle(false,false);

		_pform<<FormSetWidth(128);
		_pform<<FormSetFont(smTrebuchet,smTrebuchet);
		if(pdtData.iTimeSlot)
		{
			_pform<<FormSetFormatType(g_iConst_FormatHMSOffset,pdtData.fFirstTime);
			_pform<<FormShowField("DYN_classification_race.gene_f_time","",iPosX,0);
			_pform<<FormSetFormatType(g_iConst_FormatNormal,1.0);
			iPosX = iPosX +128;
		}
		if(pdtData.iPointSlot)
		{
			_pform<<FormShowField("DYN_classification_race.gene_f_point","",iPosX,0);
			iPosX = iPosX +128;
		}
		if(pdtData.iMountainSlot)
		{
			_pform<<FormShowField("DYN_classification_race.gene_f_mountain","",iPosX,0);
			iPosX = iPosX +128;
		}
		if(pdtData.iSpec1Slot)
		{
			if(GetClassificationType(pdtData.iSpec1Slot)==1)
				_pform<<FormSetFormatType(g_iConst_FormatHMSOffset,pdtData.fFirstSpec1);
			_pform<<FormShowField("DYN_classification_race.gene_f_spec1","",iPosX,0);
			iPosX = iPosX +128;
			_pform<<FormSetFormatType(g_iConst_FormatNormal,1.0);
		}
		if(pdtData.iSpec2Slot)
		{
			if(GetClassificationType(pdtData.iSpec1Slot)==1)
				_pform<<FormSetFormatType(g_iConst_FormatHMSOffset,pdtData.fFirstSpec2);
			_pform<<FormShowField("DYN_classification_race.gene_f_spec2","",iPosX,0);
			iPosX = iPosX +128;
			_pform<<FormSetFormatType(g_iConst_FormatNormal,1.0);
		}
		if(pdtData.iSpec3Slot)
		{
			if(GetClassificationType(pdtData.iSpec1Slot)==1)
				_pform<<FormSetFormatType(g_iConst_FormatHMSOffset,pdtData.fFirstSpec3);
			_pform<<FormShowField("DYN_classification_race.gene_f_spec3","",iPosX,0);
			iPosX = iPosX +128;
		}
	}
}
func Gui_Component NewStageClassificationListForm(i32x _iSubsetId)
{
	var Gui_Component pform;
	var Gui_dtForm_StageClassificationList pdtData;

	pdtData = new Gui_dtForm_StageClassificationList;

	// New list form
	pform = NewListForm(_iSubsetId,"DYN_classification_stage",false);
	pform<<FormSetOffset(4);

	AddInterface(pform,Gui_iForm_StageClassificationList,pdtData);

	return pform;
}
func void StageClassificationListForm_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var i32x i,iPosX;
	var szx szTxt;

	iPosX = 0;
	_pform<<FormSetDecimal(0);
	_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	_pform<<FormSetWidth(128);
	_pform<<FormSetOffset(0);

	_pform<<FormAddVariable("DYN_classification_stage.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname","CYCLISTNAME");
	_pform<<FormAddVariable("DYN_classification_stage.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_firstname","CYCLISTFIRSTNAME");
	if(_iIndex==0)
	{
		_pform<<FormSetTitle(true,true);
		_pform<<FormShowFormatField("DYN_classification_stage.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",39,"",iPosX,0);
		_pform<<FormSetTitle(true,false);

		_pform<<FormSetWidth(76);
		_pform<<FormSetFont(smTrebuchet,smTrebuchet);
		szTxt = GetLocalizedFromKey(iszTemps);
		_pform<<FormSetFormatType(g_iConst_FormatHMS,1.0);
		_pform<<FormShowField("DYN_classification_stage.gene_f_time",szTxt,iPosX,0);
		_pform<<FormSetFormatType(g_iConst_FormatNormal,1.0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszPoints);
		_pform<<FormShowField("DYN_classification_stage.gene_f_point",szTxt,iPosX,0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszPoints);
		_pform<<FormShowField("DYN_classification_stage.gene_f_mountain",szTxt,iPosX,0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszPoints);
		_pform<<FormShowField("DYN_classification_stage.gene_f_spec1",szTxt,iPosX,0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszPoints);
		_pform<<FormShowField("DYN_classification_stage.gene_f_spec2",szTxt,iPosX,0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszPoints);
		_pform<<FormShowField("DYN_classification_stage.gene_f_spec3",szTxt,iPosX,0);
		iPosX = iPosX +76;
	}
	else
	{
		_pform<<FormSetTitle(false,true);
		_pform<<FormShowFormatField("DYN_classification_stage.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",39,"",iPosX,0);
		_pform<<FormSetTitle(false,false);

		_pform<<FormSetWidth(76);
		_pform<<FormSetFont(smTrebuchet,smTrebuchet);
		_pform<<FormSetFormatType(g_iConst_FormatHMS,1.0);
		_pform<<FormShowField("DYN_classification_stage.gene_f_time","",iPosX,0);
		_pform<<FormSetFormatType(g_iConst_FormatNormal,1.0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_classification_stage.gene_f_point","",iPosX,0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_classification_stage.gene_f_mountain","",iPosX,0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_classification_stage.gene_f_spec1","",iPosX,0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_classification_stage.gene_f_spec2","",iPosX,0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_classification_stage.gene_f_spec3","",iPosX,0);
		iPosX = iPosX +76;
	}
}

func Gui_Component NewSeasonClassificationListForm(i32x _iSubsetId)
{
	var Gui_Component pform;
	var Gui_dtForm_SeasonClassificationList pdtData;

	pdtData = new Gui_dtForm_SeasonClassificationList;

	// New list form
	pform = NewListForm(_iSubsetId,"DYN_classification_season",false);
	pform<<FormSetOffset(4);
	pform<<FormSetLimiter(0,200);

	AddInterface(pform,Gui_iForm_SeasonClassificationList,pdtData);

	return pform;
}
func void SeasonClassificationListForm_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var i32x i,iPosX;
	var szx szTxt;

	iPosX = 0;
	_pform<<FormSetDecimal(0);
	_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	_pform<<FormSetWidth(128);
	_pform<<FormSetOffset(0);

	_pform<<FormAddVariable("DYN_classification_season.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname","CYCLISTNAME");
	_pform<<FormAddVariable("DYN_classification_season.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_firstname","CYCLISTFIRSTNAME");
	if(_iIndex==0)
	{
		_pform<<FormSetTitle(true,true);
		_pform<<FormShowFormatField("DYN_classification_season.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",39,"",iPosX,0);
		_pform<<FormSetTitle(true,false);

		_pform<<FormSetWidth(76);
		_pform<<FormSetFont(smTrebuchet,smTrebuchet);
		szTxt = GetLocalizedFromKey(iszSaison);
		_pform<<FormShowField("DYN_classification_season.gene_f_uci",szTxt,iPosX,0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszCoupe_du_Monde);
		_pform<<FormShowField("DYN_classification_season.gene_f_world_cup",szTxt,iPosX,0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszCoupe_du_Monde);
		_pform<<FormShowField("DYN_classification_season.gene_f_french_cup",szTxt,iPosX,0);
	}
	else
	{
		_pform<<FormSetTitle(false,true);
		_pform<<FormShowFormatField("DYN_classification_season.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",39,"",iPosX,0);
		_pform<<FormSetTitle(false,false);

		_pform<<FormSetWidth(76);
		_pform<<FormSetFont(smTrebuchet,smTrebuchet);
		_pform<<FormShowField("DYN_classification_season.gene_f_uci","",iPosX,0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_classification_season.gene_f_world_cup","",iPosX,0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_classification_season.gene_f_french_cup","",iPosX,0);
	}
}