
func i32x CyclistInfo_OnCreate()
{
	var Gui_Component pthis,pcaption;
	var Gui_dtPage_CyclistInfo pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_CyclistInfo;
	SetData(pthis,pdtData);

	// Caption
	pcaption = NewCaption(smBauer,"CyclistInfo");
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func i32x  CyclistInfo_OnDestroy()
{
	// uninit page
}

func void  CyclistInfo_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_CyclistInfo pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);
	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		// Click on back button
		pparent = GetParent(pthis);

		// Back
		pparent<<GoBack();
	}
}

func Gui_Component NewCyclistInfoForm2(i32x _iSourceDB,i32x _iStaffSubsetDb)
{
	var Gui_Component pform,pfield,ptmp;
	var szx szTxt;
	var i32x iPosX,iColumnWidth,iSubsetId,iPosY,iFormSubset,iMaxSizeX;

	iPosX = 0;
	iMaxSizeX = g_iScreenWidth - g_iScreenLeftOffset - g_iScreenRightOffset;
	iColumnWidth = iMaxSizeX/8;
	pform = NewForm(_iSourceDB,"DYN_cyclist",true);
	iFormSubset = Form_GetSubsetDb(pform);

	pform<<FormSetFont(smImpact,smTrebuchet);
	pform<<FormSetDecimal(0);
	pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	pform<<FormSetOffset(5);
	pform<<FormSetWidth(256);

	pform<<FormAddVariable("DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname","CYCLISTNAME");
	pform<<FormAddVariable("DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_firstname","CYCLISTFIRSTNAME");

	// Cyclist name
	pform<<FormSetFont(smImpact,smImpact);
	pform<<FormShowFormatField("DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",39,"",0,64);
	pform<<FormShowBitmapField("DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_TGAID_photo","",0,0);

	// UCI score WC score
	pform<<FormSetWidth(128);
	pform<<FormSetFont(smImpact,smBauer);
	szTxt = GetLocalizedFromKey(iszUCIClass);
	pform<<FormShowField("DYN_cyclist.score_i_UCI",szTxt,64+90,20);
	szTxt = GetLocalizedFromKey(iszCoupe_du_Monde);
	pform<<FormShowField("DYN_cyclist.score_i_WC",szTxt,64+90,40);

	// trainer / chiropracteur / medecin


	pform<<FormSetLocked(false);
	pform<<FormSetMaJInform(true);
	pform<<FormSetFont(smImpact,smTrebuchet);
	pform<<FormSetWidth(256);
	//  Create each staff role subset
	iSubsetId = Subset_Constructor("SUBSET_STAFF_ROLE",_iStaffSubsetDb);
	ptmp = NewSubsetEncaps(iFormSubset,iSubsetId,8);
	pform<<FormAddField(ptmp,0,0);
	pform<<FormSetDataSource(iSubsetId);
	szTxt = GetLocalizedFromKey(iszKinesitherapy);
	pform<<FormShowListBoxField("DYN_cyclist.fkIDstaff_kynesitherapist","DYN_staff.IDstaff","DYN_staff.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",szTxt,iMaxSizeX-256,0);

	iSubsetId = Subset_Constructor("SUBSET_STAFF_ROLE",_iStaffSubsetDb);
	ptmp = NewSubsetEncaps(iFormSubset,iSubsetId,4);
	pform<<FormAddField(ptmp,0,0);
	pform<<FormSetDataSource(iSubsetId);
	szTxt = GetLocalizedFromKey(iszPHYSICIAN);
	pform<<FormShowListBoxField("DYN_cyclist.fkIDstaff_physician","DYN_staff.IDstaff","DYN_staff.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",szTxt,iMaxSizeX-256,20);

	iSubsetId = Subset_Constructor("SUBSET_STAFF_ROLE",_iStaffSubsetDb);
	ptmp = NewSubsetEncaps(iFormSubset,iSubsetId,9);
	pform<<FormAddField(ptmp,0,0);
	pform<<FormSetDataSource(iSubsetId);
	szTxt = GetLocalizedFromKey(iszPsychology);
	pform<<FormShowListBoxField("DYN_cyclist.fkIDstaff_psycho_consultant","DYN_staff.IDstaff","DYN_staff.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",szTxt,iMaxSizeX-256,40);

	iSubsetId = Subset_Constructor("SUBSET_STAFF_ROLE",_iStaffSubsetDb);
	ptmp = NewSubsetEncaps(iFormSubset,iSubsetId,6);
	pform<<FormAddField(ptmp,0,0);
	pform<<FormSetDataSource(iSubsetId);
	szTxt = GetLocalizedFromKey(iszCHIROPRACTOR);
	pform<<FormShowListBoxField("DYN_cyclist.fkIDstaff_manipulator","DYN_staff.IDstaff","DYN_staff.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",szTxt,iMaxSizeX-256,60);

	iSubsetId = Subset_Constructor("SUBSET_STAFF_ROLE",_iStaffSubsetDb);
	ptmp = NewSubsetEncaps(iFormSubset,iSubsetId,7);
	pform<<FormAddField(ptmp,0,0);
	pform<<FormSetDataSource(iSubsetId);
	szTxt = GetLocalizedFromKey(iszMASSEUR_ASSISTANT);
	pform<<FormShowListBoxField("DYN_cyclist.fkIDstaff_masseur","DYN_staff.IDstaff","DYN_staff.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",szTxt,iMaxSizeX-256,80);

	iSubsetId = Subset_Constructor("SUBSET_STAFF_ROLE",_iStaffSubsetDb);
	ptmp = NewSubsetEncaps(iFormSubset,iSubsetId,5);
	pform<<FormAddField(ptmp,0,0);
	pform<<FormSetDataSource(iSubsetId);
	szTxt = GetLocalizedFromKey(iszTRAINER);
	pform<<FormShowListBoxField("DYN_cyclist.fkIDstaff_trainer","DYN_staff.IDstaff","DYN_staff.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",szTxt,iMaxSizeX-256,100);


	iPosY = 150.0;
	pform<<FormSetLocked(true);
	pform<<FormSetMaJInform(false);
	pform<<FormRestoreDataSource();
	pform<<FormSetWidth(iColumnWidth);
	pform<<FormSetFont(smImpact, smImpact);
	pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	szTxt = GetLocalizedFromKey(iszRouleur);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_riding",szTxt,iPosX,iPosY);
	iPosX = iPosX + iColumnWidth;
	szTxt = GetLocalizedFromKey(iszGrimpeur);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_climbing",szTxt,iPosX,iPosY);
	iPosX = iPosX + iColumnWidth;
	szTxt = GetLocalizedFromKey(iszDescendeur);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_downhilling",szTxt,iPosX,iPosY);
	iPosX = iPosX + iColumnWidth;
	szTxt = GetLocalizedFromKey(iszEndurance);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_resistance",szTxt,iPosX,iPosY);
	iPosX = iPosX + iColumnWidth;
	szTxt = GetLocalizedFromKey(iszRecuperation);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_endurance",szTxt,iPosX,iPosY);
	iPosX = iPosX + iColumnWidth;
	szTxt = GetLocalizedFromKey(iszAcceleration);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_acceleration",szTxt,iPosX,iPosY);
	iPosX = iPosX + iColumnWidth;
	szTxt = GetLocalizedFromKey(iszSprint);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_sprint",szTxt,iPosX,iPosY);
	iPosX = iPosX + iColumnWidth;
	szTxt = GetLocalizedFromKey(iszAgilite);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_agility",szTxt,iPosX,iPosY);
	iPosX = iPosX + iColumnWidth;

	return pform;
}

func Gui_Component NewSubsetEncaps(i32x _iFormSubset,i32x _iSubsetDb,i32x _iRole)
{
	var Gui_Component pthis;
	var Gui_dtObject_SubsetEncaps pdtData;

	pthis = NewObject(Gui_iObject_SubsetEncaps);

	pdtData = new Gui_dtObject_SubsetEncaps;

	SetData(pthis,pdtData);

	Database_AddTables(_iSubsetDb,2);
	Table_SetName(_iSubsetDb, 0, "DYN_staff");
	TableSubset_SelectColumns(_iSubsetDb, 0, "*");
	Table_SetName(_iSubsetDb, 1, "DYN_characteristic");
	TableSubset_SelectColumns(_iSubsetDb, 1, "*");

	pdtData.m_iJoinId = Join_Constructor(_iFormSubset,"DYN_cyclist.IDcyclist");

	pdtData.m_iSubsetId = _iSubsetDb;
	pdtData.m_iRole = _iRole;

	return pthis;
}
func void SubsetEncaps_OnDestroy()
{
	var Gui_Component pthis;
	var Gui_dtObject_SubsetEncaps pdtData;

	pthis = GetThis();

	pdtData = GetData(pthis);

	Join_Destructor(pdtData.m_iJoinId);
	if(pdtData.m_iSubsetId)
	{
		Subset_Destructor(pdtData.m_iSubsetId);
	}
}

func void SubsetEncaps_OnSelectKey(i32x _iKey)
{
	var Gui_Component pthis,parent;
	var Gui_dtObject_SubsetEncaps pdtData;
	var i32x iTeamId;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	iTeamId = Join_GetIntFromKey(g_oMenuJoins.m_iCyclistTeamID,_iKey);

	// Update subset
	Query_Create(0,pdtData.m_iSubsetId);
	Query_SelectTable(	0, "DYN_staff");
	Query_SelectTable(	0, "DYN_staff.fkIDcharacteristic.DYN_characteristic");
	Query_SelectWhereIntEqual(0,"DYN_staff.fkIDteam", iTeamId );
	Query_SelectWhereIntEqual(0,"DYN_staff.fkIDstaff_role", pdtData.m_iRole );
	Query_Execute(0);
}
func void SubsetEncaps_OnSelectIndex(i32x _iIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtObject_SubsetEncaps pdtData;
	var i32x iTeamId,iRowKey;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	iRowKey = Join_GetRow(pdtData.m_iJoinId,_iIndex,ROW_INDEX,ROW_KEY);

	iTeamId = Join_GetIntFromKey(g_oMenuJoins.m_iCyclistTeamID,iRowKey);

	// Update subset
	Query_Create(0,pdtData.m_iSubsetId);
	Query_SelectTable(	0, "DYN_staff");
	Query_SelectTable(	0, "DYN_staff.fkIDcharacteristic.DYN_characteristic");
	Query_SelectWhereIntEqual(0,"DYN_staff.fkIDteam", iTeamId );
	Query_SelectWhereIntEqual(0,"DYN_staff.fkIDstaff_role", pdtData.m_iRole );
	Query_Execute(0);
}
func void SubsetEncaps_OnSelectSIndex(i32x _iSIndex)
{
	var Gui_Component pthis,parent;
	var Gui_dtObject_SubsetEncaps pdtData;
	var i32x iTeamId,iRowKey;

	// Retrieve form caption pointer
	pthis = GetThis();

	// Retrieve data
	pdtData = GetData(pthis);

	iRowKey = Join_GetRow(pdtData.m_iJoinId,_iSIndex,ROW_SORT,ROW_KEY);

	iTeamId = Join_GetIntFromKey(g_oMenuJoins.m_iCyclistTeamID,iRowKey);

	// Update subset
	Query_Create(0,pdtData.m_iSubsetId);
	Query_SelectTable(	0, "DYN_staff");
	Query_SelectTable(	0, "DYN_staff.fkIDcharacteristic.DYN_characteristic");
	Query_SelectWhereIntEqual(0,"DYN_staff.fkIDteam", iTeamId );
	Query_SelectWhereIntEqual(0,"DYN_staff.fkIDstaff_role", pdtData.m_iRole );
	Query_Execute(0);
}
