
func i32x RaceInfo_OnCreate()
{
	var Gui_Component pthis,pcaption;
	var Gui_dtPage_RaceInfo pdtData;
	var i32x iRaceId;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_RaceInfo;
	SetData(pthis,pdtData);

	// Caption
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszCourse));
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// Race info form
	pdtData.gcRaceForm = NewRaceInfoFormFull();
	MountComponent(pthis,pdtData.gcRaceForm);
	MoveTo(pdtData.gcRaceForm,g_iScreenLeftOffset,g_iScreenTopOffset);
	iRaceId = Join_GetIntFromKey(g_oLocalJoins.m_iStage_iRaceId,GetCurrentStageId());
	pdtData.gcRaceForm<<FormFilterByIntEqual("STA_race.IDrace",iRaceId);

	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func i32x  RaceInfo_OnDestroy()
{
	// uninit page
}

func void  RaceInfo_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_RaceInfo pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);
	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		// Click on back button
		pparent = GetParent(pthis);

		// Back
		pparent<<GoBack();
	}
}

func Gui_Component NewRaceInfoFormFull()
{
	var Gui_Component pform,pfield;
	var szx szTxt;

	pform = NewForm(DATABASE_CLIENT,"STA_race",false);

	pform<<FormAddVariable("STA_race.gene_i_min_cyclist_by_team","VALUE1");
	pform<<FormAddVariable("STA_race.gene_i_max_cyclist_by_team","VALUE2");

	pform<<FormSetDecimal(3);
	pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	pform<<FormSetOffset(20);
	pform<<FormSetWidth(256);
	pform<<FormSetFont(smTrebuchet,smBauer);
	pform<<FormShowField("STA_race.gene_strID_race_name","",110,0);

	pform<<FormSetFont(smTrebuchet,smTrebuchet);
	szTxt = GetLocalizedFromKey(iszInformations);
	pform<<FormShowField("STA_race.gene_strID_informations",szTxt,110,20.0*g_fScreenScaleFactor);

	szTxt = GetLocalizedFromKey(iszUCIClass);
	pform<<FormShowField("STA_race.fkIDUCI_class.STA_UCI_class.gene_strID_UCI_class",szTxt,450,20.0*g_fScreenScaleFactor);

	szTxt = GetLocalizedFromKey(iszStageNumber);
	pform<<FormShowField("STA_race.gene_i_number_stages",szTxt,450,40.0*g_fScreenScaleFactor);

	szTxt = GetLocalizedFromKey(iszMinRoster);
	pform<<FormShowFormatField("STA_race.gene_i_min_cyclist_by_team",63,szTxt,110,40.0*g_fScreenScaleFactor);

	szTxt = GetLocalizedFromKey(iszJeunes);
	pform<<FormShowField("STA_race.class_i_age_young_riders",szTxt,110,60.0*g_fScreenScaleFactor);

	szTxt = GetLocalizedFromKey(iszClassement);
	pform<<FormShowField("STA_race.fkIDclassification_time.STA_classification.gene_strID_classification_name",szTxt,450,100.0*g_fScreenScaleFactor);
	szTxt = "";
	pform<<FormShowField("STA_race.fkIDclassification_mountain.STA_classification.gene_strID_classification_name",szTxt,200,140.0*g_fScreenScaleFactor);
	pform<<FormShowField("STA_race.fkIDclassification_points.STA_classification.gene_strID_classification_name",szTxt,200,180.0*g_fScreenScaleFactor);
	pform<<FormShowField("STA_race.fkIDclassification_team.STA_classification.gene_strID_classification_name",szTxt,200,220.0*g_fScreenScaleFactor);
	pform<<FormShowField("STA_race.fkIDclassification_specific1.STA_classification.gene_strID_classification_name",szTxt,260,160.0*g_fScreenScaleFactor);
	pform<<FormShowField("STA_race.fkIDclassification_specific2.STA_classification.gene_strID_classification_name",szTxt,300,180.0*g_fScreenScaleFactor);
	pform<<FormShowField("STA_race.fkIDclassification_specific3.STA_classification.gene_strID_classification_name",szTxt,340,200.0*g_fScreenScaleFactor);

	pform<<FormSetMediaSize(32,32);
	szTxt = GetLocalizedFromKey(iszMaillots);
	pform<<FormShowBitmapField("STA_race.fkIDclassification_time.STA_classification.gene_tgaID_jerseylogo",szTxt,110,100.0*g_fScreenScaleFactor);
	szTxt = "";
	pform<<FormShowBitmapField("STA_race.fkIDclassification_mountain.STA_classification.gene_tgaID_jerseylogo",szTxt,110,140.0*g_fScreenScaleFactor);
	pform<<FormShowBitmapField("STA_race.fkIDclassification_points.STA_classification.gene_tgaID_jerseylogo",szTxt,110,180.0*g_fScreenScaleFactor);
	pform<<FormShowBitmapField("STA_race.fkIDclassification_team.STA_classification.gene_tgaID_jerseylogo",szTxt,110,220.0*g_fScreenScaleFactor);
	pform<<FormShowBitmapField("STA_race.fkIDclassification_specific1.STA_classification.gene_tgaID_jerseylogo",szTxt,110,260.0*g_fScreenScaleFactor);
	pform<<FormShowBitmapField("STA_race.fkIDclassification_specific2.STA_classification.gene_tgaID_jerseylogo",szTxt,110,300.0*g_fScreenScaleFactor);
	pform<<FormShowBitmapField("STA_race.fkIDclassification_specific3.STA_classification.gene_tgaID_jerseylogo",szTxt,110,340.0*g_fScreenScaleFactor);

	return pform;
}

