func i32x StageInfo_OnInitData()
{
	var Gui_Component pthis;
	var Gui_dtPage_StageInfo pdtData;
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_StageInfo;
	SetData(pthis,pdtData);
}

func i32x StageInfo_OnCreate()
{
	var Gui_Component pthis,pcaption,pwindow;
	var Gui_dtPage_StageInfo pdtData;
	var szx szTxt;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Caption
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszEtape));
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// Create stage formulaire
	pdtData.gcStageForm = NewStageInfoFormFull();
	MountComponent(pthis,pdtData.gcStageForm);
	MoveTo(pdtData.gcStageForm,g_iScreenLeftOffset,g_iScreenTopOffset+10.0);
	pdtData.gcStageForm<<FormFilterByIntEqual("STA_stage.IDstage",GetCurrentStageId());

	// Sprint list form
	pwindow = NewWindow((g_iScreenWidth-g_iScreenLeftOffset)/2,160.0 * g_fScreenScaleFactor);
	pdtData.gcSprintListForm = NewSprintListForm();
	pwindow<<WindowMount(pdtData.gcSprintListForm);
	MountComponent(pthis,pwindow);
	MoveTo(pwindow,g_iScreenLeftOffset,g_iScreenTopOffset+180.0);
	pdtData.gcSprintListForm<<FormFilterByIntEqual("STA_sprint.fkIDstage",GetCurrentStageId());

	// Get one sprint of stage
	pdtData.m_iSprintId = Join_FindKeyFromIntData(g_oMenuJoins.m_iSprint_iStageId,GetCurrentStageId());

	// Bonus subset id
	pdtData.m_iSubsetId = Subset_Constructor("SUBSET_BONUS",DATABASE_CLIENT);
	Database_AddTables(pdtData.m_iSubsetId,2);
	Table_SetName(pdtData.m_iSubsetId, 0, "STA_bonus");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 0, "*");
	Table_SetName(pdtData.m_iSubsetId, 1, "STA_classification");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 1, "*");

	// Bonus list form
	pwindow = NewWindow((g_iScreenWidth-g_iScreenRightOffset-g_iScreenLeftOffset),g_iScreenHeight - g_iScreenBottomOffset - RelPosY(pdtData.gcStageForm) -  SizeY(pdtData.gcStageForm) - 50);
	pdtData.gcBonusListForm = NewBonusListForm(pdtData.m_iSubsetId);
	pwindow<<WindowMount(pdtData.gcBonusListForm);
	MountComponent(pthis,pwindow);
	MoveTo(pwindow,g_iScreenLeftOffset,RelPosY(pdtData.gcStageForm) + SizeY(pdtData.gcStageForm)+20);
	StageInfo_BonusUpdate();

	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func void StageInfo_OnRelease()
{
	var Gui_Component pthis,ptmp;
	var i32x i,iNumComponents;
	var Gui_dtPage_StageInfo pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	iNumComponents = GetComponentNumber(pthis);
	i=0;
	while(i<iNumComponents)
	{
		ptmp = GetComponent(pthis,i);
		if(ptmp)
		{
			DeleteComponent(ptmp);
		}
		i=i+1;
	}

	// Destroy subset if needed
	if(pdtData.m_iSubsetId)
	{
		Subset_Destructor(pdtData.m_iSubsetId);
		pdtData.m_iSubsetId = 0;
	}

	pdtData.gcBonusListForm = NULL;
	pdtData.gcSprintListForm = NULL;
	pdtData.gcStageForm = NULL;
}

func void StageInfo_BonusUpdate()
{
	var Gui_Component pthis;
	var Gui_dtPage_StageInfo pdtData;
	var i32x iTypeSprint;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = GetData(pthis);

	// Get type of sprint
	iTypeSprint = Join_GetIntFromKey(g_oMenuJoins.m_iSprint_iType,pdtData.m_iSprintId);

	DatabaseSubset_Clear(pdtData.m_iSubsetId);

	Query_Create(0,pdtData.m_iSubsetId);
	Query_SelectTable(	0, "STA_bonus");
	Query_SelectTable(	0, "STA_bonus.fkIDclassification_out.STA_classification");
	Query_SelectWhereIntEqual(0,"STA_bonus.fkIDtype",iTypeSprint);
	Query_SelectWhereIntEqual(0,"STA_bonus.fkIDcriterium_bonus",1); // sprint criterium
	Query_SelectWhereIntDifferent(0,"STA_bonus.fkIDclassification_in",0); // ignore time record bonuses
	Query_SelectWhereIntLessThan(0,"STA_bonus.fkIDclassification_in.STA_classification.fkIDcriterium_classification",11); // ignore renown
	Query_Execute(0);

	// Update bonus list form
	if(pdtData.gcBonusListForm)
		pdtData.gcBonusListForm<<FormRazFilter();
}

func i32x StageInfo_OnDestroy()
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_StageInfo pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(pdtData.m_iSubsetId)
	{
		Subset_Destructor(pdtData.m_iSubsetId);
	}
}

func void StageInfo_OnStageSelect(i32x _iStageId)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_StageInfo pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(pdtData.gcStageForm)
		pdtData.gcStageForm<<FormFilterByIntEqual("STA_stage.IDstage",_iStageId);

	if(pdtData.gcSprintListForm)
		pdtData.gcSprintListForm<<FormFilterByIntEqual("STA_sprint.fkIDstage",_iStageId);

	// Get one sprint of stage
	pdtData.m_iSprintId = Join_FindKeyFromIntData(g_oMenuJoins.m_iSprint_iStageId,_iStageId);

	// Update bonus list
	StageInfo_BonusUpdate();
}

func void StageInfo_OnSelectSprint(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_StageInfo pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_pform == pdtData.gcSprintListForm)
	{
		pdtData.m_iSprintId = _iKey;

		// Update bonus list
		StageInfo_BonusUpdate();
	}
}

func void  StageInfo_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_StageInfo pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);
	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		// Click on back button
		pparent = GetParent(pthis);

		// Back
		pparent<<GoBack();
	}
}

func Gui_Component NewStageInfoFormFull()
{
	var Gui_Component pform,pfield;
	var szx szTxt;

	pform = NewForm(DATABASE_CLIENT,"STA_stage",false);

	pform<<FormAddVariable("STA_stage.gene_i_stage_number","VALUE1");
	pform<<FormAddVariable("STA_stage.fkIDrace.STA_race.gene_i_number_stages","VALUE2");

	pform<<FormSetDecimal(3);
	pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	pform<<FormSetOffset(20);
	pform<<FormSetWidth(256);
	pform<<FormSetFont(smTrebuchet,smBauer);
	pform<<FormShowField("STA_stage.gene_strID_stage_name","",110,0);

	pform<<FormSetFont(smTrebuchet,smTrebuchet);
	szTxt = GetLocalizedFromKey(iszInformations);
	pform<<FormShowField("STA_stage.gene_strID_informations",szTxt,110,20.0*g_fScreenScaleFactor);

	pform<<FormShowField("STA_stage.fkIDstage_type.STA_stage_type.gene_strID_name","",450,20.0*g_fScreenScaleFactor);


	pform<<FormSetWidth(76);
	pform<<FormSetAlign(e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	pform<<FormSetMediaSize(g_iScreenWidth-g_iScreenLeftOffset-g_iScreenRightOffset-200,64.0*g_fScreenScaleFactor);
	pform<<FormShowMeshField("STA_stage.game_mshID_profile_2D","",g_iScreenLeftOffset,30);
	pfield = GetLastField(pform);
	pfield<<Disable();

	pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	pform<<FormSetMediaSize(300.0*g_fScreenScaleFactor,300.0*g_fScreenScaleFactor);
	pform<<FormShowMeshField("STA_stage.game_mshID_profile","",g_iScreenWidth-350,20);
	
	szTxt = GetLocalizedFromKey(iszLongueur_de_l_etape);
	pform<<FormShowField("STA_stage.gene_f_distance",szTxt,110,40.0*g_fScreenScaleFactor);
	szTxt = GetLocalizedFromKey(iszEtape);
	pform<<FormShowFormatField("STA_stage.gene_i_stage_number",63,szTxt,450,40.0*g_fScreenScaleFactor);

	return pform;
}

func Gui_Component NewSprintListForm()
{
	var Gui_Component pform;
	var Gui_dtForm_SprintListForm pdtData;

	pdtData = new Gui_dtForm_SprintListForm;

	pform = NewListForm(DATABASE_CLIENT,"STA_sprint",false);
	pform<<FormSetOffset(4);
	AddInterface(pform,Gui_iForm_SprintListForm,pdtData);

	return pform;
}


func void SprintListForm_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var Gui_Component pthis;
	var Gui_dtForm_SprintListForm pdtData;
	var szx szTxt;

	pthis =GetThis();
	pdtData = GetData(pthis);

	_pform<<FormSetDecimal(2);
	_pform<<FormSetOffset(2);
	_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);

	if(_iIndex == 0)
	{
		_pform<<FormSetTitle(true,false);
		szTxt = GetLocalizedFromKey(iszSprint);
		_pform<<FormSetWidth(256);
		_pform<<FormShowField("STA_sprint.gene_sz_name",szTxt,0,0);
		_pform<<FormSetWidth(64);
		szTxt = GetLocalizedFromKey(iszDistance);
		_pform<<FormShowField("STA_sprint.gene_f_km",szTxt,256,0);
	}
	else
	{
		szTxt = "";
		_pform<<FormSetTitle(false,false);
		_pform<<FormSetWidth(256);
		_pform<<FormShowField("STA_sprint.gene_sz_name",szTxt,0,0);
		_pform<<FormSetWidth(64);
		_pform<<FormShowField("STA_sprint.gene_f_km",szTxt,256,0);
	}
}


func Gui_Component NewBonusListForm(i32x _iSubsetId)
{
	var Gui_Component pform;
	var Gui_dtForm_BonusListForm pdtData;

	pdtData = new Gui_dtForm_BonusListForm;

	pform = NewListForm(_iSubsetId,"STA_bonus",false);
	pform<<FormSetOffset(4);
	AddInterface(pform,Gui_iForm_BonusListForm,pdtData);

	return pform;
}

func void BonusListForm_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var Gui_Component pthis;
	var Gui_dtForm_SprintListForm pdtData;
	var szx szTxt;

	pthis = GetThis();
	pdtData = GetData(pthis);

	_pform<<FormSetDecimal(2);
	_pform<<FormSetOffset(2);
	_pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	_pform<<FormCaptionAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);

	if(_iIndex == 0)
	{
		_pform<<FormSetTitle(true,false);
		szTxt = GetLocalizedFromKey(iszClassement);
		_pform<<FormSetWidth(256);
		_pform<<FormShowField("STA_bonus.fkIDclassification_out.STA_classification.gene_strID_classification_name",szTxt,0,0);
		_pform<<FormSetWidth(1024);
		szTxt = GetLocalizedFromKey(iszBONUS);
		_pform<<FormShowField("STA_bonus.gene_flist_values",szTxt,256,0);
	}
	else
	{
		szTxt = "";
		_pform<<FormSetTitle(false,false);
		_pform<<FormSetWidth(256);
		_pform<<FormShowField("STA_bonus.fkIDclassification_out.STA_classification.gene_strID_classification_name",szTxt,0,0);
		_pform<<FormSetWidth(1024);
		_pform<<FormShowField("STA_bonus.gene_flist_values",szTxt,256,0);
	}
}
