func Gui_Component NewPhotoCyclist(i32x _iId, boolx _iShowName)
{
	var Gui_Component composite,container,caption;
	var Gui_dtPhotoCyclist pdtData;
	var szx szCyclistName,szCyclistPhotoTgaName;
	var i32x iPhotoID;
	var i32x sy;

	// Create an object that will contain DynBitmap + caption
	composite = NewObject(Gui_iPhotoCyclist);

	// Two component in composite button
	SetComponentNumber(composite,2);

	pdtData = new Gui_dtPhotoCyclist;
	SetData(composite,pdtData);

	pdtData.iCyclistId = _iId;

	// Create dynamic bitmap
	container = NewDynBitmap("Gui/Cyclist_photo_msh.msh","Cyclist_Photo");
	SetAlign(container,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(container,64*g_fScreenScaleFactor,48*g_fScreenScaleFactor);

	// Retrieve cyslist name and photo file name
	szCyclistName=Join_GetStringFromKey(g_oMenuJoins.m_jCyclist_szFirstName,_iId);
	szCyclistName=szCyclistName+"\n"+Join_GetStringFromKey(g_oMenuJoins.m_jCyclist_szLastName,_iId);


	iPhotoID=Join_GetIntFromKey(g_oMenuJoins.m_jCyclist_iTgaPhotoID,_iId);
	szCyclistPhotoTgaName="./"+Join_GetStringFromKey(g_oLocalJoins.m_iTga_szDirectory,iPhotoID);
	szCyclistPhotoTgaName=szCyclistPhotoTgaName+"/"+Join_GetStringFromKey(g_oLocalJoins.m_iTga_szName,iPhotoID);

	// Update dynamic bitmap
	container<<SetBitmap(szCyclistPhotoTgaName);

	if (_iShowName == true)
	{
		caption=NewCaption(smBauer,szCyclistName);
		SetAlign(caption,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		StretchTo(caption,SizeX(container),SizeY(caption));
		SetScale(caption,0.7);
		MountComponent(composite,caption);
		// Move caption to bitmap bottom
		MoveTo(caption,0,SizeY(container));
		// calcul size photo+caption	
		sy = SizeY(caption)+SizeY(container);
	}
	else sy = SizeY(container);

	MountComponent(composite,container);

	// Stretch composite to fit content
	StretchTo(composite,SizeX(container),sy);

	return composite;
}
func i32x PhotoCyclist_OnClick(i32x _iX,i32x _iY,i32x _iButton)
{
	var Gui_Component pthis; 
	var Gui_Component parent;
	var Gui_dtPhotoCyclist pdtData;

	if(_iButton == e_Gui_Mouse_Left_Button)
	{
		pthis = GetThis();
		pdtData = GetData(pthis);
		parent = GetParent(pthis);
		parent<<SelectCyclist(pdtData.iCyclistId);
		return 1;
	}
	return 0;
}

func Gui_Component NewCyclistInfoForm()
{
	var Gui_Component pform;
	var i32x iPosX;
	var szx szTxt;

	iPosX = 0;
	pform = NewForm(DATABASE_CLIENT,"DYN_cyclist",false);

	pform<<FormSetDecimal(0);
	pform<<FormSetOffset(8);
	pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	szTxt = GetLocalizedFromKey(iszNom);
	pform<<FormSetOffset(2);
	pform<<FormSetWidth(128);

	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_firstname",szTxt,iPosX,0);
	iPosX = iPosX +128;
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",szTxt,iPosX,0);
	iPosX = iPosX +128;

	pform<<FormSetWidth(76);
	pform<<FormSetOffset(0);
	pform<<FormSetFont(smImpact,smAtomic);
	szTxt = GetLocalizedFromKey(iszRouleur);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_riding",szTxt,iPosX,0);
	iPosX = iPosX +76;
	szTxt = GetLocalizedFromKey(iszGrimpeur);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_climbing",szTxt,iPosX,0);
	iPosX = iPosX +76;
	szTxt = GetLocalizedFromKey(iszDescendeur);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_downhilling",szTxt,iPosX,0);
	iPosX = iPosX +76;
	szTxt = GetLocalizedFromKey(iszEndurance);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_resistance",szTxt,iPosX,0);
	iPosX = iPosX +76;
	szTxt = GetLocalizedFromKey(iszRecuperation);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_endurance",szTxt,iPosX,0);
	iPosX = iPosX +76;
	szTxt = GetLocalizedFromKey(iszAcceleration);
	pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_sprint",szTxt,iPosX,0);

	return pform;
}

func i32x TeamInfo_OnInitData()
{
	var Gui_Component pthis;
	var Gui_dtPage_TeamInfo pdtData;
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_TeamInfo;
	SetData(pthis,pdtData);
}

func i32x TeamInfo_OnCreate()
{
	var i32x j;
	var Gui_Component pthis,pcaption;
	var Gui_dtPage_TeamInfo pdtData;

	// get this pointer
	pthis = GetThis();

	pdtData = GetData(pthis);


	// Caption
	pcaption = NewCaption(smBauer,"Team Info");
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);


	// init join
	pdtData.m_iJoin_szTeamName = Join_Constructor(DATABASE_CLIENT,"DYN_team.gene_sz_name");
	pdtData.m_iJoin_iTeamID = Join_Constructor(DATABASE_CLIENT,"DYN_team.IDteam");
	pdtData.m_iTeamId = Join_GetIntFromIndex(pdtData.m_iJoin_iTeamID,0);

	// Left and Right command
	pdtData.gcPreviousTeam = NewButton(smLeftButton);
	pdtData.gcNextTeam = NewButton(smRightButton);
	MountComponent(pthis,pdtData.gcPreviousTeam);
	MountComponent(pthis,pdtData.gcNextTeam);
	MoveTo(pdtData.gcPreviousTeam,g_iScreenWidthDiv2-150-SizeX(pdtData.gcPreviousTeam),g_iScreenTopOffset+10);
	MoveTo(pdtData.gcNextTeam,g_iScreenWidthDiv2+150,g_iScreenTopOffset+10);

	// Select
	pdtData.gcTeamSelect = NewSelectExt(smBauer,300,SizeY(pdtData.gcPreviousTeam),pdtData.m_iJoin_szTeamName,pdtData.m_iJoin_iTeamID,false,false,false,e_GUI_HAlign_Center,e_GUI_VAlign_Center,1.0);
	MountComponent(pthis,pdtData.gcTeamSelect);
	MoveTo(pdtData.gcTeamSelect,g_iScreenWidthDiv2-150,g_iScreenTopOffset+10);

	// create subset
	pdtData.m_iSubsetId = Subset_Constructor("SUBSET_CYCLIST_LIST",DATABASE_CLIENT);
	Database_AddTables(pdtData.m_iSubsetId,2);
	Table_SetName(pdtData.m_iSubsetId, 0, "DYN_cyclist");
	TableSubset_SelectAllRows(pdtData.m_iSubsetId,0);
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 0, "*");
	Table_SetName(pdtData.m_iSubsetId, 1, "DYN_characteristic_cyclist");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 1, "*");
	TableSubset_SelectAllRows(pdtData.m_iSubsetId,1);


	// create join
	pdtData.m_iJoin_iCyclistID = Join_Constructor(pdtData.m_iSubsetId,"DYN_cyclist.IDcyclist"); 

	pdtData.gcCyclistInfo = NewCyclistInfoForm();
	MountComponent(pthis,pdtData.gcCyclistInfo);
	MoveTo(pdtData.gcCyclistInfo,g_iScreenWidthDiv2-SizeX(pdtData.gcCyclistInfo)/2,g_iScreenHeight-75);

	TeamInfo_SelectTeam(pdtData.gcTeamSelect,pdtData.m_iTeamId);
	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	// Subscribe button
	pdtData.gcSubscribeButton = NewCM2Button(GetLocalizedFromKey(iszInscription));
	MountComponent(pthis,pdtData.gcSubscribeButton);
	MoveTo(pdtData.gcSubscribeButton,g_iScreenWidth-g_iScreenRightOffset-SizeX(pdtData.gcSubscribeButton),g_iScreenHeight-SizeY(pdtData.gcSubscribeButton)-g_iScreenBottomOffset);

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}
func void TeamInfo_SelectTeam(Gui_Component _pSelect,i32x _iTeamId)
{
	var i32x i,iNumCyclists;
	var Gui_Component pthis,pphoto;
	var Gui_dtPage_TeamInfo pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);
	pdtData.m_iTeamId = _iTeamId;

	if(_pSelect == pdtData.gcTeamSelect)
	{
		// delete existing group option
		if(pdtData.gcCyclistList)
		{
			DeleteComponent(pdtData.gcCyclistList);
			pdtData.gcCyclistList = NULL;
		}

		// Create group option to contain cyclist photo
		pdtData.gcCyclistList = NewGroupOptionExt(g_iScreenWidth-50,1,1); // keep 25 pix left and right

		// create query to fill the subset
		DatabaseSubset_Clear(pdtData.m_iSubsetId);
		Query_Create(0,pdtData.m_iSubsetId);
		Query_SelectTable(	0, "DYN_cyclist");
		Query_SelectTable(	0, "DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist");
		Query_SelectWhereIntEqual(0,"DYN_cyclist.fkIDteam", _iTeamId);
		Query_Execute(0);


		// Add cyclist to group
		i=0;
		iNumCyclists = Join_GetNumRows(pdtData.m_iJoin_iCyclistID);
		while(i<iNumCyclists)
		{
			pphoto = NewPhotoCyclist(Join_GetIntFromIndex(pdtData.m_iJoin_iCyclistID,i),true);

			pdtData.gcCyclistList<<AddOption(pphoto);

			i=i+1;
		}

		// Mount group option to page
		MountComponent(pthis,pdtData.gcCyclistList);
		// Move it to correct position
		MoveTo(pdtData.gcCyclistList,25,g_iScreenTopOffset+50);

		// Update form
		pdtData.gcCyclistInfo<<FormFilterByIntEqual("DYN_cyclist.IDcyclist",Join_GetIntFromIndex(pdtData.m_iJoin_iCyclistID,0));
	}
}


func i32x  TeamInfo_OnDestroy()
{
	var Gui_Component pthis;
	var Gui_dtPage_TeamInfo pdtData;
	var i32x j;

	// uninit Cyclist List page
	// get this pointer
	pthis = GetThis();

	// get data
	pdtData = GetData(pthis);
	
	// destroy join
	if (pdtData.m_iJoin_iCyclistID)
		Join_Destructor(pdtData.m_iJoin_iCyclistID);
	if (pdtData.m_iJoin_iTeamID)
		Join_Destructor(pdtData.m_iJoin_iTeamID);
	if (pdtData.m_iJoin_szTeamName)
		Join_Destructor(pdtData.m_iJoin_szTeamName);

	// Destroy subset
	if(pdtData.m_iSubsetId)
	{
		Subset_Destructor(pdtData.m_iSubsetId);
	}
	pdtData.m_iSubsetId=0;
}

func void  TeamInfo_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_TeamInfo pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);
	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		// Click on back button
		pparent = GetParent(pthis);

		// Back
		pparent<<GoBack();
	}
	else if(_pComponent==pdtData.gcPreviousTeam)
	{
		pdtData.gcTeamSelect<<SelectPrevious();
	}
	else if(_pComponent==pdtData.gcNextTeam)
	{
		pdtData.gcTeamSelect<<SelectNext();
	}
	else if(_pComponent==pdtData.gcSubscribeButton)
	{
		// Send subscribe message
		g_pMenuServerSocket<<mGame_UserSubscribe(pdtData.m_iTeamId);
	}
}

func void TeamInfo_SelectCyclist(i32x _iCyclistId)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_TeamInfo pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Update form
	pdtData.gcCyclistInfo<<FormFilterByIntEqual("DYN_cyclist.IDcyclist",_iCyclistId);
}
