
func i32x Contracts_OnCreate()
{
	var Gui_Component pthis, ptab, pcaption,poption;
	var Gui_dtEditBox pdtEditBox;
	var Gui_dtPage_FinanceContracts pdtData;
	var i32x i;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_FinanceContracts;
	SetData(pthis,pdtData);

	// Onglet selector
	pdtData.gcOption = NewGroupOption(700.0*g_fScreenScaleFactor);
	MountComponent(pthis,pdtData.gcOption);
	MoveTo(pdtData.gcOption,10,g_iScreenTopOffset+10.0);

	// Tab selector
	pdtData.gcControlTab = NewTabControl();
	MountComponent(pthis,pdtData.gcControlTab);
	MoveTo(pdtData.gcControlTab,g_iScreenLeftOffset,g_iScreenTopOffset+30.0);

	// Current negociation list button
	poption = NewTextRadioButton(smBauer,GetLocalizedFromKey(iszTransactions),0);
	Stretch(poption,10,0);
	pdtData.gcOption<<AddOption(poption);

	// Find cyclist list button
	poption = NewTextRadioButton(smBauer,GetLocalizedFromKey(iszCycliste),1);
	Stretch(poption,10,0);
	pdtData.gcOption<<AddOption(poption);

	// Find sponsor list button
	poption = NewTextRadioButton(smBauer,GetLocalizedFromKey(iszSponsor),2);
	Stretch(poption,10,0);
	pdtData.gcOption<<AddOption(poption);

	// Find staff
	poption = NewTextRadioButton(smBauer,GetLocalizedFromKey(iszStaff),3);
	Stretch(poption,10,0);
	pdtData.gcOption<<AddOption(poption);

	// Init tab
	pdtData.gcNegociation = NewNegociationListTab();
	pdtData.gcControlTab<<AddTab(pdtData.gcNegociation);

	pdtData.gcFindCyclist = NewFindCyclistTab();
	pdtData.gcControlTab<<AddTab(pdtData.gcFindCyclist);

	pdtData.gcFindSponsor =	NewFindSponsorTab();
	pdtData.gcControlTab<<AddTab(pdtData.gcFindSponsor);

	pdtData.gcFindStaff = NewFindStaffTab();
	pdtData.gcControlTab<<AddTab(pdtData.gcFindStaff);

	// Show first tab
	pdtData.gcControlTab<<ShowTab(0);
	pdtData.gcOption<<SelectOption(0);

	// Caption
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszFinance));
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszBack));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	//CatchEvent(pthis,e_GUI_Event_Char);
	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func i32x Contracts_OnDestroy()
{
	// uninit System test page
	print("\nDestroy Page Contracts\n");
}

func void Contracts_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback, parent;
	var Gui_dtPage_FinanceContracts pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);
	parent = GetParent(pthis);

	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		parent<<GoBack();
	}
}

func void Contracts_OnDatabaseSync()
{
	var Gui_Component pthis,pback, parent;
	var Gui_dtPage_FinanceContracts pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(pdtData.gcNegociation)
	{
		pdtData.gcNegociation<<DatabaseSync();
	}
}

func void Contracts_OnRadioCheck(Gui_Component _pComponent,i32x _iValue)
{
	var Gui_Component pthis,pback, parent;
	var Gui_dtPage_FinanceContracts pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_pComponent == pdtData.gcOption)
	{
		// Show correspondant tab
		pdtData.gcControlTab<<ShowTab(_iValue);
	}
}

func Gui_Component NewNegociationListTab()
{
	var Gui_Component ptab,pwindow,pcaption;
	var Gui_dtTab_Negociation pdtData;

	// Create new tab
	ptab = NewObject(Gui_iTab_Negociation);

	// New data
	pdtData = new Gui_dtTab_Negociation;

	// Affect data to component
	SetData(ptab,pdtData);

	// Caption
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszCycliste));
	MountComponent(ptab,pcaption);
	MoveTo(pcaption,0,200.0*g_fScreenScaleFactor);
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszSponsor));
	MountComponent(ptab,pcaption);

	// Create sponsor list form
	pwindow = NewWindow(600.0*g_fScreenScaleFactor,200.0*g_fScreenScaleFactor);
	pdtData.gcSponsor = NewSponsorNegociationListForm();
	pwindow<<WindowMount(pdtData.gcSponsor);
	MountComponent(ptab,pwindow);
	MoveTo(pwindow,0,20.0*g_fScreenScaleFactor);

	// Create cyclist list form
	pwindow = NewWindow(600.0*g_fScreenScaleFactor,200.0*g_fScreenScaleFactor);
	pdtData.gcCyclist = NewCyclistNegociationListForm();
	pwindow<<WindowMount(pdtData.gcCyclist);
	MountComponent(ptab,pwindow);
	MoveTo(pwindow,0,220.0*g_fScreenScaleFactor);

	// Display only team negociation
	pdtData.gcCyclist<<FormFilterByIntEqual("DYN_xchange_cyclist.fkIDteam",GetMyTeamId());
	pdtData.gcSponsor<<FormFilterByIntEqual("DYN_xchange_sponsor.fkIDteam",GetMyTeamId());

	// Stretch tab to fit content
	StretchTo(ptab,600.0*g_fScreenScaleFactor,440.0*g_fScreenScaleFactor);

	return ptab;
}
func void TabNegociation_OnDatabaseSync()
{
	var Gui_Component pthis;
	var Gui_dtTab_Negociation pdtData;

	// Create new tab
	pthis = GetThis();

	// New data
	pdtData = GetData(pthis);

	// Display only team negociation
	pdtData.gcCyclist<<FormFilterByIntEqual("DYN_xchange_cyclist.fkIDteam",GetMyTeamId());
	pdtData.gcSponsor<<FormFilterByIntEqual("DYN_xchange_sponsor.fkIDteam",GetMyTeamId());
}

func void FindCyclist_ShowCommand(Gui_dtTab_FindCyclist _pdtData)
{
	if(_pdtData.m_iTeamId == GetMyTeamId())
	{
		_pdtData.gcRenegociate<<Show();
		_pdtData.gcLayoff<<Show();
		_pdtData.gcEdit<<Hide();
		_pdtData.gcEditTransfert<<Hide();
	}
	else if(_pdtData.m_iTeamId == LOOSER_TEAM)
	{
		_pdtData.gcEdit<<Show();
		_pdtData.gcEditTransfert<<Hide();
		_pdtData.gcRenegociate<<Hide();
		_pdtData.gcLayoff<<Hide();
	}
	else
	{
		_pdtData.gcEdit<<Show();
		_pdtData.gcEditTransfert<<Show();
		_pdtData.gcRenegociate<<Hide();
		_pdtData.gcLayoff<<Hide();
	}
	_pdtData.gcWindowList<<Show();
	_pdtData.gcTeamForm<<Show();
	_pdtData.gcNextTeam<<Show();
	_pdtData.gcPreviousTeam<<Show();
	_pdtData.gcBackToList<<Hide();
	_pdtData.gcSendProposition<<Hide();
}
func void FindCyclist_HideCommand(Gui_dtTab_FindCyclist _pdtData)
{
	_pdtData.gcRenegociate<<Hide();
	_pdtData.gcLayoff<<Hide();
	_pdtData.gcEdit<<Hide();
	_pdtData.gcEditTransfert<<Hide();
	_pdtData.gcWindowList<<Hide();
	_pdtData.gcTeamForm<<Hide();
	_pdtData.gcNextTeam<<Hide();
	_pdtData.gcPreviousTeam<<Hide();
	_pdtData.gcBackToList<<Show();
	_pdtData.gcSendProposition<<Show();
}

func void FindCyclist_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis;
	var Gui_dtTab_FindCyclist pdtData;

	pthis = GetThis();

	pdtData = GetData(pthis);

	if(_pComponent == pdtData.gcPreviousTeam)
	{
		pdtData.gcTeamForm<<PreviousRecord();
	}
	else if(_pComponent == pdtData.gcNextTeam)
	{
		pdtData.gcTeamForm<<NextRecord();
	}
	else if(_pComponent == pdtData.gcEdit)
	{
		// Create Negociation form
		if(!pdtData.gcNegociation)
		{
			pdtData.gcNegociation = NewCyclistNegociation();
			MountComponent(pthis,pdtData.gcNegociation);
			MoveTo(pdtData.gcNegociation,0,110);
		}
		FindCyclist_HideCommand(pdtData);

		pdtData.gcNegociation<<ShowNegociation(pdtData.m_iCyclistId);
		pdtData.gcNegociation<<Show();
	}
	else if(_pComponent == pdtData.gcRenegociate)
	{
		// Create Negociation form
		if(!pdtData.gcNegociation)
		{
			pdtData.gcNegociation = NewCyclistNegociation();
			MountComponent(pthis,pdtData.gcNegociation);
			MoveTo(pdtData.gcNegociation,0,110);
		}
		FindCyclist_HideCommand(pdtData);

		pdtData.gcNegociation<<ShowNegociation(pdtData.m_iCyclistId);
		pdtData.gcNegociation<<Show();
	}
	else if(_pComponent == pdtData.gcEditTransfert)
	{
		// Create Negociation form
		if(!pdtData.gcNegociation)
		{
			pdtData.gcNegociation = NewTransfertNegociation();
			MountComponent(pthis,pdtData.gcNegociation);
			MoveTo(pdtData.gcNegociation,0,110);
		}
		FindCyclist_HideCommand(pdtData);

		pdtData.gcNegociation<<ShowNegociation(pdtData.m_iCyclistId);
		pdtData.gcNegociation<<Show();
	}
	else if(_pComponent == pdtData.gcLayoff)
	{
		// Create Negociation form
		if(!pdtData.gcNegociation)
		{
			pdtData.gcNegociation = NewLayoffNegociation();
			MountComponent(pthis,pdtData.gcNegociation);
			MoveTo(pdtData.gcNegociation,0,110);
		}
		FindCyclist_HideCommand(pdtData);

		pdtData.gcNegociation<<ShowNegociation(pdtData.m_iCyclistId);
		pdtData.gcNegociation<<Show();
	}
	else if(_pComponent == pdtData.gcBackToList)
	{
		// Delete Negociation form
		if(pdtData.gcNegociation)
		{
			pdtData.gcNegociation = DeleteComponent(pdtData.gcNegociation);
		}
		FindCyclist_ShowCommand(pdtData);
	}
	else if(_pComponent == pdtData.gcSendProposition)
	{
		// Delete Negociation form
		if(pdtData.gcNegociation)
		{
			pdtData.gcNegociation<<SendRecord(g_pMenuServerSocket,"PropositionCyclistDB");
			pdtData.gcNegociation = DeleteComponent(pdtData.gcNegociation);
		}
		FindCyclist_ShowCommand(pdtData);
	}
}

func void FindCyclist_OnFormDoubleClick(Gui_Component _pForm,i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtTab_FindCyclist pdtData;

	pthis = GetThis();

	pdtData = GetData(pthis);

	if(_pForm == pdtData.gcList)
	{
		// Select cyclist

		// Is there already a proposition ?

		// Yes : edit proposition

		// No : create proposition


	}
}

func void FindCyclist_OnSelectKey(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtTab_FindCyclist pdtData;

	pthis = GetThis();

	pdtData = GetData(pthis);

	if(_pform == pdtData.gcTeamForm)
	{
		// Keep team id
		pdtData.m_iTeamId = _iKey;

		// Display command
		FindCyclist_ShowCommand(pdtData);

		// Display only selected team
		pdtData.gcList<<FormFilterByIntEqual("DYN_cyclist.fkIDteam",pdtData.m_iTeamId);
		// Select a cyclist from this team
		pdtData.m_iCyclistId = Join_FindKeyFromIntData(g_oMenuJoins.m_iCyclistTeamID,pdtData.m_iTeamId);
		pdtData.gcCyclistInfo<<FormFilterByIntEqual("DYN_cyclist.IDcyclist",pdtData.m_iCyclistId);
	}
	else if(_pform == pdtData.gcList)
	{
		pdtData.m_iCyclistId = _iKey;
		pdtData.gcCyclistInfo<<FormFilterByIntEqual("DYN_cyclist.IDcyclist",pdtData.m_iCyclistId);
	}
}


func Gui_Component NewFindCyclistTab()
{
	var Gui_Component ptab,pwindow,pcaption;
	var Gui_dtTab_FindCyclist pdtData;

	// Create new tab
	ptab = NewObject(Gui_iTab_FindCyclist);

	// New data
	pdtData = new Gui_dtTab_FindCyclist;

	// Affect data to component
	SetData(ptab,pdtData);

	// Create cyclist list form
	//pwindow = NewWindow(600.0*g_fScreenScaleFactor,200.0*g_fScreenScaleFactor);
	pdtData.gcWindowList = NewWindow(750,300);
	pdtData.gcList = NewCyclistListForm();
	pdtData.gcWindowList<<WindowMount(pdtData.gcList);
	MountComponent(ptab,pdtData.gcWindowList);
	MoveTo(pdtData.gcWindowList,0,130);

	// Cyclist Info form
	pdtData.gcCyclistInfo = NewCyclistInfoContractForm();
	MountComponent(ptab,pdtData.gcCyclistInfo);
	MoveTo(pdtData.gcCyclistInfo,0,30);
	pdtData.gcCyclistInfo<<FirstRecord();

	// Renegociate contract command
	pdtData.gcRenegociate = NewCM2Button(GetLocalizedFromKey(iszRenegociate));
	MountComponent(ptab,pdtData.gcRenegociate);
	MoveTo(pdtData.gcRenegociate,SizeX(pdtData.gcCyclistInfo)+RelPosX(pdtData.gcCyclistInfo),30);
	// Layoff proposition command
	pdtData.gcLayoff = NewCM2Button(GetLocalizedFromKey(iszLayoff));
	MountComponent(ptab,pdtData.gcLayoff);
	MoveTo(pdtData.gcLayoff,SizeX(pdtData.gcCyclistInfo)+RelPosX(pdtData.gcCyclistInfo),30+SizeY(pdtData.gcRenegociate));
	// Edit proposition command
	pdtData.gcEdit = NewCM2Button(GetLocalizedFromKey(iszEdit));
	MountComponent(ptab,pdtData.gcEdit);
	MoveTo(pdtData.gcEdit,SizeX(pdtData.gcCyclistInfo)+RelPosX(pdtData.gcCyclistInfo),30);
	// Edit transfert command
	pdtData.gcEditTransfert = NewCM2Button(GetLocalizedFromKey(iszTransfert));
	MountComponent(ptab,pdtData.gcEditTransfert);
	MoveTo(pdtData.gcEditTransfert,SizeX(pdtData.gcCyclistInfo)+RelPosX(pdtData.gcCyclistInfo),30+SizeY(pdtData.gcEdit));
	// Back to list command
	pdtData.gcBackToList = NewCM2Button(GetLocalizedFromKey(iszList));
	MountComponent(ptab,pdtData.gcBackToList);
	MoveTo(pdtData.gcBackToList,SizeX(pdtData.gcCyclistInfo)+RelPosX(pdtData.gcCyclistInfo),30);
	pdtData.gcBackToList<<Hide();
	// Send proposition command
	pdtData.gcSendProposition = NewCM2Button(GetLocalizedFromKey(iszSend));
	MountComponent(ptab,pdtData.gcSendProposition);
	MoveTo(pdtData.gcSendProposition,SizeX(pdtData.gcCyclistInfo)+RelPosX(pdtData.gcCyclistInfo),30+SizeY(pdtData.gcBackToList));
	pdtData.gcSendProposition<<Hide();

	// Team form
	pdtData.gcTeamForm = NewForm(DATABASE_CLIENT,"DYN_team",false);
	pdtData.gcTeamForm<<FormSetFont(smImpact,smBauer);
	pdtData.gcTeamForm<<FormSetWidth(384.0*g_fScreenScaleFactor);
	pdtData.gcTeamForm<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	pdtData.gcTeamForm<<FormShowField("DYN_team.config_sz_real","",0,0);
	pdtData.gcTeamForm<<FormSetMaJInform(true); // keep inform about record change

	MountComponent(ptab,pdtData.gcTeamForm);
	MoveTo(pdtData.gcTeamForm,g_iScreenWidthDiv2-(192.0*g_fScreenScaleFactor),0);

	// Left and Right command
	pdtData.gcPreviousTeam = NewButtonDyn(smLeftButton);
	pdtData.gcNextTeam = NewButtonDyn(smRightButton);
	MountComponent(ptab,pdtData.gcPreviousTeam);
	MountComponent(ptab,pdtData.gcNextTeam);
	MoveTo(pdtData.gcPreviousTeam,RelPosX(pdtData.gcTeamForm)-SizeX(pdtData.gcPreviousTeam),0);
	MoveTo(pdtData.gcNextTeam,RelPosX(pdtData.gcTeamForm)+SizeX(pdtData.gcTeamForm),0);

	pdtData.gcTeamForm<<FirstRecord();


	// Stretch tab to fit content
	StretchTo(ptab,750.0*g_fScreenScaleFactor,440.0*g_fScreenScaleFactor);

	return ptab;
}


func void FindStaff_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis;
	var Gui_dtTab_FindStaff pdtData;

	pthis = GetThis();

	pdtData = GetData(pthis);

	if(_pComponent == pdtData.gcMyStaff)
	{
		//  Display my staff
		pdtData.gcList<<FormFilterByIntEqual("DYN_staff.fkIDteam",GetMyTeamId());
		pdtData.gcInfo<<FormFilterByIntEqual("DYN_staff.fkIDteam",GetMyTeamId());
	}
	else if(_pComponent == pdtData.gcFreeStaff)
	{
		//  Display free staff
		pdtData.gcList<<FormFilterByIntEqual("DYN_staff.fkIDteam",LOOSER_TEAM);
		pdtData.gcInfo<<FormFilterByIntEqual("DYN_staff.fkIDteam",LOOSER_TEAM);
	}
	else if(_pComponent == pdtData.gcHire)
	{
		pdtData.gcInfo<<SendRecord(g_pMenuServerSocket,"HireStaffDB");
	}
	else if(_pComponent == pdtData.gcLayoff)
	{
		pdtData.gcInfo<<SendRecord(g_pMenuServerSocket,"LayoffStaffDB");
	}
}


func void FindStaff_OnSelectKey(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtTab_FindStaff pdtData;
	var i32x iStaffteamId;

	pthis = GetThis();

	pdtData = GetData(pthis);

	if(_pform == pdtData.gcList)
	{
		pdtData.m_iStaffId= _iKey;
		// Get staf team
		iStaffteamId = Join_GetIntFromKey(g_oMenuJoins.m_jStaff_iTeamID,_iKey);
		pdtData.gcInfo<<FormFilterByIntEqual("DYN_staff.IDstaff",pdtData.m_iStaffId);

		if(iStaffteamId==GetMyTeamId())
		{
			pdtData.gcLayoff<<Show();
			pdtData.gcHire<<Hide();
		}
		else
		{
			pdtData.gcLayoff<<Hide();
			pdtData.gcHire<<Show();
		}
	}
}


func Gui_Component NewFindStaffTab()
{
	var Gui_Component ptab,pwindow,pcaption;
	var Gui_dtTab_FindStaff pdtData;

	// Create new tab
	ptab = NewObject(Gui_iTab_FindStaff);

	// New data
	pdtData = new Gui_dtTab_FindStaff;

	// Affect data to component
	SetData(ptab,pdtData);

	// Create Staff list form
	//pwindow = NewWindow(600.0*g_fScreenScaleFactor,200.0*g_fScreenScaleFactor);
	pdtData.gcWindowList = NewWindow(750,300);
	pdtData.gcList = NewStaffListForm();
	pdtData.gcWindowList<<WindowMount(pdtData.gcList);
	MountComponent(ptab,pdtData.gcWindowList);
	MoveTo(pdtData.gcWindowList,0,130);
	pdtData.gcList<<FormFilterByIntEqual("DYN_staff.fkIDteam",GetMyTeamId());

	// Staff Info form
	pdtData.gcInfo = NewFormStaff();
	MountComponent(ptab,pdtData.gcInfo);
	MoveTo(pdtData.gcInfo,0,30);
	pdtData.gcInfo<<FormFilterByIntEqual("DYN_staff.fkIDteam",GetMyTeamId());

	// My staff command
	pdtData.gcMyStaff = NewCM2Button(GetLocalizedFromKey(iszStaff));
	MountComponent(ptab,pdtData.gcMyStaff);
	MoveTo(pdtData.gcMyStaff,0,0);
	// Free staff command
	pdtData.gcFreeStaff = NewCM2Button(GetLocalizedFromKey(iszlibre));
	MountComponent(ptab,pdtData.gcFreeStaff);
	MoveTo(pdtData.gcFreeStaff,SizeX(pdtData.gcMyStaff)+RelPosX(pdtData.gcMyStaff),0);

	// Hire staff command
	pdtData.gcHire = NewCM2Button(GetLocalizedFromKey(iszHire));
	MountComponent(ptab,pdtData.gcHire);
	MoveTo(pdtData.gcHire,SizeX(pdtData.gcInfo)+RelPosX(pdtData.gcInfo),30);
	pdtData.gcHire<<Hide();
	// Layoff staff command
	pdtData.gcLayoff = NewCM2Button(GetLocalizedFromKey(iszLayoff));
	MountComponent(ptab,pdtData.gcLayoff);
	MoveTo(pdtData.gcLayoff,SizeX(pdtData.gcInfo)+RelPosX(pdtData.gcInfo),30);

	// Stretch tab to fit content
	StretchTo(ptab,750.0*g_fScreenScaleFactor,440.0*g_fScreenScaleFactor);

	return ptab;
}

func void FindSponsor_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis;
	var Gui_dtTab_FindSponsor pdtData;

	pthis = GetThis();

	pdtData = GetData(pthis);

	if(_pComponent == pdtData.gcEdit)
	{
		// Create Negociation form
		if(!pdtData.gcNegociation)
		{
			print("NewSponsorNegociation:");
			pdtData.gcNegociation = NewSponsorNegociation();
			MountComponent(pthis,pdtData.gcNegociation);
			MoveTo(pdtData.gcNegociation,0,110);
		}
		pdtData.gcBackToList<<Show();
		print("ShowNegociation:"+itoa(pdtData.m_iSponsorId)+"\n");
		pdtData.gcNegociation<<ShowNegociation(pdtData.m_iSponsorId);
		pdtData.gcNegociation<<Show();
		pdtData.gcWindowList<<Hide();
		pdtData.gcEdit<<Hide();
		pdtData.gcSendProposition<<Show();
	}
	else if(_pComponent == pdtData.gcBackToList)
	{
		// Delete Negociation form
		if(pdtData.gcNegociation)
		{
			pdtData.gcNegociation = DeleteComponent(pdtData.gcNegociation);
		}
		pdtData.gcEdit<<Show();
		pdtData.gcWindowList<<Show();
		pdtData.gcBackToList<<Hide();
	}
	else if(_pComponent == pdtData.gcSendProposition)
	{
		// Delete Negociation form
		if(pdtData.gcNegociation)
		{
			pdtData.gcNegociation<<SendRecord(g_pMenuServerSocket,"PropositionSponsorDB");
			pdtData.gcNegociation = DeleteComponent(pdtData.gcNegociation);
		}
		pdtData.gcEdit<<Show();
		pdtData.gcWindowList<<Show();
		pdtData.gcSendProposition<<Hide();
		pdtData.gcBackToList<<Hide();
	}
}

func void FindSponsor_OnFormDoubleClick(Gui_Component _pForm,i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtTab_FindSponsor pdtData;

	pthis = GetThis();

	pdtData = GetData(pthis);

	if(_pForm == pdtData.gcList)
	{
		// Select sponsor

		// Is there already a proposition ?

		// Yes : edit proposition

		// No : create proposition


	}
}

func void FindSponsor_OnSelectKey(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtTab_FindSponsor pdtData;

	pthis = GetThis();

	pdtData = GetData(pthis);

	if(_pform == pdtData.gcList)
	{
		pdtData.m_iSponsorId= _iKey;
		pdtData.gcInfo<<FormFilterByIntEqual("DYN_sponsor.IDsponsor",pdtData.m_iSponsorId);
	}
}


func Gui_Component NewFindSponsorTab()
{
	var Gui_Component ptab,pwindow,pcaption;
	var Gui_dtTab_FindSponsor pdtData;

	// Create new tab
	ptab = NewObject(Gui_iTab_FindSponsor);

	// New data
	pdtData = new Gui_dtTab_FindSponsor;

	// Affect data to component
	SetData(ptab,pdtData);

	// Create cyclist list form
	//pwindow = NewWindow(600.0*g_fScreenScaleFactor,200.0*g_fScreenScaleFactor);
	pdtData.gcWindowList = NewWindow(750,300);
	pdtData.gcList = NewSponsorListForm();
	pdtData.gcWindowList<<WindowMount(pdtData.gcList);
	MountComponent(ptab,pdtData.gcWindowList);
	MoveTo(pdtData.gcWindowList,0,130);
	pdtData.gcList<<FormUpdate();

	// Cyclist Info form
	pdtData.gcInfo = NewSponsorInfoContractForm();
	MountComponent(ptab,pdtData.gcInfo);
	MoveTo(pdtData.gcInfo,0,30);
	pdtData.gcInfo<<FirstRecord();

	// Edit proposition command
	pdtData.gcEdit = NewCM2Button(GetLocalizedFromKey(iszEdit));
	MountComponent(ptab,pdtData.gcEdit);
	MoveTo(pdtData.gcEdit,SizeX(pdtData.gcInfo)+RelPosX(pdtData.gcInfo),30);
	// Back to list command
	pdtData.gcBackToList = NewCM2Button(GetLocalizedFromKey(iszList));
	MountComponent(ptab,pdtData.gcBackToList);
	MoveTo(pdtData.gcBackToList,SizeX(pdtData.gcInfo)+RelPosX(pdtData.gcInfo),30);
	pdtData.gcBackToList<<Hide();
	// Send proposition command
	pdtData.gcSendProposition = NewCM2Button(GetLocalizedFromKey(iszSend));
	MountComponent(ptab,pdtData.gcSendProposition);
	MoveTo(pdtData.gcSendProposition,SizeX(pdtData.gcInfo)+RelPosX(pdtData.gcInfo),30+SizeY(pdtData.gcBackToList));
	pdtData.gcSendProposition<<Hide();

	// Stretch tab to fit content
	StretchTo(ptab,750.0*g_fScreenScaleFactor,440.0*g_fScreenScaleFactor);

	return ptab;
}

func Gui_Component NewSponsorListForm()
{
	var Gui_Component pform;
	var Gui_dtForm_SponsorList pdtData;

	pdtData = new Gui_dtForm_SponsorList;

	// New list form
	pform = NewListForm(DATABASE_CLIENT,"DYN_sponsor",false);
	pform<<FormSetOffset(4);

	AddInterface(pform,Gui_iForm_SponsorList,pdtData);

	return pform;
}
func void SponsorListForm_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var i32x i,iPosX;
	var szx szTxt;

	iPosX = 0;
	_pform<<FormSetDecimal(0);
	_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	_pform<<FormSetWidth(128);
	_pform<<FormSetMediaSize(32,32);
	_pform<<FormSetOffset(0);

	if(_iIndex==0)
	{
		_pform<<FormSetTitle(true,true);
		szTxt = GetLocalizedFromKey(iszNom);
		//_pform<<FormShowBitmapField("DYN_sponsor.gene_tgaID_logo","",iPosX,0);
		_pform<<FormShowField("DYN_sponsor.gene_sz_name",szTxt,iPosX,0);
		_pform<<FormSetTitle(true,false);

		iPosX = iPosX + 256;
		_pform<<FormSetWidth(76);
		_pform<<FormSetFont(smImpact,smAtomic);
		szTxt = GetLocalizedFromKey(iszBudget);
		_pform<<FormShowField("DYN_sponsor.game_f_budget",szTxt,iPosX,0);
	}
	else
	{
		_pform<<FormSetTitle(false,true);
		szTxt = "";
		//_pform<<FormShowBitmapField("DYN_sponsor.gene_tgaID_logo","",iPosX,0);
		_pform<<FormShowField("DYN_sponsor.gene_sz_name","",iPosX,0);
		_pform<<FormSetTitle(false,false);

		iPosX = iPosX +256;
		_pform<<FormSetWidth(76);
		_pform<<FormSetFont(smImpact,smAtomic);
		_pform<<FormShowField("DYN_sponsor.game_f_budget","",iPosX,0);
	}
}


