
func i32x FinanceStatement_OnCreate()
{
	var Gui_Component pthis,pcaption;
	var Gui_dtPage_FinanceStatement pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_FinanceStatement;
	SetData(pthis,pdtData);

	// Caption
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszFinanceStatement));
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// Show current date

	// Finance statement form
	pdtData.gcFinanceStatement = NewFinanceStatementForm();
	MountComponent(pthis,pdtData.gcFinanceStatement);
	MoveTo(pdtData.gcFinanceStatement,g_iScreenLeftOffset,g_iScreenTopOffset+10);
	pdtData.gcFinanceStatement<<FormFilterByIntEqual("DYN_team.IDteam",GetMyTeamId());

	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func i32x  FinanceStatement_OnDestroy()
{
	// uninit page
}

func void  FinanceStatement_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_FinanceStatement pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);
	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		// Click on back button
		pparent = GetParent(pthis);

		// Back
		pparent<<GoBack();
	}
}

func Gui_Component NewFinanceStatementForm()
{
	var Gui_Component pform,pbox,pcaption;

	pform = NewForm(DATABASE_CLIENT,"DYN_team",false);

	// Background
	pbox = NewBoxFilled(smBlueFrame,500,64+8);
	pform<<FormAddField(pbox,0,0);

	pform<<FormSetDecimal(0);
	pform<<FormSetOffset(8);
	pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	pform<<FormSetWidth(256);
	pform<<FormSetMediaSize(64,64);

	pform<<FormSetFont(smImpact, smBauer);
	pform<<FormShowBitmapField("DYN_team.gene_tgaID_logo","",4,4);
	pform<<FormShowField("DYN_team.gene_sz_name","",68,4);
	pform<<FormSetFont(smImpact, smImpact);
	pform<<FormShowField("DYN_team.gene_sz_abbreviation","",68,24);

	pform<<FormSetFont(smImpact, smTrebuchet);
	pbox = NewBoxFilled(smBlueFrame,400,160);
	pform<<FormAddField(pbox,4,100);
	pcaption = NewCaption(smImpact,GetLocalizedFromKey(iszYearStatement));
	pform<<FormAddField(pcaption,4,104);
	pform<<FormShowField("DYN_team.finany_f_initial_amount",GetLocalizedFromKey(iszPayInit),200,130);
	pform<<FormShowField("DYN_team.finany_f_sponsor_fees",GetLocalizedFromKey(iszPayInit),200,150);
	pform<<FormShowField("DYN_team.finany_f_race_income",GetLocalizedFromKey(iszRaceIncome),200,170);
	pform<<FormShowField("DYN_team.finany_f_wages_basis",GetLocalizedFromKey(iszWageBasis),200,190);
	pform<<FormShowField("DYN_team.finany_f_wages_bonus",GetLocalizedFromKey(iszWageBonus),200,210);

	pbox = NewBoxFilled(smBlueFrame,150,160);
	pform<<FormAddField(pbox,405,100);
	pcaption = NewCaption(smImpact,GetLocalizedFromKey(iszMois));
	pform<<FormAddField(pcaption,408,104);
	pform<<FormShowField("DYN_team.finanm_f_initial_amount","",408,130);
	pform<<FormShowField("DYN_team.finanm_f_sponsor_fees","",408,150);
	pform<<FormShowField("DYN_team.finanm_f_race_income","",408,170);
	pform<<FormShowField("DYN_team.finanm_f_wages_basis","",408,190);
	pform<<FormShowField("DYN_team.finanm_f_wages_bonus","",408,210);

	return pform;
}