
func i32x Init_OnCreate()
{
	var Gui_Component pthis,pcaption,window,pback;
	var Gui_dtPage_Init pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_Init;
	SetData(pthis,pdtData);

	//  Create subset for valid stage list
	pdtData.m_iSubsetId= Subset_Constructor("SUBSET_FIRST_STAGE",DATABASE_LOCAL);
	Database_AddTables(pdtData.m_iSubsetId,2);
	Table_SetName(pdtData.m_iSubsetId, 0, "STA_stage");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 0, "*");
	Table_SetName(pdtData.m_iSubsetId, 1, "STA_race");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 1, "*");

	Query_Create(0,pdtData.m_iSubsetId);
	Query_SelectTable(	0, "STA_stage");
	Query_SelectTable(	0, "STA_stage.fkIDrace.STA_race");
	Query_SelectWhereIntEqual(0,"STA_stage.gene_i_stage_number", 1);
	Query_Execute(0);

	// Caption
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszSelectionner));
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// Exit button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszQuitter_le_jeu));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenLeftOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	// Gateway component
	pdtData.gcGateway = NewGatewayConnection();
	MountComponent(pthis, pdtData.gcGateway);

	// User form
	pdtData.gcUserForm = NewUserConfigForm();
	pback = NewWindow(SizeX(pdtData.gcUserForm)+5, SizeY(pdtData.gcUserForm)+5);
	MountComponent(pthis, pback);
	MountComponent(pthis,pdtData.gcUserForm);
	MoveTo(pback,g_iScreenLeftOffset,g_iScreenTopOffset+10);
	MoveTo(pdtData.gcUserForm,g_iScreenLeftOffset+2,g_iScreenTopOffset+12);

	// Games parameters
	pdtData.gcGameForm = NewGameForm(pdtData.m_iSubsetId);
	pback = NewWindow(SizeX(pdtData.gcGameForm)+5, SizeY(pdtData.gcGameForm)+5);
	MountComponent(pthis, pback);
	MountComponent(pthis,pdtData.gcGameForm);
	MoveTo(pback,g_iScreenLeftOffset,RelPosY(pdtData.gcUserForm)+SizeY(pdtData.gcUserForm)+10);
	MoveTo(pdtData.gcGameForm,g_iScreenLeftOffset+2,RelPosY(pdtData.gcUserForm)+SizeY(pdtData.gcUserForm)+12);

	// Create button
	pdtData.gcCreateGame = NewCM2Button(GetLocalizedFromKey(iszCreer));
	MountComponent(pthis,pdtData.gcCreateGame);
	MoveTo(pdtData.gcCreateGame,RelPosX(pdtData.gcGameForm)+SizeX(pdtData.gcGameForm)-SizeX(pdtData.gcCreateGame),RelPosY(pdtData.gcGameForm));


	// Game list form
	print(itoa((g_iScreenBottomOffset-SizeY(pdtData.gcCreateGame)) - (RelPosY(pdtData.gcGameForm)+SizeY(pdtData.gcGameForm))-10)+"\n");
	window = NewWindow(SizeX(pdtData.gcGameForm),(g_iScreenHeight-g_iScreenBottomOffset-SizeY(pdtData.gcCreateGame)) - (RelPosY(pdtData.gcGameForm)+SizeY(pdtData.gcGameForm))-10);
	pdtData.gcGameListForm = NewGameListForm();
	window<<WindowMount(pdtData.gcGameListForm);
	MountComponent(pthis,window);
	MoveTo(window,g_iScreenRightOffset,RelPosY(pdtData.gcGameForm)+SizeY(pdtData.gcGameForm)+10);
	if(Join_GetNumRows(g_oLocalJoins.m_iSSlot_iId)>0)
		pdtData.m_iGameId = Join_GetIntFromIndex(g_oLocalJoins.m_iSSlot_iId,0);
	else
		pdtData.m_iGameId = -1;

	pdtData.gcGameListForm<<FormUpdate();

	// Always Create a new game
	pdtData.gcGameForm<<AddRecord();

	// Load button
	pdtData.gcLoadGame = NewCM2Button(GetLocalizedFromKey(iszCharger));
	MountComponent(pthis,pdtData.gcLoadGame);
	MoveTo(pdtData.gcLoadGame,RelPosX(window)+SizeX(window)-SizeX(pdtData.gcLoadGame),g_iScreenHeight-SizeY(pdtData.gcLoadGame)-g_iScreenBottomOffset);
	pdtData.gcLoadGame<<Hide();

	// Join button
	pdtData.gcJoinGame = NewCM2Button(GetLocalizedFromKey(iszRejoindre));
	MountComponent(pthis,pdtData.gcJoinGame);
	MoveTo(pdtData.gcJoinGame,g_iScreenWidth-g_iScreenRightOffset-SizeX(pdtData.gcJoinGame),g_iScreenHeight-SizeY(pdtData.gcJoinGame)-g_iScreenBottomOffset);
	pdtData.gcJoinGame<<Hide();

	// Online caption
	pdtData.gcOnlineStatus = NewCaption(smBauer,GetLocalizedFromKey(iszSolo));
	MountComponent(pthis,pdtData.gcOnlineStatus);
	MoveTo(pdtData.gcOnlineStatus,RelPosX(pdtData.gcGameForm)+SizeX(pdtData.gcGameForm)+10,RelPosY(pdtData.gcUserForm)+SizeY(pdtData.gcUserForm)+10);

	// No game list form
	pdtData.gcJoinGameListForm = NULL;
	pdtData.gcJoinGameListWindow = NULL;

	pdtData.gcEmptyJoinListWindow = NewWindow(g_iScreenWidth - RelPosX(pdtData.gcOnlineStatus) - g_iScreenRightOffset,g_iScreenHeight - (RelPosY(pdtData.gcOnlineStatus)+SizeY(pdtData.gcOnlineStatus)+10) - 35);
	MountComponent(pthis,pdtData.gcEmptyJoinListWindow);
	MoveTo(pdtData.gcEmptyJoinListWindow,RelPosX(pdtData.gcOnlineStatus),RelPosY(pdtData.gcOnlineStatus)+SizeY(pdtData.gcOnlineStatus)+10);

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func void Init_OnGatewaySelected(i32x _id)
{
	var Gui_Component pthis;
	var Gui_dtPage_Init pdtData;
	var szx szIp;
	var i32x iPort;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	pdtData.m_iGatewayId = _id;

	print("Gateway:"+itoa(_id)+" selected.\n");

	if(_id>0)
	{
		szIp = Join_GetStringFromKey(g_oLocalJoins.m_iGateway_szIp,_id);
		print("\tIp:"+szIp+"\n");
		// Connect to gateway
		pdtData.gcGateway<<DistantConnect(szIp);
	}
}

func i32x  Init_OnDestroy()
{
	var Gui_Component pthis;
	var Gui_dtPage_Init pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// uninit page
	if(pdtData)
	{
		Subset_Destructor(pdtData.m_iSubsetId);
		pdtData.m_iSubsetId = 0;
	}
}

func void  Init_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_Init pdtData;
	var i32x i;

	// get this pointer
	pthis = GetThis();

	// Get parent 
	pparent = GetParent(pthis);

	// Get Data pointer
	pdtData = GetData(pthis);
	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		// Delete record
		pdtData.gcGameForm<<DeleteRecord();
		// Back
		pparent<<ExitGame();
	}
	else if(_pComponent == pdtData.gcCreateGame)
	{
		// CReate a new game
		if(pdtData.m_iGameId)
		{
			// Send save message to form
			pdtData.gcGameForm<<SaveRecord();

			// Create menu server
			pparent<<CreateGame(pdtData.m_iGameId);

			// Go main menu
			pparent<<DisplayPage(g_Page_Start);
		}
	}
	else if(_pComponent == pdtData.gcLoadGame)
	{
		// load a game
		if(pdtData.m_iLoadGameId)
		{
			// Send delete message to new game form
			pdtData.gcGameForm<<DeleteRecord();

			// Create menu server
			pparent<<CreateGame(pdtData.m_iLoadGameId);

			// Go main menu
			pparent<<DisplayPage(g_Page_Start);
		}
	}
	else if(_pComponent == pdtData.gcJoinGame)
	{
		//Join a multiplayer game
		InitInternet(Join_GetStringFromKey(g_stGateway.iJoinGame_szIP,pdtData.m_iJoinGameId), Join_GetIntFromKey(g_stGateway.iJoinGame_iPort,pdtData.m_iJoinGameId), 0, "Cyanide", "");
	}
}

func void Init_OnNewGame(i32x _id)
{
	var Gui_Component pthis;
	var Gui_dtPage_Init pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Store game id
	pdtData.m_iGameId = _id;
}

func void Init_OnGatewayDBOk(Gui_Component _pGateway,i32x _iDBIndex)
{
	var Gui_Component pthis;
	var Gui_dtPage_Init pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	pdtData.gcEmptyJoinListWindow<<Hide();

	// delete precedent game list if any
	if(pdtData.gcJoinGameListWindow)
		pdtData.gcJoinGameListWindow = DeleteComponent(pdtData.gcJoinGameListWindow);

	// Form is deleted too
	pdtData.gcJoinGameListForm = NULL;

	// Create a game list form
	pdtData.gcJoinGameListWindow = NewWindow(g_iScreenWidth - RelPosX(pdtData.gcOnlineStatus) - g_iScreenRightOffset,g_iScreenHeight - (RelPosY(pdtData.gcOnlineStatus)+SizeY(pdtData.gcOnlineStatus)+10) - 35);
	pdtData.gcJoinGameListForm = NewGatewayGameListForm(_iDBIndex);
	pdtData.gcJoinGameListWindow<<WindowMount(pdtData.gcJoinGameListForm);
	MountComponent(pthis,pdtData.gcJoinGameListWindow);
	MoveTo(pdtData.gcJoinGameListWindow,RelPosX(pdtData.gcOnlineStatus),RelPosY(pdtData.gcOnlineStatus)+SizeY(pdtData.gcOnlineStatus)+10);
	// Update display
	pdtData.gcJoinGameListForm<<FormRazFilter();

	// Set caption as online
	pdtData.gcOnlineStatus<<Caption(GetLocalizedFromKey(iszConnecte));
}
func void Init_OnGatewayDBRefresh(Gui_Component _pGateway,i32x _iDBIndex)
{
	var Gui_Component pthis;
	var Gui_dtPage_Init pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Update display
	if(pdtData.gcJoinGameListForm)
		pdtData.gcJoinGameListForm<<FormRazFilter();
	pdtData.gcJoinGame<<Hide();
}
func void Init_OnGatewayDBUnvalid(Gui_Component _pGateway)
{
	var Gui_Component pthis;
	var Gui_dtPage_Init pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	pdtData.gcEmptyJoinListWindow<<Show();
	// delete precedent game list if any
	if(pdtData.gcJoinGameListWindow)
	{
		pdtData.gcJoinGameListWindow = DeleteComponent(pdtData.gcJoinGameListWindow);
	}
	pdtData.gcJoinGameListForm = NULL;

	// Set caption as online
	pdtData.gcOnlineStatus<<Caption(GetLocalizedFromKey(iszSolo));
	pdtData.gcJoinGame<<Hide();
}

func void Init_OnFormSelectGame(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtPage_Init pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_pform == pdtData.gcGameListForm)
	{
		// Select an existing game slot to load
		pdtData.m_iLoadGameId = _iKey;
		pdtData.gcLoadGame<<Show();
	}
	else if(_pform == pdtData.gcJoinGameListForm)
	{
		// Select an existing game to join
		pdtData.m_iJoinGameId = _iKey;
		pdtData.gcJoinGame<<Show();
	}
}
