
func i32x InitLoad_OnCreate()
{
	var Gui_Component pthis,pcaption,window;
	var Gui_dtPage_InitLoad pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_InitLoad;
	SetData(pthis,pdtData);

	// Game list form
	window = NewWindow(750.0*g_fScreenScaleFactor,450.0*g_fScreenScaleFactor);
	pdtData.gcGameListForm = NewGameListForm();
	window<<WindowMount(pdtData.gcGameListForm);
	MountComponent(pthis,window);
	MoveTo(window,25.0*g_fScreenScaleFactor,g_iScreenTopOffset+5);
	pdtData.gcGameListForm<<FormUpdate();
	if(Join_GetNumRows(g_oLocalJoins.m_iSSlot_iId)>0)
		pdtData.m_iGameId = Join_GetIntFromIndex(g_oLocalJoins.m_iSSlot_iId,0);
	else
		pdtData.m_iGameId = -1;


	// Caption
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszCharger));
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// Ok button
	pdtData.gcOkButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcOkButton);
	MoveTo(pdtData.gcOkButton,g_iScreenLeftOffset,g_iScreenHeight-SizeY(pdtData.gcOkButton)-g_iScreenBottomOffset);

	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszBack));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func i32x  InitLoad_OnDestroy()
{
	// uninit page
	print("Destroy LoadGame\n");
}

func void  InitLoad_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_InitLoad pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);
	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		// Click on back button
		pparent = GetParent(pthis);

		// Go main menu
		pparent<<GoBack();
	}
	else if(_pComponent == pdtData.gcOkButton)
	{
		// Click on back button
		pparent = GetParent(pthis);

		if(pdtData.m_iGameId>0)
		{
			// Create menu server
			pparent<<CreateGame(pdtData.m_iGameId);
		}

		// Go main menu
		pparent<<GoBack();
	}
}

func void InitLoad_OnSelectKey(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtPage_InitLoad pdtData;

	pthis = GetThis();

	pdtData = GetData(pthis);

	if(_pform == pdtData.gcGameListForm)
	{
		// Keep team id
		pdtData.m_iGameId = _iKey;
	}
}

func void InitLoad_OnFormDoubleClick(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis,pparent;
	var Gui_dtPage_InitLoad pdtData;

	pthis = GetThis();

	pdtData = GetData(pthis);

	if(_pform == pdtData.gcGameListForm)
	{
		// Keep team id
		pdtData.m_iGameId = _iKey;

		// Click on ok button
		pparent = GetParent(pthis);

		// Create menu server
		pparent<<CreateGame(pdtData.m_iGameId);

		// Go main menu
		pparent<<GoBack();
	}
}

func Gui_Component NewGameListForm()
{
	var Gui_Component pform;
	var Gui_dtForm_GameList pdtData;


	pdtData = new Gui_dtForm_GameList;

	// New list form
	pform = NewListForm(DATABASE_LOCAL,"GAM_slot",false);
	pform<<FormSetOffset(4);

	AddInterface(pform,Gui_iForm_GameList,pdtData);

	return pform;
}
func void GameListForm_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var i32x i,iPosX;
	var szx szTxt;

	iPosX = 0;
	_pform<<FormSetDecimal(0);
	_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	_pform<<FormSetWidth(256);
	_pform<<FormSetOffset(0);

	if(_iIndex==0)
	{
		_pform<<FormSetFont(smImpact,smImpact);
		_pform<<FormSetTitle(true,false);
		_pform<<FormSetWidth(64);
		szTxt = GetLocalizedFromKey(iszDate);
		_pform<<FormShowField("GAM_slot.gene_i_date",szTxt,iPosX,0);
		iPosX = iPosX +64;
		_pform<<FormSetWidth(128);
		szTxt = GetLocalizedFromKey(iszNom);
		_pform<<FormShowField("GAM_slot.gene_sz_database",szTxt,iPosX,0);
		iPosX = iPosX +128;
		szTxt = GetLocalizedFromKey(iszMode_de_jeu);
		_pform<<FormShowField("GAM_slot.fkIDgamemode.STA_gamemode.gene_strID_caption",szTxt,iPosX,0);

		iPosX = iPosX +128;
		szTxt = GetLocalizedFromKey(iszCourse);
		_pform<<FormSetWidth(450.0*g_fScreenScaleFactor);
		_pform<<FormSetFont(smImpact,smBauer);
		_pform<<FormShowField("GAM_slot.fkIDstage.STA_stage.fkIDrace.STA_race.gene_strID_race_name",szTxt,iPosX,0);
		_pform<<FormSetFont(smImpact,smImpact);
		_pform<<FormShowField("GAM_slot.fkIDstage.STA_stage.gene_strID_stage_name","",iPosX,20);
	}
	else
	{
		_pform<<FormSetFont(smImpact,smImpact);
		_pform<<FormSetTitle(false,false);
		_pform<<FormSetWidth(64);
		_pform<<FormShowField("GAM_slot.gene_i_date","",iPosX,0);
		iPosX = iPosX +64;
		_pform<<FormSetWidth(128);
		_pform<<FormShowField("GAM_slot.gene_sz_database","",iPosX,0);
		iPosX = iPosX +128;
		_pform<<FormShowField("GAM_slot.fkIDgamemode.STA_gamemode.gene_strID_caption","",iPosX,0);

		iPosX = iPosX +128;
		_pform<<FormSetWidth(450.0*g_fScreenScaleFactor);
		_pform<<FormSetFont(smImpact,smBauer);
		_pform<<FormShowField("GAM_slot.fkIDstage.STA_stage.fkIDrace.STA_race.gene_strID_race_name","",iPosX,0);
		_pform<<FormSetFont(smImpact,smImpact);
		_pform<<FormShowField("GAM_slot.fkIDstage.STA_stage.gene_strID_stage_name","",iPosX,20);
	}
}
