func i32x NewGame_OnCreate()
{
	var Gui_Component pthis,pcaption;
	var Gui_dtPage_NewGame pdtData;
	var szx szTxt;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_NewGame;
	SetData(pthis,pdtData);

	//  Create subset for valid stage list
	pdtData.m_iSubsetId= Subset_Constructor("SUBSET_FIRST_STAGE",DATABASE_LOCAL);
	Database_AddTables(pdtData.m_iSubsetId,2);
	Table_SetName(pdtData.m_iSubsetId, 0, "STA_stage");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 0, "*");
	Table_SetName(pdtData.m_iSubsetId, 1, "STA_race");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 1, "*");

	Query_Create(0,pdtData.m_iSubsetId);
	Query_SelectTable(	0, "STA_stage");
	Query_SelectTable(	0, "STA_stage.fkIDrace.STA_race");
	Query_SelectWhereIntEqual(0,"STA_stage.gene_i_stage_number", 1);
	Query_Execute(0);

	// Caption
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszNouveau));
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// New formulaire
	pdtData.gcForm = NewGameForm(pdtData.m_iSubsetId);
	MountComponent(pthis,pdtData.gcForm);
	MoveTo(pdtData.gcForm,g_iScreenLeftOffset,150);

	pdtData.gcForm<<AddRecord();

	// Ok button
	pdtData.gcOkButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcOkButton);
	MoveTo(pdtData.gcOkButton,g_iScreenLeftOffset,g_iScreenHeight-SizeY(pdtData.gcOkButton)-g_iScreenBottomOffset);

	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszBack));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}
func void NewGame_OnRelease()
{
	var Gui_Component pthis,ptmp;
	var i32x i,iNumComponents;
	var Gui_dtPage_NewGame pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	iNumComponents = GetComponentNumber(pthis);
	i=0;
	while(i<iNumComponents)
	{
		ptmp = GetComponent(pthis,i);
		if(ptmp)
		{
			DeleteComponent(ptmp);
		}
		i=i+1;
	}

	Subset_Destructor(pdtData.m_iSubsetId);
	pdtData.m_iSubsetId = 0;

	delete pdtData;
	SetData(pthis,NULL);
}


func i32x  NewGame_OnDestroy()
{
	var Gui_Component pthis;
	var Gui_dtPage_NewGame pdtData;

	// get this pointer
	pthis = GetThis();
	
	// Get Data pointer
	pdtData = GetData(pthis);

	if(pdtData)
	{
		Subset_Destructor(pdtData.m_iSubsetId);
		pdtData.m_iSubsetId = 0;
	}
}
func void NewGame_OnGameSelect(i32x _id)
{
	var Gui_Component pthis;
	var Gui_dtPage_NewGame pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Store game id
	pdtData.m_iGameId = _id;
}


func void  NewGame_OnClick(Gui_Component _pComponent)
{
	var i32x iDay,iMode;
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_NewGame pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);
	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		// Send delete message to form
		pdtData.gcForm<<DeleteRecord();

		// Click on back button
		pparent = GetParent(pthis);

		// Back
		pparent<<GoBack();
	}
	else if(_pComponent == pdtData.gcOkButton)
	{
		// Click on back button
		pparent = GetParent(pthis);

		// Send save message to form
		pdtData.gcForm<<SaveRecord();

		// Create menu server
		pparent<<CreateGame(pdtData.m_iGameId);

		// Go main menu
		pparent<<GoBack();
	}
}

func Gui_Component NewGameForm(i32x _iStageSubsetId)
{
	var Gui_Component pform;
	var Gui_dtForm_GameData pdtData;
	var szx szTxt;

	pdtData = new Gui_dtForm_GameData;

	// Create stage formulaire
	pform = NewForm(DATABASE_LOCAL,"GAM_slot",false);

	pform<<FormSetMaJInform(true);
	pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Top);
	pform<<FormSetOffset(20);
	pform<<FormSetWidth(256);
	pform<<FormSetFont(smImpact,smTrebuchet);
	pform<<FormSetLocked(false);
	szTxt = GetLocalizedFromKey(iszMode_de_jeu);
	pform<<FormShowGroupOptionField("GAM_slot.fkIDgamemode","STA_gamemode.IDgamemode","STA_gamemode.gene_strID_caption",szTxt,100,0);
	pdtData.gcGameMode = GetLastField(pform);

	szTxt = GetLocalizedFromKey(iszMaxPlayers);
	pform<<FormShowField("GAM_slot.game_i_maxplayer",szTxt,200,20);
	
	szTxt = GetLocalizedFromKey(iszAutoAssign);
	pform<<FormShowCheckboxField("GAM_slot.gene_b_auto_assign",szTxt,200,40);
	szTxt = GetLocalizedFromKey(iszCourse);
	pform<<FormSetWidth(256);
	pform<<FormSetDataSource(_iStageSubsetId);
	pform<<FormShowListBoxField("GAM_slot.fkIDstage","STA_stage.IDstage","STA_stage.fkIDrace.STA_race.gene_strID_race_name",szTxt,100,60);
	pform<<FormRestoreDataSource();
	pdtData.gcStageField = GetLastField(pform);

	AddInterface(pform,Gui_iForm_GameData,pdtData);

	// Stretch pform to take care of list box
	Stretch(pform,0,75);
	return pform;
}

func void GameForm_OnMaJInt(Gui_Component _poField,i32x _iValue,i32x _bChanged)
{
	var Gui_Component pthis;
	var Gui_dtForm_GameData pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_poField == pdtData.gcGameMode)
	{
		if(_iValue == 1)
		{
			// Career mode
			pdtData.gcStageField<<Hide();
		}
		else if(_iValue == 2)
		{
			// race mdoe
			pdtData.gcStageField<<Show();
		}
	}
}

func void GameForm_OnNewRecord(i32x _iSubsetId,i32x _iRecord)
{
	var i32x id;
	var i32x iStageId;
	var szx szDbName;
	var Gui_Component pthis,parent;
	var Gui_dtForm_GameData pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Get game id
	id = Database_GetIntData(_iSubsetId, "GAM_slot.IDslot", ROW_INDEX, _iRecord);

	iStageId = Join_GetIntFromIndex(g_oLocalJoins.m_iStage_iId,0);

	szDbName = "Game_"+itoa(id);
	// Set default value
	Database_SetIntData(_iSubsetId, "GAM_slot.game_i_maxplayer", ROW_INDEX, _iRecord, 1); // 1 player
	Database_SetIntData(_iSubsetId, "GAM_slot.fkIDgamemode", ROW_INDEX, _iRecord, 1);		// Career mode
	Database_SetIntData(_iSubsetId, "GAM_slot.fkIDstage", ROW_INDEX, _iRecord, iStageId);		// Default stage id
	Database_SetIntData(_iSubsetId, "GAM_slot.gene_b_firstlaunch", ROW_INDEX, _iRecord, 1);		// FirstLaunch
	Database_SetStringData(_iSubsetId, "GAM_slot.gene_sz_database", ROW_INDEX, _iRecord, szDbName);		// Default name

	// Retrieve parent
	parent = GetParent(pthis);
	if(parent) parent<<GameSelect(id);
}

func Gui_Component NewUserConfigForm()
{
	var Gui_Component pform;
	var Gui_dtForm_UserConfig pdtData;
	var szx szTxt;

	pdtData = new Gui_dtForm_UserConfig;

	// Create stage formulaire
	pform = NewForm(DATABASE_LOCAL,"DYN_config",false);

	pform<<FormSetMaJInform(true);
	pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	pform<<FormSetOffset(20);
	pform<<FormSetWidth(256);
	pform<<FormSetFont(smImpact,smTrebuchet);
	pform<<FormSetLocked(false);

	// User part
	szTxt = GetLocalizedFromKey(iszNom);
	pform<<FormShowField("DYN_config.user_sz_name",szTxt,100,0);

	szTxt = GetLocalizedFromKey(iszMot_de_passe);
	pform<<FormShowField("DYN_config.user_sz_password",szTxt,100,20);

	// Gateway
	szTxt = GetLocalizedFromKey(iszServeur_de_parties);
	pform<<FormShowListBoxField("DYN_config.fkIDgateway","GAM_gateway.IDgateway","GAM_gateway.gene_sz_desc",szTxt,400,0);
	pdtData.gcGateway = GetLastField(pform);

	// Connect button
	pdtData.gcConnect = NewButtonDyn(smBtnValid);
	pform<<FormAddField(pdtData.gcConnect,RelPosX(pdtData.gcGateway)+SizeX(pdtData.gcGateway),0);
	pdtData.gcConnect<<Hide();

	AddInterface(pform,Gui_iForm_UserConfig,pdtData);

	return pform;
}

func void UserConfigForm_OnMaJInt(Gui_Component _poField,i32x _iValue,i32x _bChanged)
{
	var Gui_Component pform;
	var Gui_dtForm_UserConfig pdtData;

	pform = GetThis();
	pdtData = GetData(pform);

	if(_poField == pdtData.gcGateway)
	{
		pdtData.iGatewayId = _iValue;
		// Show connect button
		pdtData.gcConnect<<Show();
	}
}

func void UserConfigForm_OnClick(Gui_Component _poComponent)
{
	var Gui_Component pform,parent;
	var Gui_dtForm_UserConfig pdtData;

	pform = GetThis();
	pdtData = GetData(pform);

	if(_poComponent == pdtData.gcConnect)
	{
		parent = GetParent(pform);
		if(parent)
			parent<<GatewaySelected(pdtData.iGatewayId);

	}
}
