
func i32x Intro_OnCreate()
{
	var Gui_Component pthis,ptmp;
	var Gui_dtPage_Intro pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_Intro;
	SetData(pthis,pdtData);

	// Load background kit
	LoadKit(mkBackground);

	// Create intro
	pdtData.gcVideo = NewBitmap(smOutro,0);
	SetAlign(pdtData.gcVideo,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcVideo,800.0*g_fScreenScaleFactor,400.0*g_fScreenScaleFactor);
	MountComponent(pthis,pdtData.gcVideo);
	MoveTo(pdtData.gcVideo,0.0,100.0*g_fScreenScaleFactor);

	ptmp = NewBitmap(smWhite,0);
	SetAlign(ptmp,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	SetColor(ptmp,MakeARGB(255,0,0,0));
	SetBlendingMode(GetSprite(ptmp),DLC_Blend_AlphaBlend);
	SetShadingMode(GetSprite(ptmp),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	StretchTo(ptmp,800.0*g_fScreenScaleFactor,100.0*g_fScreenScaleFactor);
	MountComponent(pthis,ptmp);

	ptmp = NewBitmap(smWhite,0);
	SetAlign(ptmp,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	SetColor(ptmp,MakeARGB(255,0,0,0));
	SetBlendingMode(GetSprite(ptmp),DLC_Blend_AlphaBlend);
	SetShadingMode(GetSprite(ptmp),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	StretchTo(ptmp,800.0*g_fScreenScaleFactor,100.0*g_fScreenScaleFactor);
	MountComponent(pthis,ptmp);
	MoveTo(ptmp,0,500.0*g_fScreenScaleFactor);

	InitVideo(smOutro,"Gui/LogoCyanide_l.avi");
	PlayVideo();

	GiveFocus(pthis);

	pdtData.m_bFirstLoop = 0;

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func void Intro_OnLoop(f32x _fDeltaTime)
{
	var Gui_Component pthis,pparent;
	var Gui_dtPage_Intro pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(pdtData.m_bFirstLoop==1)
	{
		pdtData.m_fDeltatime = pdtData.m_fDeltatime + _fDeltaTime;

		if(pdtData.m_fDeltatime>1.0)
		{
			pdtData.m_fDeltatime = 0.0;

			if(IsVideoEnded())
			{
				//Return to menu page
				pparent = GetParent(pthis);

				if(isDemo())
				{
					//load the saved game
					if (DATABASE_SERVER==0)
					{
						pparent<<CreateGame(0);
					}
				}
				else
				{
					// Go main menu
					pparent<<DisplayPage(g_Page_Init);
				}
			}
		}
	}
	else
		pdtData.m_bFirstLoop = 1;
}

func i32x  Intro_OnRelease()
{
	var Gui_Component pthis;
	var Gui_dtPage_Intro pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	pdtData.gcVideo = DeleteComponent(pdtData.gcVideo);

	ReleaseKit(mkBackground);

	SetData(pthis,NULL);
	delete pdtData;

}

func i32x  Intro_OnDestroy()
{
	var Gui_Component pthis;
	var Gui_dtPage_Intro pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

}
func void Intro_OnKeyDown(i32x _iKey,i32x _iCount)
{
	var Gui_Component pthis,pparent;
	var Gui_dtPage_Intro pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_iKey == VK_Escape)
	{
		//Return to menu page
		pparent = GetParent(pthis);

		// // HADES JEUXVIDEO.COM DEMO
		if(isDemo())
		{
			//load the saved game
			pparent<<CreateGame(0);
		}
		else
		{
			// Go main menu
			pparent<<DisplayPage(g_Page_Init);
		}
	}
}


func i32x Outro_OnCreate()
{
	var Gui_Component pthis;
	var Gui_dtPage_Outro pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_Outro;
	SetData(pthis,pdtData);

	// Load background kit
	LoadKit(mkBackground);

	// Create outro
	pdtData.gcBackground = NewBitmap(smOutro,0);
	MountComponent(pthis,pdtData.gcBackground);
	SetAlign(pdtData.gcBackground,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcBackground,g_iScreenWidth,g_iScreenHeight);
	
	GiveFocus(pthis);

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func i32x Outro_OnRelease()
{
	var Gui_Component pthis;
	var Gui_dtPage_Outro pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	pdtData.gcBackground = DeleteComponent(pdtData.gcBackground);

	ReleaseKit(mkBackground);

	SetData(pthis,NULL);
	delete pdtData;
}

func i32x  Outro_OnDestroy()
{
}


func void Outro_OnKeyDown(i32x _iKey,i32x _iCount)
{
	var Gui_Component pthis,pparent;
	var Gui_dtPage_Outro pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_iKey == VK_Escape)
	{
		//Return to menu page
		pparent = GetParent(pthis);

		print("Exitgame\n");
		// Back
		pparent<<ExitGame();
	}
}
