func Gui_Component NewAnimButton3D(Menu_Mesh _poMesh)
{
	var Gui_Component gcButton;
	var Gui_dt3DButton_Anim pdtData;
	// 3D Button
	gcButton = NewButton3D(_poMesh);

	// Anim interface
	pdtData = new Gui_dt3DButton_Anim;
	pdtData.fCurrentPhi = 0;
	pdtData.bRotate = false;
	AddInterface(gcButton,Gui_i3DButton_Anim,pdtData);

	return gcButton;
}

func i32x Logo_OnLoop(f32x _fDelta)
{
	var Gui_Component pthis;
	var Gui_dtLogo pdtLogo;
	var f32x rx,ry;

	pthis = GetThis();
	pdtLogo = GetData(pthis);

	pdtLogo.fTime = pdtLogo.fTime + _fDelta;

	ry = cos(pdtLogo.fTime*0.001) * pdtLogo.fAmpZ;
	rx = sin(pdtLogo.fTime*0.001) * pdtLogo.fAmpY;

	Rotate(GetSprite(pthis),rx,ry,0);

	return 1;
}

func i32x Start_OnCreate()
{
	var f32x fRay,fPhi,fAlpha;
	var i32x i,iNumButtons,px,py,sx,sy;
	var Gui_Component pthis,temp;
	var Gui_dtPage_Start pdtData;
	var Gui_dtLogo pdtLogo;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_Start;
	SetData(pthis,pdtData);

	// Members init
	pdtData.bInGame = false;
	pdtData.bOnForeground = false;

	pdtData.gcLogo = NewMesh(s3dmLogo);
	// Affect an anim interface to logo
	pdtLogo = new Gui_dtLogo;
	pdtLogo.fTime = 0.0;
	pdtLogo.fAmpY = 0.1;
	pdtLogo.fAmpZ = 0.1;
	AddInterface(pdtData.gcLogo,Gui_iLogoAnim,pdtLogo);
	MountComponent(pthis,pdtData.gcLogo);
	// Center logo in page
	MoveTo(pdtData.gcLogo,g_iScreenWidthDiv2-SizeX(pdtData.gcLogo)/2,g_iScreenHeightDiv2-SizeY(pdtData.gcLogo)/2);
	MoveZ(GetSprite(pdtData.gcLogo),-5.0);
	
	iNumButtons = 0;
	// Start race button
	pdtData.gcGoToRaceButton = NewAnimButton3D(s3dmLogoSinglePlayer);
	MountComponent(pthis,pdtData.gcGoToRaceButton);
	g_stButtonBuf.m_stComponent[iNumButtons] = pdtData.gcGoToRaceButton;
	g_stButtonBuf.m_iHelpStrId[iNumButtons] = iszAvant_course;
	g_stButtonBuf.m_iPageIndex[iNumButtons] = g_Page_PreRace;
	iNumButtons = iNumButtons+1;

	//Start finance button
	pdtData.gcFinanceButton = NewAnimButton3D(s3dmLogoFinance);
	MountComponent(pthis,pdtData.gcFinanceButton);
	g_stButtonBuf.m_stComponent[iNumButtons] = pdtData.gcFinanceButton;
	g_stButtonBuf.m_iHelpStrId[iNumButtons] = iszFinance;
	g_stButtonBuf.m_iPageIndex[iNumButtons] = g_Page_Finance;
	iNumButtons = iNumButtons+1;

	//Season button
	pdtData.gcSeasonButton = NewAnimButton3D(s3dmLogoCalendar);
	MountComponent(pthis,pdtData.gcSeasonButton);
	g_stButtonBuf.m_stComponent[iNumButtons] = pdtData.gcSeasonButton;
	g_stButtonBuf.m_iHelpStrId[iNumButtons] = iszCalendrier;
	g_stButtonBuf.m_iPageIndex[iNumButtons] = g_Page_Season;
	iNumButtons = iNumButtons+1;

	//Training button
	pdtData.gcTrainingButton = NewAnimButton3D(s3dmLogoTraining);
	MountComponent(pthis,pdtData.gcTrainingButton);
	g_stButtonBuf.m_stComponent[iNumButtons] = pdtData.gcTrainingButton;
	g_stButtonBuf.m_iHelpStrId[iNumButtons] = iszEntrainement;
	g_stButtonBuf.m_iPageIndex[iNumButtons] = g_Page_Training;
	iNumButtons = iNumButtons+1;

	//Medical button
	pdtData.gcMedicalButton = NewAnimButton3D(s3dmLogoMedical);
	MountComponent(pthis,pdtData.gcMedicalButton);
	g_stButtonBuf.m_stComponent[iNumButtons] = pdtData.gcMedicalButton;
	g_stButtonBuf.m_iHelpStrId[iNumButtons] = iszMedical;
	g_stButtonBuf.m_iPageIndex[iNumButtons] = g_Page_MedicalDistrib;
	iNumButtons = iNumButtons+1;

	//Roster button
	pdtData.gcRosterButton = NewAnimButton3D(s3dmLogoRoster);
	MountComponent(pthis,pdtData.gcRosterButton);
	g_stButtonBuf.m_stComponent[iNumButtons] = pdtData.gcRosterButton;
	g_stButtonBuf.m_iHelpStrId[iNumButtons] = iszEffectif;
	g_stButtonBuf.m_iPageIndex[iNumButtons] = g_Page_Roster;
	iNumButtons = iNumButtons+1;

	//News button
	pdtData.gcNewsButton = NewAnimButton3D(s3dmLogoInternet);
	MountComponent(pthis,pdtData.gcNewsButton);
	g_stButtonBuf.m_stComponent[iNumButtons] = pdtData.gcNewsButton;
	g_stButtonBuf.m_iHelpStrId[iNumButtons] = iszNouvelles;
	g_stButtonBuf.m_iPageIndex[iNumButtons] = g_Page_News;
	iNumButtons = iNumButtons+1;

	//Palmares button
	pdtData.gcPalmaresButton = NewAnimButton3D(s3dmLogoPalmares);
	MountComponent(pthis,pdtData.gcPalmaresButton);
	g_stButtonBuf.m_stComponent[iNumButtons] = pdtData.gcPalmaresButton;
	g_stButtonBuf.m_iHelpStrId[iNumButtons] = iszPalmares;
	g_stButtonBuf.m_iPageIndex[iNumButtons] = g_Page_Palmares;
	iNumButtons = iNumButtons+1;

	//Classification button
	pdtData.gcClassButton = NewAnimButton3D(s3dmLogoPodium);
	MountComponent(pthis,pdtData.gcClassButton);
	g_stButtonBuf.m_stComponent[iNumButtons] = pdtData.gcClassButton;
	g_stButtonBuf.m_iHelpStrId[iNumButtons] = iszClassement;
	g_stButtonBuf.m_iPageIndex[iNumButtons] = g_Page_Classification;
	iNumButtons = iNumButtons+1;

	fAlpha = 0.0;
	fRay =  SizeX(pdtData.gcLogo) - (g_fScreenScaleFactor*80);
	fPhi = MATH_2PI/iNumButtons;
	i=0;
	while(i<iNumButtons)
	{
		sx = SizeX(g_stButtonBuf.m_stComponent[i]) / 2;
		sy = SizeY(g_stButtonBuf.m_stComponent[i]) / 2;

		// Start pos
		px = fRay * cos(fAlpha) + g_iScreenWidthDiv2;
		py = fRay * sin(fAlpha) + g_iScreenHeightDiv2;
		g_stButtonBuf.m_iSPosX[i] = px-sx;
		g_stButtonBuf.m_iSPosY[i] = py-sy;
		// End pos
		px = cos(fAlpha) * g_iScreenHeight + g_iScreenWidthDiv2;
		py = sin(fAlpha) * g_iScreenHeight + g_iScreenHeightDiv2;
		g_stButtonBuf.m_iFPosX[i] = px-sx;
		g_stButtonBuf.m_iFPosY[i] = py-sy;

		fAlpha = fAlpha + fPhi;


		// Move Component to end pos
		MoveTo(g_stButtonBuf.m_stComponent[i],g_stButtonBuf.m_iFPosX[i],g_stButtonBuf.m_iFPosY[i]);
		//print("px:"+ftoa(px-sx)+" py:"+ftoa(py-sy)+"\n");

		i = i+1;
	}
	// Save button number
	pdtData.iNumButtons = iNumButtons;

	iNumButtons = 0;
	// Init game button
	pdtData.gcNewButton = NewAnimButton3D(s3dmLogoSinglePlayer);
	MountComponent(pthis,pdtData.gcNewButton);
	g_stInitButtonBuf.m_stComponent[iNumButtons] = pdtData.gcNewButton;
	g_stInitButtonBuf.m_iHelpStrId[iNumButtons] = iszDemarrer_une_nouvelle_partie;
	g_stInitButtonBuf.m_iPageIndex[iNumButtons] = g_Page_New;
	iNumButtons = iNumButtons+1;

	pdtData.gcJoinButton = NewAnimButton3D(s3dmLogoMultiPlayer);
	MountComponent(pthis,pdtData.gcJoinButton);
	g_stInitButtonBuf.m_stComponent[iNumButtons] = pdtData.gcJoinButton;
	g_stInitButtonBuf.m_iHelpStrId[iNumButtons] = iszRejoindre_une_partie_multi_joueurs;
	g_stInitButtonBuf.m_iPageIndex[iNumButtons] = g_Page_Join;
	iNumButtons = iNumButtons+1;

	pdtData.gcLoadButton = NewAnimButton3D(s3dmLogoConfig);
	MountComponent(pthis,pdtData.gcLoadButton);
	g_stInitButtonBuf.m_stComponent[iNumButtons] = pdtData.gcLoadButton;
	g_stInitButtonBuf.m_iHelpStrId[iNumButtons] = iszCharger_une_partie_sauvegardee;
	g_stInitButtonBuf.m_iPageIndex[iNumButtons] = g_Page_Load;
	iNumButtons = iNumButtons+1;

	fAlpha = 0.0;
	fRay =  SizeX(pdtData.gcLogo) - (g_fScreenScaleFactor*80);
	fPhi = MATH_2PI/iNumButtons;
	i=0;
	while(i<iNumButtons)
	{
		sx = SizeX(g_stInitButtonBuf.m_stComponent[i]) / 2;
		sy = SizeY(g_stInitButtonBuf.m_stComponent[i]) / 2;

		// Start pos
		px = fRay * cos(fAlpha) + g_iScreenWidthDiv2;
		py = fRay * sin(fAlpha) + g_iScreenHeightDiv2;
		g_stInitButtonBuf.m_iSPosX[i] = px-sx;
		g_stInitButtonBuf.m_iSPosY[i] = py-sy;
		// End pos
		px = cos(fAlpha) * g_iScreenHeight + g_iScreenWidthDiv2;
		py = sin(fAlpha) * g_iScreenHeight + g_iScreenHeightDiv2;
		g_stInitButtonBuf.m_iFPosX[i] = px-sx;
		g_stInitButtonBuf.m_iFPosY[i] = py-sy;

		fAlpha = fAlpha + fPhi;


		// Move Component to end pos
		MoveTo(g_stInitButtonBuf.m_stComponent[i],g_stInitButtonBuf.m_iFPosX[i],g_stInitButtonBuf.m_iFPosY[i]);
		//print("px:"+ftoa(px-sx)+" py:"+ftoa(py-sy)+"\n");

		i = i+1;
	}
	// Save init button number
	pdtData.iNumInitButtons = iNumButtons;

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
	
//	NextMp3();

}
func void Start_OnEnterButton(Gui_Component _pComponent)
{
	var i32x i;
	var Gui_Component pthis, parent;
	var Gui_dtPage_Start pdtData;

	// get this pointer
	pthis = GetThis();

	// get parent
	parent = GetParent(pthis);


	// Get Data pointer
	pdtData = GetData(pthis);
	i=0;
	if(pdtData.bInGame == true)
	{

		while(i<pdtData.iNumButtons)
		{
			if(g_stButtonBuf.m_stComponent[i] == _pComponent)
			{
				// Display correspondant help
				ShowContextualHelp(GetLocalizedFromKey(g_stButtonBuf.m_iHelpStrId[i]));
				// Break loop
				i=pdtData.iNumButtons;
			}
			i=i+1;
		}
	}
	else
	{

		while(i<pdtData.iNumInitButtons)
		{
			if(g_stInitButtonBuf.m_stComponent[i] == _pComponent)
			{
				// Display correspondant help
				ShowContextualHelp(GetLocalizedFromKey(g_stInitButtonBuf.m_iHelpStrId[i]));
				// Break loop
				i=pdtData.iNumInitButtons;
			}
			i=i+1;
		}
	}
}
func void Start_OnLeaveButton(Gui_Component _pthis)
{
	// Hide contextual help
	HideContextualHelp();
}

func void Start_OnDatabaseSync()
{
	var Gui_Component pthis;
	var Gui_dtPage_Start pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(!pdtData.gcConfigForm)
	{
		pdtData.gcConfigForm = NewForm(DATABASE_CLIENT,"GAM_config",false);
//		pdtData.gcConfigForm<<FormSetFont(smBauer,smBauer);
		pdtData.gcConfigForm<<FormSetOffset(5);
		pdtData.gcConfigForm<<FormShowField("GAM_config.fkIDday","Day",0,20);
		pdtData.gcConfigForm<<FormShowField("GAM_config.fkIDstage_current.STA_stage.gene_strID_stage_name","Stage",0,40);
		pdtData.gcConfigForm<<FormShowField("GAM_config.game_i_last_year","Year",0,60);

		MountComponent(pthis,pdtData.gcConfigForm);
		MoveTo(pdtData.gcConfigForm,85.0*g_fScreenScaleFactor,5.0*g_fScreenScaleFactor);
	}
	pdtData.gcConfigForm<<FirstRecord();
}


func i32x Start_OnDestroy()
{
	// uninit System test page
}
func void Start_ShowInitButton(Gui_dtPage_Start _pdtData)
{
	var i32x i;
	i=0;
	while(i<_pdtData.iNumInitButtons)
	{
		// Anim Component to start pos
		g_stInitButtonBuf.m_stComponent[i]<<Show();
		g_stInitButtonBuf.m_stComponent[i]<<TitlePos(0);
		Add_TranslateAnim(g_stInitButtonBuf.m_stComponent[i],g_stInitButtonBuf.m_iSPosX[i],g_stInitButtonBuf.m_iSPosY[i],0.004);
		g_stInitButtonBuf.m_stComponent[i]<<StartAnim();
		i = i+1;
	}
	i=0;
	while(i<_pdtData.iNumButtons)
	{
		g_stButtonBuf.m_stComponent[i]<<Hide();
		i = i+1;
	}
}
func void Start_HideInitButton(Gui_dtPage_Start _pdtData,i32x _iSelectedButton)
{
	var i32x i;
	i=0;
	while(i<_pdtData.iNumInitButtons)
	{
		if(i!=_iSelectedButton)
		{
			// Anim Component to start pos
			Add_TranslateAnim(g_stInitButtonBuf.m_stComponent[i],g_stInitButtonBuf.m_iFPosX[i],g_stInitButtonBuf.m_iFPosY[i],0.004);
			g_stInitButtonBuf.m_stComponent[i]<<TitlePos(0);
		}
		else
		{
			// Anim Component to Top of screen
			Add_TranslateAnim(g_stInitButtonBuf.m_stComponent[i],32,32,0.004);
			g_stInitButtonBuf.m_stComponent[i]<<TitlePos(1);
		}
		g_stInitButtonBuf.m_stComponent[i]<<StartAnim();
		i = i+1;
	}
}
func void Start_ShowButton(Gui_dtPage_Start _pdtData)
{
	var i32x i;
	i=0;
	while(i<_pdtData.iNumButtons)
	{
		// Anim Component to start pos
		g_stButtonBuf.m_stComponent[i]<<Show();
		g_stButtonBuf.m_stComponent[i]<<TitlePos(0);
		Add_TranslateAnim(g_stButtonBuf.m_stComponent[i],g_stButtonBuf.m_iSPosX[i],g_stButtonBuf.m_iSPosY[i],0.004);
		g_stButtonBuf.m_stComponent[i]<<StartAnim();
		i = i+1;
	}

	i=0;
	while(i<_pdtData.iNumInitButtons)
	{
		g_stInitButtonBuf.m_stComponent[i]<<Hide();
		i = i+1;
	}
}
func void Start_HideButton(Gui_dtPage_Start _pdtData,i32x _iSelectedButton)
{
	var i32x i;
	i=0;

	while(i<_pdtData.iNumButtons)
	{
		if(i !=_iSelectedButton)
		{
			// Anim Component to start pos
			Add_TranslateAnim(g_stButtonBuf.m_stComponent[i],g_stButtonBuf.m_iFPosX[i],g_stButtonBuf.m_iFPosY[i],0.004);
			g_stButtonBuf.m_stComponent[i]<<TitlePos(0);
		}
		else
		{
			// Anim Component to start pos
			Add_TranslateAnim(g_stButtonBuf.m_stComponent[i],32,32,0.004);
			g_stButtonBuf.m_stComponent[i]<<TitlePos(1);
		}
		g_stButtonBuf.m_stComponent[i]<<StartAnim();
		i = i+1;
	}
}

func void Start_OnGoToBackground(i32x _iTabId)
{
	var i32x i,iButton,id;
	var Gui_Component pthis;
	var Gui_dtPage_Start pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	pdtData.bOnForeground = false;
	// hide button
	if(pdtData.bInGame == false)
	{
		i=0;
		while(i<pdtData.iNumInitButtons)
		{
			id = g_stInitButtonBuf.m_iPageIndex[i];
			if(id == _iTabId)
			{
				// Display correspondant page
				iButton = i;
				// Break loop
				i=pdtData.iNumInitButtons;
			}
			i=i+1;
		}

		Start_HideInitButton(pdtData,iButton);
	}
	else
	{
		i=0;
		while(i<pdtData.iNumButtons)
		{
			id = g_stButtonBuf.m_iPageIndex[i];
			if(id == _iTabId)
			{
				// Display correspondant page
				iButton = i;
				// Break loop
				i=pdtData.iNumButtons;
			}
			i=i+1;
		}

		Start_HideButton(pdtData,iButton);
	}
	//Hide logo
	Add_TranslateScaleAnim(pdtData.gcLogo,g_iScreenWidth+5,-SizeY(pdtData.gcLogo)-5,0.4*g_fScreenScaleFactor,0.004);
	pdtData.gcLogo<<StartAnim();
}
func void Start_OnGoToForeground()
{
	var Gui_Component pthis;
	var Gui_dtPage_Start pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	pdtData.bOnForeground = true;
	// show button
	if(pdtData.bInGame == false)
	{
		Start_ShowInitButton(pdtData);
	}
	else
	{
		Start_ShowButton(pdtData);
	}

	// Center logo
	Add_TranslateScaleAnim(pdtData.gcLogo,g_iScreenWidthDiv2-SizeX(pdtData.gcLogo)/2,g_iScreenHeightDiv2-SizeY(pdtData.gcLogo)/2,g_fScreenScaleFactor,0.004);
	pdtData.gcLogo<<StartAnim();
}

func void Start_AnimEnded(Gui_Component _panim)
{
	var Gui_Component pthis, parent;
	var Gui_dtPage_Start pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Toggle only when logo is okay
	if(_panim == pdtData.gcLogo)
	{
		// get parent
		parent = GetParent(pthis);

		// Send toggle to tab control
		if(parent)
		{
			parent<<ToggleOk();
		}
	}
}
func i32x Start_OnGainFocus()
{
	// Take focus
	return 1;
}
func i32x Start_OnKeyDown(i32x _iKey,i32x _iCount)
{
	var Gui_Component pthis,parent;
	var Gui_dtPage_Start pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_iKey == VK_Escape)
	{
		if(pdtData.bInGame==true)
		{
			// Unloggue from MenuServer
			parent = GetParent(pthis);
			if(parent)
				parent<<QuitGame();
		}
	}
	return 1;
}
func void Start_OnLogue(i32x _bInGame)
{
	var Gui_Component pthis;
	var Gui_dtPage_Start pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Display correct button
	if(pdtData.bInGame != _bInGame)
	{
		pdtData.bInGame = _bInGame;
		// If page is on foreground
		if(pdtData.bOnForeground==true)
		{
			if(pdtData.bInGame)
			{
				Start_ShowButton(pdtData);
			}
			else
			{
				Start_ShowInitButton(pdtData);
			}
		}
	}
}


func void Start_OnClick(Gui_Component _pComponent)
{
	var i32x i;
	var Gui_Component pthis, parent;
	var Gui_dtPage_Start pdtData;

	// get this pointer
	pthis = GetThis();

	// get parent
	parent = GetParent(pthis);


	// Get Data pointer
	pdtData = GetData(pthis);
	i=0;
	if(pdtData.bInGame == true)
	{

		while(i<pdtData.iNumButtons)
		{
			if(g_stButtonBuf.m_stComponent[i] == _pComponent)
			{
				// Display correspondant page
				parent<<DisplayPage(g_stButtonBuf.m_iPageIndex[i]);
				// Break loop
				i=pdtData.iNumButtons;
			}
			i=i+1;
		}
	}
	else
	{

		while(i<pdtData.iNumInitButtons)
		{
			if(g_stInitButtonBuf.m_stComponent[i] == _pComponent)
			{
				// Display correspondant page
				parent<<DisplayPage(g_stInitButtonBuf.m_iPageIndex[i]);
				// Break loop
				i=pdtData.iNumInitButtons;
			}
			i=i+1;
		}
	}
}

// 3DButton anim
func i32x Btn3DAnim_OnMouseEnter(i32x _iX,i32x _iY)
{
	var Gui_Component pthis,parent;
	var Gui_dt3DButton_Anim pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Update Z Wanted
	if(pdtData.bTitlePos == 0)
	{
		pdtData.fWantedZ = -40.0;
		pdtData.fSpeed = -0.025;
		pdtData.bRotate = true;
	}

	// tell parent
	parent = GetParent(pthis);
	if(parent) parent<<EnterButton(pthis);

	return 1;
}
func i32x Btn3DAnim_OnMouseLeave(i32x _iX,i32x _iY)
{
	var Gui_Component pthis,parent;
	var Gui_dt3DButton_Anim pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Update Z Wanted
	if(pdtData.bTitlePos == 0)
	{
		pdtData.fWantedZ = 0.0;
		pdtData.fSpeed = 0.025;
		pdtData.bRotate = false;
	}

	// tell parent
	parent = GetParent(pthis);
	if(parent) parent<<LeaveButton(pthis);
}
func i32x Btn3DAnim_OnLoop(f32x _fDelta)
{
	var Gui_Component pthis;
	var Gui_dt3DButton_Anim pdtData;
	var f32x fCurrentZ,fCurrentPhi;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Retrieve current Z
	fCurrentZ = GetZ(GetSprite(pthis));
	if(fCurrentZ!=pdtData.fWantedZ)
	{
		if((fCurrentZ>pdtData.fWantedZ) && (pdtData.fSpeed<0))
		{
			fCurrentZ = fCurrentZ + pdtData.fSpeed*_fDelta;
		}
		else if((fCurrentZ<pdtData.fWantedZ) && (pdtData.fSpeed>0))
		{
			fCurrentZ = fCurrentZ + pdtData.fSpeed*_fDelta;
		}
		else
		{
			fCurrentZ = pdtData.fWantedZ;
		}
		MoveZ(GetSprite(pthis),fCurrentZ - GetZ(GetSprite(pthis)));
	}
	// Retrieve current angle
	fCurrentPhi = pdtData.fCurrentPhi;
	if(pdtData.bRotate)
	{
		fCurrentPhi = fCurrentPhi + pdtData.fSpeed*_fDelta*0.1;
		Rotate(GetSprite(pthis),0,fCurrentPhi,0.0);
		pdtData.fCurrentPhi = fCurrentPhi;
	}
}

func void Btn3DAnim_SetTitlePos(i32x _iPos)
{
	var Gui_Component pthis;
	var Gui_dt3DButton_Anim pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	pdtData.bTitlePos = _iPos;
	if(_iPos == 1)
	{
		// Update Z Wanted
		pdtData.fWantedZ = -40.0;
		pdtData.fSpeed = -0.01;
		pdtData.bRotate = true;
	}
	else
	{
		pdtData.fWantedZ = 0.0;
		pdtData.fSpeed = 0.05;
		pdtData.bRotate = false;
	}
}


