
func i32x Palmares_OnCreate()
{
	var Gui_Component pthis,pcaption,pwindow;
	var Gui_dtPage_Palmares pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_Palmares;
	SetData(pthis,pdtData);

	// Caption
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszPalmares));
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// Palmares list
	pdtData.gcPalmares = NewPalmaresListForm(DATABASE_CLIENT); 
	pwindow = NewWindow(650,350);
	pwindow<<WindowMount(pdtData.gcPalmares);
	MountComponent(pthis,pwindow);
	MoveTo(pwindow,g_iScreenLeftOffset,200);

	// Team form
	pdtData.gcTeamForm = NewForm(DATABASE_CLIENT,"DYN_team",false);
	pdtData.gcTeamForm<<FormSetFont(smImpact,smBauer);
	pdtData.gcTeamForm<<FormSetWidth(384.0*g_fScreenScaleFactor);
	pdtData.gcTeamForm<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	pdtData.gcTeamForm<<FormShowField("DYN_team.config_sz_real","",0,0);
	pdtData.gcTeamForm<<FormSetMaJInform(true); // keep inform about record change

	MountComponent(pthis,pdtData.gcTeamForm);
	MoveTo(pdtData.gcTeamForm,g_iScreenWidthDiv2-(192.0*g_fScreenScaleFactor),g_iScreenTopOffset+10);

	// Left and Right command
	pdtData.gcPreviousTeam = NewButtonDyn(smLeftButton);
	pdtData.gcNextTeam = NewButtonDyn(smRightButton);
	MountComponent(pthis,pdtData.gcPreviousTeam);
	MountComponent(pthis,pdtData.gcNextTeam);
	MoveTo(pdtData.gcPreviousTeam,RelPosX(pdtData.gcTeamForm)-SizeX(pdtData.gcPreviousTeam),RelPosY(pdtData.gcTeamForm));
	MoveTo(pdtData.gcNextTeam,RelPosX(pdtData.gcTeamForm)+SizeX(pdtData.gcTeamForm),RelPosY(pdtData.gcTeamForm));

	pdtData.gcTeamForm<<FirstRecord();

	// navigation bar
	pdtData.gcNavBar = NewNavBar();
	MountComponent(pthis, pdtData.gcNavBar);
	MoveTo(pdtData.gcNavBar, g_iScreenWidth-SizeX(pdtData.gcNavBar)-g_iScreenRightOffset, g_iScreenHeight-SizeY(pdtData.gcNavBar)-g_iScreenBottomOffset);
	pdtData.gcNavBar<<SetReload(false);
	pdtData.gcNavBar<<SetApply(false);

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func i32x  Palmares_OnDestroy()
{
	// uninit page
}
func void Palmares_OnDatabaseSync()
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_Palmares pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Update palmares form
	pdtData.gcPalmares<<FormFilterByIntEqual("DYN_palmares.fkIDteam",pdtData.m_iTeamId);
}
func void  Palmares_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_Palmares pdtData;
	// get this pointer
	pthis = GetThis();
	// Get Data pointer
	pdtData = GetData(pthis);

	
	if(_pComponent == pdtData.gcPreviousTeam)
	{
		pdtData.gcTeamForm<<PreviousRecord();
	}
	else if(_pComponent == pdtData.gcNextTeam)
	{
		pdtData.gcTeamForm<<NextRecord();
	}
}

//
func void Palmares_NavBack()
{
	var Gui_Component pthis, pparent;
	var Gui_dtPage_Palmares pdtData;
	pthis = GetThis();
	pdtData = GetData(pthis);

	// go back
	pparent = GetParent(pthis);
	pparent<<GoBack();
}

//
func void Palmares_OnSelectKey(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtPage_Palmares pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_pform == pdtData.gcTeamForm)
	{
		// Keep team id
		pdtData.m_iTeamId = _iKey;

		// Display only selected team
		pdtData.gcPalmares<<FormFilterByIntEqual("DYN_palmares.fkIDteam",pdtData.m_iTeamId);
		// Select a cyclist from this team
		pdtData.m_iCyclistId = Join_FindKeyFromIntData(g_oMenuJoins.m_iCyclistTeamID,pdtData.m_iTeamId);
	}
}


func Gui_Component NewPalmaresListForm(i32x _iSubsetId)
{
	var Gui_Component pform;
	var Gui_dtForm_PalmaresList pdtData;

	pdtData = new Gui_dtForm_PalmaresList;

	// New list form
	pform = NewListForm(_iSubsetId,"DYN_palmares",false);
	pform<<FormSetOffset(4);

	AddInterface(pform,Gui_iForm_PalmaresList,pdtData);

	return pform;
}
func void PalmaresListForm_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var i32x i,iPosX;
	var szx szTxt;

	iPosX = 0;
	_pform<<FormSetDecimal(0);
	_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	_pform<<FormSetOffset(0);

	_pform<<FormAddVariable("DYN_palmares.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname","CYCLISTNAME");
	_pform<<FormAddVariable("DYN_palmares.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_firstname","CYCLISTFIRSTNAME");
	_pform<<FormAddVariable("DYN_palmares.fkIDrace.STA_race.gene_strID_race_name","RACENAME");
	_pform<<FormAddVariable("DYN_palmares.fkIDstage.STA_stage.gene_strID_stage_name","STAGENAME");
	_pform<<FormAddVariable("DYN_palmares.fkIDsprint.STA_sprint.gene_sz_name","SPRINTNAME");
	_pform<<FormAddVariable("DYN_palmares.fkIDclassification.STA_classification.gene_strID_classification_name","CLASSIFICATIONNAME");
	_pform<<FormAddVariable("DYN_palmares.fkIDclassification.STA_classification.gene_strID_jersey","JERSEYNAME");
	_pform<<FormAddVariable("DYN_palmares.gene_i_year","YEAR");
	if(_iIndex==0)
	{
		_pform<<FormSetTitle(true,true);
		_pform<<FormSetWidth(128);
		_pform<<FormShowFormatField("DYN_palmares.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",39,"",iPosX,0);
		_pform<<FormSetTitle(true,false);

		_pform<<FormSetFont(smImpact,smImpact);
		_pform<<FormSetWidth(64);
		szTxt = GetLocalizedFromKey(iszYear);
		_pform<<FormShowField("DYN_palmares.gene_i_year",szTxt,iPosX,0);
		iPosX = iPosX +64;
		_pform<<FormSetWidth(512);
		szTxt = GetLocalizedFromKey(iszPalmares);
		_pform<<FormShowField("DYN_palmares.fkIDformated_string",szTxt,iPosX,0);
	}
	else
	{
		_pform<<FormSetTitle(false,true);
		_pform<<FormSetWidth(128);
		_pform<<FormShowFormatField("DYN_palmares.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",39,"",iPosX,0);
		_pform<<FormSetTitle(false,false);

		_pform<<FormSetFont(smImpact,smImpact);
		_pform<<FormSetWidth(64);
		_pform<<FormShowField("DYN_palmares.gene_i_year","",iPosX,0);
		iPosX = iPosX +64;
		_pform<<FormSetWidth(512);
		_pform<<FormShowField("DYN_palmares.fkIDformated_string","",iPosX,0);
	}
}

