
func i32x PreRaceSelection_OnCreate()
{
	var Gui_Component pthis,pcaption;
	var Gui_dtPage_PreRaceSelection pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_PreRaceSelection;
	SetData(pthis,pdtData);

	// Caption
	pcaption = NewCaption(smBauer,"Stage selection");
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// Invited team
	pdtData.gcTeamWindow = NewWindow(400.0*g_fScreenScaleFactor,400.0*g_fScreenScaleFactor);
	pdtData.gcTeamForm = NewInviteTeamListForm();
	pdtData.gcTeamWindow<<WindowMount(pdtData.gcTeamForm);

	MountComponent(pthis,pdtData.gcTeamWindow);
	MoveTo(pdtData.gcTeamWindow,g_iScreenRightOffset,g_iScreenTopOffset+10);

	// Display only invited team
	pdtData.gcTeamForm<<FormFilterByIntDifferent("DYN_team.game_i_invite_enum",1);

	// User team
	pdtData.gcUserForm = NewTeamInviteForm();
	MountComponent(pthis,pdtData.gcUserForm);
	MoveTo(pdtData.gcUserForm,RelPosX(pdtData.gcTeamWindow)+SizeX(pdtData.gcTeamWindow)+10.0,g_iScreenTopOffset+10);
	pdtData.gcUserForm<<FormFilterByIntDifferent("DYN_team.IDteam",GetMyTeamId());

	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	// Send button
	pdtData.gcSendButton = NewCM2Button(GetLocalizedFromKey(iszSend));
	MountComponent(pthis,pdtData.gcSendButton);
	MoveTo(pdtData.gcSendButton,RelPosX(pdtData.gcBackButton)-SizeX(pdtData.gcSendButton)-10,g_iScreenHeight-SizeY(pdtData.gcSendButton)-g_iScreenBottomOffset);
	pdtData.gcSendButton<<Hide();

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func void PreRaceSelection_OnDatabaseSync()
{
	var Gui_Component pthis;
	var Gui_dtPage_PreRaceSelection pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Update team form display
	pdtData.gcTeamForm<<FormFilterByIntDifferent("DYN_team.game_i_invite_enum",1);
	pdtData.gcUserForm<<FormFilterByIntDifferent("DYN_team.IDteam",GetMyTeamId());
}
func i32x  PreRaceSelection_OnDestroy()
{
	// uninit page
}

func void  PreRaceSelection_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_PreRaceSelection pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);
	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		// Click on back button
		pparent = GetParent(pthis);

		// Back
		pparent<<GoBack();
	}
	else if(_pComponent == pdtData.gcSendButton)
	{
		// Send message to user form
		pdtData.gcUserForm<<SendRecord(g_pMenuServerSocket,"InviteDB");

		// Hide send button
		pdtData.gcSendButton<<Hide();
	}
}

func void PreRaceSelection_OnMakeAnswer()
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_PreRaceSelection pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Show send button
	pdtData.gcSendButton<<Show();


}

func Gui_Component NewInviteTeamListForm()
{
	var Gui_Component pform;
	var Gui_dtForm_InviteTeamList pdtData;
	var i32x i,iPosX;
	var szx szTxt;


	pdtData = new Gui_dtForm_InviteTeamList;

	// New list form
	pform = NewListForm(DATABASE_CLIENT,"DYN_team",false);
	pform<<FormSetOffset(5);

	AddInterface(pform,Gui_iForm_InviteTeamList,pdtData);

	return pform;
}
func void InviteTeamListForm_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var Gui_Component pthis;
	var Gui_dtForm_InviteTeamList pdtData;
	var i32x i,iPosX,bUserForm;
	var szx szTxt;

	// Get pointer to list form
	pthis = GetThis();

	// Get data
	pdtData = GetData(pthis);

	iPosX = 0;
	_pform<<FormSetDecimal(0);
	_pform<<FormSetOffset(2);
	_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	_pform<<FormSetMediaSize(32,32);

	if(_iIndex==0)
	{
		_pform<<FormSetLocked(true);
		_pform<<FormSetTitle(true,false);
		_pform<<FormSetWidth(128.0*g_fScreenScaleFactor);
		_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	//	_pform<<FormShowBitmapField("DYN_team.gene_tgaID_logo","",iPosX,0);
		iPosX = iPosX + 64;
		szTxt = GetLocalizedFromKey(iszEquipe);
		_pform<<FormShowField("DYN_team.gene_sz_name",szTxt,iPosX,0);
		iPosX = iPosX + 128;
		_pform<<FormSetWidth(128.0*g_fScreenScaleFactor);
		_pform<<FormShowField("DYN_team.game_i_invite_enum.STA_invite_enum.gene_strID_name","",iPosX,0);
		iPosX = iPosX + 128;
	}
	else
	{
		_pform<<FormSetLocked(true);
		_pform<<FormSetTitle(false,false);
		_pform<<FormSetWidth(128.0*g_fScreenScaleFactor);
		_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	//	_pform<<FormShowBitmapField("DYN_team.gene_tgaID_logo","",iPosX,0);
		iPosX = iPosX + 64;
		_pform<<FormShowField("DYN_team.gene_sz_name","",iPosX,0);
		iPosX = iPosX + 128;
		_pform<<FormSetWidth(128.0*g_fScreenScaleFactor);
		_pform<<FormShowField("DYN_team.game_i_invite_enum.STA_invite_enum.gene_strID_name","",iPosX,0);
		iPosX = iPosX + 128;
	}
}

func Gui_Component NewTeamInviteForm()
{
	var Gui_Component pform;
	var Gui_dtForm_InviteTeam pdtData;


	pform = NewForm(DATABASE_CLIENT,"DYN_team",false);
	pdtData = new Gui_dtForm_InviteTeam;

	AddInterface(pform,Gui_iForm_InviteTeam,pdtData);

	pform<<FormSetLocked(false);
	pform<<FormSetMaJInform(true);
	pform<<FormShowGroupOptionField(
			"DYN_team.game_i_invite_enum",
			"STA_invite_user.fkIDinvite_enum",
			"STA_invite_user.gene_strID_name",
			"",70,30
	);
	pdtData.gcAnswer = GetLastField(pform);
	pform<<FormSetLocked(true);
	pform<<FormShowBitmapField("DYN_team.gene_tgaID_logo","",0,0);
	pform<<FormShowField("DYN_team.game_i_invite_enum.STA_invite_enum.gene_strID_name","",70,0);
	pform<<FormShowField("DYN_team.game_i_invite_enum","",0,0);
	pdtData.gcState = GetLastField(pform);
	pdtData.gcState<<Hide();
	
	return pform;
}
func void InviteTeamForm_OnMaJInt(Gui_Component _poField,i32x _iValue,i32x _bChanged)
{
	var Gui_Component pthis,parent;
	var Gui_dtForm_InviteTeam pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	if(_bChanged)
	{
		// Get pointer to list form
		pthis = GetThis();

		// Get data
		pdtData = GetData(pthis);

		// If field parent is user form then we have
		if(_poField == pdtData.gcAnswer)
		{
			// Send that an answer have been done
			parent = GetParent(pthis);

			if(parent)
				parent<<MakeAnswer();
		}
	}
	else if(_poField == pdtData.gcState)
	{
		print("Value:"+itoa(_iValue)+"\n");
		if((_iValue == 1)||(_iValue == 5))
		{
			// Not invited or validated
			pdtData.gcAnswer<<Hide();
		}
		else
		{
			pdtData.gcAnswer<<Show();
		}
	}
}

