func void PreRaceStrategy_OnInitData()
{
	var Gui_Component pthis,pcaption;
	var Gui_dtPage_PreRaceStrategy pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_PreRaceStrategy;
	SetData(pthis,pdtData);
}

func i32x PreRaceStrategy_OnCreate()
{
	var Gui_Component pthis,pcaption,pwindow,gcGroupOptionRB;
	var Gui_dtPage_PreRaceStrategy pdtData;
	var i32x iStageId,iTeamId,iDynDb,iStrategyID,i;
	var f32x fPosX,fPosY;
	
	println("PreRaceStrategy_OnCreate");

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = GetData(pthis);

	// get current stage ID
	iStageId = Join_GetIntFromIndex(g_oMenuJoins.m_iConfig_iCurrentStageId,0);
	
	// Get current team id
	//mao debug script AI for demo
	iTeamId = GetMyTeamId();
	//iTeamId = 18;//us postal
	//iTeamId = 17;//d telekom
	//iTeamId = 14;//rabobank
	//iTeamId = 12;//once
	//iTeamId = 1;//banesto
	//iTeamId = 16;//saeco
	//iTeamId = 10;//mapei
	//iTeamId = 8;//lampre
	//iTeamId = 24;//domo
	//iTeamId = 3;//ag2r
	//iTeamId = 20;//team coast
	//iTeamId = 22;//fassa
	//iTeamId = 28;//jean delatour
	

	// Caption
	pcaption = NewCaption(smBauer,"PreRace Strategy");
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	//Database_HTMLDebugPrint(DATABASE_CLIENT);

	// Subset for zone editor
	pdtData.m_iSubsetId = Subset_Constructor("SUBSET_STRATEGY",DATABASE_CLIENT);
	Database_AddTables(pdtData.m_iSubsetId,13);
	Table_SetName(pdtData.m_iSubsetId, 0, "DYN_strategic_zone");
	//TableSubset_SelectAllRows(pdtData.m_iSubsetId,0);
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 0, "*");


	Table_SetName(pdtData.m_iSubsetId, 1, "STA_behaviour_offense");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 1, "*");
	TableSubset_SelectAllRows(pdtData.m_iSubsetId, 1);
	Table_SetName(pdtData.m_iSubsetId, 2, "DYN_behaviour_defense");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 2, "*");
	TableSubset_SelectAllRows(pdtData.m_iSubsetId, 2);
	Table_SetName(pdtData.m_iSubsetId, 3, "STA_behaviour_defense_type");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 3, "*");
	TableSubset_SelectAllRows(pdtData.m_iSubsetId, 3);
	Table_SetName(pdtData.m_iSubsetId, 4, "STA_strategic_zone_type");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 4, "*");
	TableSubset_SelectAllRows(pdtData.m_iSubsetId, 4);

	// Sprint select
	Table_SetName(pdtData.m_iSubsetId, 5, "STA_classification");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 5, "*");
	Table_SetName(pdtData.m_iSubsetId, 6, "STA_race");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 6, "*");
	Table_SetName(pdtData.m_iSubsetId, 7, "STA_stage");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 7, "*");
	Table_SetName(pdtData.m_iSubsetId, 8, "STA_sprint");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 8, "*");

	// Team select
	Table_SetName(pdtData.m_iSubsetId, 9, "DYN_team");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 9, "*");
	Table_SetName(pdtData.m_iSubsetId, 10, "DYN_cyclist");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 10, "*");
	Table_SetName(pdtData.m_iSubsetId, 11, "DYN_characteristic");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 11, "*");

	Table_SetName(pdtData.m_iSubsetId, 12,"DYN_strategy");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 12, "*");
	

	// Select strategies of the current team
	Query_Create(0,pdtData.m_iSubsetId);
	Query_SelectTable(	0, "DYN_strategy");
	Query_SelectWhereIntEqual(0,"DYN_strategy.fkIDteam", iTeamId);
	Query_Execute(0);

	// Select sprints of current stage and classification of races
	Query_Create(0,pdtData.m_iSubsetId);
	Query_SelectTable(	0, "STA_sprint");
	Query_SelectTable(	0, "STA_sprint.fkIDstage.STA_stage");
	Query_SelectTable(	0, "STA_sprint.fkIDstage.STA_stage.fkIDrace.STA_race");
	Query_SelectTable(	0, "STA_sprint.fkIDstage.STA_stage.fkIDrace.STA_race.fkIDclassification_time.STA_classification");
	Query_SelectTable(	0, "STA_sprint.fkIDstage.STA_stage.fkIDrace.STA_race.fkIDclassification_points.STA_classification");
	Query_SelectTable(	0, "STA_sprint.fkIDstage.STA_stage.fkIDrace.STA_race.fkIDclassification_mountain.STA_classification");
	Query_SelectTable(	0, "STA_sprint.fkIDstage.STA_stage.fkIDrace.STA_race.fkIDclassification_team.STA_classification");
	Query_SelectTable(	0, "STA_sprint.fkIDstage.STA_stage.fkIDrace.STA_race.fkIDclassification_specific1.STA_classification");
	Query_SelectTable(	0, "STA_sprint.fkIDstage.STA_stage.fkIDrace.STA_race.fkIDclassification_specific2.STA_classification");
	Query_SelectTable(	0, "STA_sprint.fkIDstage.STA_stage.fkIDrace.STA_race.fkIDclassification_specific3.STA_classification");
	Query_SelectWhereIntEqual(0,"STA_sprint.fkIDstage", iStageId);
	Query_Execute(0);

	// Select roster cyclists with charac
	Query_Create(0,pdtData.m_iSubsetId);
	Query_SelectTable(	0, "DYN_team");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_1.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_2.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_3.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_4.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_5.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_6.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_7.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_8.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_9.DYN_cyclist");
	
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_1.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_2.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_3.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_4.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_5.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_6.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_7.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_8.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_9.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectWhereIntEqual(0,"DYN_team.IDteam", iTeamId);
	Query_Execute(0);


	Query_Create(0,pdtData.m_iSubsetId);
	Query_SelectTable(	0, "DYN_strategic_zone");
	Query_SelectWhereIntEqual(0,"DYN_strategic_zone.fkIDstrategy", Database_GetIntData(pdtData.m_iSubsetId,"DYN_team.fkIDcyclist_1.DYN_cyclist.fkIDstrategic_group",ROW_KEY,iTeamId));
	Query_Execute(0);
	Query_SelectWhereIntEqual(0,"DYN_strategic_zone.fkIDstrategy", Database_GetIntData(pdtData.m_iSubsetId,"DYN_team.fkIDcyclist_2.DYN_cyclist.fkIDstrategic_group",ROW_KEY,iTeamId));
	Query_Execute(0);
	Query_SelectWhereIntEqual(0,"DYN_strategic_zone.fkIDstrategy", Database_GetIntData(pdtData.m_iSubsetId,"DYN_team.fkIDcyclist_3.DYN_cyclist.fkIDstrategic_group",ROW_KEY,iTeamId));
	Query_Execute(0);
	Query_SelectWhereIntEqual(0,"DYN_strategic_zone.fkIDstrategy", Database_GetIntData(pdtData.m_iSubsetId,"DYN_team.fkIDcyclist_4.DYN_cyclist.fkIDstrategic_group",ROW_KEY,iTeamId));
	Query_Execute(0);
	Query_SelectWhereIntEqual(0,"DYN_strategic_zone.fkIDstrategy", Database_GetIntData(pdtData.m_iSubsetId,"DYN_team.fkIDcyclist_5.DYN_cyclist.fkIDstrategic_group",ROW_KEY,iTeamId));
	Query_Execute(0);
	Query_SelectWhereIntEqual(0,"DYN_strategic_zone.fkIDstrategy", Database_GetIntData(pdtData.m_iSubsetId,"DYN_team.fkIDcyclist_6.DYN_cyclist.fkIDstrategic_group",ROW_KEY,iTeamId));
	Query_Execute(0);
	Query_SelectWhereIntEqual(0,"DYN_strategic_zone.fkIDstrategy", Database_GetIntData(pdtData.m_iSubsetId,"DYN_team.fkIDcyclist_7.DYN_cyclist.fkIDstrategic_group",ROW_KEY,iTeamId));
	Query_Execute(0);
	Query_SelectWhereIntEqual(0,"DYN_strategic_zone.fkIDstrategy", Database_GetIntData(pdtData.m_iSubsetId,"DYN_team.fkIDcyclist_8.DYN_cyclist.fkIDstrategic_group",ROW_KEY,iTeamId));
	Query_Execute(0);
	Query_SelectWhereIntEqual(0,"DYN_strategic_zone.fkIDstrategy", Database_GetIntData(pdtData.m_iSubsetId,"DYN_team.fkIDcyclist_9.DYN_cyclist.fkIDstrategic_group",ROW_KEY,iTeamId));
	Query_Execute(0);
	

	//Database_HTMLDebugPrint(pdtData.m_iSubsetId);

	// Subset for subscribed cycliste
	pdtData.m_iSubscribedCyclistId = Subset_Constructor("SUBSET_ROSTER",DATABASE_CLIENT);
	Database_AddTables(pdtData.m_iSubscribedCyclistId,3);
	// Team select
	Table_SetName(pdtData.m_iSubscribedCyclistId, 0, "DYN_team");
	TableSubset_SelectColumns(pdtData.m_iSubscribedCyclistId, 0, "*");
	Table_SetName(pdtData.m_iSubscribedCyclistId, 1, "DYN_cyclist");
	TableSubset_SelectColumns(pdtData.m_iSubscribedCyclistId, 1, "*");
	Table_SetName(pdtData.m_iSubscribedCyclistId, 2, "DYN_characteristic");
	TableSubset_SelectColumns(pdtData.m_iSubscribedCyclistId, 2, "*");

	// Select roster cyclists with charac
	Query_Create(0,pdtData.m_iSubscribedCyclistId);
	Query_SelectTable(	0, "DYN_team");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_1.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_2.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_3.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_4.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_5.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_6.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_7.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_8.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_9.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_1.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_2.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_3.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_4.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_5.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_6.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_7.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_8.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_9.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	// Only validated team
	Query_SelectWhereIntEqual(0,"DYN_team.game_i_invite_enum", 5);
	Query_Execute(0);
	
	//Database_HTMLDebugPrint(pdtData.m_iSubscribedCyclistId);


	//Roster form
	fPosX=g_iScreenLeftOffset+10.0*g_fScreenScaleFactor;
	fPosY=g_iScreenTopOffset+10.0*g_fScreenScaleFactor;

	pdtData.gcRoster = NewPreRaceStrategyRoster(pdtData.m_iSubsetId);
	MountComponent(pthis,pdtData.gcRoster);
	MoveTo(pdtData.gcRoster,0.0,fPosY);
	fPosY=fPosY+SizeY(pdtData.gcRoster);

	//Create a radio button for all the strategies of the team
	pdtData.iJoin_iStrategyID = Join_Constructor(pdtData.m_iSubsetId,"DYN_strategy.IDstrategy"); 
	
	if(Join_GetNumRows(pdtData.iJoin_iStrategyID))
	{
		pdtData.gcGroupOption = NewGroupOptionExt(480,12,12);
		pdtData.smGroupOptionFont = smImpact;
		pdtData.smGroupOptionRB = smDOPanel_bar_action;
		
		i=0;
		while(i<Join_GetNumRows(pdtData.iJoin_iStrategyID))
		{
			iStrategyID=Join_GetIntFromIndex(pdtData.iJoin_iStrategyID,i);
			gcGroupOptionRB=NewRadioButton_CenterText(pdtData.smGroupOptionRB,pdtData.smGroupOptionFont," "+itoa(iStrategyID)+" ",iStrategyID);
			
			/*print("iStrategyID ");
			print(itoa(i));
			print(" ");
			println(itoa(iStrategyID));*/
			
			pdtData.gcGroupOption<<AddOption(gcGroupOptionRB);
			i=i+1;
		}
		
		//Select the first radio button
		iStrategyID=Join_GetIntFromIndex(pdtData.iJoin_iStrategyID,0);

		MountComponent(pthis,pdtData.gcGroupOption);
		MoveTo(pdtData.gcGroupOption,fPosX,fPosY);
	}
	else
	{
		println("***** Error : No strategy slot in my team ***");
		pdtData.gcGroupOption=NULL;
	}
	fPosY=fPosY+SizeY(pdtData.gcGroupOption);

	// New zone button
	pdtData.gcNewZone = NewCM2Button(GetLocalizedFromKey(iszNouveau));
	MountComponent(pthis,pdtData.gcNewZone);
	MoveTo(pdtData.gcNewZone,fPosX,fPosY);
	fPosY=fPosY+SizeY(pdtData.gcNewZone);

	pdtData.gcProfile2D=NewStrategyProfile2D(iStageId,512.0*g_fScreenScaleFactor,100.0*g_fScreenScaleFactor);
	MountComponent(pthis,pdtData.gcProfile2D);
	MoveTo(pdtData.gcProfile2D,fPosX,fPosY);
	fPosY=fPosY+SizeY(pdtData.gcProfile2D);
	CatchEvent(pdtData.gcProfile2D,e_GUI_Event_Mouse_Move);
	
	
	// Create Zone Editor
	pdtData.gcZoneEditorForm = NewZoneForm(pdtData.m_iSubsetId,pdtData.m_iSubscribedCyclistId,iStageId);
	MountComponent(pthis,pdtData.gcZoneEditorForm);
	MoveTo(pdtData.gcZoneEditorForm,fPosX,fPosY);
	fPosY=fPosY+SizeY(pdtData.gcZoneEditorForm);
	
	// Get Dynamic data from form
	iDynDb = Form_GetDynamicDb(pdtData.gcZoneEditorForm);

	//Create zone list
	pwindow = NewWindow(600.0*g_fScreenScaleFactor,200.0*g_fScreenScaleFactor);
	pdtData.gcZoneListForm = NewZoneListForm(iDynDb,pdtData.m_iSubscribedCyclistId);
	pwindow<<WindowMount(pdtData.gcZoneListForm);
	MountComponent(pthis,pwindow);
	MoveTo(pwindow,fPosX,fPosY);
	fPosY=fPosY+SizeY(pdtData.gcZoneListForm);
	
	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);
	
	// Send button
	pdtData.gcSendButton = NewCM2Button(GetLocalizedFromKey(iszSend));
	MountComponent(pthis,pdtData.gcSendButton);
	MoveTo(pdtData.gcSendButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-SizeX(pdtData.gcSendButton)-10-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	if(pdtData.gcGroupOption)
	{
		pdtData.gcGroupOption<<SelectOption(iStrategyID);
		pdtData.gcZoneEditorForm<<mSelectStrategy(iStrategyID);
		pdtData.gcZoneListForm<<mSelectStrategy(iStrategyID);
	}

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);

	println("PreRaceStrategy_OnCreate OK ");
}

func i32x  PreRaceStrategy_OnDestroy()
{
	var Gui_Component pthis;
	var Gui_dtPage_PreRaceStrategy pdtData;
	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if (pdtData.iJoin_iStrategyID)
			Join_Destructor(pdtData.iJoin_iStrategyID);

	// uninit page
	if(pdtData.m_iSubsetId)
	{
		Subset_Destructor(pdtData.m_iSubsetId);
		Subset_Destructor(pdtData.m_iSubscribedCyclistId);
	}
}

func void  PreRaceStrategy_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pparent;
	var Gui_dtPage_PreRaceStrategy pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_pComponent == pdtData.gcBackButton)
	{
		// Click on back button
		pparent = GetParent(pthis);

		// Back
		pparent<<GoBack();
	}
	else if(_pComponent == pdtData.gcSendButton)
	{
		println("Send strategy databases");
		//Database_HTMLDebugPrint(pdtData.m_iSubsetId);

		//send databases
		pdtData.gcZoneEditorForm<<SaveRecord();
	
		// Update zone list
		pdtData.gcZoneListForm<<mRefreshZoneList();
		pdtData.gcZoneListForm<<FormSort("DYN_strategic_zone.gene_f_distance",1);
		pdtData.gcZoneListForm<<SendDatabase(g_pMenuServerSocket,"StratZone_DB");
		pdtData.gcRoster<<mSendStratID();
	}
	else if(_pComponent == pdtData.gcNewZone)
	{
		// Save current zone
		pdtData.gcZoneEditorForm<<SaveRecord();

		// Update zone list
		pdtData.gcZoneListForm<<mRefreshZoneList();
		pdtData.gcZoneListForm<<FormSort("DYN_strategic_zone.gene_f_distance",1);

		// Add a new zone
		pdtData.gcZoneEditorForm<<AddRecord();
	}
}

func Gui_Component NewZoneForm(i32x _iSubsetId,i32x _iRosterSubset,i32x _iStageId)
{
	var Gui_Component pform;
	var Gui_dtForm_Zone pdtData;
	var szx szTxt;
	var f32x fPosX,fPosY;

	pdtData = new Gui_dtForm_Zone;

	fPosY=0;
	fPosX=0;

	// Init members
	pdtData.iStrategyId = 0;
	pdtData.fStageDistance = Join_GetFloatFromKey(g_oMenuJoins.m_iStage_fLength,_iStageId);

	// Create stage formulaire
	pform = NewForm(_iSubsetId,"DYN_strategic_zone",true);

	pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	pform<<FormSetOffset(10);
	pform<<FormSetWidth(256);
	pform<<FormSetFont(smImpact,smImpact);
	pform<<FormSetLocked(false);
	pform<<FormSetMaJInform(true);

		// Distance field
	szTxt = GetLocalizedFromKey(iszDistance);
	pform<<FormShowField("DYN_strategic_zone.gene_f_distance",szTxt,256.0*g_fScreenScaleFactor,fPosY);
	pdtData.gcDistance = GetLastField(pform);
	fPosY=fPosY+10;
	
	// Gauge field
	pform<<FormSetWidth(512.0*g_fScreenScaleFactor);
	pform<<FormShowGaugeHField("DYN_strategic_zone.gene_f_distance","",fPosX,fPosY,0,pdtData.fStageDistance,0.1);
	pdtData.gcGauge = GetLastField(pform);
	fPosY=fPosY+20;

	// Zone type
	pform<<FormSetWidth(64);
	pform<<FormShowGroupOptionField("DYN_strategic_zone.fkIDstrategic_zone_type",
		"STA_strategic_zone_type.IDstrategic_zone_type",
		"STA_strategic_zone_type.gene_strID_name",
		"",fPosX,fPosY);
	pdtData.gcZoneType = GetLastField(pform);

	pform<<FormSetWidth(164);

	// Compete sprint checkbox
	szTxt = GetLocalizedFromKey(iszCompete);
	pform<<FormShowCheckboxField("DYN_strategic_zone.gene_b_compete",szTxt,130,fPosY+2);
	pdtData.gcCompete = GetLastField(pform);

	// Sprint list
	szTxt = GetLocalizedFromKey(iszSprint);
	pform<<FormShowListBoxField("DYN_strategic_zone.fkIDsprint",
		"STA_sprint.IDsprint",
		"STA_sprint.gene_sz_name",
		szTxt,450,fPosY);
	pdtData.gcSprint = GetLastField(pform);

	fPosY=fPosY+40;

	pform<<FormSetWidth(256);
	// Attack behaviour
	szTxt = GetLocalizedFromKey(iszComportement_offensif);
	pform<<FormShowGroupOptionField("DYN_strategic_zone.fkIDbehaviour_offense",
		"STA_behaviour_offense.IDbehaviour_offense",
		"STA_behaviour_offense.gene_strID_name",
		szTxt,150,fPosY);
	pdtData.gcOffense = GetLastField(pform);

	// Defense behaviour
	szTxt = GetLocalizedFromKey(iszComportement_defensif);
	pform<<FormShowGroupOptionField("DYN_strategic_zone.fkIDbehaviour_defense.DYN_behaviour_defense.fkIDbehaviour_defense_type",
		"STA_behaviour_defense_type.IDbehaviour_defense_type",
		"STA_behaviour_defense_type.gene_strID_name",
		szTxt,150,fPosY+25);
	pdtData.gcDefense = GetLastField(pform);

	// Condition type
	pform<<FormSetWidth(320);
	szTxt = GetLocalizedFromKey(iszCondition);
	pform<<FormSetDataSource(DATABASE_CLIENT);
	pform<<FormShowGroupOptionField("DYN_strategic_zone.fkIDbehaviour_defense.DYN_behaviour_defense.fkIDcondition_type",
		"STA_condition_type.IDcondition_type",
		"STA_condition_type.gene_strID_name",
		szTxt,420,fPosY);
	pdtData.gcConditionType = GetLastField(pform);

	// Condition value
	pform<<FormSetWidth(128);
	pform<<FormShowField("DYN_strategic_zone.fkIDbehaviour_defense.DYN_behaviour_defense.gene_f_condition_value","",
		600,fPosY+25);
	pdtData.gcConditionValue = GetLastField(pform);

	// Condition key
	szTxt = GetLocalizedFromKey(iszCaracteristiques);
	pform<<FormSetDataSource(DATABASE_CLIENT);
	pform<<FormShowListBoxField("DYN_strategic_zone.fkIDbehaviour_defense.DYN_behaviour_defense.fkIDcondition_key",
		"STA_characteristic_cyclist_type.IDcharacteristic_cyclist_type",
		"STA_characteristic_cyclist_type.gene_strID_name",
		szTxt,450,fPosY+25);
	pdtData.gcConditionCharac = GetLastField(pform);

	szTxt = GetLocalizedFromKey(iszCycliste);
	pform<<FormSetDataSource(_iRosterSubset);
	pform<<FormShowListBoxField("DYN_strategic_zone.fkIDbehaviour_defense.DYN_behaviour_defense.fkIDcondition_key",
		"DYN_cyclist.IDcyclist",
		"DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",
		szTxt,450,fPosY+25);
	pdtData.gcConditionCyclist = GetLastField(pform);

	szTxt = GetLocalizedFromKey(iszClassement);
	pform<<FormRestoreDataSource();
	pform<<FormShowListBoxField("DYN_strategic_zone.fkIDbehaviour_defense.DYN_behaviour_defense.fkIDcondition_key",
		"STA_classification.IDclassification",
		"STA_classification.gene_strID_classification_name",
		szTxt,450,fPosY+25);
	pdtData.gcConditionClass = GetLastField(pform);

	// Leader cyclist
	szTxt = GetLocalizedFromKey(iszLeader);
	pform<<FormShowListBoxField("DYN_strategic_zone.fkIDcyclist_ref",
		"DYN_cyclist.IDcyclist",
		"DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",
		szTxt,200,fPosY-40);

	AddInterface(pform,Gui_iForm_Zone,pdtData);

	return pform;
}

func void ZoneForm_OnNewRecord(i32x _iSubsetId,i32x _iRecord)
{
		var i32x id;
		var i32x iNewDefRow,iNewDefKey;
		var Gui_Component pthis;
		var Gui_dtForm_Zone pdtData;
		
		// get this pointer
		pthis = GetThis();
		
		// Get Data pointer
		pdtData = GetData(pthis);
		
		if(pdtData.iStrategyId)
		{
			// Get zone id
			id = Database_GetIntData(_iSubsetId, "DYN_strategic_zone.IDstrategic_zone", ROW_INDEX, _iRecord);
			
			// Create row in linked table
			// DYN_behaviour_defense
			iNewDefRow = Table_AddRow(_iSubsetId,Table_GetIndexFromName(_iSubsetId,"DYN_behaviour_defense"));
			iNewDefKey = Database_GetIntData(_iSubsetId, "DYN_behaviour_defense.IDbehaviour_defense", ROW_INDEX, iNewDefRow);
			// Init new behaviour
			Database_SetIntData(_iSubsetId, "DYN_behaviour_defense.fkIDbehaviour_defense_type", ROW_INDEX, iNewDefRow, 3); // none
			Database_SetIntData(_iSubsetId, "DYN_behaviour_defense.fkIDcondition_type", ROW_INDEX, iNewDefRow, 2); // charac
			Database_SetIntData(_iSubsetId, "DYN_behaviour_defense.fkIDcondition_key", ROW_INDEX, iNewDefRow, 1); // rating
			Database_SetFloatData(_iSubsetId, "DYN_behaviour_defense.gene_f_condition_value", ROW_INDEX, iNewDefRow, 50.0); // rating
			
			// Set default value
			Database_SetIntData(_iSubsetId, "DYN_strategic_zone.fkIDstrategy", ROW_INDEX, _iRecord, pdtData.iStrategyId); // Current strategy
			Database_SetIntData(_iSubsetId, "DYN_strategic_zone.fkIDstrategic_zone_type", ROW_INDEX, _iRecord, 1); // Zone type
			Database_SetIntData(_iSubsetId, "DYN_strategic_zone.fkIDbehaviour_offense", ROW_INDEX, _iRecord, 3);		// None
			Database_SetIntData(_iSubsetId, "DYN_strategic_zone.fkIDbehaviour_defense", ROW_INDEX, _iRecord, iNewDefKey); // Created behaviour
			Database_SetFloatData(_iSubsetId, "DYN_strategic_zone.gene_f_distance", ROW_INDEX, _iRecord, 0.0);		// none
		}
}

func void ZoneForm_OnMaJInt(Gui_Component _poField,i32x _iValue,i32x _bChanged)
{
	var Gui_Component pthis;
	var Gui_dtForm_Zone pdtData;
	var f32x fSprintDistance;
	var szx szValue;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_poField == pdtData.gcZoneType)
	{
		if(_iValue == 1)
		{
			// Zone mode
			pdtData.gcSprint<<Hide();
			pdtData.gcCompete<<Hide();
			pdtData.gcDistance<<Enable();
			pdtData.gcOffense<<Show();
			pdtData.gcDefense<<Show();
			pdtData.gcGauge<<Enable();
			pdtData.bSprintMode = false;
		}
		else if(_iValue == 2)
		{
			// Sprint mode
			pdtData.gcSprint<<Show();
			pdtData.gcCompete<<Show();
			pdtData.gcDistance<<Disable();
			pdtData.gcOffense<<Hide();
			pdtData.gcDefense<<Hide();
			pdtData.gcGauge<<Disable();
			pdtData.bSprintMode = true;
		}
	}
	else if(_poField == pdtData.gcDefense)
	{
		if(_iValue == 3) // none
		{
			pdtData.bDisplayCondition = false;
		}
		else
		{
			pdtData.bDisplayCondition = true;
		}
	}
	else if(_poField == pdtData.gcSprint)
	{
		// Get sprint distance an update gauge
		fSprintDistance = Join_GetFloatFromKey(g_oMenuJoins.m_iSprint_fPosition,_iValue);
		// Update edit box
		szValue = ftoa(fSprintDistance);
		pdtData.gcDistance<<Caption(szValue);
		// Update gauge
		pdtData.gcGauge<<GaugeValue(fSprintDistance);
	}
	else if(_poField == pdtData.gcConditionType)
	{
		pdtData.iConditionType = _iValue;
	}
	if(pdtData.bDisplayCondition && (!pdtData.bSprintMode))
	{
		pdtData.gcConditionType<<Show();
		if(pdtData.iConditionType == 1) // Classement
		{
			pdtData.gcConditionCyclist<<Hide();
			pdtData.gcConditionCharac<<Hide();
			pdtData.gcConditionClass<<Show();
			pdtData.gcConditionValue<<Show();
		}
		else if(pdtData.iConditionType == 2) // charac
		{
			pdtData.gcConditionCyclist<<Hide();
			pdtData.gcConditionCharac<<Show();
			pdtData.gcConditionClass<<Hide();
			pdtData.gcConditionValue<<Show();
		}
		else if(pdtData.iConditionType == 3) // cyclist
		{
			pdtData.gcConditionCyclist<<Show();
			pdtData.gcConditionCharac<<Hide();
			pdtData.gcConditionClass<<Hide();
			pdtData.gcConditionValue<<Hide();
		}
	}
	else
	{
		pdtData.gcConditionType<<Hide();
		pdtData.gcConditionCyclist<<Hide();
		pdtData.gcConditionCharac<<Hide();
		pdtData.gcConditionClass<<Hide();
		pdtData.gcConditionValue<<Hide();
	}
}

func void ZoneForm_OnMaJFloat(Gui_Component _poField,f32x _fValue,i32x _bChanged)
{
	var Gui_Component pthis;
	var Gui_dtForm_Zone pdtData;
	var szx szValue;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_poField == pdtData.gcGauge)
	{
		// Update edit box
		szValue = ftoa(_fValue);
		pdtData.gcDistance<<Caption(szValue);
	}
	else if(_poField == pdtData.gcDistance)
	{
		// Update gauge
		pdtData.gcGauge<<GaugeValue(_fValue);
	}
}

func Gui_Component NewZoneListForm(i32x _iSubsetId,i32x _iRosterSubsetID)
{
	var Gui_Component pform;
	var Gui_dtForm_ZoneList pdtData;

	pdtData = new Gui_dtForm_ZoneList;

	// member init
	pdtData.iRosterSubsetId = _iRosterSubsetID;

	// New zone list form
	pform = NewListForm(_iSubsetId,"DYN_strategic_zone",false);
	pform<<FormSetOffset(4);

	AddInterface(pform,Gui_iForm_ZoneList,pdtData);

	return pform;
}
func void ZoneList_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var Gui_Component pthis;
	var Gui_dtForm_ZoneList pdtData;
	var Gui_dtForm_ZoneInList pdtInListData;
	var i32x i,iPosX;
	var szx szTxt;

	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtInListData = new Gui_dtForm_ZoneInList;

	_pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	_pform<<FormSetOffset(10);
	_pform<<FormSetWidth(64);
	_pform<<FormSetFont(smImpact,smImpact);
	_pform<<FormSetLocked(true);

	// Zone type
	_pform<<FormSetMaJInform(true);
	_pform<<FormShowField("DYN_strategic_zone.fkIDstrategic_zone_type","",0,0);
	pdtInListData.gcZoneType = GetLastField(_pform);
	pdtInListData.gcZoneType<<Hide();
	_pform<<FormSetMaJInform(false);
	
	// Distance field
	_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	if(_iIndex==0)
	{
		_pform<<FormSetTitle(true,false);
		szTxt = GetLocalizedFromKey(iszDistance);
	}
	else
		szTxt = "";
	_pform<<FormShowField("DYN_strategic_zone.gene_f_distance",szTxt,0,0);
	_pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	_pform<<FormSetTitle(false,false);
	// Compete sprint checkbox
	szTxt = GetLocalizedFromKey(iszCompete);
	_pform<<FormShowCheckboxField("DYN_strategic_zone.gene_b_compete",szTxt,200,20);
	pdtInListData.gcCompete = GetLastField(_pform);
	// Sprint list
	szTxt = GetLocalizedFromKey(iszSprint);
	_pform<<FormShowField("DYN_strategic_zone.fkIDsprint.STA_sprint.gene_sz_name",szTxt,200,0);
	pdtInListData.gcSprint = GetLastField(_pform);

	// Attack behaviour
	szTxt = GetLocalizedFromKey(iszComportement_offensif);
	_pform<<FormShowField("DYN_strategic_zone.fkIDbehaviour_offense.STA_behaviour_offense.gene_strID_name",szTxt,200,0);
	pdtInListData.gcOffense = GetLastField(_pform);

	// Defense behaviour
	_pform<<FormSetMaJInform(true);
	szTxt = GetLocalizedFromKey(iszComportement_defensif);
	_pform<<FormShowField("DYN_strategic_zone.fkIDbehaviour_defense.DYN_behaviour_defense.fkIDbehaviour_defense_type.STA_behaviour_defense_type.gene_strID_name",szTxt,200,20);
	pdtInListData.gcDefense = GetLastField(_pform);
	_pform<<FormSetMaJInform(false);

	// Leader cyclist
	szTxt = GetLocalizedFromKey(iszLeader);
	_pform<<FormShowField("DYN_strategic_zone.fkIDcyclist_ref.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_firstname",szTxt,300,0);
	_pform<<FormShowField("DYN_strategic_zone.fkIDcyclist_ref.DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname","",300,20);
	//_pform<<FormShowBitmapField("DYN_strategic_zone.fkIDcyclist_ref.DYN_characteristic.civic_TGAID_photo","",400,0);

	// Condition type
	_pform<<FormSetMaJInform(true);
	_pform<<FormShowField("DYN_strategic_zone.fkIDbehaviour_defense.DYN_behaviour_defense.fkIDcondition_type","",0,0);
	pdtInListData.gcConditionType = GetLastField(_pform);
	pdtInListData.gcConditionType<<Hide();
	_pform<<FormSetMaJInform(false);

	// Condition key
	szTxt = GetLocalizedFromKey(iszCaracteristiques);
	_pform<<FormSetDataSource(DATABASE_CLIENT);
	_pform<<FormShowListBoxField("DYN_strategic_zone.fkIDbehaviour_defense.DYN_behaviour_defense.fkIDcondition_key",
		"STA_characteristic_cyclist_type.IDcharacteristic_cyclist_type",
		"STA_characteristic_cyclist_type.gene_strID_name",
		szTxt,540,0);
	pdtInListData.gcConditionCharac = GetLastField(_pform);

	szTxt = GetLocalizedFromKey(iszCycliste);
	_pform<<FormSetDataSource(pdtData.iRosterSubsetId);
	_pform<<FormShowListBoxField("DYN_strategic_zone.fkIDbehaviour_defense.DYN_behaviour_defense.fkIDcondition_key",
		"DYN_cyclist.IDcyclist",
		"DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",
		szTxt,540,0);
	pdtInListData.gcConditionCyclist = GetLastField(_pform);

	szTxt = GetLocalizedFromKey(iszClassement);
	_pform<<FormRestoreDataSource();
	_pform<<FormShowListBoxField("DYN_strategic_zone.fkIDbehaviour_defense.DYN_behaviour_defense.fkIDcondition_key",
		"STA_classification.IDclassification",
		"STA_classification.gene_strID_classification_name",
		szTxt,540,0);
	pdtInListData.gcConditionClass = GetLastField(_pform);

	// Condition value
	_pform<<FormSetWidth(64);
	_pform<<FormShowField("DYN_strategic_zone.fkIDbehaviour_defense.DYN_behaviour_defense.gene_f_condition_value","",540,30);
	pdtInListData.gcConditionValue = GetLastField(_pform);

	// Add interface
	AddInterface(_pform,Gui_iForm_ZoneInList,pdtInListData);
}

func void ZoneInList_OnMaJInt(Gui_Component _poField,i32x _iValue,i32x _bChanged)
{
	var Gui_Component pthis;
	var Gui_dtForm_ZoneInList pdtData;
	var f32x fSprintDistance;
	var szx szValue;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_poField == pdtData.gcZoneType)
	{
		if(_iValue == 1)
		{
			// Zone mode
			pdtData.gcSprint<<Hide();
			pdtData.gcCompete<<Hide();
			pdtData.gcOffense<<Show();
			pdtData.gcDefense<<Show();
			pdtData.bSprintMode = false;
		}
		else if(_iValue == 2)
		{
			// Sprint mode
			pdtData.gcSprint<<Show();
			pdtData.gcCompete<<Show();
			pdtData.gcOffense<<Hide();
			pdtData.gcDefense<<Hide();
			pdtData.bSprintMode = true;
		}
	}
	else if(_poField == pdtData.gcDefense)
	{
		if(_iValue == 3) // none
		{
			pdtData.bDisplayCondition = false;
		}
		else
		{
			pdtData.bDisplayCondition = true;
		}
	}
	else if(_poField == pdtData.gcConditionType)
	{
		pdtData.iConditionType = _iValue;
	}
	if(pdtData.bDisplayCondition && (!pdtData.bSprintMode))
	{
		if(pdtData.iConditionType == 1) // Classement
		{
			pdtData.gcConditionCyclist<<Hide();
			pdtData.gcConditionCharac<<Hide();
			pdtData.gcConditionClass<<Show();
			pdtData.gcConditionValue<<Show();
		}
		else if(pdtData.iConditionType == 2) // charac
		{
			pdtData.gcConditionCyclist<<Hide();
			pdtData.gcConditionCharac<<Show();
			pdtData.gcConditionClass<<Hide();
			pdtData.gcConditionValue<<Show();
		}
		else if(pdtData.iConditionType == 3) // cyclist
		{
			pdtData.gcConditionCyclist<<Show();
			pdtData.gcConditionCharac<<Hide();
			pdtData.gcConditionClass<<Hide();
			pdtData.gcConditionValue<<Hide();
		}
	}
	else
	{
		pdtData.gcConditionCyclist<<Hide();
		pdtData.gcConditionCharac<<Hide();
		pdtData.gcConditionClass<<Hide();
		pdtData.gcConditionValue<<Hide();
	}
}

func i32x PSZF_RefreshZone(i32x _iZoneID)
{
	var Gui_Component pthis;
	var Gui_dtForm_Zone pdtData;
	
	println("PSZF_RefreshZone");

	pthis=GetThis();
	pdtData=GetData(pthis);
	pthis<<FormFilterByIntEqual("DYN_strategic_zone.IDstrategic_zone",_iZoneID);
	return 1;
}

func i32x PSZF_SelectStrategy(i32x _iStrategyID)
{
	var Gui_Component pthis;
	var Gui_dtForm_Zone pdtData;
	
	println("PSZF_SelectStrategy");

	pthis=GetThis();
	pdtData=GetData(pthis);
	pdtData.iStrategyId=_iStrategyID;
	pthis<<FormFilterByIntEqual("DYN_strategic_zone.fkIDstrategy",pdtData.iStrategyId);
	return 1;
}


func i32x PSZLF_RefreshZoneList()
{
	var Gui_Component pthis;
	var Gui_dtForm_ZoneList pdtData;
	
	println("PSZLF_RefreshZoneList");

	pthis=GetThis();
	pdtData=GetData(pthis);
	pthis<<FormFilterByIntEqual("DYN_strategic_zone.fkIDstrategy",pdtData.iStrategyId);
	return 1;
}

func i32x PSZLF_SelectStrategy(i32x _iStrategyID)
{
	var Gui_Component pthis;
	var Gui_dtForm_ZoneList pdtData;
	
	println("PSZLF_SelectStrategy");

	pthis=GetThis();
	pdtData=GetData(pthis);
	pdtData.iStrategyId=_iStrategyID;
	PSZLF_RefreshZoneList();
	return 1;
}






func i32x PSW_RadioCheck(Gui_Component _pSender,i32x _iValue)
{
	var Gui_Component pthis;
	var Gui_dtPage_PreRaceStrategy pdtData;
	pthis =GetThis();
	pdtData = GetData(pthis);

	if(_pSender==pdtData.gcGroupOption)
	{
		println("mSelectStrategy");
		println(itoa(_iValue));

		pdtData.gcZoneEditorForm<<SaveRecord();
		pdtData.gcZoneEditorForm<<mSelectStrategy(_iValue);
		pdtData.gcZoneListForm<<mSelectStrategy(_iValue);
		pdtData.gcRoster<<mSelectStrategy(_iValue);
	}
}

func i32x PSZLF_FormGainFocus(Gui_Component _poForm,i32x _iKey)
{
	var Gui_Component pthis,pparent;
	var Gui_dtForm_ZoneList pdtData;
	
	println("PSZLF_FormGainFocus");

	pthis=GetThis();
	pparent=GetParent(pthis);
	
	pparent<<mPSZLFFormGainFocus(_iKey);

	return 1;
}

func i32x PSW_mPSZLFFormGainFocus(i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtPage_PreRaceStrategy pdtData;
	pthis =GetThis();
	pdtData = GetData(pthis);

	println("PSW_mPSZLFFormGainFocus");
	pdtData.gcZoneEditorForm<<SaveRecord();
	pdtData.gcZoneEditorForm<<mRefreshZone(_iKey);
}
