func Gui_Component NewGroupProfile2D(i32x _iStageId,i32x _iSizeX,i32x _iSizeY)
{
	var Gui_Component pthis;
	var Gui_dt_GroupProfile2D pdtData;

	//println("NewGroupProfile2D");

	// get this pointer
	pthis = NewObject(Gui_i_GroupProfile2D);	

	// Set Data pointer
	pdtData = new Gui_dt_GroupProfile2D;
	SetData(pthis,pdtData);

	//Background
	pdtData.gcBack = NewBitmap(smFondProfil,0);
	SetAlign(pdtData.gcBack,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcBack,_iSizeX,_iSizeY);
	MountComponent(pthis,pdtData.gcBack);
	MoveTo(pdtData.gcBack,0,0);

	//Profile
	pdtData.gcProfile2D=NewProfile2D(g_iZoneTypeGroup,_iStageId,_iSizeX,_iSizeY,0,smWhite,smWhite,0,0);
	MountComponent(pthis,pdtData.gcProfile2D);
	MoveTo(pdtData.gcProfile2D,0,0);

	//Groups
	pdtData.gcGroups=NewProfile2D(g_iZoneTypeGroup,0,_iSizeX,_iSizeY,180,smGroupArrow,smTrebuchet,2,7);
	MountComponent(pthis,pdtData.gcGroups);
	MoveTo(pdtData.gcGroups,0,0);

	//Sprints
	AddSprintProfile(pthis,_iStageId,_iSizeX,_iSizeY);

	StretchTo(pthis,_iSizeX,_iSizeY);
	
	pdtData.iNumGroup=0;
	pdtData.iNumGroupInitialized=0;
	pdtData.iActiveGroup=-1;

	println("NewGroupProfile2D OK");
	
	//CatchEvent(pthis,e_GUI_Event_Mouse_Move);

	return pthis;
}

func i32x GroupProfile2D_Destroy()
{
	println("GroupProfile2D_Destroy OK");
	return 0;
}


func i32x GroupProfile2D_Reset()
{
	var Gui_Component pthis,pcomponent;
	var Gui_dt_GroupProfile2D pdtData;
	var Gui_dt_Profile2D pdtProfileData;
	var i32x i;

	//println("GroupProfile2D_Reset");

	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtData.iNumGroup=0;
	pdtData.iNumGroupInitialized=0;
	pdtData.iActiveGroup=-1;
	
	//Hide all Groups
	pdtProfileData=GetData(pdtData.gcGroups);
	pdtProfileData.iNumZoneUsed=0;

	i=0;
	while(i<pdtProfileData.iNumZoneAllocated)
	{
		pcomponent=GetComponent(pdtData.gcGroups,pdtProfileData.iFirstZoneIndex+i);
		pcomponent<<mProfileZoneSetArea(0);
		pcomponent<<Hide();
		i=i+1;
	}

	return 1;
}



func i32x GroupProfile2D_SetNumGroup(i32x _iNumGroup)
{
	var Gui_Component pthis;
	var Gui_dt_GroupProfile2D pdtData;

	//println("GroupProfile2D_SetNumGroup:"+itoa(_iNumGroup));
	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtData.iNumGroup=_iNumGroup;
	pdtData.iNumGroupInitialized=0;
	
	return 1;
}

func i32x GroupProfile2D_SetGroup(i32x _iGroupIndex,f32x _fSplinePercentageDone,szx _szName)
{
	var Gui_Component pthis,pcomponent;
	var Gui_dt_GroupProfile2D pdtData;
	var Gui_dt_Profile2D pdtProfileData;
	var i32x iPosX,iPosY;
	
	pthis = GetThis();
	pdtData = GetData(pthis);
	
	pdtProfileData=GetData(pdtData.gcGroups);
		if((_iGroupIndex>=0)&&(_iGroupIndex!=g_InRaceClient_DEF_InvalidGroup)&&(_iGroupIndex<pdtData.iNumGroup)&&(_iGroupIndex==pdtData.iNumGroupInitialized))
	{
		if(pdtProfileData.iNumZoneUsed<pdtProfileData.iNumZoneAllocated)
		{
			pcomponent=GetComponent(pdtData.gcGroups,pdtProfileData.iFirstZoneIndex+pdtProfileData.iNumZoneUsed);

			iPosX=0.01*_fSplinePercentageDone*pdtProfileData.iSizeX-8;
			iPosY=(1.0-((GetAltitudeFromSplinePercentageDone(_fSplinePercentageDone)+200.0)/2800.0))*pdtProfileData.iSizeY-32;
			//mao debug fucking montgolfiere in demo
			if(isDemo())
				pcomponent<<mProfileZonePosition2(iPosX,iPosY+18,16,32);
			else
				pcomponent<<mProfileZonePosition2(iPosX,iPosY,16,32);

			pcomponent<<mProfileZoneSetText(_szName);
			pcomponent<<Show();
			//println("GroupProfile2D_SetGroup"+itoa(_iGroupIndex)+" "+ftoa(_fSplinePercentageDone)+" "+_szName);
			pdtProfileData.iNumZoneUsed=pdtProfileData.iNumZoneUsed+1;
		}
		pdtData.iNumGroupInitialized=pdtData.iNumGroupInitialized+1;
	}
	return 1;
}

func i32x GroupProfile2D_ClickZone(i32x _iZoneType,i32x _iZoneIndex)
{
	var Gui_Component pthis,pparent;
	
	//println("GroupProfile2D_ClickZone"+itoa(_iZoneType)+itoa(_iZoneIndex));

	pthis=GetThis();
	pparent=GetParent(pthis);
	if(_iZoneType==g_iZoneTypeGroup)
		pparent<<mSelectGroup(_iZoneIndex);
	else if(_iZoneType==g_iZoneTypeSprint)
		pparent<<mSelectSprint(_iZoneIndex);
	return 1;
}

func i32x GroupProfile2D_mSelectGroup(i32x _iGroupIndex)
{
	var Gui_Component pthis,pcomponent;
	var Gui_dt_GroupProfile2D pdtData;
	var Gui_dt_Profile2D pdtProfileData;
	pthis = GetThis();
	pdtData = GetData(pthis);
	pdtProfileData=GetData(pdtData.gcGroups);
	
	if(pdtData.iNumGroupInitialized==pdtData.iNumGroup)
	{
		if(_iGroupIndex!=g_InRaceClient_DEF_InvalidGroup&&_iGroupIndex<pdtData.iNumGroupInitialized)
		{
			if(pdtData.iActiveGroup!=-1&&pdtData.iActiveGroup<pdtData.iNumGroupInitialized)
			{
				pcomponent=GetComponent(pdtData.gcGroups,pdtProfileData.iFirstZoneIndex+pdtData.iActiveGroup);
				pcomponent<<mProfileZoneSetArea(0);
			}
			pcomponent=GetComponent(pdtData.gcGroups,pdtProfileData.iFirstZoneIndex+_iGroupIndex);
			pcomponent<<mProfileZoneSetArea(1);
			pdtData.iActiveGroup=_iGroupIndex;
		}
	}
	else
	{
		println("Error on GroupProfile2D_mSelectGroup:You forgot to initialize a group");
	}
}
