func Gui_Component NewStrategyProfile2D(i32x _iStageId,i32x _iSizeX,i32x _iSizeY)
{
	var Gui_Component pthis;
	var Gui_dt_StrategyProfile2D pdtData;

	//println("NewStrategyProfile2D");

	// get this pointer
	pthis = NewObject(Gui_i_StrategyProfile2D);	

	// Set Data pointer
	pdtData = new Gui_dt_StrategyProfile2D;
	SetData(pthis,pdtData);

	pdtData.gcProfile2D=NewProfile2D(g_iZoneTypeStrategy,_iStageId,_iSizeX,_iSizeY,128,smWhite,smTrebuchet,0,0);
	MountComponent(pthis,pdtData.gcProfile2D);
	MoveTo(pdtData.gcProfile2D,0,0);
	StretchTo(pthis,_iSizeX,_iSizeY);
	
	pdtData.iNumZone=0;
	pdtData.iNumZoneInitialized=0;
	
	//println("NewStrategyProfile2D OK");
	
	return pthis;
}

func i32x StrategyProfile2D_Destroy()
{
	println("StrategyProfile2D_Destroy OK");
	return 0;
}


func i32x StrategyProfile2D_Reset()
{
	var Gui_Component pthis,pcomponent;
	var Gui_dt_StrategyProfile2D pdtData;
	var Gui_dt_Profile2D pdtProfileData;
	var i32x i;

	//println("StrategyProfile2D_Reset");

	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtData.iNumZone=0;
	pdtData.iNumZoneInitialized=0;
	
	//Hide all zones
	pdtProfileData=GetData(pdtData.gcProfile2D);
	pdtProfileData.iNumZoneUsed=0;

	i=0;
	while(i<pdtProfileData.iNumZoneAllocated)
	{
		pcomponent=GetComponent(pdtData.gcProfile2D,pdtProfileData.iFirstZoneIndex+i);
		pcomponent<<Hide();
		i=i+1;
	}

	return 1;
}



func i32x StrategyProfile2D_SetNumZone(i32x _iNumZone)
{
	var Gui_Component pthis;
	var Gui_dt_StrategyProfile2D pdtData;

	//println("StrategyProfile2D_SetNumZone:"+itoa(_iNumZone));
	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtData.iNumZone=_iNumZone;
	pdtData.iNumZoneInitialized=0;
	
	return 1;
}


func i32x StrategyProfile2D_SetZone(i32x _iZoneIndex,i32x _iOffZoneType,i32x _iDefZoneType,i32x _iSprintType,f32x _fStartRatio,f32x _fEndRatio,i32x _iColor)
{
	var Gui_Component pthis,pcomponent;
	var Gui_dt_StrategyProfile2D pdtData;
	var Gui_dt_Profile2D pdtProfileData;

	//println("StrategyProfile2D_SetZone"+itoa(_iZoneIndex));

	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtProfileData=GetData(pdtData.gcProfile2D);

	if(_iZoneIndex>=0&&_iZoneIndex<pdtData.iNumZone&&_iZoneIndex==pdtData.iNumZoneInitialized)
	{
		//Remark : You must set zone from the forst to last one
		if(_iSprintType==IRS_eZoneType_CurrentPos)
		{
			//Add a current position zone
			if(pdtProfileData.iNumZoneUsed<pdtProfileData.iNumZoneAllocated)
			{
				var f32x fEndX;
				pcomponent=GetComponent(pdtData.gcProfile2D,pdtProfileData.iFirstZoneIndex+pdtProfileData.iNumZoneUsed);
				fEndX=_fStartRatio+(2.0*g_fScreenScaleFactor)/(1.0*pdtProfileData.iSizeX);
				pcomponent<<mProfileZonePosition(_fStartRatio,fEndX,0.0,1.0);
				pcomponent<<mProfileZoneColor(GetStrategyColor(_iSprintType));
				pcomponent<<Show();
				//println("StrategyProfile2D_SetZone Show"+itoa(pdtProfileData.iNumZoneUsed));
				pdtProfileData.iNumZoneUsed=pdtProfileData.iNumZoneUsed+1;
			}
		}
		if(_iSprintType==IRS_eZoneType_Slope)
		{
			//Add a slope zone
			if(pdtProfileData.iNumZoneUsed<pdtProfileData.iNumZoneAllocated)
			{
				pcomponent=GetComponent(pdtData.gcProfile2D,pdtProfileData.iFirstZoneIndex+pdtProfileData.iNumZoneUsed);
				pcomponent<<mProfileZonePosition(_fStartRatio,_fEndRatio,0.95,1.0);
				pcomponent<<mProfileZoneColor(_iColor);
				pcomponent<<Show();
				//println("StrategyProfile2D_SetZone Show"+itoa(pdtProfileData.iNumZoneUsed));
				pdtProfileData.iNumZoneUsed=pdtProfileData.iNumZoneUsed+1;
			}
		}
		else if(_iSprintType==IRS_eZoneType_Sprint)
		{
			//Add a sprint zone
			if(pdtProfileData.iNumZoneUsed<pdtProfileData.iNumZoneAllocated)
			{
				var f32x fEndX;
				pcomponent=GetComponent(pdtData.gcProfile2D,pdtProfileData.iFirstZoneIndex+pdtProfileData.iNumZoneUsed);
				fEndX=_fStartRatio+(2.0*g_fScreenScaleFactor)/(1.0*pdtProfileData.iSizeX);
				pcomponent<<mProfileZonePosition(_fStartRatio,fEndX,0.0,1.0);
				pcomponent<<mProfileZoneColor(GetStrategyColor(_iSprintType));
				pcomponent<<Show();
				//println("StrategyProfile2D_SetZone Show"+itoa(pdtProfileData.iNumZoneUsed));
				pdtProfileData.iNumZoneUsed=pdtProfileData.iNumZoneUsed+1;
			}
		}
		else
		{
			if(_iOffZoneType!=IRS_eZoneType_Null)
			{
				if(pdtProfileData.iNumZoneUsed<pdtProfileData.iNumZoneAllocated)
				{
					pcomponent=GetComponent(pdtData.gcProfile2D,pdtProfileData.iFirstZoneIndex+pdtProfileData.iNumZoneUsed);
					pcomponent<<mProfileZonePosition(_fStartRatio,_fEndRatio,0.85,0.90);
					pcomponent<<mProfileZoneColor(GetStrategyColor(_iOffZoneType));
					pcomponent<<Show();
					//println("StrategyProfile2D_SetZone Show"+itoa(pdtProfileData.iNumZoneUsed));
					pdtProfileData.iNumZoneUsed=pdtProfileData.iNumZoneUsed+1;
				}
			}
			if(_iDefZoneType!=IRS_eZoneType_Null)
			{
				if(pdtProfileData.iNumZoneUsed<pdtProfileData.iNumZoneAllocated)
				{
					pcomponent=GetComponent(pdtData.gcProfile2D,pdtProfileData.iFirstZoneIndex+pdtProfileData.iNumZoneUsed);
					pcomponent<<mProfileZonePosition(_fStartRatio,_fEndRatio,0.90,0.95);
					pcomponent<<mProfileZoneColor(GetStrategyColor(_iDefZoneType));
					pcomponent<<Show();
					//println("StrategyProfile2D_SetZone Show"+itoa(pdtProfileData.iNumZoneUsed));
					pdtProfileData.iNumZoneUsed=pdtProfileData.iNumZoneUsed+1;
				}
			}
			if(_iSprintType==IRS_eZoneType_Null&&_iOffZoneType==IRS_eZoneType_Null&&_iDefZoneType==IRS_eZoneType_Null)
			{
				if(pdtProfileData.iNumZoneUsed<pdtProfileData.iNumZoneAllocated)
				{
					pcomponent=GetComponent(pdtData.gcProfile2D,pdtProfileData.iFirstZoneIndex+pdtProfileData.iNumZoneUsed);
					pcomponent<<mProfileZonePosition(_fStartRatio,_fEndRatio,0.85,0.95);
					pcomponent<<mProfileZoneColor(GetStrategyColor(_iDefZoneType));
					pcomponent<<Show();
					//println("StrategyProfile2D_SetZone Show"+itoa(pdtProfileData.iNumZoneUsed));
					pdtProfileData.iNumZoneUsed=pdtProfileData.iNumZoneUsed+1;
				}
			}
		}
		pdtData.iNumZoneInitialized=pdtData.iNumZoneInitialized+1;
	}
	else
	{
		println("Error on StrategyProfile2D_SetZone : bad parameters.");
	}

	return 1;
}

func i32x StrategyProfile2D_ClickZone(i32x _iZoneType,i32x _iZoneIndex)
{
	return 1;
}