func Gui_Component NewProfileZone(i32x _iZoneType,i32x _iZoneIndex,i32x _iProfileSizeX,i32x _iProfileSizeY,Menu_Material smDefaultMaterial,Menu_Material smDefaultFont,i32x _iTextOffsetX,i32x _iTextOffsetY)
{
	var Gui_Component pthis;
	var Gui_dt_ProfileZone pdtData;

	//println("NewProfileZone");

	// get this pointer
	pthis = NewObject(Gui_i_ProfileZone);	

	// Set Data pointer
	pdtData = new Gui_dt_ProfileZone;
	SetData(pthis,pdtData);

	if(_iZoneType>=0&&_iZoneType<g_iZoneTypeNumber)
	{
		pdtData.iZoneType=_iZoneType;
	}
	else
	{
		println("Error, bad type of zone:"+itoa(_iZoneType));
	}

	pdtData.iZoneIndex=_iZoneIndex;
	pdtData.iProfileSizeX=_iProfileSizeX;
	pdtData.iProfileSizeY=_iProfileSizeY;

	pdtData.gcZone=NewButton(smDefaultMaterial);
	SetAlign(pdtData.gcZone,e_GUI_HAlign_Zoom,e_GUI_HAlign_Zoom);
	MountComponent(pthis,pdtData.gcZone);
	MoveTo(pdtData.gcZone,0,0);
	SetShadingMode(GetSprite(pdtData.gcZone),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	SetBlendingMode(GetSprite(pdtData.gcZone),DLC_Blend_AlphaBlend);
	SetColor(pdtData.gcZone,MakeARGB(255,255,255,255));
		
	pdtData.gcText=NewCaption(smDefaultFont,"");
	SetAlign(pdtData.gcText,e_GUI_HAlign_Left,e_GUI_HAlign_Center);
	MountComponent(pthis,pdtData.gcText);
	MoveTo(pdtData.gcText,_iTextOffsetX,_iTextOffsetY);
	pdtData.gcText<<Disable();
	
	//println("Size of zone: "+itoa(SizeX(pdtData.gcZone))+" "+itoa(SizeY(pdtData.gcZone)));
	StretchTo(pthis,SizeX(pdtData.gcZone),SizeY(pdtData.gcZone));

	AddHelpInterface(pthis,"");

	//CatchEvent(pthis,e_GUI_Event_Mouse_Move);

	return pthis;
}

func i32x ProfileZone_Destroy()
{
	return 1;
}

func i32x ProfileZone_Color(i32x _iColor)
{
	var Gui_dt_ProfileZone pdtData;
	pdtData=GetData(GetThis());

	//println("ProfileZone_Color:"+itoa(_iColor));
	SetColor(pdtData.gcZone,_iColor);
	return 1;
}

//Set position and stretch
func i32x ProfileZone_Position(f32x _fStartX,f32x _fEndX,f32x _fStartY,f32x _fEndY)
{
	//println("ProfileZone_Position");

	if(_fStartX>=0.0&&_fStartX<=1.0&&_fEndX>=0.0&&_fEndX<=1.5&&_fStartY>=0.0&&_fStartY<=1.0&&_fEndY>=0.0&&_fEndY<=1.0
		&&_fEndX>=_fStartX&&_fEndY>=_fStartY)
	{
		var Gui_dt_ProfileZone pdtData;
		var Gui_Component pthis;
		pthis=GetThis();
		pdtData=GetData(pthis);
		MoveTo(pthis,_fStartX*pdtData.iProfileSizeX,_fStartY*pdtData.iProfileSizeY);
		StretchTo(pdtData.gcZone,(_fEndX-_fStartX)*pdtData.iProfileSizeX,(_fEndY-_fStartY)*pdtData.iProfileSizeY);
		StretchTo(pthis,SizeX(pdtData.gcZone),SizeY(pdtData.gcZone));
	}
	else
	{
		println("ProfileZone_Position : Error bad parameters : "+ftoa(_fStartX)+" "+ftoa(_fEndX)+" "+ftoa(_fStartY)+" "+ftoa(_fEndY));
	}
	return 1;
}

//Set position without stretch
func i32x ProfileZone_Position2(i32x _iPosX,i32x _iPosY,i32x _iSizeX,i32x _iSizeY)
{
	//println("ProfileZone_Position2 "+itoa(_iPosX)+" "+itoa(_iPosY));
	var Gui_Component pthis;
	var Gui_dt_ProfileZone pdtData;
	pthis=GetThis();
	pdtData=GetData(pthis);
	MoveTo(pthis,_iPosX,_iPosY);
	StretchTo(pdtData.gcZone,_iSizeX,_iSizeY);
	StretchTo(pthis,_iSizeX,_iSizeY);
	return 1;
}



func i32x ProfileZone_Material(Menu_Material smMaterial)
{
	var Gui_dt_ProfileZone pdtData;
	pdtData=GetData(GetThis());
	SetMaterial(GetSprite(pdtData.gcZone),smMaterial);
	return 1;
}


func i32x ProfileZone_SetText(szx _szText)
{
	var Gui_dt_ProfileZone pdtData;
	pdtData=GetData(GetThis());
	//println("ProfileZone_SetText "+_szText);

	if(strlen(_szText)>=1)
	{
		pdtData.gcText<<Show();
		pdtData.gcText<<Caption(_szText);
	}
	else
		pdtData.gcText<<Hide();

	return 1;
}

func i32x ProfileZone_SetFont(Menu_Material smFont)
{
	var Gui_dt_ProfileZone pdtData;
	pdtData=GetData(GetThis());
	SetMaterial(GetSprite(pdtData.gcText),smFont);
	return 1;
}

func i32x ProfileZone_SetArea(i32x _iArea)
{
	var Gui_dt_ProfileZone pdtData;
	pdtData=GetData(GetThis());
	SetArea(GetSprite(pdtData.gcZone),_iArea);
	return 1;
}


func i32x ProfileZone_SetHelpString(szx _szHelpString)
{
	var Gui_Component pthis;
	var Gui_dt_ProfileZone pdtData;
	pthis=GetThis();
	pdtData=GetData(pthis);
	pthis<<SetHelpString(_szHelpString);
	return 1;
}

func i32x ProfileZone_Click(Gui_Component _pComponent)
{
	var Gui_Component pthis;
	var Gui_dt_ProfileZone pdtData;
	pthis=GetThis();
	pdtData=GetData(pthis);

	//println("ProfileZone_Click");

	if(_pComponent==pdtData.gcZone)
	{
		var Gui_Component pparent;
		pparent=GetParent(pthis);
		pparent<<ClickZone(pdtData.iZoneType,pdtData.iZoneIndex);
	}
	return 1;
}