/*
 *	Function		: Cyclist Panel constructor 
 *	Parameters		: _iCyclistId : Default Cyclist ID
 */
func Gui_Component fn_oNewAIDataWindow(szx _szTitle)
{
	var Gui_Component pthis;
	var Gui_dtAIDataWindow pdtData;
	var i32x iStageId;

	pthis = NewObject(Gui_iAIDataWindow);
	pdtData = new Gui_dtAIDataWindow;
	SetData(pthis,pdtData);

	// Two component in composite button
	SetComponentNumber(pthis,12);

	pdtData.gcBack=NewBitmap(smWhite,0);
	SetShadingMode(GetSprite(pdtData.gcBack),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcBack,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcBack);
	MoveTo(pdtData.gcBack,0,0);
	SetColor(pdtData.gcBack,MakeARGB(255,128,128,128));

	pdtData.gcBar=NewDragger(smDOPanelBarre,20,20);
	SetShadingMode(GetSprite(pdtData.gcBar),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcBar,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcBar);
	MoveTo(pdtData.gcBar,0,0);
	SetColor(pdtData.gcBar,MakeARGB(255,255,255,255));
	SetArea(GetSprite(pdtData.gcBar),1);

	pdtData.gcWinMin=NewButton(smDownButton);
	SetAlign(pdtData.gcWinMin,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcWinMin);
	StretchTo(pdtData.gcWinMin,18,18);
	MoveTo(pdtData.gcWinMin,1,1);

	pdtData.gcWinCaption=NewCaption(smArial,_szTitle);
	SetShadingMode(GetSprite(pdtData.gcWinCaption),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcWinCaption,e_GUI_HAlign_Max,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcWinCaption,104,18);
	MountComponent(pthis,pdtData.gcWinCaption);
	MoveTo(pdtData.gcWinCaption,24,1);
	SetColor(pdtData.gcWinCaption,MakeARGB(255,0,0,0));
	pdtData.gcWinCaption<<Disable();

	pdtData.gcLine=NewBitmap(smWhite,0);
	SetShadingMode(GetSprite(pdtData.gcLine),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcLine,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcLine);
	MoveTo(pdtData.gcLine,0,19);
	SetColor(pdtData.gcLine,MakeARGB(255,0,0,0));


	//Create Deltapos caption,gauge and slider
	pdtData.gcMSDeltaPosCaption = NewCaption(smArial,"DeltaPos:x0.25------x1-------x4");
	MountComponent(pthis,pdtData.gcMSDeltaPosCaption);
	MoveTo(pdtData.gcMSDeltaPosCaption,0,20);
	
	pdtData.gcMSDeltaPosGauge=NewBitmap(smDOPanelEffortGauge,0);
	SetAlign(pdtData.gcMSDeltaPosGauge,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcMSDeltaPosGauge,300,10);
	MountComponent(pthis,pdtData.gcMSDeltaPosGauge);
	MoveTo(pdtData.gcMSDeltaPosGauge,0,40);

	pdtData.gcMSDeltaPosSlider=NewSliderH(smDOPanelEffortSlider,300);
	MountComponent(pthis,pdtData.gcMSDeltaPosSlider);
	MoveTo(pdtData.gcMSDeltaPosSlider,0,40);
	pdtData.gcMSDeltaPosSlider<<SldValue(0.5);


	//Create Deltaspeed caption,gauge and slider
	pdtData.gcMSDeltaSpeedCaption = NewCaption(smArial,"DeltaSpeed:x0.25------1------x4");
	MountComponent(pthis,pdtData.gcMSDeltaSpeedCaption);
	MoveTo(pdtData.gcMSDeltaSpeedCaption,320,20);
	
	pdtData.gcMSDeltaSpeedGauge=NewBitmap(smDOPanelEffortGauge,0);
	SetAlign(pdtData.gcMSDeltaSpeedGauge,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcMSDeltaSpeedGauge,300,10);
	MountComponent(pthis,pdtData.gcMSDeltaSpeedGauge);
	MoveTo(pdtData.gcMSDeltaSpeedGauge,320,40);

	pdtData.gcMSDeltaSpeedSlider=NewSliderH(smDOPanelEffortSlider,300);
	MountComponent(pthis,pdtData.gcMSDeltaSpeedSlider);
	MoveTo(pdtData.gcMSDeltaSpeedSlider,320,40);
	pdtData.gcMSDeltaSpeedSlider<<SldValue(0.5);



	//debug text caption
	pdtData.gcDataCaption = NewCaption(smImpact,"0");
	StretchTo(pdtData.gcDataCaption,672,580);
	SetAlign(pdtData.gcDataCaption,e_GUI_HAlign_Left,e_GUI_VAlign_Top);
	MountComponent(pthis,pdtData.gcDataCaption);
	MoveTo(pdtData.gcDataCaption,0,60);
	pdtData.gcDataCaption<<Disable();
		
	iStageId = Join_GetIntFromIndex(g_oMenuJoins.m_iConfig_iCurrentStageId,0);
	pdtData.gcProfile2D=NewStrategyProfile2D(iStageId,340,100);
	MountComponent(pthis,pdtData.gcProfile2D);
	MoveTo(pdtData.gcProfile2D,0,460);
	//pdtData.gcProfile2D<<Disable();

	pdtData.iMinimized=1;

	pdtData.gcProfile2D<<Hide();
	pdtData.gcDataCaption<<Hide();

	pdtData.gcMSDeltaPosCaption<<Hide();
	pdtData.gcMSDeltaPosGauge<<Hide();
	pdtData.gcMSDeltaPosSlider<<Hide();

	pdtData.gcMSDeltaSpeedCaption<<Hide();
	pdtData.gcMSDeltaSpeedGauge<<Hide();
	pdtData.gcMSDeltaSpeedSlider<<Hide();

	StretchTo(pdtData.gcBar,AIDW_iSizeX(pthis),AIDW_iBarSizeY(pthis));
	StretchTo(pdtData.gcLine,AIDW_iSizeX(pthis),1);
	StretchTo(pthis,AIDW_iSizeX(pthis),AIDW_iSizeY(pthis));
	StretchTo(pdtData.gcBack,AIDW_iSizeX(pthis),AIDW_iSizeY(pthis));

	return pthis;
}

func i32x AIDW_Destroy()
{
	print("Release AIDW\n");
}

func i32x AIDW_iBarSizeX(Gui_Component _pthis)
{
	return 140;
}

func i32x AIDW_iBarSizeY(Gui_Component _pthis)
{
	return 20;
}

func i32x AIDW_iSizeX(Gui_Component _pthis)
{
		var Gui_dtAIDataWindow pdtData;
		pdtData=GetData(_pthis);
		//var i32x iSizeXMax;

		if(pdtData.iMinimized)
		{
			return AIDW_iBarSizeX(_pthis);
		}
		else
		{
			return 672;
			//iSizeXMax=PrecalcTextWidth(GetSprite(pdtData.gcDataCaption),GetText(GetSprite(pdtData.gcDataCaption)));
			//if(iSizeXMax>=AIDW_iBarSizeX(_pthis)) return iSizeXMax;
			//else return AIDW_iBarSizeX(_pthis);
		}
}

func i32x AIDW_iSizeY(Gui_Component _pthis)
{
	var Gui_dtAIDataWindow pdtData;
		pdtData=GetData(_pthis);
		if(pdtData.iMinimized)
		{
			return AIDW_iBarSizeY(_pthis);
		}
		else
		{
			return 740;
			//AIDW_iBarSizeY(_pthis)+PrecalcTextHeight(GetSprite(pdtData.gcDataCaption),GetText(GetSprite(pdtData.gcDataCaption)));
		}
}



func void AIDW_WindowUpdate()
{
	var Gui_Component pthis,pparent;
	var Gui_dtAIDataWindow pdtData;
	pthis =GetThis();
	pdtData = GetData(pthis);

	StretchTo(pdtData.gcBar,AIDW_iSizeX(pthis),AIDW_iBarSizeY(pthis));
	StretchTo(pdtData.gcLine,AIDW_iSizeX(pthis),1);
	StretchTo(pthis,AIDW_iSizeX(pthis),AIDW_iSizeY(pthis));
	StretchTo(pdtData.gcBack,AIDW_iSizeX(pthis),AIDW_iSizeY(pthis));

	//print("AIDW WindowUpdate.\n");

	pparent=GetParent(pthis);
	pparent<<WindowUpdate();
}

func i32x AIDW_Click(Gui_Component _pthis)
{
	var Gui_Component pthis;
	var Gui_dtAIDataWindow pdtData;
	
	pthis =GetThis();
	pdtData = GetData(pthis);

	if(_pthis==pdtData.gcWinMin)
	{
		if(pdtData.iMinimized==0)
		{
			pdtData.iMinimized=1;
			pdtData.gcProfile2D<<Hide();
			pdtData.gcDataCaption<<Hide();
			
			pdtData.gcMSDeltaPosCaption<<Hide();
			pdtData.gcMSDeltaPosGauge<<Hide();
			pdtData.gcMSDeltaPosSlider<<Hide();

			pdtData.gcMSDeltaSpeedCaption<<Hide();
			pdtData.gcMSDeltaSpeedGauge<<Hide();
			pdtData.gcMSDeltaSpeedSlider<<Hide();
		}
		else
		{
			pdtData.iMinimized=0;
			pdtData.gcProfile2D<<Show();
			pdtData.gcDataCaption<<Show();

			pdtData.gcMSDeltaPosCaption<<Show();
			pdtData.gcMSDeltaPosGauge<<Show();
			pdtData.gcMSDeltaPosSlider<<Show();

			pdtData.gcMSDeltaSpeedCaption<<Show();
			pdtData.gcMSDeltaSpeedGauge<<Show();
			pdtData.gcMSDeltaSpeedSlider<<Show();
		}
		AIDW_WindowUpdate();
	}
}


func i32x AIDW_Drag(Gui_Component _pComponent,i32x _iDeltaX,i32x _iDeltaY)
{
	var Gui_Component pthis;
	var Gui_dtAIDataWindow pdtData;
	
	pthis =GetThis();
	pdtData = GetData(pthis);

	if(_pComponent==pdtData.gcBar)
	{
		var Gui_Component pparent; 
		pparent=GetParent(pthis);
		pparent<<Drag(pthis,_iDeltaX,_iDeltaY);
 }
}

func void AIDW_UpdateAIDW()
{
	var Gui_Component pthis;
	var Gui_dtAIDataWindow pdtData;
	var szx szData;
	var i32x i,iCyclistIndex,iNumSprint,iColor,iNumZone,iTypeDef,iTypeOff,iNumSlopeZone;
	var f32x fStart,fEnd;

	// Retrive data
	pthis = GetThis();
	pdtData = GetData(pthis);

	//Get AI string data
	szData=GetActiveCyclistAIState();
	//Set cyclist data
	pdtData.gcDataCaption<<Caption(szData);

	//Update profile
	iCyclistIndex=GetActiveCyclistPreRaceIndex();
	
	if(iCyclistIndex!=-1)
	{
		iNumSprint=GetCyclistStrategyNumSprint(iCyclistIndex);
		iNumZone=GetCyclistStrategyNumZone(iCyclistIndex);
	}
	else
	{
		iNumSprint=0;
		iNumZone=0;
	}
	iNumSlopeZone=GetNumSlopeZone();

	pdtData.gcProfile2D<<mStrategyProfileReset();
	i=iNumSlopeZone+iNumZone+iNumSprint+1;
	pdtData.gcProfile2D<<mStrategyProfileSetNumZone(i);
	
	i=0;
	while(i<iNumSlopeZone)
	{
		fStart=GetSlopeZoneStartRatio(i);
		fEnd=GetSlopeZoneEndRatio(i);
		iColor=GetSlopeZoneColor(i);
		pdtData.gcProfile2D<<mStrategyProfileSetZone(i,IRS_eZoneType_Null,IRS_eZoneType_Null,IRS_eZoneType_Slope,fStart,fEnd,iColor);
		i=i+1;
	}

	i=0;
	while(i<iNumZone)
	{
		fStart=GetCyclistStrategyZoneStartRatio(iCyclistIndex,i);
		fEnd=GetCyclistStrategyZoneEndRatio(iCyclistIndex,i);
		iTypeOff=GetCyclistStrategyZoneOffType(iCyclistIndex,i);
		iTypeDef=GetCyclistStrategyZoneDefType(iCyclistIndex,i);
		pdtData.gcProfile2D<<mStrategyProfileSetZone(i+iNumSlopeZone,iTypeOff,iTypeDef,IRS_eZoneType_Null,fStart,fEnd,0);
		i=i+1;
	}

	i=0;
	while(i<iNumSprint)
	{
		fStart=GetCyclistStrategySprintStartRatio(iCyclistIndex,i);
		pdtData.gcProfile2D<<mStrategyProfileSetZone(i+iNumSlopeZone+iNumZone,IRS_eZoneType_Null,IRS_eZoneType_Null,IRS_eZoneType_Sprint,fStart,0.0,0);
		i=i+1;
	}

	//Current position
	fStart=0.01*GetCyclistSplinePercentageDone(iCyclistIndex);
	pdtData.gcProfile2D<<mStrategyProfileSetZone(iNumSlopeZone+iNumZone+iNumSprint,IRS_eZoneType_Null,IRS_eZoneType_Null,IRS_eZoneType_CurrentPos,fStart,0.0,0);
	
	//AIDW_WindowUpdate();
}

func i32x AIDW_MouseDown(i32x _iX,i32x _iY,i32x _iButton)
{
	return 1;
}

func i32x AIDW_OnSldChange(Gui_Component _pthis,f32x _fValue)
{
	var Gui_Component pthis;
	var Gui_dtAIDataWindow pdtData;
	
	pthis =GetThis();
	pdtData = GetData(pthis);
	
	if(_pthis==pdtData.gcMSDeltaPosSlider)
	{
		if(_fValue>=0.5)
			_fValue=1.0+(_fValue-0.5)*6.0;
		else
			_fValue=0.25+_fValue*1.5;
		g_pMenuServerSocket<<mPhysicDeltaPos(_fValue);
	}
	else if(_pthis==pdtData.gcMSDeltaSpeedSlider)
	{
		if(_fValue>=0.5)
			_fValue=1.0+(_fValue-0.5)*6.0;
		else
			_fValue=0.25+_fValue*1.5;
		g_pMenuServerSocket<<mPhysicDeltaSpeed(_fValue);
	}
}
