/*
 *	Function		: Cyclist Panel constructor 
 *	Parameters		: _iCyclistId : Default Cyclist ID
 */
func Gui_Component fn_oNewDebugDataWindow(szx _szTitle)
{
	var Gui_Component pthis,gcComponent;
	var Gui_dtDebugDataWindow pdtData;
	var i32x i;

	pthis = NewObject(Gui_iDebugDataWindow);
	pdtData = new Gui_dtDebugDataWindow;
	SetData(pthis,pdtData);
	
	print("fn_oNewDebugDataWindow");
	println("_szTitle");

	// Two component in composite button
	SetComponentNumber(pthis,5+3*GetCyclistDebugDataNumber());

	pdtData.gcBack=NewBitmap(smWhite,0);
	SetShadingMode(GetSprite(pdtData.gcBack),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcBack,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcBack);
	MoveTo(pdtData.gcBack,0,0);
	SetColor(pdtData.gcBack,MakeARGB(255,128,128,128));

	pdtData.gcBar=NewDragger(smDOPanelBarre,20,20);
	SetShadingMode(GetSprite(pdtData.gcBar),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcBar,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcBar);
	MoveTo(pdtData.gcBar,0,0);
	SetColor(pdtData.gcBar,MakeARGB(255,255,255,255));
	SetArea(GetSprite(pdtData.gcBar),1);

	pdtData.gcWinMin=NewButton(smDownButton);
	SetAlign(pdtData.gcWinMin,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcWinMin);
	StretchTo(pdtData.gcWinMin,18,18);
	MoveTo(pdtData.gcWinMin,1,1);

	pdtData.gcWinCaption=NewCaption(smArial,_szTitle);
	SetShadingMode(GetSprite(pdtData.gcWinCaption),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcWinCaption,e_GUI_HAlign_Max,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcWinCaption,104,18);
	MountComponent(pthis,pdtData.gcWinCaption);
	MoveTo(pdtData.gcWinCaption,24,1);
	SetColor(pdtData.gcWinCaption,MakeARGB(255,0,0,0));
	pdtData.gcWinCaption<<Disable();

	pdtData.gcLine=NewBitmap(smWhite,0);
	SetShadingMode(GetSprite(pdtData.gcLine),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcLine,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcLine);
	MoveTo(pdtData.gcLine,0,19);
	SetColor(pdtData.gcLine,MakeARGB(255,0,0,0));

	pdtData.iNumDataBar=GetCyclistDebugDataNumber();
	pdtData.iFirstDataBarIndex=5;
	i=0;
	while(i<pdtData.iNumDataBar)
	{
		gcComponent=fn_oNewDebugDataBar(GetCyclistDebugDataName(i),GetCyclistDebugDataMin(i),GetCyclistDebugDataMax(i));
		MountComponent(pthis,gcComponent);
		i=i+1;
	}

	pdtData.iFirstDataBarCheckboxIndex=pdtData.iFirstDataBarIndex+pdtData.iNumDataBar;
	i=0;
	while(i<pdtData.iNumDataBar)
	{
		gcComponent=NewCheckbox(smIcon);
		MountComponent(pthis,gcComponent);
		SetAlign(gcComponent,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
		StretchTo(gcComponent,20,10);
		MoveTo(gcComponent,20*i,20);
		gcComponent<<QuietCheck();
		i=i+1;
	}

	pdtData.iFirstDataBarCaptionIndex=pdtData.iFirstDataBarCheckboxIndex+pdtData.iNumDataBar;
	i=0;
	while(i<pdtData.iNumDataBar)
	{
		gcComponent=NewCaption(smArial,GetCyclistDebugDataName(i));
		MountComponent(pthis,gcComponent);
		SetShadingMode(GetSprite(gcComponent),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
		SetColor(gcComponent,MakeARGB(255,255,128,128));
		SetAlign(gcComponent,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
		StretchTo(gcComponent,20,10);
		MoveTo(gcComponent,20*i,20);
		i=i+1;
	}
	
	pdtData.iMinimized=1;
	
	i=0;
	while(i<pdtData.iNumDataBar)
	{
		gcComponent=GetComponent(pthis,pdtData.iFirstDataBarIndex+i);
		gcComponent<<Hide();
		gcComponent=GetComponent(pthis,pdtData.iFirstDataBarCheckboxIndex+i);
		gcComponent<<Hide();
		gcComponent=GetComponent(pthis,	pdtData.iFirstDataBarCaptionIndex+i);
		gcComponent<<Hide();
		i=i+1;
	}

	
	DDW_UpdatePositions(pthis);
	StretchTo(pdtData.gcBar,DDW_iSizeX(pthis),DDW_iBarSizeY(pthis));
	StretchTo(pdtData.gcLine,DDW_iSizeX(pthis),1);
	StretchTo(pthis,DDW_iSizeX(pthis),DDW_iSizeY(pthis));
	StretchTo(pdtData.gcBack,DDW_iSizeX(pthis),DDW_iSizeY(pthis));

	return pthis;
}

func i32x DDW_Destroy()
{
	println("DDW_Destroy OK");
}

func i32x DDW_iBarSizeX(Gui_Component _pthis)
{
	return 140;
}

func i32x DDW_iBarSizeY(Gui_Component _pthis)
{
	return 20;
}

func i32x DDW_iSizeX(Gui_Component _pthis)
{
		var Gui_dtDebugDataWindow pdtData;
		pdtData=GetData(_pthis);
		//var i32x iSizeXMax;

		if(pdtData.iMinimized)
			return DDW_iBarSizeX(_pthis);
		else
			return 660;
}

func i32x DDW_iSizeY(Gui_Component _pthis)
{
	var Gui_dtDebugDataWindow pdtData;
	pdtData=GetData(_pthis);
	if((pdtData.iMinimized)||(!pdtData.iNumDataBar))
	{
		return DDW_iBarSizeY(_pthis);
	}
	else
	{
		return 20+DDB_iSizeY(GetComponent(_pthis,pdtData.iFirstDataBarIndex));
	}
}

func i32x DDW_UpdatePositions(Gui_Component _pthis)
{
	var Gui_dtDebugDataWindow pdtData;
	var i32x i=0,iPosX=0;

	pdtData=GetData(_pthis);
	while(i<pdtData.iNumDataBar)
	{
		MoveTo(GetComponent(_pthis,pdtData.iFirstDataBarIndex+i),iPosX,22);
		iPosX=iPosX+5+DDB_iSizeX(GetComponent(_pthis,pdtData.iFirstDataBarIndex));
		i=i+1;
	}
}


func void DDW_WindowUpdate()
{
	var Gui_Component pthis,pparent;
	var Gui_dtDebugDataWindow pdtData;
	pthis =GetThis();
	pdtData = GetData(pthis);

	StretchTo(pdtData.gcBar,DDW_iSizeX(pthis),DDW_iBarSizeY(pthis));
	StretchTo(pdtData.gcLine,DDW_iSizeX(pthis),1);
	StretchTo(pthis,DDW_iSizeX(pthis),DDW_iSizeY(pthis));
	StretchTo(pdtData.gcBack,DDW_iSizeX(pthis),DDW_iSizeY(pthis));

	//print("DDW WindowUpdate.\n");

	pparent=GetParent(pthis);
	pparent<<WindowUpdate();
}

func i32x DDW_Click(Gui_Component _pthis)
{
	var Gui_Component pthis,gcComponent;
	var Gui_dtDebugDataWindow pdtData;
	var i32x i;
	
	pthis =GetThis();
	pdtData = GetData(pthis);

	if(_pthis==pdtData.gcWinMin)
	{
		if(pdtData.iMinimized==0)
		{
			pdtData.iMinimized=1;
			
			i=0;
			while(i<pdtData.iNumDataBar)
			{
				gcComponent=GetComponent(pthis,pdtData.iFirstDataBarIndex+i);
				gcComponent<<Hide();
				gcComponent=GetComponent(pthis,pdtData.iFirstDataBarCheckboxIndex+i);
				gcComponent<<Hide();
				gcComponent=GetComponent(pthis,	pdtData.iFirstDataBarCaptionIndex+i);
				gcComponent<<Hide();
				i=i+1;
			}
		}
		else
		{
			pdtData.iMinimized=0;
			i=0;
			while(i<pdtData.iNumDataBar)
			{
				gcComponent=GetComponent(pthis,pdtData.iFirstDataBarIndex+i);
				gcComponent<<Show();
				gcComponent=GetComponent(pthis,pdtData.iFirstDataBarCheckboxIndex+i);
				gcComponent<<Show();
				gcComponent=GetComponent(pthis,	pdtData.iFirstDataBarCaptionIndex+i);
				gcComponent<<Show();
				i=i+1;
			}
		}
		DDW_WindowUpdate();
	}
}


func i32x DDW_Drag(Gui_Component _pComponent,i32x _iDeltaX,i32x _iDeltaY)
{
	var Gui_Component pthis;
	var Gui_dtDebugDataWindow pdtData;
	
	pthis =GetThis();
	pdtData = GetData(pthis);

	if(_pComponent==pdtData.gcBar)
	{
		var Gui_Component pparent; 
		pparent=GetParent(pthis);
		pparent<<Drag(pthis,_iDeltaX,_iDeltaY);
 }
}

func void DDW_Update(Gui_Component _pSender)
{
	var Gui_Component pthis,gcComponent;
	var Gui_dtDebugDataWindow pdtData;
	var i32x i;

	// Retrive data
	pthis = GetThis();
	pdtData = GetData(pthis);

	i=0;
	while(i<pdtData.iNumDataBar)
	{
		gcComponent=GetComponent(pthis,pdtData.iFirstDataBarIndex+i);
		gcComponent<<mDDB_SetValue(GetCyclistDebugDataValue(i));
		i=i+1;
	}
}
func i32x DDW_MouseDown(i32x _iX,i32x _iY,i32x _iButton)
{
	return 1;
}




