///////////////////////////////////////
//DirectOrderPanelEffortSlider effort component
///////////////////////////////////////
func Gui_Component fn_oNewDirectOrderPanelEffortSlider()
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanelEffortSlider pdtData;
	
	// get this pointer
	pthis = NewObject(Gui_iDirectOrderPanelEffortSlider);

	// Set Data pointer
	pdtData = new Gui_dtDirectOrderPanelEffortSlider;
	SetData(pthis,pdtData);

	SetComponentNumber(pthis,2);
	
	pdtData.gcEffortGauge=NewBitmap(smDOPanelEffortGauge,0);
	SetAlign(pdtData.gcEffortGauge,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcEffortGauge,3.0*g_fScreenScaleFactor,64);
	MountComponent(pthis,pdtData.gcEffortGauge);
	MoveTo(pdtData.gcEffortGauge,7.0*g_fScreenScaleFactor,1);
	SetShadingMode(GetSprite(pdtData.gcEffortGauge),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetColor(pdtData.gcEffortGauge,MakeARGB(255,255,255,255));

	pdtData.gcEffortMaxGauge=NewBitmap(smDOPanelEffortGauge,0);
	SetAlign(pdtData.gcEffortMaxGauge,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcEffortMaxGauge,3.0*g_fScreenScaleFactor,0);
	MountComponent(pthis,pdtData.gcEffortMaxGauge);
	MoveTo(pdtData.gcEffortMaxGauge,7.0*g_fScreenScaleFactor,1);
	SetArea(GetSprite(pdtData.gcEffortMaxGauge),1);
	SetShadingMode(GetSprite(pdtData.gcEffortMaxGauge),DLC_GouraudMode_Decal,DLC_GouraudMode_Decal);
	SetBlendingMode(GetSprite(pdtData.gcEffortMaxGauge),DLC_Blend_AlphaBlend);

	pdtData.gcEffortSlider=NewSliderV(smDOPanelEffortSlider,76);
	MountComponent(pthis,pdtData.gcEffortSlider);
	MoveTo(pdtData.gcEffortSlider,3.0*g_fScreenScaleFactor,-5);
	pdtData.gcEffortSlider<<QuietSldValue(0.4);
	
	pdtData.fEffort=60.0;
	pdtData.fEffortMax=100.0;

	StretchTo(pthis,16.0*g_fScreenScaleFactor,66);

	print("Create Slider OK\n");
	return pthis;
}

func i32x DOPSE_Destroy()
{}


func i32x DOPSE_SldChange(Gui_Component _pthis,f32x _fValue)
{
	var Gui_Component pthis,pDOW;
	var Gui_dtDirectOrderPanelEffortSlider pdtData;
	var Gui_dtDirectOrderPanel pDOPdata;
	
	pthis =GetThis();
	pdtData = GetData(pthis);
	
	if(_pthis==pdtData.gcEffortSlider)
	{
		pDOPdata=GetData(GetParent(pthis));
		pDOW=GetParent(GetParent(pthis));
		pdtData.fEffort=(1.0-_fValue)*100.0;
		if(pdtData.fEffort>=pdtData.fEffortMax)
			pdtData.fEffort=pdtData.fEffortMax;
		pDOW<<mDOW_SelectPanel(pDOPdata.iCyclistIndexInTeam);
		pDOW<<mIndividualOrder(0,IRS_eIndividualOrder,IRS_eIndivOrderTypeEffort,0,pdtData.fEffort);
	}
	return 1;
}


func i32x DOPSE_IndividualOrder(i32x _iCyclistLocalId,i32x _iButton,i32x _iButtonState,i32x _iValue,f32x _fValue)
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanelEffortSlider pdtData;
	
	pthis =GetThis();
	pdtData = GetData(pthis);

	////println("DOPSE_IndividualOrder");

	if(_iButtonState==IRS_eIndivOrderTypeEffort)
	{
		pdtData.fEffort=_fValue;
		_fValue=1.0-(_fValue*0.01);
		pdtData.gcEffortSlider<<QuietSldValue(_fValue);
	}
	else
	{
		println("!!!! Error on DOPSE_IndividualOrder.");
	}
	return 1;
}

func i32x DOPSE_EffortMax(f32x _fEffortMax)
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanelEffortSlider pdtData;
	
	pthis =GetThis();
	pdtData = GetData(pthis);

	pdtData.fEffortMax=_fEffortMax;
	StretchTo(pdtData.gcEffortMaxGauge,3.0*g_fScreenScaleFactor,64.0*(1.0-(0.01*pdtData.fEffortMax)));
}

func i32x DOPSE_Disable()
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanelEffortSlider pdtData;
	
	pthis =GetThis();
	pdtData = GetData(pthis);

	pthis<<Disable();
	SetColor(pdtData.gcEffortGauge,MakeARGB(255,128,128,128));
	
	return 1;
}

func i32x DOPSE_Enable()
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanelEffortSlider pdtData;
	
	pthis =GetThis();
	pdtData = GetData(pthis);

	pthis<<Enable();
	SetColor(pdtData.gcEffortGauge,MakeARGB(255,255,255,255));
	
	return 1;
}
		

func Gui_Component fn_oNewEnergyGauge()
{
	var Gui_Component pthis;
	var Gui_dtEnergyGauge pdtData;
	
	// get this pointer
	pthis = NewObject(Gui_iEnergyGauge);

	// Set Data pointer
	pdtData = new Gui_dtEnergyGauge;
	SetData(pthis,pdtData);

	SetComponentNumber(pthis,2);
	
	pdtData.gcEnergyGauge=NewBitmap(smDOPanelEnergyGauge,0);
	SetAlign(pdtData.gcEnergyGauge,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcEnergyGauge,3.0*g_fScreenScaleFactor,28);
	MountComponent(pthis,pdtData.gcEnergyGauge);
	MoveTo(pdtData.gcEnergyGauge,0,1);

	pdtData.gcEnergyMaxGauge=NewBitmap(smDOPanelEnergyGauge,0);
	SetAlign(pdtData.gcEnergyMaxGauge,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcEnergyMaxGauge,3.0*g_fScreenScaleFactor,0);
	MountComponent(pthis,pdtData.gcEnergyMaxGauge);
	MoveTo(pdtData.gcEnergyMaxGauge,0,1);
	SetArea(GetSprite(pdtData.gcEnergyMaxGauge),1);
	SetShadingMode(GetSprite(pdtData.gcEnergyMaxGauge),DLC_GouraudMode_Decal,DLC_GouraudMode_Decal);
	SetBlendingMode(GetSprite(pdtData.gcEnergyMaxGauge),DLC_Blend_AlphaBlend);

	pdtData.fEnergy=100.0;

	StretchTo(pthis,3.0*g_fScreenScaleFactor,28);
	return pthis;
}

func i32x DOPNRJ_Destroy()
{
	return 1;
}

func i32x DOPNRJ_Energy(f32x _fEnergy)
{
	var Gui_Component pthis;
	var Gui_dtEnergyGauge pdtData;
	
	pthis =GetThis();
	pdtData = GetData(pthis);

	pdtData.fEnergy=_fEnergy;
	StretchTo(pdtData.gcEnergyMaxGauge,3.0*g_fScreenScaleFactor,28.0*(1.0-(0.01*pdtData.fEnergy)));

	return 1;
}



///////////////////////////////////////
//DirectOrderPanelSetting component
///////////////////////////////////////
func Gui_Component fn_oNewDirectOrderPanelSetting()
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanelSetting pdtData;
	var i32x iCyclistID,iPosX,iPosY,iSizeX,iPosX2,iSizeY,iDeltaY;
	var szx szCyclistName;
	
	// get this pointer
	pthis = NewObject(Gui_iDirectOrderPanelSetting);

	// Set Data pointer
	pdtData = new Gui_dtDirectOrderPanelSetting;
	SetData(pthis,pdtData);

	SetComponentNumber(pthis,24);
	
	iSizeX=32;
	iSizeY=14;
	iDeltaY=2;
	iPosX=4.0+(1.0*g_fScreenScaleFactor);
	iPosY=2;

	pdtData.iInterface=IRS_eInterfaceIndividual;

	pdtData.gcAttackButton=NewButton(smDOPIndividualButtons);
	SetAlign(pdtData.gcAttackButton,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcAttackButton,iSizeX,iSizeY);
	MountComponent(pthis,pdtData.gcAttackButton);
	MoveTo(pdtData.gcAttackButton,iPosX,iPosY);
	pdtData.iAttackIndivState=0;
	pdtData.iAttackGroupState=0;
	AddHelpInterface(pdtData.gcAttackButton,GetLocalizedFromKey(iszig_indiv_attack));

	iPosY=iPosY+SizeY(pdtData.gcAttackButton)+iDeltaY;
	
	pdtData.gcSprintButton=NewButton(smDOPIndividualButtons);
	SetAlign(pdtData.gcSprintButton,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcSprintButton,iSizeX,iSizeY);
	MountComponent(pthis,pdtData.gcSprintButton);
	MoveTo(pdtData.gcSprintButton,iPosX,iPosY);
	pdtData.iSprintIndivState=0;
	pdtData.iSprintGroupState=0;
	AddHelpInterface(pdtData.gcSprintButton,GetLocalizedFromKey(iszig_indiv_sprint));
	
	iPosY=iPosY+SizeY(pdtData.gcSprintButton)+iDeltaY;

	pdtData.gcRelayButton=NewButton(smDOPIndividualButtons);
	SetAlign(pdtData.gcRelayButton,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcRelayButton,iSizeX,iSizeY);
	MountComponent(pthis,pdtData.gcRelayButton);
	MoveTo(pdtData.gcRelayButton,iPosX,iPosY);
	pdtData.iRelayIndivState=0;
	pdtData.iRelayGroupState=0;
	AddHelpInterface(pdtData.gcRelayButton,GetLocalizedFromKey(iszig_indiv_relay_no));

	iPosY=iPosY+SizeY(pdtData.gcRelayButton)+iDeltaY;

	pdtData.gcSupplyButton=NewButton(smDOPIndividualButtons);
	SetAlign(pdtData.gcSupplyButton,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcSupplyButton,iSizeX,iSizeY);
	MountComponent(pthis,pdtData.gcSupplyButton);
	MoveTo(pdtData.gcSupplyButton,iPosX,iPosY);
	pdtData.iSupplyIndivState=0;
	pdtData.iSupplyGroupState=0;
	AddHelpInterface(pdtData.gcSupplyButton,GetLocalizedFromKey(iszig_indiv_supply));

	pdtData.iSavedAttackButtonState=0;
	pdtData.iSavedRelayButtonState=IRS_eIndivRelayTypeNo;
	pdtData.iSavedSprintButtonState=0;
	pdtData.iIsGroupActive=0;

	iPosY=iPosY+SizeY(pdtData.gcSupplyButton);

	StretchTo(pthis,iSizeX,iPosY);

	DOPS_UpdateButtonStates(pthis);


	print("Create Setting OK\n");
	return pthis;
}
func i32x DOPS_Destroy()
{}

func void DOPS_UpdateButtonStates(Gui_Component _pthis)
{
	var Gui_dtDirectOrderPanelSetting pdtData;
	pdtData = GetData(_pthis);
	var szx szHelp;
	
	if(pdtData.iInterface==IRS_eInterfaceStrategy)
	{
		pdtData.gcAttackButton<<Hide();
		pdtData.gcRelayButton<<Hide();
		pdtData.gcSupplyButton<<Hide();
		pdtData.gcSprintButton<<Hide();
	}
	else if(pdtData.iInterface==IRS_eInterfaceIndividual)
	{
		pdtData.gcAttackButton<<Show();
		pdtData.gcRelayButton<<Show();
		pdtData.gcSupplyButton<<Show();
		pdtData.gcSprintButton<<Show();
	
		SetMaterial(GetSprite(pdtData.gcAttackButton),smDOPIndividualButtons);
		SetMaterial(GetSprite(pdtData.gcSprintButton),smDOPIndividualButtons);
		SetMaterial(GetSprite(pdtData.gcRelayButton),smDOPIndividualRelayButton);
		SetMaterial(GetSprite(pdtData.gcSupplyButton),smDOPIndividualButtons);

		szHelp=GetLocalizedFromKey(iszig_indiv_attack);
		pdtData.gcAttackButton<<SetHelpString(szHelp);
		if(pdtData.iAttackIndivState==0)
			SetArea(GetSprite(pdtData.gcAttackButton),0);
		else
			SetArea(GetSprite(pdtData.gcAttackButton),2);
		
		
		szHelp=GetLocalizedFromKey(iszig_indiv_sprint);
		pdtData.gcSprintButton<<SetHelpString(szHelp);
		if(pdtData.iSprintIndivState==0)
			SetArea(GetSprite(pdtData.gcSprintButton),3);
		else
			SetArea(GetSprite(pdtData.gcSprintButton),5);
		
		
		if(pdtData.iRelayIndivState>=3) pdtData.iRelayIndivState=0;
		if(pdtData.iRelayIndivState==0)
		{
			SetArea(GetSprite(pdtData.gcRelayButton),0);
			szHelp=GetLocalizedFromKey(iszig_indiv_relay_no);
			pdtData.gcRelayButton<<SetHelpString(szHelp);
		}
		else if(pdtData.iRelayIndivState==1)
		{
			SetArea(GetSprite(pdtData.gcRelayButton),5);
			szHelp=GetLocalizedFromKey(iszig_indiv_relay_normal);
			pdtData.gcRelayButton<<SetHelpString(szHelp);
		}
		else if(pdtData.iRelayIndivState==2)
		{
			SetArea(GetSprite(pdtData.gcRelayButton),8);
			szHelp=GetLocalizedFromKey(iszig_indiv_relay_infinite);
			pdtData.gcRelayButton<<SetHelpString(szHelp);
		}
		
		szHelp=GetLocalizedFromKey(iszig_indiv_supply);
		pdtData.gcSupplyButton<<SetHelpString(szHelp);
		if(pdtData.iSupplyIndivState==0)
			SetArea(GetSprite(pdtData.gcSupplyButton),9);
		else
			SetArea(GetSprite(pdtData.gcSupplyButton),11);
	}
	else if(pdtData.iInterface==IRS_eInterfaceGroup)
	{
		pdtData.gcAttackButton<<Show();
		pdtData.gcRelayButton<<Show();
		pdtData.gcSupplyButton<<Show();
		pdtData.gcSprintButton<<Show();

		if(pdtData.iAttackGroupState>=IRS_eAttackBehaviourNumber) pdtData.iAttackGroupState=0;
		if(pdtData.iSprintGroupState>=IRS_eSprintBehaviourNumber) pdtData.iSprintGroupState=0;
		if(pdtData.iRelayGroupState>=IRS_eRelayBehaviourNumber) pdtData.iRelayGroupState=0;
		if(pdtData.iSupplyGroupState>=IRS_ePelotonBehaviourNumber) pdtData.iSupplyGroupState=0;
		

		SetMaterial(GetSprite(pdtData.gcAttackButton),smDOPAttackButton);
		SetMaterial(GetSprite(pdtData.gcSprintButton),smDOPSprintButton);
		SetMaterial(GetSprite(pdtData.gcRelayButton),smDOPRelayButton);
		SetMaterial(GetSprite(pdtData.gcSupplyButton),smDOPPelotonButton);
		SetArea(GetSprite(pdtData.gcAttackButton),pdtData.iAttackGroupState);
		SetArea(GetSprite(pdtData.gcSprintButton),pdtData.iSprintGroupState);
		SetArea(GetSprite(pdtData.gcRelayButton),pdtData.iRelayGroupState);
		SetArea(GetSprite(pdtData.gcSupplyButton),pdtData.iSupplyGroupState);

		if(pdtData.iAttackGroupState==IRS_eAttackBehaviourNothing)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_attack_nothing);
		else if(pdtData.iAttackGroupState==IRS_eAttackBehaviourAttacker)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_attack_attacker);
		else if(pdtData.iAttackGroupState==IRS_eAttackBehaviourPilot)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_attack_pilot);
		else if(pdtData.iAttackGroupState==IRS_eAttackBehaviourCounter)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_attack_counter);
		else if(pdtData.iAttackGroupState==IRS_eAttackBehaviourBlock)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_attack_blocker);
		else 
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_attack_relayfake);
		pdtData.gcAttackButton<<SetHelpString(szHelp);


		if(pdtData.iSprintGroupState==IRS_eSprintBehaviourNothing)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_sprint_nothing);
		else if(pdtData.iSprintGroupState==IRS_eSprintBehaviourSprinter)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_sprint_sprinter);
		else if(pdtData.iSprintGroupState==IRS_eSprintBehaviourPilot)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_sprint_pilot);
		else
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_sprint_blocker);
		pdtData.gcSprintButton<<SetHelpString(szHelp);


		if(pdtData.iRelayGroupState==IRS_eRelayBehaviourNothing)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_relay_nothing);
		else if(pdtData.iRelayGroupState==IRS_eRelayBehaviourRelayer)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_relay_relayer);
		else if(pdtData.iRelayGroupState==IRS_eRelayBehaviourGateKeeper)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_relay_gatekeeper);
		else if(pdtData.iRelayGroupState==IRS_eRelayBehaviourProtector)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_relay_protector);
		else
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_relay_protected);
		pdtData.gcRelayButton<<SetHelpString(szHelp);


		if(pdtData.iSupplyGroupState==IRS_ePelotonBehaviourNothing)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_peloton_nothing);
		else if(pdtData.iSupplyGroupState==IRS_ePelotonBehaviourSupply)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_peloton_supply);
		else if(pdtData.iSupplyGroupState==IRS_ePelotonBehaviourHead)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_peloton_attack);
		else if(pdtData.iSupplyGroupState==IRS_ePelotonBehaviourProtector)
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_peloton_protector);
		else 
			szHelp=GetLocalizedFromKey(iszig_group_behaviour_peloton_protected);

		pdtData.gcSupplyButton<<SetHelpString(szHelp);
	}
	else
	{
		println("!!!! Error on DOPS_UpdateButtonStates.");
	}
}

func i32x DOPS_IndividualOrder(i32x _iCyclistLocalId,i32x _iButton,i32x _iButtonState,i32x _iValue,f32x _fValue)
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanelSetting pdtData;
	var Gui_dtCheckbox pdtCheckbox;
	
	pthis =GetThis();
	pdtData = GetData(pthis);
	
	//println("DOPS_IndividualOrder");

	if(_iButton==IRS_eInterfaceOrder)
	{
		pdtData.iInterface=_iButtonState;
		DOPS_UpdateButtonStates(pthis);
		return 1;
	}

	if(pdtData.iInterface==IRS_eInterfaceIndividual)
	{
		pdtData.iAttackIndivState=0;
		pdtData.iSprintIndivState=0;
		pdtData.iRelayIndivState=0;
		pdtData.iSupplyIndivState=0;
		
		////println("DOPS_IndividualOrder:");
		if(_iButtonState==IRS_eIndivOrderTypeAttack)
		{
			pdtData.iAttackIndivState=_iValue;
		}
		else if(_iButtonState==IRS_eIndivOrderTypeSprint)
		{
			pdtData.iSprintIndivState=_iValue;
		}
		else if(_iButtonState==IRS_eIndivOrderTypeSupply)
		{
			pdtData.iSupplyIndivState=_iValue;
		}
		else if(_iButtonState==IRS_eIndivOrderTypeRelay)
		{
			pdtData.iRelayIndivState=_iValue;
		}
		else
		{
			println("!!!! Error on DOPS_IndividualOrder.");
		}
	}
	else if(pdtData.iInterface==IRS_eInterfaceGroup)
	{
		if (_iButton==IRS_eGroupBehaviour)
		{
			if(_iButtonState==IRS_eBehaviourTypeAttack)
			{
				pdtData.iAttackGroupState=_iValue;
			}
			else if(_iButtonState==IRS_eBehaviourTypeSprint)
			{
				pdtData.iSprintGroupState=_iValue;
			}
			else if(_iButtonState==IRS_eBehaviourTypePeloton)
			{
				pdtData.iSupplyGroupState=_iValue;
			}
			else if(_iButtonState==IRS_eBehaviourTypeRelay)
			{
				pdtData.iRelayGroupState=_iValue;
			}
			else
			{
				println("!!!! Error on DOPS_IndividualOrder.");
			}
		}
		else if(_iButton==IRS_eGroupOrder)
		{
			if(_iButtonState==IRS_eGroupOrderTypeAttack)
			{
				pdtData.iSavedAttackButtonState=_iValue;
				if(_iValue)
				{
					pdtData.iSavedSprintButtonState=0;
					pdtData.iSavedRelayButtonState=0;
				}
			}
			else if(_iButtonState==IRS_eGroupOrderTypeSprint)
			{
				pdtData.iSavedSprintButtonState=_iValue;
				if(_iValue)
				{
					pdtData.iSavedAttackButtonState=0;
					pdtData.iSavedRelayButtonState=0;
				}
			}
			else if(_iButtonState==IRS_eGroupOrderTypeRelay) 
			{
				pdtData.iSavedRelayButtonState=_iValue;
				if(_iValue)
				{
					pdtData.iSavedAttackButtonState=0;
					pdtData.iSavedSprintButtonState=0;
				}
			}
			else
			{
				println("!!!! Error on DOPS_IndividualOrder.");
			}
		}
	}

	DOPS_UpdateButtonStates(pthis);
	return 1;
}


func i32x DOPS_Click(Gui_Component _pthis)
{
	var Gui_Component pthis,pDOW,ppanel;
	var Gui_dtDirectOrderPanelSetting pdtData;
	var Gui_dtDirectOrderPanel pdtPanelData;
	var Gui_dtCheckbox pdtCheckbox;
	var i32x iData;
	
	pthis =GetThis();
	pdtData = GetData(pthis);
	ppanel = GetParent(pthis);
	pdtPanelData = GetData(ppanel);
	pDOW = GetParent(ppanel);
	
	////println("DOPS_Click");
	pDOW<<mDOW_SelectPanel(pdtPanelData.iCyclistIndexInTeam);
	
	if(pdtData.iInterface==IRS_eInterfaceIndividual)
	{
		if(_pthis==pdtData.gcAttackButton)
			pDOW<<mIndividualOrder(0,IRS_eIndividualOrder,IRS_eIndivOrderTypeAttack,!pdtData.iAttackIndivState,0);
		else if(_pthis==pdtData.gcSprintButton)
			pDOW<<mIndividualOrder(0,IRS_eIndividualOrder,IRS_eIndivOrderTypeSprint,!pdtData.iSprintIndivState,0);
		else if(_pthis==pdtData.gcSupplyButton)
			pDOW<<mIndividualOrder(0,IRS_eIndividualOrder,IRS_eIndivOrderTypeSupply,!pdtData.iSupplyIndivState,0);
		else if(_pthis==pdtData.gcRelayButton)
		{
			iData=pdtData.iRelayIndivState+1;
			if(iData>=3) iData=0;
			pDOW<<mIndividualOrder(0,IRS_eIndividualOrder,IRS_eIndivOrderTypeRelay,iData,0);
		}
	}
	else if(pdtData.iInterface==IRS_eInterfaceGroup)
	{
		if(_pthis==pdtData.gcAttackButton)
		{
			iData=pdtData.iAttackGroupState+1;
			if(iData>=IRS_eAttackBehaviourNumber) iData=0;
			pDOW<<mIndividualOrder(0,IRS_eGroupBehaviour,IRS_eBehaviourTypeAttack,iData,0);
		}
		else if(_pthis==pdtData.gcSprintButton)
		{
			iData=pdtData.iSprintGroupState+1;
			if(iData>=IRS_eSprintBehaviourNumber) iData=0;
			pDOW<<mIndividualOrder(0,IRS_eGroupBehaviour,IRS_eBehaviourTypeSprint,iData,0);
		}
		else if(_pthis==pdtData.gcSupplyButton)
		{
			iData=pdtData.iSupplyGroupState+1;
			if(iData>=IRS_ePelotonBehaviourNumber) iData=0;
			pDOW<<mIndividualOrder(0,IRS_eGroupBehaviour,IRS_eBehaviourTypePeloton,iData,0);
		}
		else if(_pthis==pdtData.gcRelayButton)
		{
			iData=pdtData.iRelayGroupState+1;
			if(iData>=IRS_eRelayBehaviourNumber) iData=0;
			pDOW<<mIndividualOrder(0,IRS_eGroupBehaviour,IRS_eBehaviourTypeRelay,iData,0);
		}
	}
	return 1;
}


func i32x DOPName_MouseDown(i32x _iX,i32x _iY,i32x _iButton)
{
	var Gui_Component pthis;
	var Gui_Component pDOP,pDOW; 
	
	pthis =GetThis();
	pDOP=GetParent(pthis);
	pDOW=GetParent(pDOP);
	pDOW<<mDOW_AddPanelToSelection(pDOP);

	return 1;
}

func i32x DOPName_MouseDblClick(i32x _iX,i32x _iY,i32x _iButton)
{
	var Gui_Component pthis;
	var Gui_Component pDOP,pDOW; 
	
	pthis =GetThis();
	pDOP=GetParent(pthis);
	pDOW=GetParent(pDOP);
	
	////println("DOW_SelectPanel");
	if(GetKeyState(VK_Control))
		pDOW<<mDOW_SelectAllPanels(pthis);

	return 1;
}


///////////////////////////////////////
//DirectOrderPanel
///////////////////////////////////////
func Gui_Component fn_oNewDirectOrderPanel(i32x _iCyclistIndexInTeam)
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanel pdtData;
	var Gui_dtDOPName pdtBack;
	var i32x iCyclistID,iPosX,iPosY,iCyclistFlag,i,iPhotoID,iTextSizeY;
	var szx szCyclistName,szCyclistPhotoTgaName;

	// get this pointer
	pthis = NewObject(Gui_iDirectOrderPanel);

	// Set Data pointer
	pdtData = new Gui_dtDirectOrderPanel;
	SetData(pthis,pdtData);

	SetComponentNumber(pthis,32);
	iPosX=0;
	iPosY=0;
	iTextSizeY=13;

	pdtData.gcBack=NewBitmap(smDOPanelBack,0);
	//SetShadingMode(GetSprite(pdtData.gcBack),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcBack,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcBack);
	MoveTo(pdtData.gcBack,0,0);
	//SetColor(pdtData.gcBack,MakeARGB(255,185,199,212));
	SetArea(GetSprite(pdtData.gcBack),2);
	pdtBack = new Gui_dtDOPName;
	AddInterface(pdtData.gcBack,Gui_iDOPName,pdtBack);
	

	pdtData.iCyclistIndexInTeam = _iCyclistIndexInTeam;
	pdtData.iOrder = _iCyclistIndexInTeam;
		
	iCyclistID=GetCyclistIDFromPreRaceIndex(GetCyclistPreRaceIndexFromTeamAndIndexInTeam(GetMyInRaceTeamId(),pdtData.iCyclistIndexInTeam));
	szCyclistName=Join_GetStringFromKey(g_oMenuJoins.m_jCyclist_szFirstName,iCyclistID);
	szCyclistName=strncpy(szCyclistName,0,1);
	szCyclistName=szCyclistName+"."+Join_GetStringFromKey(g_oMenuJoins.m_jCyclist_szLastName,iCyclistID);
	
	pdtData.gcCyclistName=NewCaption(smTrebuchet,szCyclistName);
	SetShadingMode(GetSprite(pdtData.gcCyclistName),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcCyclistName,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	StretchTo(pdtData.gcCyclistName,60.0*g_fScreenScaleFactor,14);
	MountComponent(pthis,pdtData.gcCyclistName);
	MoveTo(pdtData.gcCyclistName,iPosX,iPosY);
	SetColor(pdtData.gcCyclistName,MakeARGB(255,0,0,0));
	Clip(pdtData.gcCyclistName);
	pdtData.gcCyclistName<<Disable();
	
	pdtData.gcGroupNameBackground=NewButton(smWhite);
	SetShadingMode(GetSprite(pdtData.gcGroupNameBackground),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	SetBlendingMode(GetSprite(pdtData.gcGroupNameBackground), DLC_Blend_AlphaBlend);
	SetAlign(pdtData.gcGroupNameBackground,e_GUI_HAlign_Zoom,e_GUI_HAlign_Zoom);
	StretchTo(pdtData.gcGroupNameBackground,25.0*g_fScreenScaleFactor,14);
	MountComponent(pthis,pdtData.gcGroupNameBackground);
	MoveTo(pdtData.gcGroupNameBackground,61.0*g_fScreenScaleFactor,iPosY);
	SetColor(pdtData.gcGroupNameBackground,MakeARGB(160,178,203,203));
	
	pdtData.gcGroupNameCaption=NewCaption(smTrebuchet,"");
	SetShadingMode(GetSprite(pdtData.gcGroupNameCaption),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcGroupNameCaption,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	StretchTo(pdtData.gcGroupNameCaption,25.0*g_fScreenScaleFactor,14);
	MountComponent(pthis,pdtData.gcGroupNameCaption);
	MoveTo(pdtData.gcGroupNameCaption,61.0*g_fScreenScaleFactor,iPosY);
	SetColor(pdtData.gcGroupNameCaption,MakeARGB(255,0,0,0));
	Clip(pdtData.gcGroupNameCaption);
	pdtData.gcGroupNameCaption<<Disable();

	
	iPosX=7.0*g_fScreenScaleFactor;
	iPosY=16;

	//Photo
	iPhotoID=Join_GetIntFromKey(g_oMenuJoins.m_jCyclist_iTgaPhotoID,iCyclistID);
	//print("iPhotoID");
	////println(itoa(iPhotoID));
	szCyclistPhotoTgaName="./"+Join_GetStringFromKey(g_oLocalJoins.m_iTga_szDirectory,iPhotoID);
	szCyclistPhotoTgaName=szCyclistPhotoTgaName+"/"+Join_GetStringFromKey(g_oLocalJoins.m_iTga_szName,iPhotoID);
	////println(szCyclistPhotoTgaName);

	pdtData.mkPhotoKit=LoadMaterialKit("Gui/Cyclist_photo_msh.msh");
	LoadKit(pdtData.mkPhotoKit);
	pdtData.smPhotoMaterial=FindMaterial(pdtData.mkPhotoKit,"Cyclist_Photo");
	LoadTexture(pdtData.smPhotoMaterial,szCyclistPhotoTgaName);

	pdtData.gcPhotoBitmap=NewBitmap(pdtData.smPhotoMaterial,0);
	SetAlign(pdtData.gcPhotoBitmap,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcPhotoBitmap,23.0,23.0);
	MountComponent(pthis,pdtData.gcPhotoBitmap);
	MoveTo(pdtData.gcPhotoBitmap,iPosX,iPosY);
	pdtData.gcPhotoBitmap<<Disable();

	iPosY=iPosY+22;
	/*pdtData.gcEnergyGauge=fn_oNewEnergyGauge();
	MountComponent(pthis,pdtData.gcEnergyGauge);
	MoveTo(pdtData.gcEnergyGauge,iPosX-5*g_fScreenScaleFactor,iPosY);
	*/

	pdtData.gcSpeedCaption=NewCaption(smTrebuchet,"");
	SetShadingMode(GetSprite(pdtData.gcSpeedCaption),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcSpeedCaption,e_GUI_HAlign_Left,e_GUI_VAlign_Top);
	StretchTo(pdtData.gcSpeedCaption,24.0+16.0*g_fScreenScaleFactor,iTextSizeY);
	MountComponent(pthis,pdtData.gcSpeedCaption);
	MoveTo(pdtData.gcSpeedCaption,iPosX,iPosY);
	SetColor(pdtData.gcSpeedCaption,MakeARGB(255,0,0,0));
	AddHelpInterface(pdtData.gcSpeedCaption,GetLocalizedFromKey(iszig_speed));

	iPosY=iPosY+iTextSizeY;

	pdtData.gcHeartCaption=NewCaption(smTrebuchet,"60");
	SetShadingMode(GetSprite(pdtData.gcHeartCaption),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcHeartCaption,e_GUI_HAlign_Left,e_GUI_VAlign_Top);
	StretchTo(pdtData.gcHeartCaption,24.0+16.0*g_fScreenScaleFactor,iTextSizeY);
	MountComponent(pthis,pdtData.gcHeartCaption);
	MoveTo(pdtData.gcHeartCaption,iPosX,iPosY);
	SetColor(pdtData.gcHeartCaption,MakeARGB(255,0,0,0));
	AddHelpInterface(pdtData.gcHeartCaption,GetLocalizedFromKey(iszig_hr));

	iPosY=iPosY+iTextSizeY;

	pdtData.gcSupplyCaption=NewCaption(smTrebuchet,"1");
	SetShadingMode(GetSprite(pdtData.gcSupplyCaption),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcSupplyCaption,e_GUI_HAlign_Left,e_GUI_VAlign_Top);
	StretchTo(pdtData.gcSupplyCaption,24.0+16.0*g_fScreenScaleFactor,iTextSizeY);
	MountComponent(pthis,pdtData.gcSupplyCaption);
	MoveTo(pdtData.gcSupplyCaption,iPosX,iPosY);
	SetColor(pdtData.gcSupplyCaption,MakeARGB(255,0,0,0));
	AddHelpInterface(pdtData.gcSupplyCaption,GetLocalizedFromKey(iszig_supply));

	iPosY=iPosY+iTextSizeY;

	pdtData.gcDOPSE=fn_oNewDirectOrderPanelEffortSlider();
	MountComponent(pthis,pdtData.gcDOPSE);

	iPosX=DOP_fSizeX(pthis)-SizeX(pdtData.gcDOPSE);
	iPosY=14;
	MoveTo(pdtData.gcDOPSE,iPosX,iPosY);
	
	pdtData.gcDOPS=fn_oNewDirectOrderPanelSetting();
	MountComponent(pthis,pdtData.gcDOPS);
	iPosX=(1.0*iPosX)-SizeX(pdtData.gcDOPS)-4;
	MoveTo(pdtData.gcDOPS,iPosX,iPosY);

	iCyclistFlag=1;
	i=0;
	while(i<_iCyclistIndexInTeam)
	{
		iCyclistFlag=iCyclistFlag*2;
		i=i+1;
	}
	pdtData.iCyclistFlag=iCyclistFlag;
	pdtData.iSelected=0;
	
	StretchTo(pthis,DOP_fSizeX(pthis),DOP_fSizeY(pthis));
	StretchTo(pdtData.gcBack,DOP_fSizeX(pthis),DOP_fSizeY(pthis));

	//select individual interface
	pthis<<mIndividualOrder(0,IRS_eInterfaceOrder,IRS_eInterfaceIndividual,0,0);
	g_pMenuServerSocket<<mIndividualOrder(65535,IRS_eInterfaceOrder,IRS_eInterfaceIndividual,0,0);

	print("Create Panel:");
	print(itoa(_iCyclistIndexInTeam));
	//println(" OK");

	DOP_UpdateBack(pthis);

	return pthis;
}

func i32x DOP_Destroy()
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanel pdtData;
	pthis =GetThis();
	pdtData = GetData(pthis);

	ReleaseKit(pdtData.mkPhotoKit);
	DeleteKit(pdtData.mkPhotoKit);
}

func f32x DOP_fSizeX(Gui_Component _pthis)
{
	return 89.5*g_fScreenScaleFactor;
}

func f32x DOP_fSizeY(Gui_Component _pthis)
{
	return 80.0;
}

func i32x DOP_IndividualOrder(i32x _iCyclistLocalId,i32x _iButton,i32x _iButtonState,i32x _iValue,f32x _fValue)
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanel pdtData;
	
	pthis =GetThis();
	pdtData = GetData(pthis);
	
	//println("DOP_IndividualOrder"+"_iButton="+itoa(_iButton)+"_iButtonState="+itoa(_iButtonState)+"_iValue="+itoa(_iValue)+"pdtData.iInterface="+itoa(pdtData.iInterface));

	if(_iButton==IRS_eInterfaceOrder)
	{
		pdtData.iInterface=_iButtonState;
		pdtData.gcDOPS<<mIndividualOrder(_iCyclistLocalId,_iButton,_iButtonState,_iValue,_fValue);

		if(pdtData.iInterface!=IRS_eInterfaceIndividual)
			pdtData.gcDOPSE<<mDOPSEDisable();
		else
			pdtData.gcDOPSE<<mDOPSEEnable();
		
		DOP_UpdateBack(pthis);
		return 1;
	}
	else if(_iButton==IRS_eIndividualOrder)
	{
		if(_iButtonState==IRS_eIndivOrderTypeEffort&&pdtData.iInterface==IRS_eInterfaceIndividual)
		pdtData.gcDOPSE<<mIndividualOrder(_iCyclistLocalId,_iButton,_iButtonState,_iValue,_fValue);
		else if (pdtData.iInterface==IRS_eInterfaceIndividual)
		pdtData.gcDOPS<<mIndividualOrder(_iCyclistLocalId,_iButton,_iButtonState,_iValue,_fValue);
	}
	else if (_iButton==IRS_eGroupBehaviour)
	{
		if (pdtData.iInterface==IRS_eInterfaceGroup)
			pdtData.gcDOPS<<mIndividualOrder(_iCyclistLocalId,_iButton,_iButtonState,_iValue,_fValue);
	}
	else if (_iButton==IRS_eGroupOrder)
	{
		if (pdtData.iInterface==IRS_eInterfaceGroup)
			pdtData.gcDOPS<<mIndividualOrder(_iCyclistLocalId,_iButton,_iButtonState,_iValue,_fValue);
	}
	return 1;
}


func void DOP_WindowUpdate()
{
	var Gui_Component pthis,pparent;
	var Gui_dtDirectOrderPanel pdtData;
	pthis =GetThis();
	pdtData = GetData(pthis);
	
	StretchTo(pthis,DOP_fSizeX(pthis),DOP_fSizeY(pthis));
	StretchTo(pdtData.gcBack,DOP_fSizeX(pthis),DOP_fSizeY(pthis));
	
	pparent=GetParent(pthis);
	pparent<<WindowUpdate();
}

func i32x DOP_Click(Gui_Component _pthis)
{
	var Gui_Component pthis,pDOW;
	var Gui_dtDirectOrderPanel pdtData;
	
	pthis =GetThis();
	pdtData = GetData(pthis);
	pDOW = GetParent(pthis);
	
	////println("DOP_Click");
	if(_pthis==pdtData.gcBack)
		pDOW<<mDOW_SelectPanel(pdtData.iCyclistIndexInTeam);
	else if(_pthis==pdtData.gcGroupNameBackground)
		pDOW<<mDOW_SelectPanelForGroup(pdtData.iCyclistIndexInTeam);
	return 1;
}


func void DOP_UpdateBack(Gui_Component _pthis)
{
	var Gui_dtDirectOrderPanel pdtData;

	////println("DOP_UpdateBack");
	pdtData = GetData(_pthis);
	if(pdtData.iSelected)
	{
		if(pdtData.iInterface==IRS_eInterfaceIndividual)
			SetArea(GetSprite(pdtData.gcBack),6);
		else if(pdtData.iInterface==IRS_eInterfaceGroup)
			SetArea(GetSprite(pdtData.gcBack),5);
		else if(pdtData.iInterface==IRS_eInterfaceStrategy)
			SetArea(GetSprite(pdtData.gcBack),4);
	}
	else
	{
		if(pdtData.iInterface==IRS_eInterfaceIndividual)
			SetArea(GetSprite(pdtData.gcBack),2);
		else if(pdtData.iInterface==IRS_eInterfaceGroup)
			SetArea(GetSprite(pdtData.gcBack),1);
		else if(pdtData.iInterface==IRS_eInterfaceStrategy)
			SetArea(GetSprite(pdtData.gcBack),0);
	}
}

func i32x DOP_UnSelect()
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanel pdtData;

	////println("DOP_UnSelect");

	pthis =GetThis();
	pdtData = GetData(pthis);
	pdtData.iSelected=0;

	DOP_UpdateBack(pthis);

	return 1;
}

func i32x DOP_Select()
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanel pdtData;

	////println("DOP_Select");
	pthis =GetThis();
	pdtData = GetData(pthis);
	pdtData.iSelected=1;

	DOP_UpdateBack(pthis);
	
	return 1;
}

func i32x DOP_Loop(f32x _fDelay)
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanel pdtData;
	var i32x iValue,iPreRaceIndex;
	var f32x fMax;
	var szx szValue;

	////println("DOP_Loop");

	pthis =GetThis();
	pdtData = GetData(pthis);


	iPreRaceIndex=GetCyclistPreRaceIndexFromTeamAndIndexInTeam(GetMyInRaceTeamId(),pdtData.iCyclistIndexInTeam);
	szValue=itoa(GetCyclistSpeedValue(iPreRaceIndex));
	pdtData.gcSpeedCaption<<Caption(szValue);
	
	szValue=itoa(GetCyclistHRValue(iPreRaceIndex));
	pdtData.gcHeartCaption<<Caption(szValue);

	szValue=GetGroupNameFromPreRaceCyclistIndex(iPreRaceIndex);
	pdtData.gcGroupNameCaption<<Caption(szValue);

	fMax=GetCyclistEffortMax(iPreRaceIndex);
	pdtData.gcDOPSE<<EffortMax(fMax);

	fMax=2.0*0.01*GetCyclistEnergy(iPreRaceIndex);
	szValue=Formattedftoa(fMax,1,1);
	pdtData.gcSupplyCaption<<Caption(szValue);
	//pdtData.gcEnergyGauge<<Energy(fMax);
}


func i32x DOP_UpdateDrawing()
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderPanel pdtData;
	var Gui_dtDirectOrderPanelSetting pdtDOPSdata;
	
	////println("DOP_UpdateDrawing");
	pthis = GetThis();
	pdtData = GetData(pthis);
	pdtDOPSdata = GetData(pdtData.gcDOPS);

	//Set group background in Red when active
	if(pdtDOPSdata.iIsGroupActive)
		SetColor(pdtData.gcGroupNameBackground,MakeARGB(255,178,203,203));
	else
		SetColor(pdtData.gcGroupNameBackground,MakeARGB(160,178,203,203));
}

