//DirectOrderWindow constructor
func Gui_Component fn_oNewDirectOrderWindow(i32x _iNumPanelToCreate)
{
	var Gui_Component pthis;
	var Gui_Component cPanel;
	var Gui_dtDirectOrderWindow pdtData;
	var i32x i,iMountedComponentIndex,iPosX,iPosY,iSizeX,iSizeY;
	
	// get this pointer
	pthis = NewObject(Gui_iDirectOrderWindow);

	// Set Data pointer
	pdtData = new Gui_dtDirectOrderWindow;
	SetData(pthis,pdtData);
	
	pdtData.gcBar=NewBitmap(smDOPanelBarre,1);
	SetAlign(pdtData.gcBar,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcBar);
	MoveTo(pdtData.gcBar,0,0);
	//SetArea(GetSprite(pdtData.gcBar),1);
	StretchTo(pdtData.gcBar,800.0*g_fScreenScaleFactor,20);

	pdtData.gcWinCaption=NewCaption(smArial,"Cyclist Orders");
	SetShadingMode(GetSprite(pdtData.gcWinCaption),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_Decal);
	SetAlign(pdtData.gcWinCaption,e_GUI_HAlign_Max,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcWinCaption,106,18);
	MountComponent(pthis,pdtData.gcWinCaption);
	MoveTo(pdtData.gcWinCaption,18,1);
	SetColor(pdtData.gcWinCaption,MakeARGB(255,0,0,0));
	pdtData.gcWinCaption<<Disable();

	
	pdtData.gcWinSort=NewButton(smRightButton);
	SetAlign(pdtData.gcWinSort,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcWinSort);
	StretchTo(pdtData.gcWinSort,18,18);
	MoveTo(pdtData.gcWinSort,124,1);

	pdtData.gcWinTeamDrawingCheckbox=NewCheckbox(smRightButton);
	SetAlign(pdtData.gcWinTeamDrawingCheckbox,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcWinTeamDrawingCheckbox);
	StretchTo(pdtData.gcWinTeamDrawingCheckbox,18,18);
	MoveTo(pdtData.gcWinTeamDrawingCheckbox,144,1);
	pdtData.gcWinTeamDrawingCheckbox<<QuietUncheck();

	iPosX=144+24;
	iPosY=1;

	pdtData.gcIndividualButton=NewCM2InRaceButton1(GetLocalizedFromKey(iszig_individual));
	MountComponent(pthis,pdtData.gcIndividualButton);
	MoveTo(pdtData.gcIndividualButton,iPosX,iPosY);
	iPosX=iPosX+SizeX(pdtData.gcIndividualButton)+6;
	AddHelpInterface(pdtData.gcIndividualButton,GetLocalizedFromKey(iszig_individual_help));
	
	pdtData.gcGroupButton=NewCM2InRaceButton1(GetLocalizedFromKey(iszig_group));
	MountComponent(pthis,pdtData.gcGroupButton);
	MoveTo(pdtData.gcGroupButton,iPosX,iPosY);
	iPosX=iPosX+SizeX(pdtData.gcGroupButton)+6;
	AddHelpInterface(pdtData.gcGroupButton,GetLocalizedFromKey(iszig_group_help));
	
	if(!isDemo)
	{
		pdtData.gcStrategyButton=NewCM2InRaceButton1(GetLocalizedFromKey(iszig_strategy));
		MountComponent(pthis,pdtData.gcStrategyButton);
		MoveTo(pdtData.gcStrategyButton,iPosX,iPosY);
		iPosX=iPosX+SizeX(pdtData.gcStrategyButton)+6;
		AddHelpInterface(pdtData.gcStrategyButton,GetLocalizedFromKey(iszig_strategy_help));
	}
	
	iSizeX=32;
	iSizeY=14;
	iPosY=3;
	pdtData.gcGroupAttackButton=NewButton(smDOPIndividualButtons);
	SetAlign(pdtData.gcGroupAttackButton,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcGroupAttackButton,iSizeX,iSizeY);
	MountComponent(pthis,pdtData.gcGroupAttackButton);
	MoveTo(pdtData.gcGroupAttackButton,iPosX,iPosY);
	iPosX=iPosX+SizeX(pdtData.gcGroupAttackButton)+6;
	AddHelpInterface(pdtData.gcGroupAttackButton,"");
	pdtData.iGroupAttackState=0;

	pdtData.gcGroupSprintButton=NewButton(smDOPIndividualButtons);
	SetAlign(pdtData.gcGroupSprintButton,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcGroupSprintButton,iSizeX,iSizeY);
	MountComponent(pthis,pdtData.gcGroupSprintButton);
	MoveTo(pdtData.gcGroupSprintButton,iPosX,iPosY);
	iPosX=iPosX+SizeX(pdtData.gcGroupSprintButton)+6;
	AddHelpInterface(pdtData.gcGroupSprintButton,"");
	pdtData.iGroupSprintState=0;
	
	pdtData.gcGroupRelayButton=NewButton(smDOPGroupRelayButton);
	SetAlign(pdtData.gcGroupRelayButton,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcGroupRelayButton,iSizeX,iSizeY);
	MountComponent(pthis,pdtData.gcGroupRelayButton);
	MoveTo(pdtData.gcGroupRelayButton,iPosX,iPosY);
	iPosX=iPosX+SizeX(pdtData.gcGroupRelayButton)+6;
	AddHelpInterface(pdtData.gcGroupRelayButton,"");
	pdtData.iGroupRelayState=IRS_eGroupRelayTypeNo;


	pdtData.iNumPanelCreated = _iNumPanelToCreate;
	pdtData.iMinimized = 0;
	pdtData.iAllDOPSelectedFlag = 0;
		

	pdtData.iFirstPanelIndex=-1;
	i=0;
	while(i<_iNumPanelToCreate)
	{
		// Create cyclist panel
		cPanel = fn_oNewDirectOrderPanel(i);
		// Mount component in page
		iMountedComponentIndex=MountComponent(pthis,cPanel);
		if(pdtData.iFirstPanelIndex==-1)
		{
			pdtData.iFirstPanelIndex=iMountedComponentIndex;
		}
		i=i+1;
	}

	pdtData.iActiveGroupPanelIndex=-1;
	DOW_UpdatePanelPositions(pthis);
	StretchTo(pthis,800.0*g_fScreenScaleFactor,100);
	DOW_UpdateDrawing(pthis);
	
	//println("Create Direct Order Window OK");
	return pthis;
}

func i32x DOW_Destroy()
{
	//println("DOW_Destroy OK");
}

func i32x DOW_MouseDown(i32x _iX,i32x _iY,i32x _iButton)
{
	return 1;
}

func void DOW_UpdateGroupButtonStates(Gui_Component _pthis)
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderWindow pdtData;

	pdtData = GetData(_pthis);
	
	//Hide group orders if no group selected
	if(pdtData.iActiveGroupPanelIndex==-1)
	{
		pdtData.gcGroupRelayButton<<Hide();
		pdtData.gcGroupSprintButton<<Hide();
		pdtData.gcGroupAttackButton<<Hide();
	}
	else
	{
		var szx szValue,szHelp;
		var i32x iPreRaceIndex;
		
		pdtData.gcGroupRelayButton<<Show();
		pdtData.gcGroupSprintButton<<Show();
		pdtData.gcGroupAttackButton<<Show();
		
		//Update sprite area
		//Set group help hint string "Group E1 attack" for example

		iPreRaceIndex=GetCyclistPreRaceIndexFromTeamAndIndexInTeam(GetMyInRaceTeamId(),pdtData.iActiveGroupPanelIndex);
		szValue=" "+GetGroupNameFromPreRaceCyclistIndex(iPreRaceIndex)+" ";
		//println("DOW_UpdateGroupButtonStates on cyclist:"+itoa(iPreRaceIndex));
		
		if(pdtData.iGroupAttackState==0)
			SetArea(GetSprite(pdtData.gcGroupAttackButton),0);
		else
			SetArea(GetSprite(pdtData.gcGroupAttackButton),2);
		szHelp=GetLocalizedFromKey(iszgroup)+szValue+GetLocalizedFromKey(iszig_indiv_attack);
		pdtData.gcGroupAttackButton<<SetHelpString(szHelp);
		
		if(pdtData.iGroupSprintState==0)
			SetArea(GetSprite(pdtData.gcGroupSprintButton),3);
		else
			SetArea(GetSprite(pdtData.gcGroupSprintButton),5);
		szHelp=GetLocalizedFromKey(iszgroup)+szValue+GetLocalizedFromKey(iszig_group_sprint);
		pdtData.gcGroupSprintButton<<SetHelpString(szHelp);
		
		
		if(pdtData.iGroupRelayState==IRS_eGroupRelayTypeNo)
		{
			SetArea(GetSprite(pdtData.gcGroupRelayButton),3);
			szHelp=GetLocalizedFromKey(iszgroup)+szValue+GetLocalizedFromKey(iszig_group_relay_no);
		}
		else if(pdtData.iGroupRelayState==IRS_eGroupRelayTypeMax)
		{
			SetArea(GetSprite(pdtData.gcGroupRelayButton),5);
			szHelp=GetLocalizedFromKey(iszgroup)+szValue+GetLocalizedFromKey(iszig_group_relay_max);
		}
		else if(pdtData.iGroupRelayState==IRS_eGroupRelayTypeFake)
		{
			SetArea(GetSprite(pdtData.gcGroupRelayButton),2);
			szHelp=GetLocalizedFromKey(iszgroup)+szValue+GetLocalizedFromKey(iszig_group_relay_fake);
		}
		else if(pdtData.iGroupRelayState==IRS_eGroupRelayTypeControl)
		{
			SetArea(GetSprite(pdtData.gcGroupRelayButton),8);
			szHelp=GetLocalizedFromKey(iszgroup)+szValue+GetLocalizedFromKey(iszig_group_relay_control);
		}
		pdtData.gcGroupRelayButton<<SetHelpString(szHelp);
	}
}


func i32x DOW_Click(Gui_Component _pthis)
{
	var Gui_Component pthis,cPanel;
	var Gui_dtDirectOrderWindow pdtData;
	var i32x i;
	
	//println("DOW_Click");


	pthis =GetThis();
	pdtData = GetData(pthis);

	if(_pthis==pdtData.gcWinSort)
	{
		DOW_SortPanelPositions(pthis);
	}
	else if(_pthis==pdtData.gcIndividualButton)
	{
		//println("IndivButton");
		pthis<<mIndividualOrder(0,IRS_eInterfaceOrder,IRS_eInterfaceIndividual,0,0);
	}
	else if(_pthis==pdtData.gcGroupButton)
	{
		//println("GroupButton");
		pthis<<mIndividualOrder(0,IRS_eInterfaceOrder,IRS_eInterfaceGroup,0,0);
	}
	else if(_pthis==pdtData.gcStrategyButton)
	{
		//println("StrategyButton");
		pthis<<mIndividualOrder(0,IRS_eInterfaceOrder,IRS_eInterfaceStrategy,0,0);
	}
	else if(_pthis==pdtData.gcGroupAttackButton)
	{
		//println("GroupAttackButton");
		pdtData.iGroupRelayState=0;
		pdtData.iGroupSprintState=0;
		pdtData.iGroupAttackState=!pdtData.iGroupAttackState;
		pthis<<mIndividualOrder(0,IRS_eGroupOrder,IRS_eGroupOrderTypeAttack,pdtData.iGroupAttackState,0);
	}
	else if(_pthis==pdtData.gcGroupSprintButton)
	{
		//println("GroupRelayButton");
		pdtData.iGroupAttackState=0;
		pdtData.iGroupRelayState=0;
		pdtData.iGroupSprintState=!pdtData.iGroupSprintState;
		pthis<<mIndividualOrder(0,IRS_eGroupOrder,IRS_eGroupOrderTypeSprint,1,0);
	}
	else if(_pthis==pdtData.gcGroupRelayButton)
	{
		//println("GroupAttackButton");
		pdtData.iGroupAttackState=0;
		pdtData.iGroupSprintState=0;
		pdtData.iGroupRelayState=pdtData.iGroupRelayState+1;
		if(pdtData.iGroupRelayState>=IRS_eGroupRelayTypeNumber) pdtData.iGroupRelayState=0;
		pthis<<mIndividualOrder(0,IRS_eGroupOrder,IRS_eGroupOrderTypeRelay,pdtData.iGroupRelayState,0);
	}
	DOW_UpdateActiveGroup();
	return 1;
}

func i32x DOW_Drag(Gui_Component _pComponent,i32x _iDeltaX,i32x _iDeltaY)
{
	var Gui_Component pthis;
	var Gui_dtDirectOrderWindow pdtData;
	
	pthis =GetThis();
	pdtData = GetData(pthis);

	if(_pComponent==pdtData.gcBar)
	{
		var Gui_Component pparent; 
		pparent=GetParent(pthis);
		pparent<<Drag(pthis,_iDeltaX,_iDeltaY);
 }
	return 1;
}

func i32x DOW_IndividualOrder(i32x _iCyclistLocalId,i32x _iButton,i32x _iButtonState,i32x _iValue,f32x _fValue)
{
	var Gui_Component pthis,cPanel,pRaceWindow;
	var Gui_dtDirectOrderWindow pdtDOWData;
	var Gui_dtDirectOrderPanel pdtDOPData;
	var Gui_dtPage_Race pdtRaceData;
	var i32x i,iFlag;
	
	//println("DOW_IndividualOrder");
	
	pthis=GetThis();
	pdtDOWData = GetData(pthis);
	
	if(_iButton==IRS_eGroupOrder)
	{
		//Select the group
		var i32x iActiveGroupIndex;
		iActiveGroupIndex=GetActiveGroupIndex();
		i=0;
		while(i<pdtDOWData.iNumPanelCreated)
		{
			cPanel = GetComponent(pthis,pdtDOWData.iFirstPanelIndex+i);
			pdtDOPData = GetData(cPanel);
			if(pdtDOPData.iInterface==IRS_eInterfaceGroup&&iActiveGroupIndex==GetGroupFromPreRaceCyclistIndex(GetCyclistPreRaceIndexFromTeamAndIndexInTeam(GetMyInRaceTeamId(),i)))
				DOW_QuietSelectPanel(i);
			else 
				DOW_QuietUnSelectPanel(i);
			i=i+1;
		}
	}

	i=0;
	iFlag=0;
	//send message to all selected panels
	while(i<pdtDOWData.iNumPanelCreated)
	{
		cPanel = GetComponent(pthis,pdtDOWData.iFirstPanelIndex+i);
		pdtDOPData = GetData(cPanel);
		if(pdtDOPData.iSelected)
		{
			iFlag=iFlag|pdtDOPData.iCyclistFlag;
			cPanel<<mIndividualOrder(_iCyclistLocalId,_iButton,_iButtonState,_iValue,_fValue);
		}
		i=i+1;
	}

	//send message to server
	if(iFlag)
		g_pMenuServerSocket<<mIndividualOrder(iFlag,_iButton,_iButtonState,_iValue,_fValue);

	return 1;
}


func i32x DOW_SelectPanel(i32x _iCyclistIndexInTeam)
{
	var Gui_Component pthis,cPanel;
	var Gui_dtDirectOrderWindow pdtData;
	var Gui_dtDirectOrderPanel pdtPanelData;
	var Gui_dtPage_Race pdtRaceData;
	var i32x i,iControlKeyState;

	////println("DOW_SelectPanel");

	iControlKeyState=GetKeyState(VK_Control);
	pthis =GetThis();
	pdtData = GetData(pthis);

	i=0;
	while(i<pdtData.iNumPanelCreated)
	{
		cPanel=GetComponent(pthis,pdtData.iFirstPanelIndex+i);
		
		if(i==_iCyclistIndexInTeam)
		{
			cPanel<<mDOP_Select();
			if(!iControlKeyState)
			{
				//if control key do not change active cyclist
				SetActiveCyclist(GetCyclistPreRaceIndexFromTeamAndIndexInTeam(GetMyInRaceTeamId(),i));
				DOW_UpdateActiveGroup();
			}
		}
		else
		{
			if(!iControlKeyState)
			{
				cPanel<<mDOP_UnSelect();
			}
		}
		i=i+1;
	}
	return 1;
}

func i32x DOW_SelectPanelForGroup(i32x _iCyclistIndexInTeam)
{
	//Select the group
	var Gui_Component pthis,cPanel;
	var Gui_dtDirectOrderWindow pdtData;
	var Gui_dtDirectOrderPanel pdtPanelData;
	var i32x iActiveGroupIndex,i;
	
	//println("DOW_SelectPanelForGroup"+itoa(_iCyclistIndexInTeam));

	pthis =GetThis();
	pdtData = GetData(pthis);
	iActiveGroupIndex=GetGroupFromPreRaceCyclistIndex(GetCyclistPreRaceIndexFromTeamAndIndexInTeam(GetMyInRaceTeamId(),_iCyclistIndexInTeam));
	i=0;
	while(i<pdtData.iNumPanelCreated)
	{
		cPanel = GetComponent(pthis,pdtData.iFirstPanelIndex+i);
		pdtPanelData = GetData(cPanel);
		if(iActiveGroupIndex==GetGroupFromPreRaceCyclistIndex(GetCyclistPreRaceIndexFromTeamAndIndexInTeam(GetMyInRaceTeamId(),i)))
			DOW_QuietSelectPanel(i);
		else 
			DOW_QuietUnSelectPanel(i);
		i=i+1;
	}
	
	return 1;
}



func i32x DOW_QuietSelectPanel(i32x _iCyclistIndexInTeam)
{
	var Gui_Component pthis,cPanel;
	var Gui_dtDirectOrderWindow pdtData;

	////println("DOW_QuietSelectPanel");
	pthis =GetThis();
	pdtData = GetData(pthis);
	cPanel=GetComponent(pthis,pdtData.iFirstPanelIndex+_iCyclistIndexInTeam);
	cPanel<<mDOP_Select();

	return 1;
}

func i32x DOW_QuietUnSelectPanel(i32x _iCyclistIndexInTeam)
{
	var Gui_Component pthis,cPanel;
	var Gui_dtDirectOrderWindow pdtData;

	////println("DOW_QuietUnSelectPanel");
	pthis =GetThis();
	pdtData = GetData(pthis);
	cPanel=GetComponent(pthis,pdtData.iFirstPanelIndex+_iCyclistIndexInTeam);
	cPanel<<mDOP_UnSelect();

	return 1;
}



func i32x DOW_SelectAllPanels(Gui_Component _gcSender)
{
	var Gui_Component pthis,cPanel;
	var Gui_dtDirectOrderWindow pdtDOWData;
	var i32x i;
	
	////println("DOW_SelectAllPanels");
	pthis=GetThis();
	pdtDOWData = GetData(pthis);
	
	if(pdtDOWData.iNumPanelCreated)
	{
		if(pdtDOWData.iAllDOPSelectedFlag)
		{
			//unselect all
			pdtDOWData.iAllDOPSelectedFlag=0;
			
			i=0;
			while(i<pdtDOWData.iNumPanelCreated)
			{
				cPanel=GetComponent(pthis,pdtDOWData.iFirstPanelIndex+i);
				cPanel<<mDOP_UnSelect();
				i=i+1;
			}
		}
		else
		{
			//select all
			pdtDOWData.iAllDOPSelectedFlag=1;
			
			i=0;
			while(i<pdtDOWData.iNumPanelCreated)
			{
				cPanel=GetComponent(pthis,pdtDOWData.iFirstPanelIndex+i);
				cPanel<<mDOP_Select();
				i=i+1;
			}
		}
	}
	return 1;
}


func i32x DOW_AddPanelToSelection(Gui_Component _ppanel)
{
	var Gui_Component pthis,cPanel;
	var Gui_dtDirectOrderWindow pdtData;
	var Gui_dtDirectOrderPanel pdtPanelData;
	var Gui_dtPage_Race pdtRaceData;
	var i32x i,iControlKeyState;

	////println("DOW_AddPanelToSelection");

	iControlKeyState=GetKeyState(VK_Control);
	pthis =GetThis();
	pdtData = GetData(pthis);

	i=0;
	while(i<pdtData.iNumPanelCreated)
	{
		cPanel=GetComponent(pthis,pdtData.iFirstPanelIndex+i);
		
		if(cPanel==_ppanel)
		{
			if(!iControlKeyState)
			{
				cPanel<<mDOP_Select();
				//if control key do not change active cyclist
				SetActiveCyclist(GetCyclistPreRaceIndexFromTeamAndIndexInTeam(GetMyInRaceTeamId(),i));
				DOW_UpdateActiveGroup();
			}
			else
			{
				pdtPanelData=GetData(cPanel);
				if(pdtPanelData.iSelected)
				{
					cPanel<<mDOP_UnSelect();
				}
				else
				{
					cPanel<<mDOP_Select();
				}
			}
		}
		else
		{
			if(!iControlKeyState)
			{
				cPanel<<mDOP_UnSelect();
			}
		}
		i=i+1;
	}
	return 1;
}

func i32x DOW_GainFocus()
{
	//take focus
	return 1;
}

func i32x DOW_KeyDown(i32x _iKey,i32x _iCount)
{
	//println("DOW_PanelKeyDown");
	
	if(_iKey==VK_PageUp)
	{
		var Gui_Component pthis;
		var Gui_dtDirectOrderWindow pdtDOWData;
		var Gui_dtDirectOrderPanel pdtDOPData,pdtDOPData2;
		var i32x iMinNotSelectedOrder,i,j,iReorder;
		
		pthis=GetThis();
		pdtDOWData=GetData(pthis);

		//Compute iMinNotSelectedOrder
		iMinNotSelectedOrder=pdtDOWData.iNumPanelCreated;
		i=0;
		while(i<pdtDOWData.iNumPanelCreated)
		{
			pdtDOPData=GetData(GetComponent(pthis,pdtDOWData.iFirstPanelIndex+i));
			if((!pdtDOPData.iSelected)&&(pdtDOPData.iOrder<iMinNotSelectedOrder))
			{
				iMinNotSelectedOrder=pdtDOPData.iOrder;
			}
			i=i+1;
		}
		
		//Order-- for all selected panels > iMinNotSelectedOrder
		i=0;
		while(i<pdtDOWData.iNumPanelCreated)
		{
			pdtDOPData=GetData(GetComponent(pthis,pdtDOWData.iFirstPanelIndex+i));
			if((pdtDOPData.iSelected)&&(pdtDOPData.iOrder>iMinNotSelectedOrder))
			{
				pdtDOPData.iOrder=pdtDOPData.iOrder-1;
			}
			i=i+1;
		}
		
		//Order++ for all not selected panels for whom order = changed order of a selected panel
		//Recursive till no reorder done
		i=0;
		while(i<pdtDOWData.iNumPanelCreated)
		{
			pdtDOPData=GetData(GetComponent(pthis,pdtDOWData.iFirstPanelIndex+i));
			iReorder=0;
			if(!pdtDOPData.iSelected)
			{
				j=0;
				while(j<pdtDOWData.iNumPanelCreated)
				{
					pdtDOPData2=GetData(GetComponent(pthis,pdtDOWData.iFirstPanelIndex+j));
					if((pdtDOPData2.iSelected)&&(i!=j)&&(pdtDOPData2.iOrder==pdtDOPData.iOrder))
					{
						pdtDOPData.iOrder=pdtDOPData.iOrder+1;
						iReorder=1;
					}
					j=j+1;
				}
			}
			if(iReorder==0) i=i+1;
		}
		DOW_UpdatePanelPositions(pthis);
		return 1;
	}//if((_iKey==VK_PageUp)
	else if(_iKey==VK_PageDown)
	{
		var Gui_Component pthis;
		var Gui_dtDirectOrderWindow pdtDOWData;
		var Gui_dtDirectOrderPanel pdtDOPData,pdtDOPData2;
		var i32x iMaxNotSelectedOrder,i,j,iReorder;
		
		pthis=GetThis();
		pdtDOWData=GetData(pthis);

		//Compute iMaxNotSelectedOrder
		iMaxNotSelectedOrder=-1;
		i=0;
		while(i<pdtDOWData.iNumPanelCreated)
		{
			pdtDOPData=GetData(GetComponent(pthis,pdtDOWData.iFirstPanelIndex+i));
			if((!pdtDOPData.iSelected)&&(pdtDOPData.iOrder>iMaxNotSelectedOrder))
			{
				iMaxNotSelectedOrder=pdtDOPData.iOrder;
			}
			i=i+1;
		}
		
		//Order++ for all selected panels > iMinNotSelectedOrder
		//Recursive till no reorder done
		i=0;
		while(i<pdtDOWData.iNumPanelCreated)
		{
			pdtDOPData=GetData(GetComponent(pthis,pdtDOWData.iFirstPanelIndex+i));
			if((pdtDOPData.iSelected)&&(pdtDOPData.iOrder<iMaxNotSelectedOrder))
			{
				pdtDOPData.iOrder=pdtDOPData.iOrder+1;
			}
			i=i+1;
		}
		
		//Order-- for all not selected panels for whom order = changed order of a selected panel
		//Recursive till no reorder done
		i=0;
		while(i<pdtDOWData.iNumPanelCreated)
		{
			pdtDOPData=GetData(GetComponent(pthis,pdtDOWData.iFirstPanelIndex+i));
			iReorder=0;
			if(!pdtDOPData.iSelected)
			{
				j=0;
				while(j<pdtDOWData.iNumPanelCreated)
				{
					pdtDOPData2=GetData(GetComponent(pthis,pdtDOWData.iFirstPanelIndex+j));
					if((pdtDOPData2.iSelected)&&(i!=j)&&(pdtDOPData2.iOrder==pdtDOPData.iOrder))
					{
						pdtDOPData.iOrder=pdtDOPData.iOrder-1;
						iReorder=1;
					}
					j=j+1;
				}
			}
			if(iReorder==0) i=i+1;
		}
		DOW_UpdatePanelPositions(pthis);
		return 1;
	}//else if(_iKey==VK_PageDown)

	return 0;
}

func i32x DOW_UpdatePanelPositions(Gui_Component _pthis)
{
	var Gui_Component cPanel;
	var Gui_dtDirectOrderWindow pdtDOWData;
	var Gui_dtDirectOrderPanel pdtDOPData;
	var Gui_stDOWPanelOrder stDOWPanelOrder;
	var i32x i;
	var i32x iPosX,iPosY;

	//println("DOW_UpdatePanelPositions");

	pdtDOWData=GetData(_pthis);
	//Get ordered panels
	i=0;
	while(i<pdtDOWData.iNumPanelCreated)
	{
		cPanel=GetComponent(_pthis,pdtDOWData.iFirstPanelIndex+i);
		pdtDOPData=GetData(cPanel);
		stDOWPanelOrder.a9_pOrderedPanels[pdtDOPData.iOrder]=cPanel;
		i=i+1;
	}

	//Set positions
	i=0;
	iPosX=0;
	iPosY=20;
	while(i<pdtDOWData.iNumPanelCreated)
	{
		cPanel=stDOWPanelOrder.a9_pOrderedPanels[i];
		pdtDOPData=GetData(cPanel);
		//println(itoa(pdtDOPData.iCyclistIndexInTeam));

		MoveTo(cPanel,iPosX,iPosY);
		iPosX=iPosX+SizeX(cPanel);
		i=i+1;
	}
	return 1;
}

func i32x DOW_UpdateDrawing(Gui_Component _pthis)
{
	var Gui_Component cPanel;
	var Gui_dtDirectOrderWindow pdtDOWData;
	var i32x i;
	
	//println("DOW_UpdatePanelDrawing");
	pdtDOWData=GetData(_pthis);
	i=0;
	while(i<pdtDOWData.iNumPanelCreated)
	{
		cPanel=GetComponent(_pthis,pdtDOWData.iFirstPanelIndex+i);
		//Set group background in Red when active
		cPanel<<mUpdateDrawing();
		i=i+1;
	}

	DOW_UpdateGroupButtonStates(_pthis);
	return 1;
}




func i32x DOW_SortPanelPositions(Gui_Component _pDOW)
{
	var Gui_dtDirectOrderWindow pdtDOWData;
	var Gui_dtDirectOrderPanel pdtDOPData;
	var i32x i;

	pdtDOWData=GetData(_pDOW);
	i=0;
	while(i<pdtDOWData.iNumPanelCreated)
	{
		pdtDOPData=GetData(GetComponent(_pDOW,pdtDOWData.iFirstPanelIndex+GetInTeamSortedCyclistIndexInTeam(GetMyInRaceTeamId(),i)));
		pdtDOPData.iOrder=i;
		i=i+1;
	}
	DOW_UpdatePanelPositions(_pDOW);
}


func i32x DOW_iIsCyclistIndexInFlag(i32x _iCyclistIndexInTeam,i32x _iFlag)
{
	var i32x i,iBit;
	i=0;
	iBit=1;
	while(i<_iCyclistIndexInTeam)
	{
		iBit=iBit*2;
		i=i+1;
	}
	if(_iFlag&iBit) return 1;
	return 0;
}

func i32x DOW_Check(Gui_Component _pthis)
{
	var Gui_Component pthis,cPanel;
	var Gui_dtDirectOrderWindow pdtDOWData;
	//println("DOW_Check");
	pthis=GetThis();
	pdtDOWData = GetData(pthis);
	if(_pthis==pdtDOWData.gcWinTeamDrawingCheckbox)
		SetTeamDrawingIndex(GetMyInRaceTeamId());
	return 1;
}

func i32x DOW_Uncheck(Gui_Component _pthis)
{
	var Gui_Component pthis,cPanel;
	var Gui_dtDirectOrderWindow pdtDOWData;
	
	//println("DOW_Uncheck");
	pthis=GetThis();
	pdtDOWData = GetData(pthis);
	if(_pthis==pdtDOWData.gcWinTeamDrawingCheckbox)
		SetTeamDrawingIndex(-1);
	return 1;
}


func i32x DOW_iGetTeamDrawing(Gui_Component _gcDirectOrderWindow)
{
	var Gui_dtDirectOrderWindow pdtDOWData;
	pdtDOWData = GetData(_gcDirectOrderWindow);
	return Checkbox_bIsChecked(pdtDOWData.gcWinTeamDrawingCheckbox);
}

func i32x DOW_UpdateActiveCyclist()
{
	//Select active cyclist panel
	//println("DOW_UpdateActiveCyclist");

	//Update active cyclist
	if((GetActiveCyclistPreRaceIndex()!=-1)&&(GetCyclistPreRaceTeamIndex(GetActiveCyclistPreRaceIndex())==GetMyInRaceTeamId()))
		DOW_SelectPanel(GetCyclistIndexInTeam(GetActiveCyclistPreRaceIndex()));
	else
		DOW_SelectPanel(-1);//Unselect all

	//Update groups
	DOW_UpdateActiveGroup();

	return 1;
}


func i32x DOW_UpdateActiveGroup()
{
	var Gui_Component pthis,cPanel,cActiveGroupPanel;
	var Gui_dtDirectOrderWindow pdtData;
	var Gui_dtDirectOrderPanel pdtDOPdata;
	var Gui_dtDirectOrderPanelSetting pdtDOPSdata;
	var i32x iActiveGroupIndex,i,iIndex;

	pthis = GetThis();
	pdtData = GetData(pthis);
	iActiveGroupIndex=GetActiveGroupIndex();
	
	//println("DOW_UpdateActiveGroup iActiveGroupIndex="+itoa(iActiveGroupIndex));
	
	i=0;
	pdtData.iActiveGroupPanelIndex=-1;
	while(i<pdtData.iNumPanelCreated)
	{
		iIndex=GetInTeamSortedCyclistIndexInTeam(GetMyInRaceTeamId(),i);
		cPanel=GetComponent(pthis,pdtData.iFirstPanelIndex+iIndex);
		pdtDOPdata=GetData(cPanel);
		pdtDOPSdata=GetData(pdtDOPdata.gcDOPS);
		if((pdtDOPSdata.iInterface==IRS_eInterfaceGroup)&&
			(iActiveGroupIndex==GetGroupFromPreRaceCyclistIndex(GetCyclistPreRaceIndexFromTeamAndIndexInTeam(GetMyInRaceTeamId(),iIndex))))
		{
			if(pdtData.iActiveGroupPanelIndex==-1)
			{
				//Save active DOP to restore Group interface with saved data from DOP
				//print("cActiveGroupPanel:");
				//println(itoa(iIndex));
				cActiveGroupPanel=cPanel;
				pdtData.iActiveGroupPanelIndex=iIndex;
			}
			pdtDOPSdata.iIsGroupActive=1;
		}
		else
		{
			pdtDOPSdata.iIsGroupActive=0;
		}
		i=i+1;
	}
	
	//Restore Group interface with saved data in DOP
	if(pdtData.iActiveGroupPanelIndex!=-1)
	{
		pdtDOPdata=GetData(cActiveGroupPanel);
		pdtDOPSdata=GetData(pdtDOPdata.gcDOPS);
		
		if(pdtDOPSdata.iSavedAttackButtonState!=pdtData.iGroupAttackState)
		{
			//print("pdtDOPdata.iSavedAttackButtonState!=");
			//println(itoa(pdtData.iGroupAttackState));
			pdtData.iGroupAttackState=pdtDOPSdata.iSavedAttackButtonState;
		}
		
		if(pdtDOPSdata.iSavedSprintButtonState!=pdtData.iGroupSprintState)
		{
			//print("pdtDOPdata.iSavedSprintButtonState!=");
			//println(itoa(pdtData.iGroupSprintState));
			pdtData.iGroupSprintState=pdtDOPSdata.iSavedSprintButtonState;
		}
		
		if(pdtDOPSdata.iSavedRelayButtonState!=pdtData.iGroupRelayState)
		{
			//print("pdtDOPdata.iSavedRelayButtonState!=");
			//println(itoa(pdtData.iGroupRelayState));
			pdtData.iGroupRelayState=pdtDOPSdata.iSavedRelayButtonState;
		}
	}

	DOW_UpdateDrawing(pthis);
}
