// Classification panel

func Gui_Component fn_oNewClassPanel()
{
	var Gui_Component pthis,pwindow;
	var Gui_dtClassPanel pdtData;
	var i32x iStageId,iRaceId;
	
	pthis = NewObject(Gui_iClassPanel);	

	// Set Data pointer
	pdtData = new Gui_dtClassPanel;
	SetData(pthis,pdtData);

	// Background
	pdtData.gcBackground = NewBoxFilled(smPanelBackground,g_iScreenWidth,205);
	MountComponent(pthis,pdtData.gcBackground);

	iStageId = Join_GetIntFromIndex(g_oMenuJoins.m_iConfig_iLastStageId,0);
	if(iStageId!=0)
	{
		iRaceId = Join_GetIntFromKey(g_oLocalJoins.m_iStage_iRaceId,iStageId);
		// Class list form
		// Create subset for form
		pdtData.m_iSubsetId = Subset_Constructor("SUBSET_RACE_CLASS",DATABASE_CLIENT);
		Database_AddTables(pdtData.m_iSubsetId,4);
		Table_SetName(pdtData.m_iSubsetId, 0, "DYN_classification_race");
		TableSubset_SelectColumns(pdtData.m_iSubsetId, 0, "*");
		Table_SetName(pdtData.m_iSubsetId, 1, "DYN_cyclist");
		TableSubset_SelectColumns(pdtData.m_iSubsetId, 1, "fkIDcharacteristic");
		Table_SetName(pdtData.m_iSubsetId, 2, "DYN_team");
		TableSubset_SelectColumns(pdtData.m_iSubsetId, 2, "*");
		Table_SetName(pdtData.m_iSubsetId, 3, "DYN_characteristic");
		TableSubset_SelectColumns(pdtData.m_iSubsetId, 3, "*");
		// Select classification of current race 
		Query_Create(0,pdtData.m_iSubsetId);
		Query_SelectTable(	0, "DYN_classification_race");
		Query_SelectTable(	0, "DYN_classification_race.fkIDcyclist.DYN_cyclist");
		Query_SelectTable(	0, "DYN_classification_race.fkIDcyclist.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
		Query_SelectTable(	0, "DYN_classification_race.fkIDteam.DYN_team");
		Query_SelectWhereIntEqual(0,"DYN_classification_race.fkIDrace", iRaceId);
		Query_SelectWhereIntEqual(0,"DYN_classification_race.fkIDcyclist.DYN_cyclist.race_b_withdrawal", 0);
		Query_Execute(0);

		pdtData.gcClassForm = NewRaceClassificationListForm(pdtData.m_iSubsetId,iRaceId);
		pwindow = NewWindow(g_iScreenWidth-5,200);
		pwindow<<WindowMount(pdtData.gcClassForm);
		pdtData.gcClassForm<<FormFilterByIntDifferent("DYN_classification_race.fkIDcyclist",0);
		MountComponent(pthis,pwindow);
		MoveTo(pwindow,2,2);
	}
	else
	{
		pwindow = NewCaption(smTrebuchet,GetLocalizedFromKey(iszNoClassification));
		MountComponent(pthis,pwindow);
		MoveTo(pwindow,2,2);
	}

	StretchTo(pthis,g_iScreenWidth,200);
	return pthis;
}

func void ClassPanel_OnDestroy()
{
	var Gui_Component pthis,pwindow;
	var Gui_dtClassPanel pdtData;
	
	pthis = GetThis();	
	pdtData = GetData(pthis);

	if(pdtData.m_iSubsetId)
	{
		Subset_Destructor(pdtData.m_iSubsetId);
	}
}

