// Cyclist Info panel

func Gui_Component fn_oNewCyclistInfoPanel()
{
	var Gui_Component pthis;
	var Gui_dtCyclistInfoPanel pdtData;
	
	pthis = NewObject(Gui_iCyclistInfoPanel);	

	// Set Data pointer
	pdtData = new Gui_dtCyclistInfoPanel;
	SetData(pthis,pdtData);

	var i32x iValue, iPos_X, iPos_Y0, iPos_Y1, iPos_Y2, iOffset;
	var i32x fValue;
	var i32x iActiveCyclistIndex;
	var szx szString;

	iPos_Y0 = 0;
	iPos_Y1 = 13;
	iPos_Y2 = 26;
	iOffset = 15.0*g_fScreenScaleFactor;
	iActiveCyclistIndex = GetActiveCyclistPreRaceIndex();
	
	// Panel Background
	// Background
	pdtData.gcBackground = NewBoxFilled(smPanelBackground,g_iScreenWidth,46);
	MountComponent(pthis,pdtData.gcBackground);
	MoveTo(pdtData.gcBackground,0,0);

	if(iActiveCyclistIndex!=-1)
	{
		iPos_X = 10;
		
		szString= GetCyclistName(iActiveCyclistIndex);	//name
		szString= szString+" "+strncpy(GetCyclistFirstName(iActiveCyclistIndex),0,1)+".";	//first name
		szString= szString+" ("+GetCyclistTeamNameAbbreviation(iActiveCyclistIndex)+")";	//team name abbreviation
		pdtData.gcName = NewCaption(smTrebuchet,szString);
		SetAlign(pdtData.gcName,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcName);
		MoveTo(pdtData.gcName,iPos_X,iPos_Y0);

		// Riding
		pdtData.gcFlatTitle = NewCaption(smTrebuchet,GetLocalizedFromKey(iszRIDING_ABBREV));
		SetAlign(pdtData.gcFlatTitle,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcFlatTitle);
		MoveTo(pdtData.gcFlatTitle,iPos_X,iPos_Y1);
		iValue = GetCyclistFlatCarac(iActiveCyclistIndex);
		pdtData.gcFlat = NewCaption(smTrebuchet,itoa(iValue));
		SetAlign(pdtData.gcFlat,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcFlat);
		MoveTo(pdtData.gcFlat,iPos_X,iPos_Y2);

		iPos_X = iPos_X + iOffset + SizeX(pdtData.gcFlatTitle);

		// Climbing
		pdtData.gcMountainTitle = NewCaption(smTrebuchet,GetLocalizedFromKey(iszCLIMBING_ABBREV));
		SetAlign(pdtData.gcMountainTitle,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcMountainTitle);
		MoveTo(pdtData.gcMountainTitle,iPos_X,iPos_Y1);
		iValue = GetCyclistMountainCarac(iActiveCyclistIndex);
		pdtData.gcMountain = NewCaption(smTrebuchet,itoa(iValue));
		SetAlign(pdtData.gcMountain,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcMountain);
		MoveTo(pdtData.gcMountain,iPos_X,iPos_Y2);

		iPos_X = iPos_X + iOffset + SizeX(pdtData.gcMountainTitle);

		// Downhilling
		pdtData.gcDescentTitle = NewCaption(smTrebuchet,GetLocalizedFromKey(iszDOWNHILLING_ABBREV));
		SetAlign(pdtData.gcDescentTitle,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcDescentTitle);
		MoveTo(pdtData.gcDescentTitle,iPos_X,iPos_Y1);
		iValue = GetCyclistDescentCarac(iActiveCyclistIndex);
		pdtData.gcDescent = NewCaption(smTrebuchet,itoa(iValue));
		SetAlign(pdtData.gcDescent,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcDescent);
		MoveTo(pdtData.gcDescent,iPos_X,iPos_Y2);


		iPos_X = iPos_X + iOffset*2 + SizeX(pdtData.gcDescentTitle);


		// Sprint
		pdtData.gcSprintTitle = NewCaption(smTrebuchet,GetLocalizedFromKey(iszSPRINT_ABBREV));
		SetAlign(pdtData.gcSprintTitle,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcSprintTitle);
		MoveTo(pdtData.gcSprintTitle,iPos_X,iPos_Y1);
		iValue = GetCyclistSprintCarac(iActiveCyclistIndex);
		pdtData.gcSprint = NewCaption(smTrebuchet,itoa(iValue));
		SetAlign(pdtData.gcSprint,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcSprint);
		MoveTo(pdtData.gcSprint,iPos_X,iPos_Y2);

		iPos_X = iPos_X + iOffset + SizeX(pdtData.gcSprintTitle);

		// Endurance
		pdtData.gcEnduranceTitle = NewCaption(smTrebuchet,GetLocalizedFromKey(iszENDURANCE_ABBREV));
		SetAlign(pdtData.gcEnduranceTitle,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcEnduranceTitle);
		MoveTo(pdtData.gcEnduranceTitle,iPos_X,iPos_Y1);
		iValue = GetCyclistEnduranceCarac(iActiveCyclistIndex);
		pdtData.gcEndurance = NewCaption(smTrebuchet,itoa(iValue));
		SetAlign(pdtData.gcEndurance,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcEndurance);
		MoveTo(pdtData.gcEndurance,iPos_X,iPos_Y2);

		iPos_X = iPos_X + iOffset + SizeX(pdtData.gcEnduranceTitle);

		// Resistance
		pdtData.gcRecoveryTitle = NewCaption(smTrebuchet,GetLocalizedFromKey(iszRESISTANCE_ABBREV));
		SetAlign(pdtData.gcRecoveryTitle,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcRecoveryTitle);
		MoveTo(pdtData.gcRecoveryTitle,iPos_X,iPos_Y1);
		iValue = GetCyclistRecoveryCarac(iActiveCyclistIndex);
		pdtData.gcRecovery = NewCaption(smTrebuchet,itoa(iValue));
		SetAlign(pdtData.gcRecovery,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcRecovery);
		MoveTo(pdtData.gcRecovery,iPos_X,iPos_Y2);

//		iPos_X = iPos_X + 10*g_fScreenScaleFactor + SizeX(pdtData.gcRecoveryTitle);
		// Acceleration

///////////
		iPos_X = iPos_X + iOffset*2 + SizeX(pdtData.gcRecoveryTitle);// gcAcceleration!!

		// Agility
		pdtData.gcAgilityTitle = NewCaption(smTrebuchet,GetLocalizedFromKey(iszAGILITY_ABBREV));
		SetAlign(pdtData.gcAgilityTitle,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcAgilityTitle);
		MoveTo(pdtData.gcAgilityTitle,iPos_X,iPos_Y1);
		iValue = GetCyclistAgilityCarac(iActiveCyclistIndex);
		pdtData.gcAgility = NewCaption(smTrebuchet,itoa(iValue));
		SetAlign(pdtData.gcAgility,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcAgility);
		MoveTo(pdtData.gcAgility,iPos_X,iPos_Y2);

		iPos_X = iPos_X + iOffset*2 + SizeX(pdtData.gcAgilityTitle);

		// Heart Rate
		pdtData.gcHeartRate = NewCaption(smTrebuchet,itoa(GetCyclistHRValue(iActiveCyclistIndex))+" bpm");
		SetAlign(pdtData.gcHeartRate,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcHeartRate);
		MoveTo(pdtData.gcHeartRate,iPos_X,iPos_Y0);

		// Speed
		pdtData.gcSpeed = NewCaption(smTrebuchet,itoa(GetCyclistSpeedValue(iActiveCyclistIndex))+"km/h");
		SetAlign(pdtData.gcSpeed,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcSpeed);
		MoveTo(pdtData.gcSpeed,iPos_X,iPos_Y1);

		// Group
		pdtData.gcGroup = NewCaption(smTrebuchet,"Group: "+GetGroupNameFromPreRaceCyclistIndex(iActiveCyclistIndex));
		SetAlign(pdtData.gcGroup,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcGroup);
		MoveTo(pdtData.gcGroup,iPos_X,iPos_Y2);
	}

	return pthis;
}

func i32x CyclistInfoPanel_OnDestroy()
{
}

func void CyclistInfo_UpdateActiveCyclist()
{
	var Gui_Component pthis;
	var Gui_dtCyclistInfoPanel pdtData;
	var i32x iActiveCyclistIndex;
	var szx szString;
	
	pthis = GetThis();
	pdtData = GetData(pthis);

	iActiveCyclistIndex = GetActiveCyclistPreRaceIndex();

	if(iActiveCyclistIndex!=-1)
	{
		szString= GetCyclistName(iActiveCyclistIndex);	//name
		szString= szString+" "+strncpy(GetCyclistFirstName(iActiveCyclistIndex),0,1)+".";	//first name
		szString= szString+" ("+GetCyclistTeamNameAbbreviation(iActiveCyclistIndex)+")";	//team name abbreviation
		pdtData.gcName<<Caption(szString);
		pdtData.gcFlat<<Caption(itoa(GetCyclistFlatCarac(iActiveCyclistIndex)));
		pdtData.gcMountain<<Caption(itoa(GetCyclistMountainCarac(iActiveCyclistIndex)));
		pdtData.gcDescent<<Caption(itoa(GetCyclistDescentCarac(iActiveCyclistIndex)));
		pdtData.gcSprint<<Caption(itoa(GetCyclistSprintCarac(iActiveCyclistIndex)));
		pdtData.gcEndurance<<Caption(itoa(GetCyclistEnduranceCarac(iActiveCyclistIndex)));
		pdtData.gcRecovery<<Caption(itoa(GetCyclistRecoveryCarac(iActiveCyclistIndex)));
		pdtData.gcAgility<<Caption(itoa(GetCyclistAgilityCarac(iActiveCyclistIndex)));
		pdtData.gcHeartRate<<Caption(itoa(GetCyclistHRValue(iActiveCyclistIndex))+" bpm");
		pdtData.gcSpeed<<Caption(itoa(GetCyclistSpeedValue(iActiveCyclistIndex))+"km/h");
		pdtData.gcGroup<<Caption("Group: "+GetGroupNameFromPreRaceCyclistIndex(iActiveCyclistIndex));
	}
}
