// General Info window

func Gui_Component fn_oNewGeneralInfoWindow()
{
	var Gui_Component pthis;
	var Gui_dtGeneralInfoWindow pdtData;

	print("fn_oNewGeneralInfoWindow\n");
	
	pthis = NewObject(Gui_iGeneralInfoWindow);	

	SetComponentNumber(pthis,32);

	// Set Data pointer
	pdtData = new Gui_dtGeneralInfoWindow;
	SetData(pthis,pdtData);

	// Get member values
	var i32x iButton_PosX, iButton_PosY, iButton_PosY2, iPanel_PosX;
	var i32x iActiveCyclistIndex, iActiveGroupIndex;
	var f32x fTemp;
	
	iButton_PosY = 1;
	iButton_PosY2 = 21;
	iPanel_PosX = 0;
	pdtData.iPanel_PosY = 46;
	
	//Spline angle
	fTemp=GetActiveCyclistSplineAngle();
	fTemp=fTemp*100.0;
	pdtData.iAngleValue = fTemp;

	//Weather
	pdtData.iWeatherIndex = GetWeather();
	if(pdtData.iWeatherIndex>=2)
		pdtData.iWeatherIndex = pdtData.iWeatherIndex+1;
	
	//Wind Speed
	fTemp=GetWindSpeed();
	pdtData.iWindValue = fTemp*3.6;
	pdtData.iWindIndex = pdtData.iWindValue/2;

	if(pdtData.iWindIndex>7)
		pdtData.iWindIndex=7;

	pdtData.iCameraIndex = 0;
	pdtData.iSpeedValue = 1;

	// Panel Background
	pdtData.gcBack=NewBitmap(smFondPanelControl,0);
	SetAlign(pdtData.gcBack,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	StretchTo(pdtData.gcBack,g_iScreenWidth,pdtData.iPanel_PosY);
	MountComponent(pthis,pdtData.gcBack);
	MoveTo(pdtData.gcBack,0,0);

	// FrameText buttons
	iButton_PosX = g_fScreenScaleFactor*2.0;

	// Cyclist Info button + panel
	pdtData.gcCyclistInfoButton=NewCM2InRaceButton("####################",GetLocalizedFromKey(iszigClassifications),GetLocalizedFromKey(iszigCyclistInfo_Contextual));
	iActiveCyclistIndex = GetActiveCyclistPreRaceIndex();
	if(iActiveCyclistIndex!=-1)
	{
		pdtData.gcCyclistInfoButton<<Caption(GetCyclistName(iActiveCyclistIndex));
	}
	MoveTo(pdtData.gcCyclistInfoButton,iButton_PosX,iButton_PosY);
	MountComponent(pthis,pdtData.gcCyclistInfoButton);
	pdtData.gcCyclistInfoPanel = fn_oNewCyclistInfoPanel();
	MountComponent(pthis,pdtData.gcCyclistInfoPanel);
	MoveTo(pdtData.gcCyclistInfoPanel,iPanel_PosX,pdtData.iPanel_PosY);
	pdtData.gcCyclistInfoPanel<<Hide();

	// Classification button + panel
	pdtData.gcClassificationsButton=NewCM2InRaceButton(GetLocalizedFromKey(iszigClassifications),"####################",GetLocalizedFromKey(iszigClassifications_Contextual));
	MoveTo(pdtData.gcClassificationsButton,iButton_PosX,iButton_PosY2);
	MountComponent(pthis,pdtData.gcClassificationsButton);
	pdtData.gcClassificationPanel = fn_oNewClassPanel();
	MountComponent(pthis,pdtData.gcClassificationPanel);
	MoveTo(pdtData.gcClassificationPanel,iPanel_PosX,pdtData.iPanel_PosY);
	pdtData.gcClassificationPanel<<Hide();

	iButton_PosX = iButton_PosX + SizeX(pdtData.gcCyclistInfoButton) + 3.0*g_fScreenScaleFactor;
	
	// Group Info button + panel
	pdtData.gcGroupInfoButton=NewCM2InRaceButton("###",GetLocalizedFromKey(iszigRaceInfo),GetLocalizedFromKey(iszigGroupInfo_Contextual)); 
	iActiveGroupIndex = GetActiveGroupIndex();
	if(iActiveGroupIndex!=g_InRaceClient_DEF_InvalidGroup)
	{
		pdtData.gcGroupInfoButton<<Caption(GetGroupName(iActiveGroupIndex));
	}
	MoveTo(pdtData.gcGroupInfoButton,iButton_PosX,iButton_PosY);
	MountComponent(pthis,pdtData.gcGroupInfoButton);
	pdtData.gcGroupInfoPanel = fn_oNewGroupInfoPanel();
	MountComponent(pthis,pdtData.gcGroupInfoPanel);
	MoveTo(pdtData.gcGroupInfoPanel,iPanel_PosX,pdtData.iPanel_PosY);
	pdtData.gcGroupInfoPanel<<Hide();
	
	// Race Info button
	pdtData.gcRaceInfoButton=NewCM2InRaceButton(GetLocalizedFromKey(iszigRaceInfo),"###",GetLocalizedFromKey(iszigRaceInfo_Contextual));
	MoveTo(pdtData.gcRaceInfoButton,iButton_PosX,iButton_PosY2);
	MountComponent(pthis,pdtData.gcRaceInfoButton);

	iButton_PosX = iButton_PosX + SizeX(pdtData.gcRaceInfoButton) + 3.0*g_fScreenScaleFactor;

	// Events button
	pdtData.gcEventsButton=NewCM2InRaceButton(GetLocalizedFromKey(iszigEvents),GetLocalizedFromKey(iszigProfile),GetLocalizedFromKey(iszigEvents_Contextual));
	MoveTo(pdtData.gcEventsButton,iButton_PosX,iButton_PosY);
	MountComponent(pthis,pdtData.gcEventsButton);

	// Profile button + panel
	pdtData.gcProfileButton=NewCM2InRaceButton(GetLocalizedFromKey(iszigProfile),GetLocalizedFromKey(iszigEvents),GetLocalizedFromKey(iszigProfile_Contextual));
	MoveTo(pdtData.gcProfileButton,iButton_PosX,iButton_PosY2);
	MountComponent(pthis,pdtData.gcProfileButton);
	pdtData.gcProfilePanel=NewGroupProfile2D(Join_GetIntFromIndex(g_oMenuJoins.m_iConfig_iCurrentStageId,0),g_iScreenWidth,72);
	MountComponent(pthis,pdtData.gcProfilePanel);
	MoveTo(pdtData.gcProfilePanel,iPanel_PosX,pdtData.iPanel_PosY);
	pdtData.gcProfilePanel<<Hide();
	pdtData.iProfileShown=0;
	
	iButton_PosX = iButton_PosX + SizeX(pdtData.gcEventsButton) + 3.0*g_fScreenScaleFactor;

	// Chat button
	pdtData.gcChatButton=NewCM2InRaceButton(GetLocalizedFromKey(iszigChat),GetLocalizedFromKey(iszigChat),GetLocalizedFromKey(iszigChat_Contextual));
	MoveTo(pdtData.gcChatButton,iButton_PosX,iButton_PosY);
	MountComponent(pthis,pdtData.gcChatButton);



	//Bitmap buttons
	iButton_PosX = iButton_PosX + SizeX(pdtData.gcChatButton);
	fTemp = (g_iScreenWidth - iButton_PosX - 252)/2;
	iButton_PosX = iButton_PosX + fTemp;

	//Camera Selection
	pdtData.gcCameraSelection=NewCM2BmpButton(smCamMp3Speed,0,3,GetLocalizedFromKey(iszigCamera_Contextual));
	MountComponent(pthis,pdtData.gcCameraSelection);
	MoveTo(pdtData.gcCameraSelection,iButton_PosX,iButton_PosY);
	StretchTo(pdtData.gcCameraSelection,42,42);
	pdtData.iCameraIndex=0;
	SetArea(GetSprite(pdtData.gcCameraSelection),0);
	
	pdtData.gcCameraPanel=fn_oNewCameraPanel();
	MountComponent(pthis,pdtData.gcCameraPanel);
	MoveTo(pdtData.gcCameraPanel,iButton_PosX,pdtData.iPanel_PosY);
	pdtData.gcCameraPanel<<Hide();

	iButton_PosX = iButton_PosX + 42;

	//Mp3 Player
	pdtData.gcMp3Selection=NewCM2BmpButton(smCamMp3Speed,1,3,GetLocalizedFromKey(iszigMp3_Contextual));
	MountComponent(pthis,pdtData.gcMp3Selection);
	MoveTo(pdtData.gcMp3Selection,iButton_PosX,iButton_PosY);
	StretchTo(pdtData.gcMp3Selection,42,42);
	SetArea(GetSprite(pdtData.gcMp3Selection),1);

	pdtData.gcMp3Panel=fn_oNewMp3Panel();
	MountComponent(pthis,pdtData.gcMp3Panel);
	MoveTo(pdtData.gcMp3Panel,iButton_PosX,pdtData.iPanel_PosY);
	pdtData.gcMp3Panel<<Hide();
	
	iButton_PosX = iButton_PosX + 42;

	//Speed Slider
	pdtData.gcSpeedSelection=NewCM2BmpButton(smCamMp3Speed,2,3,GetLocalizedFromKey(iszigSpeed_Contextual));
	MountComponent(pthis,pdtData.gcSpeedSelection);
	MoveTo(pdtData.gcSpeedSelection,iButton_PosX,iButton_PosY);
	StretchTo(pdtData.gcSpeedSelection,42,42);
	pdtData.iSpeedValue=1;
	SetArea(GetSprite(pdtData.gcSpeedSelection),2);

	pdtData.gcSpeedPanel=fn_oNewSpeedPanel();
	MountComponent(pthis,pdtData.gcSpeedPanel);
	MoveTo(pdtData.gcSpeedPanel,iButton_PosX,pdtData.iPanel_PosY);
	pdtData.gcSpeedPanel<<Hide();


	
	iButton_PosX = g_iScreenWidth - 126 - g_fScreenScaleFactor*2.0;

	// Wind Info
	pdtData.gcWindInfo=NewButton(smWind);
	MountComponent(pthis,pdtData.gcWindInfo);
	MoveTo(pdtData.gcWindInfo,iButton_PosX,iButton_PosY);
	StretchTo(pdtData.gcWindInfo,42,42);
	SetArea(GetSprite(pdtData.gcWindInfo),pdtData.iWindIndex);
	AddHelpInterface(pdtData.gcWindInfo,GetLocalizedFromKey(iszigWind_Contextual));

	pdtData.gcWindValue = NewCaption(smBauer,itoa(pdtData.iWindValue));
	StretchTo(pdtData.gcWindValue,14,10);
	SetAlign(pdtData.gcWindValue,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcWindValue);
	MoveTo(pdtData.gcWindValue,iButton_PosX+15,iButton_PosY+3);
	iButton_PosX = iButton_PosX + 42;

	
	//Angle Info
	pdtData.gcAngleInfo=NewButton(smWind);
	MountComponent(pthis,pdtData.gcAngleInfo);
	MoveTo(pdtData.gcAngleInfo,iButton_PosX,iButton_PosY);
	StretchTo(pdtData.gcAngleInfo,42,42);
	SetArea(GetSprite(pdtData.gcAngleInfo),8);
	AddHelpInterface(pdtData.gcAngleInfo,GetLocalizedFromKey(iszigAngle_Contextual));

	pdtData.gcAngleValue = NewCaption(smBauer,itoa(pdtData.iAngleValue));
	StretchTo(pdtData.gcAngleValue,14,10);
	SetAlign(pdtData.gcAngleValue,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcAngleValue);
	MoveTo(pdtData.gcAngleValue,iButton_PosX+15,iButton_PosY+3);
	iButton_PosX = iButton_PosX + 42;


	//Weather value
	pdtData.gcWeatherInfo=NewButton(smWeather);
	MountComponent(pthis,pdtData.gcWeatherInfo);
	MoveTo(pdtData.gcWeatherInfo,iButton_PosX,iButton_PosY);
	StretchTo(pdtData.gcWeatherInfo,42,42);
	SetArea(GetSprite(pdtData.gcWeatherInfo),pdtData.iWeatherIndex);
	AddHelpInterface(pdtData.gcWeatherInfo,GetLocalizedFromKey(iszigWeather_Contextual));

	
	StretchTo(pthis,g_iScreenWidth,87);

	return pthis;
}

func i32x GIW_OnDestroy()
{}

func i32x GIW_iBarSizeX(Gui_Component _pthis)
{
	return 140;
}

func i32x GIW_iBarSizeY(Gui_Component _pthis)
{
	return 20;
}

func i32x GIW_Click(Gui_Component _pComponent)
{
	var Gui_Component pthis;
	var Gui_Component pparent;
	var Gui_dtGeneralInfoWindow pdtData;
	var i32x iSizeY;
	
	pthis = GetThis();
	pdtData = GetData(pthis);

	if(_pComponent==pdtData.gcCameraSelection)
	{
		pdtData.gcMp3Selection<<Uncheck(_pComponent);
		pdtData.gcSpeedSelection<<Uncheck(_pComponent);
		pdtData.gcMp3Panel<<Hide();
		pdtData.gcCameraPanel<<Show();
		pdtData.gcCameraPanel<<Active();
		pdtData.gcSpeedPanel<<Hide();
		iSizeY = RelPosY(pdtData.gcCameraPanel)+SizeY(pdtData.gcCameraPanel);
	}
	else if(_pComponent==pdtData.gcMp3Selection)
	{
		pdtData.gcCameraSelection<<Uncheck(_pComponent);
		pdtData.gcSpeedSelection<<Uncheck(_pComponent);
		pdtData.gcMp3Panel<<Show();
		pdtData.gcCameraPanel<<Hide();
		pdtData.gcSpeedPanel<<Hide();
		iSizeY = RelPosY(pdtData.gcMp3Panel)+SizeY(pdtData.gcMp3Panel);
	}
	else if(_pComponent==pdtData.gcSpeedSelection)
	{
		pdtData.gcMp3Selection<<Uncheck(_pComponent);
		pdtData.gcCameraSelection<<Uncheck(_pComponent);
		pdtData.gcMp3Panel<<Hide();
		pdtData.gcCameraPanel<<Hide();
		pdtData.gcSpeedPanel<<Show();
		iSizeY = RelPosY(pdtData.gcSpeedPanel)+SizeY(pdtData.gcSpeedPanel);
	}
	else if(_pComponent==pdtData.gcGroupInfoButton)
	{
		pdtData.gcChatButton<<Uncheck(_pComponent);
		pdtData.gcClassificationsButton<<Uncheck(_pComponent);
		pdtData.gcCyclistInfoButton<<Uncheck(_pComponent);
		pdtData.gcRaceInfoButton<<Uncheck(_pComponent);
		pdtData.gcEventsButton<<Uncheck(_pComponent);
		pdtData.gcGroupInfoPanel<<Show();
		pdtData.gcProfileButton<<Uncheck(_pComponent);
		pdtData.gcClassificationPanel<<Hide();
		pdtData.gcProfilePanel<<Hide();
		pdtData.iProfileShown=0;
		pdtData.gcCyclistInfoPanel<<Hide();
		iSizeY = RelPosY(pdtData.gcGroupInfoPanel)+SizeY(pdtData.gcGroupInfoPanel);
	}
	else if(_pComponent==pdtData.gcChatButton)
	{
		pdtData.gcGroupInfoButton<<Uncheck(_pComponent);
		pdtData.gcClassificationsButton<<Uncheck(_pComponent);
		pdtData.gcCyclistInfoButton<<Uncheck(_pComponent);
		pdtData.gcRaceInfoButton<<Uncheck(_pComponent);
		pdtData.gcEventsButton<<Uncheck(_pComponent);
		pdtData.gcProfileButton<<Uncheck(_pComponent);
		pdtData.gcProfilePanel<<Hide();
		pdtData.iProfileShown=0;
//		pdtData.gcChat<<Show();
		pdtData.gcCyclistInfoPanel<<Hide();
		pdtData.gcClassificationPanel<<Hide();
		pdtData.gcGroupInfoPanel<<Hide();
		iSizeY = RelPosY(pdtData.gcClassificationPanel)+SizeY(pdtData.gcClassificationPanel);
	}
	else if(_pComponent==pdtData.gcClassificationsButton)
	{
		pdtData.gcChatButton<<Uncheck(_pComponent);
		pdtData.gcGroupInfoButton<<Uncheck(_pComponent);
		pdtData.gcCyclistInfoButton<<Uncheck(_pComponent);
		pdtData.gcRaceInfoButton<<Uncheck(_pComponent);
		pdtData.gcEventsButton<<Uncheck(_pComponent);
		pdtData.gcProfileButton<<Uncheck(_pComponent);
		pdtData.gcProfilePanel<<Hide();
		pdtData.iProfileShown=0;
		pdtData.gcCyclistInfoPanel<<Hide();
		pdtData.gcGroupInfoPanel<<Hide();
		pdtData.gcClassificationPanel<<Show();
		iSizeY = RelPosY(pdtData.gcClassificationPanel)+SizeY(pdtData.gcClassificationPanel);
	}
	else if(_pComponent==pdtData.gcCyclistInfoButton)
	{
		pdtData.gcChatButton<<Uncheck(_pComponent);
		pdtData.gcClassificationsButton<<Uncheck(_pComponent);
		pdtData.gcGroupInfoButton<<Uncheck(_pComponent);
		pdtData.gcRaceInfoButton<<Uncheck(_pComponent);
		pdtData.gcEventsButton<<Uncheck(_pComponent);
		pdtData.gcProfileButton<<Uncheck(_pComponent);
		pdtData.gcProfilePanel<<Hide();
		pdtData.iProfileShown=0;
		pdtData.gcCyclistInfoPanel<<Show();
		pdtData.gcGroupInfoPanel<<Hide();
		pdtData.gcClassificationPanel<<Hide();
		iSizeY = RelPosY(pdtData.gcCyclistInfoPanel)+SizeY(pdtData.gcCyclistInfoPanel);
	}
	else if(_pComponent==pdtData.gcRaceInfoButton)
	{
		pdtData.gcChatButton<<Uncheck(_pComponent);
		pdtData.gcClassificationsButton<<Uncheck(_pComponent);
		pdtData.gcCyclistInfoButton<<Uncheck(_pComponent);
		pdtData.gcGroupInfoButton<<Uncheck(_pComponent);
		pdtData.gcEventsButton<<Uncheck(_pComponent);
		pdtData.gcProfileButton<<Uncheck(_pComponent);
		pdtData.gcProfilePanel<<Hide();
		pdtData.iProfileShown=0;
//		pdtData.gcRaceInfo<<Show();
		pdtData.gcCyclistInfoPanel<<Hide();
		pdtData.gcGroupInfoPanel<<Hide();
		pdtData.gcClassificationPanel<<Hide();
		iSizeY = RelPosY(pdtData.gcClassificationPanel)+SizeY(pdtData.gcClassificationPanel);
	}
	else if(_pComponent==pdtData.gcEventsButton)
	{
		pdtData.gcChatButton<<Uncheck(_pComponent);
		pdtData.gcClassificationsButton<<Uncheck(_pComponent);
		pdtData.gcCyclistInfoButton<<Uncheck(_pComponent);
		pdtData.gcRaceInfoButton<<Uncheck(_pComponent);
		pdtData.gcGroupInfoButton<<Uncheck(_pComponent);
		pdtData.gcProfileButton<<Uncheck(_pComponent);
		pdtData.gcProfilePanel<<Hide();
		pdtData.iProfileShown=0;
//		pdtData.gcEvents<<Show();
		pdtData.gcCyclistInfoPanel<<Hide();
		pdtData.gcGroupInfoPanel<<Hide();
		pdtData.gcClassificationPanel<<Hide();
		iSizeY = RelPosY(pdtData.gcClassificationPanel)+SizeY(pdtData.gcClassificationPanel);
	}
	else if(_pComponent==pdtData.gcProfileButton)
	{
		pdtData.gcChatButton<<Uncheck(_pComponent);
		pdtData.gcClassificationsButton<<Uncheck(_pComponent);
		pdtData.gcCyclistInfoButton<<Uncheck(_pComponent);
		pdtData.gcRaceInfoButton<<Uncheck(_pComponent);
		pdtData.gcGroupInfoButton<<Uncheck(_pComponent);
		pdtData.gcEventsButton<<Uncheck(_pComponent);
		pdtData.gcCyclistInfoPanel<<Hide();
		pdtData.gcProfilePanel<<Show();
		pdtData.iProfileShown=1;
		pdtData.gcGroupInfoPanel<<Hide();
		pdtData.gcClassificationPanel<<Hide();
		iSizeY = RelPosY(pdtData.gcProfilePanel)+SizeY(pdtData.gcProfilePanel);
	}
	
	if(pdtData.iProfileShown)
	{
		//mao debug maximum size when profile drawn
		iSizeY = RelPosY(pdtData.gcProfilePanel)+SizeY(pdtData.gcProfilePanel);
	}

	if(iSizeY<80) iSizeY = 80;
	StretchTo(pthis,g_iScreenWidth,iSizeY);

	pparent=GetParent(pthis);
	pparent<<WindowUpdate();
}

func i32x GIW_Uncheck(Gui_Component _pComponent)
{
	var Gui_Component pthis;
	var Gui_Component pparent;
	var Gui_dtGeneralInfoWindow pdtData;
	
	pthis = GetThis();
	pdtData = GetData(pthis);

	if(_pComponent==pdtData.gcCameraSelection)
	{
		pdtData.gcCameraPanel<<Hide();
	}
	else if(_pComponent==pdtData.gcMp3Selection)
	{
		pdtData.gcMp3Panel<<Hide();
	}
	else if(_pComponent==pdtData.gcSpeedSelection)
	{
		pdtData.gcSpeedPanel<<Hide();
	}
	else if(_pComponent==pdtData.gcGroupInfoButton)
	{
		pdtData.gcGroupInfoPanel<<Hide();
	}
/*	else if(_pComponent==pdtData.gcChatButton)
	{
		pdtData.gcChat<<Hide();
	}
*/	else if(_pComponent==pdtData.gcClassificationsButton)
	{
		pdtData.gcClassificationPanel<<Hide();
	}
	else if(_pComponent==pdtData.gcCyclistInfoButton)
	{
		pdtData.gcCyclistInfoPanel<<Hide();
	}
/*	else if(_pComponent==pdtData.gcRaceInfoButton)
	{
		pdtData.gcRaceInfo<<Hide();
	}
	else if(_pComponent==pdtData.gcEventsButton)
	{
		pdtData.gcEvents<<Hide();
	}
*/	else if(_pComponent==pdtData.gcProfileButton)
	{
		pdtData.gcProfilePanel<<Hide();
		pdtData.iProfileShown=0;
	}

	StretchTo(pthis,g_iScreenWidth,87);


	pparent=GetParent(pthis);
	pparent<<WindowUpdate();
}

func i32x GIW_MouseDown(i32x _iX,i32x _iY,i32x _iButton)
{
	return 1;
}	

func i32x GIW_mSelectGroup(i32x _iGroupIndex)
{
	var Gui_Component pthis,pparent;
	pthis =GetThis();
	pparent=GetParent(pthis);
	pparent<<mSelectGroup(_iGroupIndex);
	return 1;
}

func i32x GIW_mSelectSprint(i32x _iSprint)
{
	var Gui_Component pthis,pparent;
	pthis =GetThis();
	pparent=GetParent(pthis);
	pparent<<mSelectSprint(_iSprint);
	return 1;
}

func i32x GIW_OnLoop(f32x _fDelay)
{
	var Gui_Component pthis;
	var Gui_dtGeneralInfoWindow pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	var f32x fTemp;
	var i32x iTemp, iActiveCyclistIndex, iActiveGroupIndex;

	//Spline angle
	fTemp=GetActiveCyclistSplineAngle();
	fTemp=fTemp*100.0;
	pdtData.iAngleValue = fTemp;
	pdtData.gcAngleValue<<Caption(itoa(pdtData.iAngleValue));

	//Wind Speed
	fTemp=GetWindSpeed();
	pdtData.iWindValue = fTemp*3.6;
	pdtData.iWindIndex = pdtData.iWindValue/2;
	SetArea(GetSprite(pdtData.gcWindInfo),pdtData.iWindIndex);
	pdtData.gcWindValue<<Caption(itoa(pdtData.iWindValue));

	//Cyclist name
	iActiveCyclistIndex = GetActiveCyclistPreRaceIndex();
	if(iActiveCyclistIndex!=-1)
	{
		pdtData.gcCyclistInfoButton<<Caption(GetCyclistName(iActiveCyclistIndex));
	}

	//Group name
	iActiveGroupIndex = GetActiveGroupIndex();
	if(iActiveGroupIndex!=g_InRaceClient_DEF_InvalidGroup)
	{
		pdtData.gcGroupInfoButton<<Caption(GetGroupName(iActiveGroupIndex));
	}

	return 1;
}

func i32x GIW_OnUpdateActiveCyclist()
{
	var Gui_Component pthis;
	var Gui_dtGeneralInfoWindow pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtData.gcCyclistInfoPanel<<mUpdateActiveCyclist();
	pdtData.gcGroupInfoPanel<<mUpdateActiveCyclist();

	return 1;
}
