// Group Info panel

func Gui_Component fn_oNewGroupInfoPanel()
{
	var Gui_Component pthis;
	var Gui_dtGroupInfoPanel pdtData;
	
	pthis = NewObject(Gui_iGroupInfoPanel);	

	// Set Data pointer
	pdtData = new Gui_dtGroupInfoPanel;
	SetData(pthis,pdtData);

	var i32x iActiveGroupIndex, iCyclistPreRaceIndex;
	var f32x fTimeAdvance, fPercentage, fDistance;

	var i32x iPos_X, iPos_Y1, iPos_Y2, iOffset;

	iPos_X = 10;
	iPos_Y1 = 0;
	iPos_Y2 = 15;
	iOffset = 30.0*g_fScreenScaleFactor;

	// Panel Background
	pdtData.gcBackground = NewBoxFilled(smPanelBackground,g_iScreenWidth,35);
	MountComponent(pthis,pdtData.gcBackground);
	MoveTo(pdtData.gcBackground,0,0);

	iActiveGroupIndex = GetActiveGroupIndex();

	if(iActiveGroupIndex!=g_InRaceClient_DEF_InvalidGroup)
	{
		// Group name title
		pdtData.gcGroupNameTitle = NewCaption(smTrebuchet,GetLocalizedFromKey(iszigGroupName)+": ");
		SetAlign(pdtData.gcGroupNameTitle,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcGroupNameTitle);
		MoveTo(pdtData.gcGroupNameTitle,iPos_X,iPos_Y1);

		// Group time advance title
		pdtData.gcGroupTimeAdvanceTitle = NewCaption(smTrebuchet,GetLocalizedFromKey(iszigTimeAdvance)+": ");
		SetAlign(pdtData.gcGroupTimeAdvanceTitle,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcGroupTimeAdvanceTitle);
		MoveTo(pdtData.gcGroupTimeAdvanceTitle,iPos_X,iPos_Y2);


		iPos_X = iPos_X + 100;

		// Group name
		pdtData.gcGroupName = NewCaption(smTrebuchet,GetGroupName(iActiveGroupIndex));
		SetAlign(pdtData.gcGroupName,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcGroupName);
		MoveTo(pdtData.gcGroupName,iPos_X,iPos_Y1);

		//Group time advance
		pdtData.gcGroupTimeAdvance = NewCaption(smTrebuchet,"0");
		SetAlign(pdtData.gcGroupTimeAdvance,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcGroupTimeAdvance);
		MoveTo(pdtData.gcGroupTimeAdvance,iPos_X,iPos_Y2);


		iPos_X = iPos_X + iOffset + 40;

		// Distance to the arrival title
		fPercentage=100.0-GetGroupSplinePercentageDone(iActiveGroupIndex);
		fDistance=GetRaceDistanceFromSplinePercentageDone(fPercentage);
		pdtData.gcDistanceToEndTitle = NewCaption(smTrebuchet,GetLocalizedFromKey(iszigArrival)+": ");
		SetAlign(pdtData.gcDistanceToEndTitle,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcDistanceToEndTitle);
		MoveTo(pdtData.gcDistanceToEndTitle,iPos_X,iPos_Y1);
		
		// Distance to next sprint title
		pdtData.gcDistanceToSprintTitle = NewCaption(smTrebuchet,GetLocalizedFromKey(iszigNextSprint)+": ");
		SetAlign(pdtData.gcDistanceToSprintTitle,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcDistanceToSprintTitle);
		MoveTo(pdtData.gcDistanceToSprintTitle,iPos_X,iPos_Y2);


		iPos_X = iPos_X + 90;

		//Distance to the arrival
		pdtData.gcDistanceToEnd = NewCaption(smTrebuchet,ftoa(1.0*fDistance));
		SetAlign(pdtData.gcDistanceToEnd,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcDistanceToEnd);
		MoveTo(pdtData.gcDistanceToEnd,iPos_X,iPos_Y1);

		//Distance to next sprint
		pdtData.gcDistanceToSprint = NewCaption(smTrebuchet,"0");
		SetAlign(pdtData.gcDistanceToSprint,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
		MountComponent(pthis,pdtData.gcDistanceToSprint);
		MoveTo(pdtData.gcDistanceToSprint,iPos_X,iPos_Y2);


		// 4 firsts cyclists of the group
		if(GetNbCyclistsInGroup(iActiveGroupIndex)>3)
		{
			iPos_X = iPos_X + 70;

			// First cyclist
			iCyclistPreRaceIndex = GetRateSortedCyclistPreRaceIndexFromGroup(iActiveGroupIndex,0);
			pdtData.gcCyclist1Title = NewCaption(smTrebuchet,GetLocalizedFromKey(iszigFirst)+": ");
			SetAlign(pdtData.gcCyclist1Title,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
			MountComponent(pthis,pdtData.gcCyclist1Title);
			MoveTo(pdtData.gcCyclist1Title,iPos_X,iPos_Y1);
			pdtData.gcCyclist1 = NewCaption(smTrebuchet,GetCyclistName(iCyclistPreRaceIndex));
			SetAlign(pdtData.gcCyclist1,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
			MountComponent(pthis,pdtData.gcCyclist1);
			MoveTo(pdtData.gcCyclist1,iPos_X+50,iPos_Y1);

			// Third cyclist
			iCyclistPreRaceIndex = GetRateSortedCyclistPreRaceIndexFromGroup(iActiveGroupIndex,2);
			pdtData.gcCyclist3Title = NewCaption(smTrebuchet,GetLocalizedFromKey(iszigThird)+": ");
			SetAlign(pdtData.gcCyclist3Title,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
			MountComponent(pthis,pdtData.gcCyclist3Title);
			MoveTo(pdtData.gcCyclist3Title,iPos_X,iPos_Y2);
			pdtData.gcCyclist3 = NewCaption(smTrebuchet,GetCyclistName(iCyclistPreRaceIndex));
			SetAlign(pdtData.gcCyclist3,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
			MountComponent(pthis,pdtData.gcCyclist3);
			MoveTo(pdtData.gcCyclist3,iPos_X+50,iPos_Y2);


			iPos_X = iPos_X + iOffset + 50 + SizeX(pdtData.gcCyclist1);

			// Second cyclist
			iCyclistPreRaceIndex = GetRateSortedCyclistPreRaceIndexFromGroup(iActiveGroupIndex,1);
			pdtData.gcCyclist2Title = NewCaption(smTrebuchet,GetLocalizedFromKey(iszigSecond)+": ");
			SetAlign(pdtData.gcCyclist2Title,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
			MountComponent(pthis,pdtData.gcCyclist2Title);
			MoveTo(pdtData.gcCyclist2Title,iPos_X,iPos_Y1);
			pdtData.gcCyclist2 = NewCaption(smTrebuchet,GetCyclistName(iCyclistPreRaceIndex));
			SetAlign(pdtData.gcCyclist2,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
			MountComponent(pthis,pdtData.gcCyclist2);
			MoveTo(pdtData.gcCyclist2,iPos_X+50,iPos_Y1);

			// Fourth cyclist
			iCyclistPreRaceIndex = GetRateSortedCyclistPreRaceIndexFromGroup(iActiveGroupIndex,3);
			pdtData.gcCyclist4Title = NewCaption(smTrebuchet,GetLocalizedFromKey(iszigFourth)+": ");
			SetAlign(pdtData.gcCyclist4Title,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
			MountComponent(pthis,pdtData.gcCyclist4Title);
			MoveTo(pdtData.gcCyclist4Title,iPos_X,iPos_Y2);
			pdtData.gcCyclist4 = NewCaption(smTrebuchet,GetCyclistName(iCyclistPreRaceIndex));
			SetAlign(pdtData.gcCyclist4,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
			MountComponent(pthis,pdtData.gcCyclist4);
			MoveTo(pdtData.gcCyclist4,iPos_X+50,iPos_Y2);
		}
	}

	return pthis;
}

func i32x GroupInfoPanel_OnDestroy()
{
}

func void GroupInfo_UpdateActiveCyclist()
{
	var Gui_Component pthis;
	var Gui_dtGroupInfoPanel pdtData;
	
	var i32x iActiveGroupIndex, iCyclistPreRaceIndex;
	var f32x fTimeAdvance, fPercentage, fDistance;

	pthis = GetThis();
	pdtData = GetData(pthis);

	iActiveGroupIndex = GetActiveGroupIndex();

	if(iActiveGroupIndex!=g_InRaceClient_DEF_InvalidGroup)
	{
		// Group name
		pdtData.gcGroupName<<Caption(GetGroupName(iActiveGroupIndex));

		// Group time advance
		if(iActiveGroupIndex<GetNbGroups()-1)
		{
			fTimeAdvance = 10.0*GetGroupTimeAdvance(iActiveGroupIndex);
			pdtData.gcGroupTimeAdvance<<Caption(GetHMS(fTimeAdvance));
		}
		else
		{
			pdtData.gcGroupTimeAdvance<<Caption("");
		}


		// Distance to the arrival
		fPercentage=100.0-GetGroupSplinePercentageDone(iActiveGroupIndex);
		fDistance=GetRaceDistanceFromSplinePercentageDone(fPercentage);
		pdtData.gcDistanceToEnd<<Caption(itoa(1.0*fDistance));
		
		// Distance to the next sprint

		// 4 firsts cyclists of the group
		if(GetNbCyclistsInGroup(iActiveGroupIndex)>0)
		{
			// First cyclist
			iCyclistPreRaceIndex = GetRateSortedCyclistPreRaceIndexFromGroup(iActiveGroupIndex,0);
			pdtData.gcCyclist1<<Caption(GetCyclistName(iCyclistPreRaceIndex));
		}
		else
		{
			pdtData.gcCyclist1<<Caption(" ");
		}

		if(GetNbCyclistsInGroup(iActiveGroupIndex)>1)
		{
			// Second cyclist
			iCyclistPreRaceIndex = GetRateSortedCyclistPreRaceIndexFromGroup(iActiveGroupIndex,1);
			pdtData.gcCyclist2<<Caption(GetCyclistName(iCyclistPreRaceIndex));
		}
		else
		{
			pdtData.gcCyclist2<<Caption(" ");
		}

		if(GetNbCyclistsInGroup(iActiveGroupIndex)>2)
		{
			// Third cyclist
			iCyclistPreRaceIndex = GetRateSortedCyclistPreRaceIndexFromGroup(iActiveGroupIndex,2);
			pdtData.gcCyclist3<<Caption(GetCyclistName(iCyclistPreRaceIndex));
		}
		else
		{
			pdtData.gcCyclist3<<Caption(" ");
		}

		if(GetNbCyclistsInGroup(iActiveGroupIndex)>3)
		{
			// Fourth cyclist
			iCyclistPreRaceIndex = GetRateSortedCyclistPreRaceIndexFromGroup(iActiveGroupIndex,3);
			pdtData.gcCyclist4<<Caption(GetCyclistName(iCyclistPreRaceIndex));
		}
		else
		{
			pdtData.gcCyclist4<<Caption(" ");
		}
	}
}
