func void Race_OnInitData()
{
	var Gui_Component pthis;
	var Gui_dtPage_Race pdtData;
	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_Race;
	SetData(pthis,pdtData);
}
func i32x Race_OnCreate()
{
	var Gui_Component pthis,parent;
	var Gui_dtPage_Race pdtData;
	var f32x fValue;

	// get this pointer
	pthis = GetThis();

	SetComponentNumber(pthis,32);

	// Set Data pointer
	pdtData = GetData(pthis);

	pdtData.iTakeScreenshot = 0;
	pdtData.iCurrentCamera = 0;
	pdtData.iMouseX = 0;
	pdtData.iMouseY = 0;

	pdtData.iCurrentCyclistInfo=IRC_CyclistInfoNull;
	
	// Create general info window
	pdtData.gcGeneralInfoWindow = fn_oNewGeneralInfoWindow();
	MountComponent(pthis,pdtData.gcGeneralInfoWindow);
	pdtData.iGIWPosX=0;
	pdtData.iGIWPosY=0;
	MoveTo(pdtData.gcGeneralInfoWindow,pdtData.iGIWPosX,pdtData.iGIWPosY);
		
/*	// Create weather info window
	pdtData.gcWeatherInfoWindow = fn_oNewWeatherInfoWindow();
	MountComponent(pthis,pdtData.gcWeatherInfoWindow);
	pdtData.iWIWPosX=0;
	pdtData.iWIWPosY=60;
	MoveTo(pdtData.gcWeatherInfoWindow,pdtData.iWIWPosX,pdtData.iWIWPosY);
		
	// Create tools window
	pdtData.gcToolsWindow = fn_oNewToolsWindow();
	MountComponent(pthis,pdtData.gcToolsWindow);
	pdtData.iTWPosX=0;
	pdtData.iTWPosY=140;
	MoveTo(pdtData.gcToolsWindow,pdtData.iTWPosX,pdtData.iTWPosY);
*/		

	//Help bar
	/*pdtData.gcHelpBar=NewBitmap(smDOPanelBarre,1);
	SetAlign(pdtData.gcHelpBar,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(pthis,pdtData.gcHelpBar);
	MoveTo(pdtData.gcHelpBar,0,g_iScreenHeight-20);
	//SetArea(GetSprite(pdtData.gcHelpBar),1);
	StretchTo(pdtData.gcHelpBar,800.0*g_fScreenScaleFactor,20);
	*/

	// Create cyclist panel
	pdtData.gcDirectOrderWindow = fn_oNewDirectOrderWindow(9);
	MountComponent(pthis,pdtData.gcDirectOrderWindow);
	
	println("g_iScreenHeight="+itoa(g_iScreenHeight));
	println("SizeY="+itoa(SizeY(pdtData.gcDirectOrderWindow)));
	MoveTo(pdtData.gcDirectOrderWindow,0,g_iScreenHeight-SizeY(pdtData.gcDirectOrderWindow));//-20);


	// Create AIData window
	if(isAIdebug())
	{
		pdtData.gcAIDataWindow = fn_oNewAIDataWindow("AIDRAW");
		MountComponent(pthis,pdtData.gcAIDataWindow);
		pdtData.iAIDWPosX=0;
		pdtData.iAIDWPosY=g_iScreenHeight-SizeY(pdtData.gcDirectOrderWindow)-SizeY(pdtData.gcAIDataWindow);
		MoveTo(pdtData.gcAIDataWindow,pdtData.iAIDWPosX,pdtData.iAIDWPosY);
	}

	// Create debug data window
	if(isAIdebug())
	{
		pdtData.gcDebugDataWindow = fn_oNewDebugDataWindow("DebugDataWindow");
		MountComponent(pthis,pdtData.gcDebugDataWindow);
		pdtData.iDDWPosX=g_iScreenWidth-SizeX(pdtData.gcDebugDataWindow);
		pdtData.iDDWPosY=g_iScreenHeight-SizeY(pdtData.gcDirectOrderWindow)-SizeY(pdtData.gcDebugDataWindow);
		MoveTo(pdtData.gcDebugDataWindow,pdtData.iDDWPosX,pdtData.iDDWPosY);
	}




	// Stretch page
	StretchTo(pthis,Race_iSizeX(pthis),Race_iSizeY(pthis));

	//Camera management
	Race_LoadCameraPositions(pthis);

	//Fog management
	CreateFogs(4);
	UpdateFogsParameters();
	SelectFog(0);

	print("Create Race window OK\n");

	parent = GetParent(pthis);
	if(parent) parent<<RaceConnect();

	//Select first panel
	/*{
		var Gui_dtDirectOrderWindow pdtDOWData;
		pdtDOWData=GetData(pdtData.gcDirectOrderWindow);
		if(pdtDOWData.iNumPanelCreated) 
		{
			pdtData.gcDirectOrderWindow<<mDOW_SelectPanel(0);
		}
	}*/

	return 1;
}

func i32x Race_OnDestroy()
{
	println("RaceDestroy OK");
	// uninit System test page
}

func void Race_OnRelease()
{
	var Gui_Component pthis,ptmp,parent;
	var i32x i,iNumComponents;
	var Gui_dtPage_Race pdtData;

	print("Release race...");
	pthis = GetThis();
	pdtData = GetData(pthis);

	parent = GetParent(pthis);
	if(parent) parent<<RaceDisconnect();

	iNumComponents = GetComponentNumber(pthis);
	i=0;
	while(i<iNumComponents)
	{
		ptmp = GetComponent(pthis,i);
		if(ptmp)
		{
			DeleteComponent(ptmp);
		}
		i=i+1;
	}

	pdtData.gcAIDataWindow = NULL;
	pdtData.gcDebugDataWindow = NULL;
	pdtData.gcDirectOrderWindow = NULL;
	pdtData.gcGeneralInfoWindow = NULL;
//	pdtData.gcWeatherInfoWindow = NULL;
//	pdtData.gcToolsWindow = NULL;
	pdtData.gcPodium = NULL;
	pdtData.bShowPodium = false;
	print(" Ok !\n");
}

func i32x Race_iSizeX(Gui_Component _pthis)
{
	return g_iScreenWidth;
}

func i32x Race_iSizeY(Gui_Component _pthis)
{
	return g_iScreenHeight;
}

// Page Race implementation
func i32x Race_OnGainFocus()
{
	// Take focus
	return 1;
}
func i32x Race_OnKeyDown(i32x _iKey,i32x _iCount)
{
	var Gui_Component pthis,pparent;
	var Gui_dtPage_Race pdtData;
	// get this pointer
	pthis = GetThis();
	pdtData = GetData(pthis);

	if(_iKey == VK_Left)
	{
		// Previous cyclist
		if(GetActiveCamera()==CameraManFollowCyclist)
		{
			if(DOW_iGetTeamDrawing(pdtData.gcDirectOrderWindow))
				SetNextActiveCyclistInTeam(GetMyInRaceTeamId());
			else
				SetNextActiveCyclist();
			Race_UpdateActiveCyclist();
		}
	}
	else if(_iKey == VK_Right)
	{
		// Next cyclist
		if(GetActiveCamera()==CameraManFollowCyclist)
		{
			// next active cyclist
			if(DOW_iGetTeamDrawing(pdtData.gcDirectOrderWindow))
				SetPreviousActiveCyclistInTeam(GetMyInRaceTeamId());
			else 
				SetPreviousActiveCyclist();
			Race_UpdateActiveCyclist();
		}
	}
	else if(_iKey==VK_Up)
	{
		if(GetActiveCamera()==CameraManFollowCyclist)
		{
				SetPreviousActiveCyclistInTeam(GetMyInRaceTeamId());
			Race_UpdateActiveCyclist();
		}
	}
	else if(_iKey==VK_Down)
	{
		if(GetActiveCamera()==CameraManFollowCyclist)
		{
			SetNextActiveCyclistInTeam(GetMyInRaceTeamId());
			Race_UpdateActiveCyclist();
		}
	}
	else if(_iKey == VK_F5)
	{
		//cameraman free
		if(GetActiveCamera()!=CameraManFree)
		{
			if(!isDemo())
			{
				SetActiveCamera(CameraManFree);
			}
		}
	}
	else if(_iKey == VK_F4)
	{
		//cameraman path
		if(GetActiveCamera()!=CameraManBus)
		{
			if(isAIdebug())
			{
				SetActiveCamera(CameraManBus);
			}
		}
	}
	else if(_iKey == VK_F6)
	{
		//cameraman path
		if(GetActiveCamera()!=CameraManPath)
		{
			if(!isDemo())
			{
				SetActiveCamera(CameraManPath);
			}
		}
	}
	/*else if ((_iKey == VK_F7)&&(GetActiveCamera()!=CameraManPodium))
	{
		//cameraman follow cyclist
		if (GetActiveCamera()!=CameraManFollowCyclist)
		{
			SetActiveCamera(CameraManFollowCyclist);
		}
		else
		{
			//Change camera path
			pdtData.iCurrentCamera=pdtData.iCurrentCamera+1;
			
			if (pdtData.iCurrentCamera>=9)
				pdtData.iCurrentCamera=0;
			SelectInRaceCamera(pdtData.iCurrentCamera);
		}
	}*/
	else if(_iKey == VK_T)
	{
		var Gui_dtDirectOrderWindow pdtDOWData;
		SetTeamDrawingIndex(GetMyInRaceTeamId());
		pdtDOWData=GetData(pdtData.gcDirectOrderWindow);
		pdtDOWData.gcWinTeamDrawingCheckbox<<QuietCheck();
	}
	else if((_iKey == VK_L)&&(isAIdebug()))
	{
		//Goto the current zone leader of the active cyclist
		var i32x iCyclistIndex;
		iCyclistIndex=GetActiveCyclistPreRaceIndex();
		SetZoneLeaderActiveCyclist(iCyclistIndex);
	}
	else if((_iKey == VK_N)&&(isAIdebug()))
	{
		pdtData.iCurrentCyclistInfo=IRC_CyclistInfoNull;
		SetCyclistInfo(pdtData.iCurrentCyclistInfo);
	}
	else if((_iKey == VK_E)&&(isAIdebug()))
	{
		pdtData.iCurrentCyclistInfo=IRC_CyclistInfoEffort;
		SetCyclistInfo(pdtData.iCurrentCyclistInfo);
	}
	else if((_iKey == VK_A)&&(isAIdebug()))
	{
		pdtData.iCurrentCyclistInfo=IRC_CyclistInfoAction;
		SetCyclistInfo(pdtData.iCurrentCyclistInfo);
	}
	else if((_iKey == VK_R)&&(isAIdebug()))
	{
		pdtData.iCurrentCyclistInfo=IRC_CyclistInfoRole;
		SetCyclistInfo(pdtData.iCurrentCyclistInfo);
	}
	else if((_iKey == VK_G)&&(isAIdebug()))
	{
		pdtData.iCurrentCyclistInfo=IRC_CyclistInfoGroupTactic;
		SetCyclistInfo(pdtData.iCurrentCyclistInfo);
	}
	else if((_iKey == VK_S)&&(isAIdebug()))
	{
		pdtData.iCurrentCyclistInfo=IRC_CyclistInfoGroupStrategy;
		SetCyclistInfo(pdtData.iCurrentCyclistInfo);
	}
	else if((_iKey == VK_X)&&(isAIdebug()))
	{
		pdtData.iCurrentCyclistInfo=IRC_CyclistInfoExternalPower;
		SetCyclistInfo(pdtData.iCurrentCyclistInfo);
	}
	else if((_iKey == VK_Q)&&(isAIdebug()))
	{
		pdtData.iCurrentCyclistInfo=IRC_CyclistInfoRelativeAcc;
		SetCyclistInfo(pdtData.iCurrentCyclistInfo);
	}
	else if((_iKey == VK_W)&&(isAIdebug()))
	{
		pdtData.iCurrentCyclistInfo=IRC_CyclistInfoPMax;
		SetCyclistInfo(pdtData.iCurrentCyclistInfo);
	}
	else if((_iKey == VK_B)&&(isAIdebug()))
	{
			var i32x i;
			i=GetActiveCyclistPreRaceIndex();
			if(pdtData.iCurrentCyclistInfo==IRC_CyclistInfoEffort)
					g_pMenuServerSocket <<  mAIBreak (i,IRS_DebugAIPhysic);
			else if(pdtData.iCurrentCyclistInfo==IRC_CyclistInfoAction)
				g_pMenuServerSocket <<  mAIBreak (i,IRS_DebugAIAction);
			else if(pdtData.iCurrentCyclistInfo==IRC_CyclistInfoRole)
				g_pMenuServerSocket <<  mAIBreak (i,IRS_DebugAIRole);
			else if(pdtData.iCurrentCyclistInfo==IRC_CyclistInfoGroupTactic)
				g_pMenuServerSocket <<  mAIBreak (i,IRS_DebugAITactic);
	}
	else if(_iKey == VK_F)
	{
		if(isAIdebug())
		{
			var i32x i;
			i=GetActiveCyclistPreRaceIndex();
			g_pMenuServerSocket <<  mAIFall (i);
		}
	}
	else if ((_iKey>=VK_1) && (_iKey<=VK_5))
	{
		// choose camera for cyclist or sprint
		var i32x i;
		
		i = _iKey - VK_1;
		if ((GetActiveCamera()==0) || (GetActiveCamera()==3))
		{
			if (i<pdtData.iNbCameras)
			{
				pdtData.iCurrentCamera=i;
				SelectInRaceCamera(i);
			}
		}
	}
	else if(_iKey == VK_F2)
	{
		if(isdebug())
		{
			Race_SaveCameraPositions(pthis);
		}
	}
	else if(_iKey == VK_Escape)
	{
		//Return to menu page
		pparent = GetParent(pthis);

		// Back
		pparent<<GoBack();

		//ExitNow();
	}
	else if((_iKey == VK_C)&&(GetKeyState(VK_Control)))
	{
		if(isAIdebug())
			SetNextActiveBus();
	}
	else if(_iKey == VK_H)
	{
		if(isdebug())
		{
			if(pdtData.iTakeScreenshot)
			{
				if(isAIdebug())
				{
					pdtData.gcAIDataWindow<<Show();
					pdtData.gcDebugDataWindow<<Show();
				}
				pdtData.gcDirectOrderWindow<<Show();
				pdtData.gcGeneralInfoWindow<<Show();
//				pdtData.gcWeatherInfoWindow<<Show();
//				pdtData.gcToolsWindow<<Show();
				pdtData.iTakeScreenshot=0;
			}
			else
			{
				if(isAIdebug())
				{
					pdtData.gcAIDataWindow<<Hide();
					pdtData.gcDebugDataWindow<<Hide();
				}
				pdtData.gcDirectOrderWindow<<Hide();
				pdtData.gcGeneralInfoWindow<<Hide();
//				pdtData.gcWeatherInfoWindow<<Hide();
//				pdtData.gcToolsWindow<<Hide();
				pdtData.iTakeScreenshot=1;
			}
		}
	}
	else if((_iKey == VK_M)&&isdebug())
	{
		SwitchMaterialBuffer();
	}
	else if((_iKey == VK_I)&&(GetKeyState(VK_A))&&isAIdebug())
	{
		SwitchAIDraw();
	}
	return 1;
}

func i32x Race_OnKeyUp(i32x _iKey)
{
	if(_iKey == VK_T)
	{
		var Gui_Component pthis;
		var Gui_dtPage_Race pdtData;
		var Gui_dtDirectOrderWindow pdtDOWData;

		SetTeamDrawingIndex(-1);

		// get this pointer
		pthis = GetThis();
		pdtData = GetData(pthis);
		pdtDOWData=GetData(pdtData.gcDirectOrderWindow);
		pdtDOWData.gcWinTeamDrawingCheckbox<<QuietUncheck();
	}
}

func i32x Race_OnMouseDown(i32x _iX,i32x _iY,i32x _iButton)
{
	var Gui_Component pthis;
	var Gui_dtPage_Race pdtData;

	// get this pointer
	pthis = GetThis();
	pdtData = GetData(pthis);
	
	if(_iButton == e_Gui_Mouse_Left_Button)
	{
		if((!GetKeyState(VK_Menu)) && (!GetKeyState(VK_Control)))
		{
			var f32x px,py;

			px = _iX;
			py = _iY;
			px = 2.0*((0.5+px)/g_iScreenWidth)-1.0;
			py = 2.0*((0.5+py-46.0)/(g_iScreenHeight-121.0))-1.0;
			
			if((px>1.0)||(px<-1.0)) 
			{
				print("\nError on picking X coordinate:");
				print(ftoa(px));
				print("\n");
			}
			else if((py>1.0)||(py<-1.0)) 
			{
				print("\nError on picking Y coordinate:");
				print(ftoa(py));
				print("\n");
			}
			else
			{
				if(GetActiveCamera()==CameraManFree)
				{
					MoveCameraToPickedPoint(px,py);
				}
				else
				{
					var i32x iPreviousActiveCyclist;
					
					iPreviousActiveCyclist=GetActiveCyclistPreRaceIndex();
					if(PickCyclist(px,py))
					{
						//println("PickCyclist");
						SetActiveCamera(CameraManFollowCyclist);
						
						if(iPreviousActiveCyclist!=GetActiveCyclistPreRaceIndex())
						{
							Race_UpdateActiveCyclist();
						}
					}
					else
					{
						if(PickBus(px,py))
							SetActiveCamera(CameraManBus);
					}
				}
			}
		}
	}
	
	return 1;
}


func i32x Race_OnMouseRoll(i32x _iX,i32x _iY,i32x _iZ)
{
	var i32x iMouseRoll;
	var i32x iInTeam;
	var Gui_Component pthis;
	var Gui_dtPage_Race pdtData;
	var f32x fValueX,fValueY,fValueZ;

	pthis = GetThis();
	pdtData = GetData(pthis);
	
	if (GetKeyState(VK_Menu)==0)
	{
		// change cyclist

		iMouseRoll=5*(_iZ/240)+(_iZ/120)%2;
		
		iInTeam=DOW_iGetTeamDrawing(pdtData.gcDirectOrderWindow);
		
		if (iMouseRoll>0)
		{
			while(iMouseRoll>0)
			{
				if(iInTeam)
					SetPreviousActiveCyclistInTeam(GetMyInRaceTeamId());
				else
					SetPreviousActiveCyclist();
				iMouseRoll=iMouseRoll-1;
			}
			Race_UpdateActiveCyclist();
		}
		else
		{
			while(iMouseRoll<0)
			{
				if(iInTeam)
					SetNextActiveCyclistInTeam(GetMyInRaceTeamId());
				else
					SetNextActiveCyclist();
				iMouseRoll=iMouseRoll+1;
			}
			Race_UpdateActiveCyclist();
		}
	}
	else
	{
		// zoom
		fValueX=0.0;
		fValueY=0.0;
		fValueZ=-0.02*_iZ;
		CameraOffsetPosition(fValueX,fValueY,fValueZ);
	}

	return 1;
}

func i32x Race_OnMouseMove(i32x _iX,i32x _iY)
{
	var Gui_Component pthis;
	var Gui_dtPage_Race pdtData;
	var f32x fValueX,fValueY,fValueZ;
	
	// get this pointer
	pthis = GetThis();
	pdtData = GetData(pthis);
	
	if (isdebug())
	{
		if((GetActiveCamera()==CameraManFollowCyclist)||(GetActiveCamera()==CameraManPath)||(GetActiveCamera()==CameraManSprint))
		{
			var i32x iAltKeyState,iLButtonState,iRButtonState,iMButtonState;
			
			iAltKeyState=GetKeyState(VK_Menu);
			iLButtonState=GetKeyState(VK_LButton);
			iMButtonState=GetKeyState(VK_MButton);
			iRButtonState=GetKeyState(VK_RButton);
			
			//Cameraman path
			if(iAltKeyState)
			{
				if(iLButtonState&&iMButtonState)
				{
					fValueX=0.0;
					fValueY=0.0;
					fValueZ=-0.1*(_iX-pdtData.iMouseX);
					CameraOffsetPosition(fValueX,fValueY,fValueZ);
				}
				else if((GetActiveCamera()==CameraManPath)&&iRButtonState&&iMButtonState)
				{
					if(_iX!=pdtData.iMouseX)
					{
						fValueX=0.5*(_iX-pdtData.iMouseX);
						CameraStrafeRightLeft(fValueX);
					}
				}
				else if(iMButtonState)
				{
					fValueX=-0.03*(_iX-pdtData.iMouseX);
					fValueY=0.03*(_iY-pdtData.iMouseY);
					fValueZ=0.0;
					CameraOffsetPosition(fValueX,fValueY,fValueZ);
				}
				else if(iLButtonState)
				{
					if(_iX!=pdtData.iMouseX)
					{
						fValueX=-0.01*(_iX-pdtData.iMouseX);
						CameraTurn(fValueX);
					}
					if(_iY!=pdtData.iMouseY)
					{
						fValueY=0.01*(_iY-pdtData.iMouseY);
						CameraRoll(fValueY);
					}
				}
				else if(iRButtonState)
				{
					if(_iX!=pdtData.iMouseX)
					{
						fValueX=0.01*(_iX-pdtData.iMouseX);
						CameraOffsetFocale(fValueX);
					}
				}
			}//if(iAltKeyState)
		}
		else if(GetActiveCamera()==CameraManFree)
		{
			//Cameraman free
			if(_iX!=pdtData.iMouseX)
			{
				fValueX=0.005*(_iX-pdtData.iMouseX);
				CameraTurn(fValueX);
			}
			if(_iY!=pdtData.iMouseY)
			{
				fValueY=0.005*(_iY-pdtData.iMouseY);
				CameraRoll(fValueY);
			}
			
			pdtData.iMouseX=0.5*(0.5+g_iScreenWidth);
			pdtData.iMouseY=0.5*(0.5+g_iScreenHeight);
			SetCursorPos(pdtData.iMouseX,pdtData.iMouseY);
			return 1;
		}
	}
	else if (GetKeyState(VK_Menu) && GetKeyState(VK_LButton))
	{
		if(_iX!=pdtData.iMouseX)
		{
			fValueX=-0.01*(_iX-pdtData.iMouseX);
			CameraTurn(fValueX);
		}
		if(_iY!=pdtData.iMouseY)
		{
			fValueY=0.01*(_iY-pdtData.iMouseY);
			CameraRoll(fValueY);
		}
	}
	
	pdtData.iMouseX = _iX;
	pdtData.iMouseY = _iY;
	
	return 1;
}

func i32x Race_OnLoop(f32x _fDelay)
{
	var i32x iSpeed;
	var Gui_Component pthis;
	var Gui_dtPage_Race pdtData;

	// get this pointer
	pthis = GetThis();
	pdtData = GetData(pthis);

	if(isAIdebug())
	{
		pdtData.gcAIDataWindow<<mUpdateAIDW();

		//MAO DEBUG TIMER INSTEAD OF UPDATE
		pdtData.gcDebugDataWindow<<mUpdateDDW(pthis);
	}
	
	if(GetActiveCamera()==CameraManFree)
	{
		//Cameraman free strafe
		if(GetKeyState(VK_Up)&&!GetKeyState(VK_Down))
		{
			CameraStrafeFrontBack(4.0);
		}
		else if (!GetKeyState(VK_Up)&&GetKeyState(VK_Down))
		{
			CameraStrafeFrontBack(-4.0);
		}

		if(GetKeyState(VK_Right)&&!GetKeyState(VK_Left))
		{
			CameraStrafeRightLeft(4.0);
		}
		else if(GetKeyState(VK_Left)&&!GetKeyState(VK_Right))
		{
			CameraStrafeRightLeft(-4.0);
		}
	}
	
	return 1;
}

func i32x Race_OnDrag(Gui_Component _pComponent,i32x _iDeltaX,i32x _iDeltaY)
{
	var Gui_Component pthis;
	var Gui_dtPage_Race pdtData;

	pthis =GetThis();
	pdtData = GetData(pthis);
	
	if(isAIdebug())
	{
		if(_pComponent==pdtData.gcGeneralInfoWindow)
		{
			pdtData.iGIWPosX=pdtData.iGIWPosX+_iDeltaX;
			pdtData.iGIWPosY=pdtData.iGIWPosY+_iDeltaY;
			
			if(pdtData.iGIWPosX>Race_iSizeX(pthis)-GIW_iBarSizeX(pdtData.gcGeneralInfoWindow))
			{
				pdtData.iGIWPosX=Race_iSizeX(pthis)-GIW_iBarSizeX(pdtData.gcGeneralInfoWindow);
			}
			if(pdtData.iGIWPosX<0)
			{
				pdtData.iGIWPosX=0;
			}
			
			if(pdtData.iGIWPosY>Race_iSizeY(pthis)-GIW_iBarSizeY(pdtData.gcGeneralInfoWindow))
			{
				pdtData.iGIWPosY=Race_iSizeY(pthis)-GIW_iBarSizeY(pdtData.gcGeneralInfoWindow);
			}
			if(pdtData.iGIWPosY<0)
			{
				pdtData.iGIWPosY=0;
			}
			MoveTo(pdtData.gcGeneralInfoWindow,pdtData.iGIWPosX,pdtData.iGIWPosY);
		}
/*		else if(_pComponent==pdtData.gcWeatherInfoWindow)
		{
			pdtData.iWIWPosX=pdtData.iWIWPosX+_iDeltaX;
			pdtData.iWIWPosY=pdtData.iWIWPosY+_iDeltaY;
			
			if(pdtData.iWIWPosX>Race_iSizeX(pthis)-WIW_iSizeX(pdtData.gcWeatherInfoWindow))
			{
				pdtData.iWIWPosX=Race_iSizeX(pthis)-WIW_iSizeX(pdtData.gcWeatherInfoWindow);
			}
			if(pdtData.iWIWPosX<0)
			{
				pdtData.iWIWPosX=0;
			}
			
			if(pdtData.iWIWPosY>Race_iSizeY(pthis)-WIW_iSizeY(pdtData.gcWeatherInfoWindow))
			{
				pdtData.iWIWPosY=Race_iSizeY(pthis)-WIW_iSizeY(pdtData.gcWeatherInfoWindow);
			}
			if(pdtData.iWIWPosY<0)
			{
				pdtData.iWIWPosY=0;
			}
			MoveTo(pdtData.gcWeatherInfoWindow,pdtData.iWIWPosX,pdtData.iWIWPosY);
		}
		else if(_pComponent==pdtData.gcToolsWindow)
		{
			pdtData.iTWPosX=pdtData.iTWPosX+_iDeltaX;
			pdtData.iTWPosY=pdtData.iTWPosY+_iDeltaY;
			
			if(pdtData.iTWPosX>Race_iSizeX(pthis)-TW_iSizeX(pdtData.gcToolsWindow))
			{
				pdtData.iTWPosX=Race_iSizeX(pthis)-TW_iSizeX(pdtData.gcToolsWindow);
			}
			if(pdtData.iTWPosX<0)
			{
				pdtData.iTWPosX=0;
			}
			
			if(pdtData.iTWPosY>Race_iSizeY(pthis)-TW_iSizeY(pdtData.gcToolsWindow))
			{
				pdtData.iTWPosY=Race_iSizeY(pthis)-TW_iSizeY(pdtData.gcToolsWindow);
			}
			if(pdtData.iTWPosY<0)
			{
				pdtData.iTWPosY=0;
			}
			MoveTo(pdtData.gcToolsWindow,pdtData.iTWPosX,pdtData.iTWPosY);
		}
*/		else if(_pComponent==pdtData.gcAIDataWindow)
		{
			pdtData.iAIDWPosX=pdtData.iAIDWPosX+_iDeltaX;
			pdtData.iAIDWPosY=pdtData.iAIDWPosY+_iDeltaY;
			
			if(pdtData.iAIDWPosX>Race_iSizeX(pthis)-AIDW_iBarSizeX(pdtData.gcAIDataWindow))
			{
				pdtData.iAIDWPosX=Race_iSizeX(pthis)-AIDW_iBarSizeX(pdtData.gcAIDataWindow);
			}
			if(pdtData.iAIDWPosX<0)
			{
				pdtData.iAIDWPosX=0;
			}
			
			if(pdtData.iAIDWPosY>Race_iSizeY(pthis)-AIDW_iBarSizeY(pdtData.gcAIDataWindow))
			{
				pdtData.iAIDWPosY=Race_iSizeY(pthis)-AIDW_iBarSizeY(pdtData.gcAIDataWindow);
			}
			if(pdtData.iAIDWPosY<0)
			{
				pdtData.iAIDWPosY=0;
			}
			MoveTo(pdtData.gcAIDataWindow,pdtData.iAIDWPosX,pdtData.iAIDWPosY);
		}
		else if(_pComponent==pdtData.gcDebugDataWindow)
		{
			pdtData.iDDWPosX=pdtData.iDDWPosX+_iDeltaX;
			pdtData.iDDWPosY=pdtData.iDDWPosY+_iDeltaY;
			
			if(pdtData.iDDWPosX>Race_iSizeX(pthis)-DDW_iBarSizeX(pdtData.gcDebugDataWindow))
			{
				pdtData.iDDWPosX=Race_iSizeX(pthis)-DDW_iBarSizeX(pdtData.gcDebugDataWindow);
			}
			if(pdtData.iDDWPosX<0)
			{
				pdtData.iDDWPosX=0;
			}
			
			if(pdtData.iDDWPosY>Race_iSizeY(pthis)-DDW_iBarSizeY(pdtData.gcDebugDataWindow))
			{
				pdtData.iDDWPosY=Race_iSizeY(pthis)-DDW_iBarSizeY(pdtData.gcDebugDataWindow);
			}
			if(pdtData.iDDWPosY<0)
			{
				pdtData.iDDWPosY=0;
			}
			MoveTo(pdtData.gcDebugDataWindow,pdtData.iDDWPosX,pdtData.iDDWPosY);
		}
	}
}



func void Race_OnWindowUpdate()
{
	var Gui_Component pthis;
	var Gui_dtPage_Race pdtData;

	pthis =GetThis();
	pdtData = GetData(pthis);
}

func void Race_UpdateGroupsFunc()
{
	var Gui_Component pthis;
	var Gui_dtPage_Race pdtData;
	var Gui_dtGeneralInfoWindow pdtGIWData;
	var i32x i,iNumGroups;
	var f32x fRacePercentageDone;
	var szx szName;
	
	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtGIWData=GetData(pdtData.gcGeneralInfoWindow);
	//Update groups
	iNumGroups=GetNbGroups();
	pdtGIWData.gcProfilePanel<<mGroupProfileReset();
	pdtGIWData.gcProfilePanel<<mGroupProfileSetNumGroup(iNumGroups);
	i=0;
	while(i<iNumGroups)
	{
		fRacePercentageDone=GetGroupSplinePercentageDone(i);
		szName=GetGroupName(i);
		pdtGIWData.gcProfilePanel<<mGroupProfileSetGroup(i,fRacePercentageDone,szName);
		i=i+1;
	}
	//Update active cyclist
	Race_UpdateActiveCyclist();
}

func i32x Race_mSelectGroup(i32x _iGroupIndex)
{
	var Gui_Component pthis;
	var Gui_dtPage_Race pdtData;
	//println("Race_mSelectGroup"+itoa(_iGroupIndex));
	pthis = GetThis();
	pdtData = GetData(pthis);
	SetActiveCyclist(GetFirstCyclistPreRaceIndexFromGroup(_iGroupIndex));
	Race_UpdateActiveCyclist();
	return 1;
}

func i32x Race_mSelectSprint(i32x _iSprint)
{
	var Gui_Component pthis;
	var Gui_dtPage_Race pdtData;
	//println("Race_mSelectSprint"+itoa(_iSprint));
	pthis = GetThis();
	pdtData = GetData(pthis);
	SetActiveCamera(CameraManSprint);
	SetCameraSprint(_iSprint);
	return 1;
}

func i32x Race_OnChangeCamera(i32x _iCameraIndex)
{
	var Gui_Component pthis;
	var Gui_dtPage_Race pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtData.iCurrentCamera=_iCameraIndex;
			
	if (pdtData.iCurrentCamera>=9)
		pdtData.iCurrentCamera=0;
	SelectInRaceCamera(pdtData.iCurrentCamera);
	return 1;
}

func void Race_UpdateActiveCyclist()
{
	var Gui_Component pthis;
	var Gui_dtPage_Race pdtData;
	var Gui_dtGeneralInfoWindow pdtGIWData;
	//println("Race_UpdateActiveCyclist");
	pthis = GetThis();
	pdtData = GetData(pthis);
	pdtGIWData=GetData(pdtData.gcGeneralInfoWindow);
	pdtData.gcDirectOrderWindow<<mUpdateActiveCyclist();
	pdtGIWData.gcProfilePanel<<mSelectGroup(GetActiveGroupIndex());
	pdtData.gcGeneralInfoWindow<<mUpdateActiveCyclist();
}

func void Race_OnShowPodium()
{
	var Gui_Component pthis;
	var Gui_dtPage_Race pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	
	pdtData.gcGeneralInfoWindow<<Hide();
//	pdtData.gcWeatherInfoWindow<<Hide();
//	pdtData.gcToolsWindow<<Hide();
	pdtData.gcDirectOrderWindow<<Hide();
	if(pdtData.gcDebugDataWindow)
		pdtData.gcDebugDataWindow<<Hide();
	if(pdtData.gcDirectOrderWindow)
		pdtData.gcDirectOrderWindow<<Hide();
	if(pdtData.gcGeneralInfoWindow)
		pdtData.gcGeneralInfoWindow<<Hide();
	if(pdtData.gcHelpBar)
		pdtData.gcHelpBar<<Hide();
	if(pdtData.gcHelpCaption)
		pdtData.gcHelpCaption<<Hide();

	
	pdtData.gcPodium = NewInRacePodium();
	MountComponent(pthis,pdtData.gcPodium);

	pdtData.gcPodium<<ShowClassification(Join_GetIntFromIndex(g_oMenuJoins.m_iConfig_iLastStageId,0));

}
func void Race_OnEndPodium()
{
	var Gui_Component pthis,parent;
	var Gui_dtPage_Race pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	parent = GetParent(pthis);
	if(parent)
	{
		// Back
		parent<<GoBack();
	}
}

// *****************************
// * Podium
// *****************************
func Gui_Component NewPodiumEntry()
{
	var Gui_Component pthis,pentry;
	var Gui_dtPodiumEntry pdtData;
	var i32x i,id;

	pthis = NewObject(Gui_iPodiumEntry);

	pdtData = new Gui_dtPodiumEntry;

	SetData(pthis,pdtData);

	pdtData.gcTeam = NewCaption(smBauer,"(TEA)");
	SetBlendingMode(GetSprite(pdtData.gcTeam),DLC_Blend_AlphaBlend);
	SetShadingMode(GetSprite(pdtData.gcTeam),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	SetColor(pdtData.gcTeam,MakeARGB(255,255,255,0));
	SetScale(pdtData.gcTeam,g_fScreenScaleFactor);
	SetAlign(pdtData.gcTeam,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	MountComponent(pthis,pdtData.gcTeam);

	pdtData.gcCaption = NewCaption(smBauer,"Entry");
	SetBlendingMode(GetSprite(pdtData.gcCaption),DLC_Blend_AlphaBlend);
	SetShadingMode(GetSprite(pdtData.gcCaption),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	SetScale(pdtData.gcCaption,g_fScreenScaleFactor);
	SetAlign(pdtData.gcCaption,e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	MoveTo(pdtData.gcCaption,75.0*g_fScreenScaleFactor,0);
	MountComponent(pthis,pdtData.gcCaption);

	pdtData.gcValue = NewCaption(smBauer,"Val");
	SetBlendingMode(GetSprite(pdtData.gcValue),DLC_Blend_AlphaBlend);
	SetShadingMode(GetSprite(pdtData.gcValue),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	SetScale(pdtData.gcValue,g_fScreenScaleFactor);
	SetAlign(pdtData.gcValue,e_GUI_HAlign_Right,e_GUI_VAlign_Center);
	MountComponent(pthis,pdtData.gcValue);
	MoveTo(pdtData.gcValue,475.0*g_fScreenScaleFactor,0);

	SetModulateColor(pthis,MakeARGB(0,255,255,255));
	return pthis;
}
func void PodiumEntry_SetEntry(szx _szTeam,szx _szCaption,szx _szValue)
{
	var Gui_Component pthis,pentry;
	var Gui_dtPodiumEntry pdtData;
	var i32x i,id;

	pthis = GetThis();

	pdtData = GetData(pthis);

	pdtData.gcTeam<<Caption(_szTeam);
	pdtData.gcCaption<<Caption(_szCaption);
	pdtData.gcValue<<Caption(_szValue);
}

func Gui_Component NewInRacePodium()
{
	var Gui_Component pthis,pentry;
	var Gui_dtInRacePodium pdtData;
	var i32x i,id;

	pthis = NewObject(Gui_iInRacePodium);

	pdtData = new Gui_dtInRacePodium;

	SetData(pthis,pdtData);

	pdtData.iNumEntries = 10;

	// Background
	pdtData.gcBackground = NewBitmap(smWhite,0);
	SetModulateColor(pdtData.gcBackground,MakeARGB(0,0,0,0));
	SetAlign(pdtData.gcBackground,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	SetBlendingMode(GetSprite(pdtData.gcBackground),DLC_Blend_AlphaBlend);
	SetShadingMode(GetSprite(pdtData.gcBackground),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	StretchTo(pdtData.gcBackground,800.0*g_fScreenScaleFactor,400.0*g_fScreenScaleFactor);
	MountComponent(pthis,pdtData.gcBackground);
	MoveTo(pdtData.gcBackground,0,100.0*g_fScreenScaleFactor);

	pdtData.gcTopBackground = NewBitmap(smWhite,0);
	SetColor(pdtData.gcTopBackground,MakeARGB(255,0,0,0));
	SetAlign(pdtData.gcTopBackground,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	SetBlendingMode(GetSprite(pdtData.gcTopBackground),DLC_Blend_AlphaBlend);
	SetShadingMode(GetSprite(pdtData.gcTopBackground),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	StretchTo(pdtData.gcTopBackground,800.0*g_fScreenScaleFactor,100.0*g_fScreenScaleFactor);
	MountComponent(pthis,pdtData.gcTopBackground);

	pdtData.gcBottomBackground = NewBitmap(smWhite,0);
	SetColor(pdtData.gcBottomBackground,MakeARGB(255,0,0,0));
	SetAlign(pdtData.gcBottomBackground,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	SetBlendingMode(GetSprite(pdtData.gcBottomBackground),DLC_Blend_AlphaBlend);
	SetShadingMode(GetSprite(pdtData.gcBottomBackground),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	StretchTo(pdtData.gcBottomBackground,800.0*g_fScreenScaleFactor,100.0*g_fScreenScaleFactor);
	MountComponent(pthis,pdtData.gcBottomBackground);
	MoveTo(pdtData.gcBottomBackground,0,500.0*g_fScreenScaleFactor);

	// Classification title
	pdtData.gcTitle = NewCaption(smBauer,"Classification title");
	SetBlendingMode(GetSprite(pdtData.gcTitle),DLC_Blend_AlphaBlend);
	SetShadingMode(GetSprite(pdtData.gcTitle),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	SetScale(pdtData.gcTitle,g_fScreenScaleFactor);
	SetAlign(pdtData.gcTitle,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	StretchTo(pdtData.gcTitle,800.0*g_fScreenScaleFactor,50);
	MountComponent(pthis,pdtData.gcTitle);
	MoveTo(pdtData.gcTitle,0,100.0*g_fScreenScaleFactor);

	// Podium
	i=0;
	while(i<pdtData.iNumEntries)
	{
		pentry = NewPodiumEntry();
		id = MountComponent(pthis,pentry);
		if(i==0)
			pdtData.iStartPodiumIndex = id;
		else if(i==(pdtData.iNumEntries-1))
			pdtData.iEndPodiumIndex = id;

		MoveTo(pentry,g_iScreenWidthDiv2 - ((525.0*g_fScreenScaleFactor)/2.0),150.0*g_fScreenScaleFactor + 30.0*i*g_fScreenScaleFactor);

		i=i+1;
	}

	// Subset
	pdtData.m_iCyclistSubset = Subset_Constructor("SUBSET_CYCLIST_CLASS",DATABASE_CLIENT);
	Database_AddTables(pdtData.m_iCyclistSubset,3);
	Table_SetName(pdtData.m_iCyclistSubset, 0, "DYN_cyclist");
	TableSubset_SelectColumns(pdtData.m_iCyclistSubset, 0, "*");
	Table_SetName(pdtData.m_iCyclistSubset, 1, "DYN_classification_stage");
	TableSubset_SelectColumns(pdtData.m_iCyclistSubset, 1, "*");
	Table_SetName(pdtData.m_iCyclistSubset, 2, "DYN_classification_race");
	TableSubset_SelectColumns(pdtData.m_iCyclistSubset, 2, "*");

	pdtData.m_iTeamSubset = Subset_Constructor("SUBSET_TEAM_CLASS",DATABASE_CLIENT);
	Database_AddTables(pdtData.m_iTeamSubset,3);
	Table_SetName(pdtData.m_iTeamSubset, 0, "DYN_team");
	TableSubset_SelectColumns(pdtData.m_iTeamSubset, 0, "*");
	Table_SetName(pdtData.m_iTeamSubset, 1, "DYN_classification_stage");
	TableSubset_SelectColumns(pdtData.m_iTeamSubset, 1, "*");
	Table_SetName(pdtData.m_iTeamSubset, 2, "DYN_classification_race");
	TableSubset_SelectColumns(pdtData.m_iTeamSubset, 2, "*");

	pdtData.m_jJoinId = 0;

	return pthis;
}
func void Podium_OnDestroy()
{
	var Gui_Component pthis,pentry;
	var Gui_dtInRacePodium pdtData;

	pthis = GetThis();

	pdtData = GetData(pthis);

	if(pdtData.m_jJoinId)
		Join_Destructor(pdtData.m_jJoinId);

	if(pdtData.m_iTeamSubset)
	{
		Subset_Destructor(pdtData.m_iTeamSubset);
	}
	if(pdtData.m_iCyclistSubset)
	{
		Subset_Destructor(pdtData.m_iCyclistSubset);
	}

}

func void Podium_OnShowClassification(i32x _iStageId)
{
	var Gui_Component pthis,pentry;
	var Gui_dtInRacePodium pdtData;
	var i32x i,id;

	pthis = GetThis();

	pdtData = GetData(pthis);

	// Reset current slot
	pdtData.iCurrentSlot = -1;

	pdtData.m_iStageId = _iStageId;
	pdtData.m_iRaceId = Join_GetIntFromKey(g_oLocalJoins.m_iStage_iRaceId,_iStageId);

	// Active podium mode
	pdtData.iCamera = 0;
	SetPodiumInRaceMode();

	Podium_UpdateDisplay();
}

func void Podium_OnAnimEnded(Gui_Component _pthis)
{
	var Gui_Component pthis,pentry;
	var Gui_dtInRacePodium pdtData;
	var i32x i,id,index,iNumIndex;

	pthis = GetThis();

	pdtData = GetData(pthis);

	if(pdtData.bShowing)
	{
		if(pdtData.gcTitle == _pthis)
		{
			// Title End anim
			i=pdtData.iStartPodiumIndex;
			while(i<=pdtData.iEndIndex)
			{
				pentry = GetComponent(pthis,i);
				if(pentry)
				{
					SetModulateColor(pentry,MakeARGB(0,255,255,255));
					MoveTo(pentry,g_iScreenWidthDiv2 - ((525.0*g_fScreenScaleFactor)/2.0),RelPosY(pentry));
					Add_FonduAnim(pentry,cWhite,0.004);
				}
				i=i+1;
			}	

			// Start Anim entry
			pentry = GetComponent(pthis,pdtData.iStartPodiumIndex);
			if(pentry)
			{
				pentry<<StartAnim();
			}
		}
		else if((GetId(_pthis)>=pdtData.iStartPodiumIndex)&&(GetId(_pthis)<pdtData.iEndIndex))
		{
			// Start next anim
			pentry = GetComponent(pthis,GetId(_pthis)+1);
			if(pentry)
			{
				pentry<<StartAnim();
			}
		}
		else if(GetId(_pthis)==pdtData.iEndIndex)
		{
			var i32x iOdd;
			// End of display let's hide them all
			pdtData.bShowing  = false;

			// Title End anim
			i=pdtData.iStartPodiumIndex;
			while(i<=pdtData.iEndIndex)
			{
				iOdd = i%2;
				pentry = GetComponent(pthis,i);
				if(pentry)
				{
					if(iOdd==0)
						Add_TranslateAnim(pentry,800.0*g_fScreenScaleFactor,RelPosY(pentry),0.007);	
					else
						Add_TranslateAnim(pentry,-800.0*g_fScreenScaleFactor,RelPosY(pentry),0.007);
					pentry<<StartAnim();
				}
				i=i+1;
			}
			Add_FonduAnim(pdtData.gcTitle,0,0.007);
			pdtData.gcTitle<<StartAnim();
			Add_FonduAnim(pdtData.gcBackground,cBlack,0.0048);
			pdtData.gcBackground<<StartAnim();
		}
	}
	else if(pdtData.gcBackground == _pthis)
	{
		var i32x ok,iClassId,iStrId;
		ok = 0;
		while((pdtData.iCurrentSlot<6)&&(ok==0))
		{
			pdtData.iCurrentSlot=pdtData.iCurrentSlot+1;
			iClassId = GetRaceClassId(pdtData.m_iRaceId,pdtData.iCurrentSlot);
			if(iClassId>0)
			{
				// Update Title
				iStrId = Join_GetIntFromKey(g_oMenuJoins.m_iClass_iStrId,iClassId);
				if(iStrId>0)
				{
					ok = 1;
				}
			}
			else if(pdtData.iCurrentSlot>4)
			{
				// break loop
				pdtData.iCurrentSlot = 6;
			}
		}
		if(ok == 1)
		{
			Podium_UpdateDisplay();
		}
		else
		{
			var Gui_Component parent;
			parent = GetParent(pthis);
			if(parent)
				parent<<EndPodium();

		}
	}
}

func void Podium_UpdateDisplay()
{
	var Gui_Component pthis,pentry;
	var Gui_dtInRacePodium pdtData;
	var i32x i,id,index,iNumIndex;
	var szx szCaption,szValue,szTeam;
	var f32x fFirstValue,fValue;
	fFirstValue = 0.0;

	pthis = GetThis();

	pdtData = GetData(pthis);

	if(pdtData.m_jJoinId>0)
	{
		Join_Destructor(pdtData.m_jJoinId);
		pdtData.m_jJoinId = 0;
	}

	DatabaseSubset_Clear(pdtData.m_iCyclistSubset);
	DatabaseSubset_Clear(pdtData.m_iTeamSubset);

	if(pdtData.iCurrentSlot == -1)
	{
		// Starting with arrival time
		pdtData.m_jJoinId = Join_Constructor(pdtData.m_iCyclistSubset,"DYN_cyclist.fkIDclassification_stage.DYN_classification_stage.gene_f_ref");
		pdtData.m_bTeam = false;

		// Select classification for cyclist
		Query_Create(0,pdtData.m_iCyclistSubset);
		Query_SelectTable(	0, "DYN_cyclist");
		Query_SelectTable(	0, "DYN_cyclist.fkIDclassification_stage.DYN_classification_stage");
		Query_SelectWhereIntEqual(0,"DYN_cyclist.fkIDclassification_stage.DYN_classification_stage.fkIDstage", pdtData.m_iStageId);
		Query_SelectWhereFloatDifferent(0,"DYN_cyclist.fkIDclassification_stage.DYN_classification_stage.gene_f_ref", 0.0);
		Query_SelectWhereIntEqual(0,"DYN_cyclist.race_b_withdrawal", 0);
		Query_Execute(0);

		SortClassSlot(GetRaceClassId(pdtData.m_iRaceId,RACE_SLOT_TIME),pdtData.m_jJoinId);
		// Update Title
		szCaption = GetLocalizedFromKey(iszArrivee);
		pdtData.gcTitle<<Caption(szCaption);

	}
	else
	{
		var i32x iClassId,iStrId;
		if(pdtData.iCurrentSlot == RACE_SLOT_TEAM)
		{
			pdtData.m_jJoinId = Join_Constructor(pdtData.m_iTeamSubset,"DYN_team.fkIDclassification_race.DYN_classification_race."+GetClassSlotName(pdtData.iCurrentSlot));

			// Select classification for team
			Query_Create(0,pdtData.m_iTeamSubset);
			Query_SelectTable(	0, "DYN_team");
			Query_SelectTable(	0, "DYN_team.fkIDclassification_race.DYN_classification_race");
			Query_SelectWhereFloatDifferent(0,Join_GetDesc(pdtData.m_jJoinId), 0.0);
			Query_SelectWhereIntEqual(0,"DYN_team.fkIDclassification_race.DYN_classification_race.fkIDrace", pdtData.m_iRaceId);
			Query_Execute(0);

			pdtData.m_bTeam = true;
		}
		else
		{
			pdtData.m_jJoinId = Join_Constructor(pdtData.m_iCyclistSubset,"DYN_cyclist.fkIDclassification_race.DYN_classification_race."+GetClassSlotName(pdtData.iCurrentSlot));

			// Select classification for cyclist
			Query_Create(0,pdtData.m_iCyclistSubset);
			Query_SelectTable(	0, "DYN_cyclist");
			Query_SelectTable(	0, "DYN_cyclist.fkIDclassification_race.DYN_classification_race");
			Query_SelectWhereIntEqual(0,"DYN_cyclist.fkIDclassification_race.DYN_classification_race.fkIDrace", pdtData.m_iRaceId);
			Query_SelectWhereFloatDifferent(0,Join_GetDesc(pdtData.m_jJoinId), 0.0);
			Query_SelectWhereIntEqual(0,"DYN_cyclist.race_b_withdrawal", 0);
			Query_Execute(0);

			pdtData.m_bTeam = false;
		}
		SortClassSlot(GetRaceClassId(pdtData.m_iRaceId,pdtData.iCurrentSlot),pdtData.m_jJoinId);

		// Update Title
		iClassId = GetRaceClassId(pdtData.m_iRaceId,pdtData.iCurrentSlot);
		iStrId = Join_GetIntFromKey(g_oMenuJoins.m_iClass_iStrId,iClassId);
		szCaption = GetLocalizedFromKey(iStrId);
		pdtData.gcTitle<<Caption(szCaption);
	}

	// Start display anim
	index = 0;
	iNumIndex = Join_GetNumRows(pdtData.m_jJoinId);
	if(iNumIndex>0)
	{
		i=pdtData.iStartPodiumIndex;
		while(i<=pdtData.iEndPodiumIndex)
		{
			pentry = GetComponent(pthis,i);
			if(i<iNumIndex+pdtData.iStartPodiumIndex)
			{
				id = Join_GetRow(pdtData.m_jJoinId,index,ROW_SORT,ROW_KEY);
				if(pdtData.iCurrentSlot==-1)
				{
					if(index==0)
					{
						fFirstValue = Join_GetFloatFromSortedIndex(pdtData.m_jJoinId,index);
						fValue = fFirstValue;
					}
					else
					{
						fValue = Join_GetFloatFromSortedIndex(pdtData.m_jJoinId,index) - fFirstValue;
					}
					szValue = GetHMS(fValue);
				}
				else if(GetClassificationType(GetRaceClassId(pdtData.m_iRaceId,pdtData.iCurrentSlot))==1)
				{
					if(index==0)
					{
						fFirstValue = Join_GetFloatFromSortedIndex(pdtData.m_jJoinId,index);
						fValue = fFirstValue;
					}
					else
					{
						fValue = Join_GetFloatFromSortedIndex(pdtData.m_jJoinId,index) - fFirstValue;
					}
					szValue = GetHMS(fValue);
				}
				else
				{
					szValue = itoa(Join_GetFloatFromSortedIndex(pdtData.m_jJoinId,index));
				}

				if(pdtData.m_bTeam)
				{
					szCaption = Join_GetStringFromKey(g_oMenuJoins.m_iTeamName,id);
					szTeam = "";
				}
				else
				{
					var i32x iTeamId;

					if(i==0)
					{
						// Update podium active cyclist
						SetPodiumActiveCyclist(id,GetRaceClassId(pdtData.m_iRaceId,pdtData.iCurrentSlot));
					}

					szCaption = Join_GetStringFromKey(g_oMenuJoins.m_jCyclist_szLastName,id);
					iTeamId = Join_GetIntFromKey(g_oMenuJoins.m_iCyclistTeamID,id);
					szTeam = Join_GetStringFromKey(g_oMenuJoins.m_iTeamAbrev,iTeamId);
				}

				if(pentry)
				{
					pentry<<SetEntry(szTeam,szCaption,szValue);
					pentry<<Show();
				}
				pdtData.iEndIndex = i;
				index = index + 1;
			}
			else
			{
				if(pentry)
					pentry<<Hide();
			}
			i=i+1;
		}
	}
	else
	{
		i=pdtData.iStartPodiumIndex;
		while(i<=pdtData.iEndPodiumIndex)
		{
			pentry = GetComponent(pthis,i);
			if(pentry)
				pentry<<Hide();
			i=i+1;
		}
		pentry = GetComponent(pthis,pdtData.iStartPodiumIndex);
		pdtData.iEndIndex = pdtData.iStartPodiumIndex;
		pentry<<SetEntry("",GetLocalizedFromKey(iszNoClassification),"");
		pentry<<Show();
	}

	// select next podium camera
	SelectPodiumInRaceCamera(pdtData.iCamera);
	pdtData.iCamera=pdtData.iCamera+1;
	pdtData.iCamera=pdtData.iCamera%6;

	// Add fondu anim to title
	pdtData.bShowing = true;
	Add_FonduAnim(pdtData.gcBackground,MakeARGB(128,0,0,0),0.0048);
	pdtData.gcBackground<<StartAnim();
	SetModulateColor(pdtData.gcTitle,MakeARGB(0,255,255,255));
	Add_FonduAnim(pdtData.gcTitle,cWhite,0.0008);
	pdtData.gcTitle<<StartAnim();
}
