func i32x GetCurrentStageId()
{
	var i32x iStageId;
	iStageId = Join_GetIntFromIndex(g_oMenuJoins.m_iConfig_iCurrentStageId,0);
	return iStageId;
}

func void RosterCyclist_OnInitData()
{
	var Gui_Component pthis, pcaption, plist, pBack;
	var Gui_dtPage_RosterCyclist pdtData;

	var i32x iRosterFormPosition;
	iRosterFormPosition = 150;


	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_RosterCyclist;
	SetData(pthis,pdtData);
}

func void RosterCyclist_OnRelease()
{
	var Gui_Component pthis,ptmp;
	var i32x i,iNumComponents;
	var Gui_dtPage_RosterCyclist pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	iNumComponents = GetComponentNumber(pthis);
	i=0;
	while(i<iNumComponents)
	{
		ptmp = GetComponent(pthis,i);
		if(ptmp)
		{
			DeleteComponent(ptmp);
		}
		i=i+1;
	}

	// Destroy subset if needed
	if(pdtData.m_iSubsetId)
	{
		Subset_Destructor(pdtData.m_iSubsetId);
		pdtData.m_iSubsetId = 0;
		Database_Destructor(pdtData.m_iDbId);
		pdtData.m_iDbId = 0;
	}

	pdtData.gcPhotoForm = NULL;
	pdtData.gcRosterListForm = NULL;
	pdtData.gcListForm = NULL;
}


func i32x RosterCyclist_OnCreate()
{
	var Gui_Component pthis, pcaption, pwindow, pPhotoBack, pNav;
	var Gui_dtPage_RosterCyclist pdtData;
	var i32x iStageId,iRaceId,iSubsetId;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData =GetData(pthis);

	// create  a DB copy subset
	iSubsetId = Subset_Constructor("SUBSET_ROSTER",DATABASE_CLIENT);
	Database_AddTables(iSubsetId,4);
	Table_SetName(iSubsetId, 0, "DYN_team");
	TableSubset_SelectColumns(iSubsetId, 0, "*");
	Table_SetName(iSubsetId, 1, "DYN_cyclist");
	TableSubset_SelectColumns(iSubsetId, 1, "*");
	Table_SetName(iSubsetId, 2, "DYN_characteristic");
	TableSubset_SelectColumns(iSubsetId, 2, "*");
	Table_SetName(iSubsetId, 3, "DYN_characteristic_cyclist");
	TableSubset_SelectColumns(iSubsetId, 3, "*");

	Query_Create(0,iSubsetId);
	Query_SelectTable(	0, "DYN_cyclist");
	Query_SelectTable(	0, "DYN_cyclist.fkIDteam.DYN_team");
	Query_SelectTable(	0, "DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist");
	Query_SelectWhereIntEqual(0,"DYN_cyclist.fkIDteam", GetMyTeamId() );
	Query_Execute(0);

	pdtData.m_iDbId = Database_CopyConstructor("DB_COPY_ROSTER",iSubsetId);

	Subset_Destructor(iSubsetId);

	// Num cyclist to register in this race
	iStageId = GetCurrentStageId();
	iRaceId = Join_GetIntFromKey(g_oLocalJoins.m_iStage_iRaceId,iStageId);
	pdtData.m_iNumCyclistsToRegister = Database_GetIntData(DATABASE_CLIENT,"STA_race.gene_i_min_cyclist_by_team",ROW_KEY,iRaceId);
	pdtData.m_iMaxCyclistsToRegister = Database_GetIntData(DATABASE_CLIENT,"STA_race.gene_i_max_cyclist_by_team",ROW_KEY,iRaceId);

	// create subset
	pdtData.m_iSubsetId = Subset_Constructor("SUBSET_ROSTER",pdtData.m_iDbId);
	Database_AddTables(pdtData.m_iSubsetId,4);
	Table_SetName(pdtData.m_iSubsetId, 0, "DYN_team");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 0, "*");
	Table_SetName(pdtData.m_iSubsetId, 1, "DYN_cyclist");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 1, "*");
	Table_SetName(pdtData.m_iSubsetId, 2, "DYN_characteristic");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 2, "*");
	Table_SetName(pdtData.m_iSubsetId, 3, "DYN_characteristic_cyclist");
	TableSubset_SelectColumns(pdtData.m_iSubsetId, 3, "*");

	// Update susbet
	RosterCyclist_Update();

	// Caption
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszEffectif));
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetColor(pcaption, cPageTitleColor);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// photo back
	var f32x iPhotoZoneWidth, iPhotoZoneHeight; // relative to 800x600
	var f32x iBackWidth, iBackHeight; // relative to 800x600
	var f32x iPhotoWidth, iPhotoHeight; // relative to 800x600
	var f32x iBackPosX, iBackPosY; // relative to 800x600
	iPhotoZoneWidth = 200.0;
	iPhotoZoneHeight = 200.0;
	iBackWidth = 100.0;
	iBackHeight = 125.0;
	iPhotoWidth = 80;
	iPhotoHeight = 90;
	iBackPosX = g_iScreenWidth - iPhotoZoneWidth*g_fScreenScaleFactor + ((iPhotoZoneWidth - iBackWidth)/2*g_fScreenScaleFactor);
	iBackPosY = g_iScreenTopOffset + g_fScreenScaleFactor*(iPhotoZoneHeight - iBackHeight)/2;
	pPhotoBack = NewBitmap(smDOPanelBack, 1);
	SetShadingMode(GetSprite(pPhotoBack), DLC_GouraudMode_ModulateDiffuse, DLC_GouraudMode_ModulateDiffuse);
	SetBlendingMode(GetSprite(pPhotoBack), DLC_Blend_AlphaBlend);
	SetAlign(pPhotoBack, e_GUI_HAlign_Zoom, e_GUI_VAlign_Zoom);
	StretchTo(pPhotoBack, iBackWidth*g_fScreenScaleFactor, iBackHeight*g_fScreenScaleFactor);
	MoveTo(pPhotoBack, iBackPosX, iBackPosY);
	MountComponent(pthis, pPhotoBack);

	// photo form
	pdtData.gcPhotoForm = NewForm(DATABASE_CLIENT, "DYN_cyclist", false);
	pdtData.gcPhotoForm<<FormSetRef(ROW_KEY);
	pdtData.gcPhotoForm<<FormSetMediaSize(iPhotoWidth, iPhotoHeight);
	pdtData.gcPhotoForm<<FormShowBitmapField("DYN_cyclist.gene_tgaID_photo", "", 0, 0);
	MountComponent(pthis, pdtData.gcPhotoForm);
	MoveTo(pdtData.gcPhotoForm, iBackPosX + (iBackWidth-iPhotoWidth)/2*g_fScreenScaleFactor, (iBackPosY + (iBackHeight-iPhotoHeight)/2*g_fScreenScaleFactor));
	

	var i32x iRosterWidth;
	iRosterWidth = g_iScreenWidth - iPhotoZoneWidth*g_fScreenScaleFactor - g_iScreenLeftOffset;

	// Roster form
	// Roster cyclist list form
	pwindow = NewWindow(iRosterWidth, 220.0);
	pdtData.gcRosterListForm = NewCyclistListFormExt(pdtData.m_iSubsetId, false);
	pwindow<<WindowMount(pdtData.gcRosterListForm);
	pdtData.gcRosterListForm<<FormSetOffset(0);
	pdtData.gcRosterListForm<<FormRazFilter();
	MountComponent(pthis, pwindow);
	MoveTo(pwindow, g_iScreenLeftOffset, g_iScreenTopOffset+25);

	var f32x fButtonX, fButtonY;
	fButtonX = iBackPosX + iBackWidth*g_fScreenScaleFactor;
	fButtonY = iBackPosY + iBackHeight*g_fScreenScaleFactor;

	// Register/Unregister button
	pdtData.gcRegister = NewButtonDyn(smPlusButton);
	MountComponent(pthis,pdtData.gcRegister);
	pdtData.gcUnregister = NewButtonDyn(smMinusButton);
	MountComponent(pthis,pdtData.gcUnregister);

	MoveTo(pdtData.gcRegister, fButtonX, fButtonY);
	MoveTo(pdtData.gcUnregister, fButtonX, fButtonY);
	
	pdtData.gcRegister<<Hide();
	pdtData.gcUnregister<<Hide();

	var i32x iListPosY, iListHeight;
	iListPosY = RelPosY(pwindow)+SizeY(pwindow)+g_iScreenBottomOffset;
	iListHeight = g_iScreenHeight - iListPosY - g_iScreenBottomOffset - 48;
	
	// cyclist list form
	pwindow = NewWindow((g_iScreenWidth - g_iScreenLeftOffset - g_iScreenRightOffset), iListHeight);
	pdtData.gcListForm = NewCyclistListForm();
	pwindow<<WindowMount(pdtData.gcListForm);
	pdtData.gcListForm<<FormSetOffset(iTableGapWidth);
	pdtData.gcListForm<<FormFilterByIntEqual("DYN_cyclist.fkIDteam",GetMyTeamId());
	MountComponent(pthis, pwindow);
	MoveTo(pwindow, g_iScreenLeftOffset, iListPosY);

	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);
	pdtData.gcBackButton<<Hide();

	// Send button
	pdtData.gcSendButton = NewCM2Button(GetLocalizedFromKey(iszSend));
	MountComponent(pthis,pdtData.gcSendButton);
	MoveTo(pdtData.gcSendButton,RelPosX(pdtData.gcBackButton)-SizeX(pdtData.gcSendButton)-10,g_iScreenHeight-SizeY(pdtData.gcSendButton)-g_iScreenBottomOffset);
	pdtData.gcSendButton<<Hide();

	pdtData.m_bDataIsValid = RosterCyclist_RosterIsValid(Form_GetDynamicDb(pdtData.gcRosterListForm));
	
	pNav = NewNavBar();
	MountComponent(pthis, pNav);
	MoveTo(pNav, g_iScreenWidth-SizeX(pNav)-g_iScreenRightOffset, g_iScreenHeight-SizeY(pNav)-g_iScreenBottomOffset);
	pNav<<SetReload(pdtData.m_bDataChanged);
	pNav<<SetApply(pdtData.m_bDataIsValid && pdtData.m_bDataChanged);
	pdtData.gcNavBar = pNav;

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

//
func void RosterCyclist_OnSelectKey(Gui_Component _pform, i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtPage_RosterCyclist pdtData;
	var i32x iDBId;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = GetData(pthis);

	if(_pform == pdtData.gcRosterListForm)
	{
		// Select a cyclist from roster
		pdtData.m_iSelectedCyclistId = _iKey;
		pdtData.gcRegister<<Hide();
		pdtData.gcUnregister<<Show();
	}
	else if(_pform == pdtData.gcListForm)
	{
		// Select a cyclist from global list
		pdtData.m_iSelectedCyclistId = _iKey;

		// Check if it his registered
		iDBId = Form_GetDynamicDb(pdtData.gcRosterListForm);

		if(IsCyclistPresent(iDBId,_iKey)==1)
		{
			pdtData.gcRegister<<Hide();
			//pdtData.gcUnregister<<Show();
			pdtData.gcUnregister<<Hide();
		}
		else
		{
			if(GetNumCyclistsPresent(iDBId)<pdtData.m_iMaxCyclistsToRegister)
			{
				pdtData.gcRegister<<Show();
				pdtData.gcUnregister<<Hide();
			}
			else
			{
				pdtData.gcRegister<<Hide();
				pdtData.gcUnregister<<Hide();
			}
		}
	}

	// update photo
	pdtData.gcPhotoForm<<GoToRecord(_iKey);
}

//
func void RosterCyclist_OnFormDoubleClick(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtPage_RosterCyclist pdtData;
	var i32x iDBId;
	// get this pointer
	pthis = GetThis();
	// Set Data pointer
	pdtData = GetData(pthis);

	iDBId = Form_GetDynamicDb(pdtData.gcRosterListForm);
	if(_pform == pdtData.gcRosterListForm)
	{
		// remove cyclist
		RosterCyclist_UnRegister(iDBId, _iKey);
		
		// hide buttons
		pdtData.gcRegister<<Hide();
		pdtData.gcUnregister<<Hide();
	}
	else if(_pform == pdtData.gcListForm)
	{
		//print("NumCyclistPresent:"+itoa(GetNumCyclistsPresent(iDBId))+"\n");
		if(GetNumCyclistsPresent(iDBId)<pdtData.m_iMaxCyclistsToRegister)
		{
			// add cyclist
			RosterCyclist_Register(iDBId, _iKey);

			// update register/unregister buttons status
			if(IsCyclistPresent(iDBId,_iKey)==1)
			{
				//print("\tCyclistPresent:"+itoa(_iKey)+"\n");
				pdtData.gcRegister<<Hide();
				//pdtData.gcUnregister<<Show();
				pdtData.gcUnregister<<Hide();
			}
			else
			{
				//print("\tCyclistNotPresent:"+itoa(_iKey)+"\n");
				if(GetNumCyclistsPresent(iDBId)<pdtData.m_iMaxCyclistsToRegister)
				{
					pdtData.gcRegister<<Show();
					pdtData.gcUnregister<<Hide();
				}
				else
				{
					pdtData.gcRegister<<Hide();
					pdtData.gcUnregister<<Hide();
				}
			}
		}
	}
}

//
func i32x IsCyclistPresent(i32x _iDBId,i32x _iCyclistId)
{
	var i32x iJoinId,iRow;
	iJoinId = Join_Constructor(_iDBId,"DYN_cyclist.IDcyclist");

	iRow = Join_FindIndexFromIntData(iJoinId,_iCyclistId);

	Join_Destructor(iJoinId);

	if(iRow>=0)
		return 1;
	return 0;
}

func i32x GetNumCyclistsPresent(i32x _iDBId)
{
	var i32x iJoinId,iNumRows;
	iJoinId = Join_Constructor(_iDBId,"DYN_cyclist.IDcyclist");

	iNumRows = Join_GetNumRows(iJoinId);

	Join_Destructor(iJoinId);

	return iNumRows;
}

func void RosterCyclist_Update()
{
	var Gui_Component pthis;
	var Gui_dtPage_RosterCyclist pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = GetData(pthis);

	DatabaseSubset_Clear(pdtData.m_iSubsetId);

	Query_Create(0,pdtData.m_iSubsetId);
	Query_SelectTable(	0, "DYN_team");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_1.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_2.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_3.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_4.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_5.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_6.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_7.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_8.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_9.DYN_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_1.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_2.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_3.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_4.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_5.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_6.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_7.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_8.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_9.DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_1.DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_2.DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_3.DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_4.DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_5.DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_6.DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_7.DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_8.DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist");
	Query_SelectTable(	0, "DYN_team.fkIDcyclist_9.DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist");
	Query_SelectWhereIntEqual(0,"DYN_team.IDteam", GetMyTeamId());
	Query_Execute(0);

	// Update roster form
	if(pdtData.gcRosterListForm)
		pdtData.gcRosterListForm<<FormRazFilter();
}
func i32x  RosterCyclist_OnDestroy()
{
	var Gui_Component pthis;
	var Gui_dtPage_RosterCyclist pdtData;

	// Retrieve page pointer
	pthis = GetThis();

	// Retrieve Roster data pointer
	pdtData = GetData(pthis);

	// Delete subset
	if(pdtData.m_iSubsetId)
	{
		Subset_Destructor(pdtData.m_iSubsetId);
		Database_Destructor(pdtData.m_iDbId);
	}
}

// to be called by a message callback !
func i32x RosterCyclist_RosterIsValid(i32x _iDB)
{
	var Gui_Component pthis;
	var Gui_dtPage_RosterCyclist pdtData;
	var i32x iDBId;
	pthis = GetThis();
	pdtData = GetData(pthis);
	
	if((GetNumCyclistsPresent(_iDB)>=pdtData.m_iNumCyclistsToRegister)&&(GetNumCyclistsPresent(_iDB)<=pdtData.m_iMaxCyclistsToRegister))
		return true;
	else
		return false;
}


// to be called by a message callback !
func void RosterCyclist_Register(i32x _iDB, i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtPage_RosterCyclist pdtData;
	var i32x iDBId;
	pthis = GetThis();
	pdtData = GetData(pthis);

	// Check if it his registered
	if (RegisterCyclist(_iDB, _iKey))
	{
		pdtData.gcNavBar<<SetReload(true);
		pdtData.m_bDataChanged = true;
	}

	RosterCyclist_Update();
	
	//if((GetNumCyclistsPresent(_iDB)>=pdtData.m_iNumCyclistsToRegister)&&(GetNumCyclistsPresent(_iDB)<=pdtData.m_iMaxCyclistsToRegister))
	if (RosterCyclist_RosterIsValid(_iDB))
	{
		// pdtData.gcSendButton<<Show();
		pdtData.gcNavBar<<SetApply(true);
		pdtData.m_bDataIsValid = true;
	}
	else
	{
		// pdtData.gcSendButton<<Hide();
		pdtData.gcNavBar<<SetApply(false);
		pdtData.m_bDataIsValid = false;
	}
}




//
func void RosterCyclist_UnRegister(i32x _iDB, i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtPage_RosterCyclist pdtData;
	var i32x iDBId;
	pthis = GetThis();
	pdtData = GetData(pthis);

	// Check if it his registered
	if (UnregisterCyclist(_iDB, _iKey))
	{
		pdtData.gcNavBar<<SetReload(true);
		pdtData.m_bDataChanged = true;
	}
	
	RosterCyclist_Update();

	//if(GetNumCyclistsPresent(_iDB)>=pdtData.m_iMaxCyclistsToRegister)
	if (RosterCyclist_RosterIsValid(_iDB))
	{
		// pdtData.gcSendButton<<Show();
		pdtData.gcNavBar<<SetApply(true);
		pdtData.m_bDataIsValid = true;
	}
	else
	{
		// pdtData.gcSendButton<<Hide();
		pdtData.gcNavBar<<SetApply(false);
		pdtData.m_bDataIsValid = false;
	}
}

//
func void  RosterCyclist_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis, pparent;
	var Gui_dtPage_RosterCyclist pdtData;
	var i32x iDBId;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_pComponent == pdtData.gcRegister)
	{
		iDBId = Form_GetDynamicDb(pdtData.gcRosterListForm);
		RosterCyclist_Register(iDBId, pdtData.m_iSelectedCyclistId);
	}
	else if(_pComponent == pdtData.gcUnregister)
	{
		iDBId = Form_GetDynamicDb(pdtData.gcRosterListForm);
		RosterCyclist_UnRegister(iDBId, pdtData.m_iSelectedCyclistId);
	}
}


func void RosterCyclist_NavBack()
{
	var Gui_Component pthis, pparent;
	var Gui_dtPage_RosterCyclist pdtData;
	pthis = GetThis();
	pdtData = GetData(pthis);

	// go back
	pparent = GetParent(pthis);
	pparent<<GoBack();
}

func void RosterCyclist_NavReload()
{
/*
	var Gui_Component pthis;
	var Gui_dtPage_RosterCyclist pdtData;
	pthis = GetThis();
	pdtData = GetData(pthis);

	RosterCyclist_Update();

	// hide nav buttons
	pdtData.gcNavBar<<SetReload(false);
	pdtData.gcNavBar<<SetApply(false);
	pdtData.m_bDataChanged = false;
	*/
}

func void RosterCyclist_NavApply()
{
	var Gui_Component pthis;
	var Gui_dtPage_RosterCyclist pdtData;
	pthis = GetThis();
	pdtData = GetData(pthis);

	// set data
	pdtData.gcRosterListForm<<SendRoster();

	// hide nav buttons
	pdtData.gcNavBar<<SetReload(false);
	pdtData.gcNavBar<<SetApply(false);
	pdtData.m_bDataChanged = false;
}

//
func i32x RegisterCyclist(i32x _iDBId,i32x _iCyclistId)
{
	var szx szTxt,szCyclist,szJoin;
	var i32x iRegisteredCyclistId,i;
	szCyclist = "fkIDcyclist_";
	var boolx bAlreadySelected;

	// check if cyclist is already selected
	bAlreadySelected = false;
	i=0;
	while(i<9)
	{
		szJoin = "DYN_team."+szCyclist+itoa(i+1);
		iRegisteredCyclistId = Database_GetIntData(_iDBId,szJoin,ROW_KEY,GetMyTeamId());
		if(iRegisteredCyclistId==_iCyclistId)
		{
			bAlreadySelected = true;
		 println("cyclist already selected");
			i=9;
		}
		i=i+1;
	}	
	
	if (!bAlreadySelected)
	{
		// add cyclist in first free slot
		i=0;
		while(i<9)
		{
			szJoin = "DYN_team."+szCyclist+itoa(i+1);
			iRegisteredCyclistId = Database_GetIntData(_iDBId,szJoin,ROW_KEY,GetMyTeamId());
			// println("\tRegistered:"+itoa(iRegisteredCyclistId));
			if(iRegisteredCyclistId<=0)
			{
				// println("\t\tAddSlot:"+itoa(i));
				// free slot
				Database_SetIntData(_iDBId,szJoin,ROW_KEY,GetMyTeamId(),_iCyclistId);
				// break loop
				i=20;
			}
			i=i+1;
		}

		if (i>=20) return true;
	}

	return false;
}

//
func i32x UnregisterCyclist(i32x _iDBId,i32x _iCyclistId)
{
	var szx szTxt,szCyclist,szJoin;
	var i32x iRegisteredCyclistId,i;
	szCyclist = "fkIDcyclist_";
	i=0;
	while(i<9)
	{
		szJoin = "DYN_team."+szCyclist+itoa(i+1);
		iRegisteredCyclistId = Database_GetIntData(_iDBId,szJoin,ROW_KEY,GetMyTeamId());
		//println("\tRegistered:"+itoa(iRegisteredCyclistId));
		if(iRegisteredCyclistId==_iCyclistId)
		{
			//println("\t\tRemoveSlot:"+itoa(i));
			// unregister cyclist
			Database_SetIntData(_iDBId,szJoin,ROW_KEY,GetMyTeamId(),0);
			return true;
		}
		i=i+1;
	}

	return false;
}


func Gui_Component NewFormRoster(i32x _iSubsetId)
{
	var Gui_Component pform;
	var Gui_dtForm_Roster pdtData;
	var i32x i;
	var f32x fSize;
	var szx szTxt,szCyclist,szJoin;

	szCyclist = "fkIDcyclist_";

	pdtData = new Gui_dtForm_Roster;


	// Create roster formulaire
	pform = NewForm(_iSubsetId,"DYN_team",true);

	pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Top);
	pform<<FormSetOffset(20);
	pform<<FormSetWidth(256);
	pform<<FormSetLocked(true);

	// stepX
	var f32x fStepX, fSpaceX, fPhotoX;
	fStepX = (800 - g_iScreenLeftOffset - g_iScreenRightOffset);
	fPhotoX = 80 * fStepX / 100;
	fSpaceX = fStepX - fPhotoX;
	fPhotoX = fPhotoX / 9.0;
	fSpaceX = fSpaceX / 10.0;
	fStepX = fPhotoX + fSpaceX;


	// Roster photo cyclist
	pform<<FormSetFont(smImpact,smImpact);
	pform<<FormSetAlign(e_GUI_HAlign_Max,e_GUI_VAlign_Top);
	i=0;
	while(i<9)
	{
		szJoin = "DYN_team."+szCyclist+itoa(i+1)+".DYN_cyclist.gene_tgaID_photo";
//		pform<<FormShowBitmapField(szJoin,"",75.0*g_fScreenScaleFactor*i,100);
		pform<<FormShowBitmapField(szJoin,"", fStepX*g_fScreenScaleFactor*i,0);
		szJoin = "DYN_team."+szCyclist+itoa(i+1)+".DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname";
//		pform<<FormShowField(szJoin,"",75.0*g_fScreenScaleFactor*i,100+64.0*g_fScreenScaleFactor);
		pform<<FormShowField(szJoin,"", fStepX*g_fScreenScaleFactor*i,64.0*g_fScreenScaleFactor);
		i=i+1;
	}
	AddInterface(pform,Gui_iForm_Roster,pdtData);

	return pform;
}

func Gui_Component NewCyclistListForm()
{
	return NewCyclistListFormExt(DATABASE_CLIENT,false);
}
func Gui_Component NewCyclistListFormExt(i32x _iSubsetId,i32x _bDynamic)
{
	var Gui_Component pform;
	var Gui_dtForm_CyclistList pdtData;
	var i32x i,iPosX;
	var szx szTxt;


	pdtData = new Gui_dtForm_CyclistList;

	// New list form
	pform = NewListForm(_iSubsetId,"DYN_cyclist",_bDynamic);
	pform<<FormSetOffset(4);

	AddInterface(pform,Gui_iForm_CyclistList,pdtData);

	return pform;
}
func void CyclistListForm_OnSendRoster()
{
	var Gui_Component pthis;
	var Gui_dtForm_CyclistList pdtData;
	var i32x iSubsetId,iDbId;

	pthis = GetThis();
	pdtData = GetData(pthis);

	iDbId = Form_GetDynamicDb(pthis);
	iSubsetId = Subset_Constructor("RosterDB",iDbId);
	Database_AddTables(iSubsetId,1);
	Table_SetName(iSubsetId, 0, "DYN_team");
	TableSubset_SelectColumns(iSubsetId, 0, "*");
	Query_Create(0,iSubsetId);
	Query_SelectTable(	0, "DYN_team");
	Query_SelectWhereIntEqual(0,"DYN_team.IDteam", GetMyTeamId());
	Query_Execute(0);

	// Send subset to server
	Database_Send(iSubsetId,"RosterDB",g_pMenuServerSocket);

	Subset_Destructor(iSubsetId);
}

func void CyclistListForm_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var Gui_Component gcGrid;
	var i32x i,iPosX;
	var szx szTxt;

	var i32x iNameColumnWidth;
	var i32x iColumnWidth;
	iNameColumnWidth = 128;
	iColumnWidth = 96;

	iPosX = 0;
	_pform<<FormSetDecimal(0);
	_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	_pform<<FormSetWidth(128);
	_pform<<FormSetOffset(10);

	_pform<<FormAddVariable("DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname","CYCLISTNAME");
	_pform<<FormAddVariable("DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_firstname","CYCLISTFIRSTNAME");
	if(_iIndex==0)
	{
		_pform<<FormSetTitle(true,true);
		_pform<<FormShowFormatField("DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",39,"",iPosX,0);
		_pform<<FormSetTitle(true,false);

		_pform<<FormSetWidth(iColumnWidth);
		_pform<<FormSetFont(smImpact, smTrebuchet);
		szTxt = GetLocalizedFromKey(iszDisponibility);
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic.DYN_characteristic.gene_f_disponibility",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		szTxt = GetLocalizedFromKey(iszRouleur);
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_riding",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		szTxt = GetLocalizedFromKey(iszGrimpeur);
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_climbing",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		szTxt = GetLocalizedFromKey(iszDescendeur);
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_downhilling",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		szTxt = GetLocalizedFromKey(iszEndurance);
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_resistance",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		szTxt = GetLocalizedFromKey(iszRecuperation);
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_endurance",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		szTxt = GetLocalizedFromKey(iszAcceleration);
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_acceleration",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		// MistER-j LOCALISATION
		szTxt = GetLocalizedFromKey(iszSprint);
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_sprint",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		// MistER-j LOCALISATION
		szTxt = GetLocalizedFromKey(iszAgilite);
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_agility",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		
	}
	else
	{
		_pform<<FormSetTitle(false,true);
		szTxt = "";
		_pform<<FormShowFormatField("DYN_cyclist.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",39,szTxt,iPosX,0);
		_pform<<FormSetTitle(false,false);

		_pform<<FormSetWidth(iColumnWidth);
		_pform<<FormSetFont(smImpact, smTrebuchet);
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic.DYN_characteristic.gene_f_disponibility",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_riding",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_climbing",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_downhilling",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_resistance",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_endurance",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_sprint",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_sprint",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		_pform<<FormShowField("DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist.charac_f_agility",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
	}
}
