func i32x GetMyInRaceTeamId()
{
	return Join_GetIntFromKey(g_oMenuJoins.m_jUser_iInRaceTeamId, GetMyUserId());
}
func i32x GetMyTeamId()
{
	return Join_GetIntFromKey(g_oMenuJoins.m_jUser_iTeamId, GetMyUserId());
}
func i32x GetMyUserId()
{
	return g_oUser.m_iMyID;
}
func i32x Roster_OnCreate()
{
	var Gui_Component pthis,pcaption,ptab,poption;
	var Gui_dtPage_Roster pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_Roster;
	SetData(pthis,pdtData);

	if(GetMyTeamId()>0)
		pdtData.m_iTeamId = GetMyTeamId();
	else
		pdtData.m_iTeamId = Join_GetIntFromIndex(g_oMenuJoins.m_iTeamID,0);



	// Onglet selector
	pdtData.gcOption = NewGroupOption(700.0*g_fScreenScaleFactor);
	MountComponent(pthis,pdtData.gcOption);
	MoveTo(pdtData.gcOption,10,g_iScreenTopOffset+10.0);

	// Tab selector
	pdtData.gcControlTab = NewTabControl();
	MountComponent(pthis,pdtData.gcControlTab);
	MoveTo(pdtData.gcControlTab,g_iScreenLeftOffset,g_iScreenTopOffset+40.0);

	// Current negociation list button
	poption = NewTextRadioButton(smBauer,GetLocalizedFromKey(iszCycliste),0);
	Stretch(poption,10,0);
	pdtData.gcOption<<AddOption(poption);

	// Find cyclist list button
	poption = NewTextRadioButton(smBauer,GetLocalizedFromKey(iszStaff),1);
	Stretch(poption,10,0);
	pdtData.gcOption<<AddOption(poption);

	// Cyclist info form
	pdtData.gcCyclistInfoTab = NewCyclistInfoTab();
	pdtData.gcControlTab<<AddTab(pdtData.gcCyclistInfoTab);

	pdtData.gcStaffInfoTab = NewStaffInfoTab();
	pdtData.gcControlTab<<AddTab(pdtData.gcStaffInfoTab);

	pdtData.gcControlTab<<ShowTab(0);
	pdtData.gcOption<<SelectOption(0);

	// Subscribe button
	pdtData.gcSubscribeButton = NewCM2Button(GetLocalizedFromKey(iszInscription));
	MountComponent(pthis,pdtData.gcSubscribeButton);
	MoveTo(pdtData.gcSubscribeButton,g_iScreenWidth-g_iScreenRightOffset-SizeX(pdtData.gcSubscribeButton),(g_iScreenTopOffset-SizeY(pdtData.gcSubscribeButton))/2+10);

	// team form
	pdtData.gcTeamForm = NewForm(DATABASE_CLIENT,"DYN_team",false);
	pdtData.gcTeamForm<<FormSetFont(smImpact,smBauer);
	pdtData.gcTeamForm<<FormSetWidth(384.0*g_fScreenScaleFactor);
	pdtData.gcTeamForm<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	pdtData.gcTeamForm<<FormShowField("DYN_team.config_sz_real","",0,0);
	pdtData.gcTeamForm<<FormSetMaJInform(true); // keep inform about record change

	MountComponent(pthis,pdtData.gcTeamForm);
	MoveTo(pdtData.gcTeamForm,g_iScreenWidthDiv2-(192.0*g_fScreenScaleFactor),(g_iScreenTopOffset-SizeY(pdtData.gcTeamForm))/2);

	// Left and Right command
	pdtData.gcPreviousTeam = NewButtonDyn(smLeftButton);
	pdtData.gcNextTeam = NewButtonDyn(smRightButton);
	MountComponent(pthis,pdtData.gcPreviousTeam);
	MountComponent(pthis,pdtData.gcNextTeam);
	MoveTo(pdtData.gcPreviousTeam,RelPosX(pdtData.gcTeamForm)-SizeX(pdtData.gcPreviousTeam),(g_iScreenTopOffset-SizeY(pdtData.gcTeamForm))/2+10);
	MoveTo(pdtData.gcNextTeam,RelPosX(pdtData.gcTeamForm)+SizeX(pdtData.gcTeamForm),(g_iScreenTopOffset-SizeY(pdtData.gcTeamForm))/2+10);

	pdtData.gcTeamForm<<FormSetRef(ROW_KEY);
	pdtData.gcTeamForm<<GoToRecord(pdtData.m_iTeamId);



	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	// Send button
	pdtData.gcSendButton = NewCM2Button(GetLocalizedFromKey(iszSend));
	MountComponent(pthis,pdtData.gcSendButton);
	MoveTo(pdtData.gcSendButton,RelPosX(pdtData.gcBackButton)-SizeX(pdtData.gcSendButton)-10,g_iScreenHeight-SizeY(pdtData.gcSendButton)-g_iScreenBottomOffset);
	pdtData.gcSendButton<<Hide();

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func void Roster_OnSelectKey(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis,pback, parent;
	var Gui_dtPage_Roster pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_pform == pdtData.gcTeamForm)
	{
		pdtData.m_iTeamId = _iKey;
		if(pdtData.m_iTeamId!=GetMyTeamId())
			pdtData.gcSubscribeButton<<Show();
		else
			pdtData.gcSubscribeButton<<Hide();
		pdtData.gcStaffInfoTab<<DisplayTeam(_iKey);
		pdtData.gcCyclistInfoTab<<DisplayTeam(_iKey);
	}
}

func i32x  Roster_OnDestroy()
{
	// uninit page
}

func void Roster_OnRadioCheck(Gui_Component _pComponent,i32x _iValue)
{
	var Gui_Component pthis,pback, parent;
	var Gui_dtPage_Roster pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_pComponent == pdtData.gcOption)
	{
		// Show correspondant tab
		pdtData.gcControlTab<<ShowTab(_iValue);
	}
}



func void  Roster_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_Roster pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Retrieve parent
	pparent = GetParent(pthis);

	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		pthis<<Hide();
		// Back
		pparent<<GoBack();
	}
	else if(_pComponent == pdtData.gcSendButton)
	{
		// Tell list form to send database
		pdtData.gcStaffInfoTab<<SendDatabase(g_pMenuServerSocket,"StaffRoleDB");
		pdtData.gcCyclistInfoTab<<SendDatabase(g_pMenuServerSocket,"CyclistStaffDB");

		pdtData.gcSendButton<<Hide();
	}
	else if(_pComponent == pdtData.gcPreviousTeam)
	{
		pdtData.gcTeamForm<<PreviousRecord();
	}
	else if(_pComponent == pdtData.gcNextTeam)
	{
		pdtData.gcTeamForm<<NextRecord();
	}
	else if(_pComponent==pdtData.gcSubscribeButton)
	{
		// Send subscribe message
		g_pMenuServerSocket<<mGame_UserSubscribe(pdtData.m_iTeamId);
	}
}

func void Roster_OnNeedSend()
{
	var Gui_Component pthis;
	var Gui_dtPage_Roster pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	pdtData.gcSendButton<<Show();

}

// forward declaration
func Gui_Component NewCyclistInfoTab()
{
	var Gui_Component pthis,pwindow;
	var Gui_dtOnglet_Cyclist pdtData;
	var i32x iSubsetId;

	pthis = NewObject(Gui_iOnglet_Cyclist);
	pdtData = new Gui_dtOnglet_Cyclist;

	SetData(pthis,pdtData);

	iSubsetId = Subset_Constructor("SUBSET_CYCLIST_INFO",DATABASE_CLIENT);
	Database_AddTables(iSubsetId,3);
	Table_SetName(iSubsetId, 0, "DYN_cyclist");
	TableSubset_SelectColumns(iSubsetId, 0, "*");
	Table_SetName(iSubsetId, 1, "DYN_characteristic");
	TableSubset_SelectColumns(iSubsetId, 1, "*");
	Table_SetName(iSubsetId, 2, "DYN_characteristic_cyclist");
	TableSubset_SelectColumns(iSubsetId, 2, "*");

	Query_Create(0,iSubsetId);
	Query_SelectTable(	0, "DYN_cyclist");
	Query_SelectTable(	0, "DYN_cyclist.fkIDcharacteristic.DYN_characteristic");
	Query_SelectTable(	0, "DYN_cyclist.fkIDcharacteristic_cyclist.DYN_characteristic_cyclist");
	Query_SelectWhereIntDifferent(0,"DYN_cyclist.fkIDteam", LOOSER_TEAM );
	Query_Execute(0);

	pdtData.m_iSubsetId = iSubsetId;

	iSubsetId = Subset_Constructor("SUBSET_TEAM_STAFF_INFO",DATABASE_CLIENT);
	Database_AddTables(iSubsetId,3);
	Table_SetName(iSubsetId, 0, "DYN_staff");
	TableSubset_SelectColumns(iSubsetId, 0, "*");
	Table_SetName(iSubsetId, 1, "DYN_characteristic");
	TableSubset_SelectColumns(iSubsetId, 1, "*");

	Query_Create(0,iSubsetId);
	Query_SelectTable(	0, "DYN_staff");
	Query_SelectTable(	0, "DYN_staff.fkIDcharacteristic.DYN_characteristic");
	Query_SelectWhereIntEqual(0,"DYN_staff.fkIDteam", GetMyTeamId() );
	Query_Execute(0);

	pdtData.m_iStaffDbId = iSubsetId;

	// Cyclist info form
	var Gui_dtInfo_Cyclist pdtFormData;
	pdtFormData = new Gui_dtInfo_Cyclist;

	pdtData.gcCyclistInfoForm =  NewCyclistInfoForm2(pdtData.m_iSubsetId,pdtData.m_iStaffDbId);
	AddInterface(pdtData.gcCyclistInfoForm,Gui_iForm_InfoCyclist,pdtFormData);
	pdtData.gcCyclistInfoForm<<FormFilterByIntEqual("DYN_cyclist.fkIDteam",GetMyTeamId());
	MountComponent(pthis,pdtData.gcCyclistInfoForm);

	// cyclist list form
	pwindow = NewWindow((g_iScreenWidth - g_iScreenLeftOffset - g_iScreenRightOffset), g_iScreenHeight - g_iScreenBottomOffset- (AbsPosY(pdtData.gcCyclistInfoForm)+SizeY(pdtData.gcCyclistInfoForm)+10) - 170);
	pdtData.gcCyclistListForm = NewCyclistListForm();
	pwindow<<WindowMount(pdtData.gcCyclistListForm);
	pdtData.gcCyclistListForm<<FormSetOffset(iTableGapWidth);
	pdtData.gcCyclistListForm<<FormFilterByIntEqual("DYN_cyclist.fkIDteam",GetMyTeamId());
	MountComponent(pthis, pwindow);
	MoveTo(pwindow, 0, RelPosY(pdtData.gcCyclistInfoForm)+SizeY(pdtData.gcCyclistInfoForm)+5 );

	StretchTo(pthis,RelPosX(pwindow)+SizeX(pwindow),RelPosY(pwindow)+SizeY(pwindow));

	return pthis;
}
func void OngletCyclist_OnDisplayTeam(i32x _iTeamId)
{
	var Gui_Component pthis;
	var Gui_dtOnglet_Cyclist pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = GetData(pthis);

	pdtData.gcCyclistListForm<<FormFilterByIntEqual("DYN_cyclist.fkIDteam",_iTeamId);
	pdtData.gcCyclistInfoForm<<FormFilterByIntEqual("DYN_cyclist.fkIDteam",_iTeamId);

	// check own team
	if(GetMyTeamId() == _iTeamId)
	{
		pdtData.gcCyclistInfoForm<<Enable();
	}
	else
	{
		pdtData.gcCyclistInfoForm<<Disable();
	}
}

func void OngletCyclist_OnSelectKey(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtOnglet_Cyclist pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = GetData(pthis);

	if(_pform == pdtData.gcCyclistListForm)
	{
		// Select a cyclist from global list
		pdtData.m_iSelectedCyclistId = _iKey;

		pdtData.m_iSelectedTeamId = Join_GetIntFromKey(g_oMenuJoins.m_iCyclistTeamID,_iKey);

		if(pdtData.m_iSelectedTeamId != GetMyTeamId())
		{
			pdtData.gcCyclistInfoForm<<Disable();
		}
		else
			pdtData.gcCyclistInfoForm<<Enable();

		if(pdtData.m_iNeedSave)
		{
			pdtData.gcCyclistInfoForm<<SaveRecord();
		}
		pdtData.m_iNeedSave = 0;
		pdtData.gcCyclistInfoForm<<FormFilterByIntEqual("DYN_cyclist.IDcyclist",_iKey);
	}
}

func void OngletCyclist_SendDatabase(Net_Client _poServer,szx _szName)
{
	var Gui_Component pthis;
	var Gui_dtOnglet_Cyclist pdtData;
	var i32x iDBId,iSubsetId;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Save record
	pdtData.gcCyclistInfoForm<<SaveRecord();

	iDBId = Form_GetDynamicDb(pdtData.gcCyclistInfoForm);

	iSubsetId = Subset_Constructor(_szName,iDBId);

	Database_AddTables(iSubsetId,1);
	Table_SetName(iSubsetId, 0, "DYN_cyclist");
	TableSubset_SelectColumns(iSubsetId, 0, "IDcyclist");
	TableSubset_SelectColumns(iSubsetId, 0, "fkIDteam");
	TableSubset_SelectColumns(iSubsetId, 0, "fkIDstaff*");

	Query_Create(0,iSubsetId);
	Query_SelectTable(	0, "DYN_cyclist");
	Query_SelectWhereIntEqual(0,"DYN_cyclist.fkIDteam", GetMyTeamId() );
	Query_Execute(0);

	Database_Send(iSubsetId, _szName, _poServer);

	Subset_Destructor(iSubsetId);
}



func void OngletCyclist_OnMaj(Gui_Component _pform,i32x _iValue,boolx _bChanged)
{
	var Gui_Component pthis,parent;
	var Gui_dtOnglet_Cyclist pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = GetData(pthis);

	if(_bChanged)
	{
		pdtData.m_iNeedSave = true;

		parent = GetParent(pthis);
		if(parent)
			parent<<NeedSend();
	}
}
func void InfoCyclist_OnMaj(Gui_Component _pform,i32x _iValue,boolx _bChanged)
{
	var Gui_Component pthis,parent;
	var Gui_dtOnglet_Cyclist pdtData;

	// get this pointer
	pthis = GetThis();

	parent = GetParent(pthis);

	if(parent)
		parent<<FormMaJInt(_pform,_iValue,_bChanged);

}

// forward declaration
func Gui_Component NewStaffInfoTab()
{
	var Gui_Component pthis,pwindow;
	var Gui_dtOnglet_Staff pdtData;

	pthis = NewObject(Gui_iOnglet_Staff);
	pdtData = new Gui_dtOnglet_Staff;

	SetData(pthis,pdtData);

	// Staff info form
	pdtData.gcStaffInfo = NewFormStaff();
	MountComponent(pthis,pdtData.gcStaffInfo);
	pdtData.gcStaffInfo<<FormFilterByIntEqual("DYN_staff.fkIDteam",GetMyTeamId());

	// Staff list form
	pwindow = NewWindow((g_iScreenWidth - g_iScreenLeftOffset - g_iScreenRightOffset), g_iScreenHeight - g_iScreenBottomOffset- (AbsPosY(pdtData.gcStaffInfo)+SizeY(pdtData.gcStaffInfo)+10) - 170);
	pdtData.gcStaffList = NewStaffListForm();
	pwindow<<WindowMount(pdtData.gcStaffList);
	pdtData.gcStaffList<<FormSetOffset(5);
	MountComponent(pthis,pwindow);
	pdtData.gcStaffList<<FormFilterByIntEqual("DYN_staff.fkIDteam",GetMyTeamId());
	MoveTo(pwindow,0,RelPosY(pdtData.gcStaffInfo)+SizeY(pdtData.gcStaffInfo)+5);


	StretchTo(pthis,RelPosX(pwindow)+SizeX(pwindow),RelPosY(pwindow)+SizeY(pwindow));
	
	return pthis;
}

func void OngletStaff_OnDisplayTeam(i32x _iTeamId)
{
	var Gui_Component pthis;
	var Gui_dtOnglet_Staff pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = GetData(pthis);

	pdtData.gcStaffInfo<<FormFilterByIntEqual("DYN_staff.fkIDteam",_iTeamId);
	pdtData.gcStaffList<<FormFilterByIntEqual("DYN_staff.fkIDteam",_iTeamId);

	// check own team
	if(GetMyTeamId() == _iTeamId)
	{
		pdtData.gcStaffInfo<<Enable();
	}
	else
	{
		pdtData.gcStaffInfo<<Disable();
	}
}

func void OngletStaff_OnRoleChange()
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtOnglet_Staff pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Show send button
	pparent = GetParent(pthis);
	if(pparent)
		pparent<<NeedSend();

	pdtData.gcStaffList<<FormUpdate();
}

func void OngletStaff_OnSelectKey(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtOnglet_Staff pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_pform == pdtData.gcStaffList)
	{
		pdtData.gcStaffInfo<<FormFilterByIntEqual("DYN_staff.IDstaff",_iKey);
	}
}


func void OngletStaff_SendDatabase(Net_Client _poServer,szx _szName)
{
	var Gui_Component pthis;
	var Gui_dtOnglet_Staff pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	pdtData.gcStaffList<<SendDatabase(_poServer,_szName);
}
