
func i32x RosterStaff_OnCreate()
{
	var Gui_Component pthis,pcaption,pwindow;
	var Gui_dtPage_RosterStaff pdtData;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_RosterStaff;
	SetData(pthis,pdtData);

	// Caption
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszStaffRoster));
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetColor(pcaption, cPageTitleColor);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// Staff info form
	pdtData.gcStaffInfo = NewFormStaff();
	MountComponent(pthis,pdtData.gcStaffInfo);
	MoveTo(pdtData.gcStaffInfo,g_iScreenLeftOffset,g_iScreenTopOffset+10);
	pdtData.gcStaffInfo<<FormFilterByIntEqual("DYN_staff.fkIDteam",GetMyTeamId());

	// Staff list form
	pwindow = NewWindow(700.0*g_fScreenScaleFactor,250.0*g_fScreenScaleFactor);
	pdtData.gcStaffList = NewStaffListForm();
	pwindow<<WindowMount(pdtData.gcStaffList);
	pdtData.gcStaffList<<FormSetOffset(5);
	MountComponent(pthis,pwindow);
	pdtData.gcStaffList<<FormFilterByIntEqual("DYN_staff.fkIDteam",GetMyTeamId());
	MoveTo(pwindow,g_iScreenLeftOffset,300.0*g_fScreenScaleFactor);

	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	// Send button
	pdtData.gcSendButton = NewCM2Button(GetLocalizedFromKey(iszSend));
	MountComponent(pthis,pdtData.gcSendButton);
	MoveTo(pdtData.gcSendButton,RelPosX(pdtData.gcBackButton)-SizeX(pdtData.gcSendButton)-10,g_iScreenHeight-SizeY(pdtData.gcSendButton)-g_iScreenBottomOffset);
	pdtData.gcSendButton<<Hide();

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func i32x  RosterStaff_OnDestroy()
{
	// uninit page
}

func void  RosterStaff_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_RosterStaff pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);
	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		// Click on back button
		pparent = GetParent(pthis);

		// Back
		pparent<<GoBack();
	}
	else if(_pComponent == pdtData.gcSendButton)
	{
		// Tell list form to send database
		pdtData.gcStaffList<<SendDatabase(g_pMenuServerSocket,"StaffRoleDB");

		// Hide send button
		pdtData.gcSendButton<<Hide();
	}
}

func void RosterStaff_OnRoleChange()
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_RosterStaff pdtData;

	// get this pointer
	pthis = GetThis();


	// Get Data pointer
	pdtData = GetData(pthis);

	// Show send button
	pdtData.gcSendButton<<Show();
	pdtData.gcStaffList<<FormUpdate();
}

func void RosterStaff_OnSelectKey(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_RosterStaff pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	if(_pform == pdtData.gcStaffList)
	{
		pdtData.gcStaffInfo<<FormFilterByIntEqual("DYN_staff.IDstaff",_iKey);
	}
}

func void StaffForm_OnFormMaJInt(Gui_Component _poField,i32x _iValue,i32x _bChanged)
{
	var Gui_Component pthis,parent;
	var Gui_dtForm_Staff pdtData;

	pthis = GetThis();

	// Save record auto
	if(_bChanged)
	{
		pthis<<SaveRecord();

		// Inform parent of role change
		parent = GetParent(pthis);
		if(parent) parent<<RoleChange();
	}
}

func Gui_Component NewFormStaff()
{
	var Gui_Component pform,pbox;
	var Gui_dtForm_Staff pdtData;
	var szx szTxt;

	pdtData = new Gui_dtForm_Staff;
	// New list form
	pform = NewForm(DATABASE_CLIENT,"DYN_staff",false);
	pform<<FormSetFont(smImpact,smTrebuchet);
	pform<<FormSetAlign(e_GUI_HAlign_Left,e_GUI_VAlign_Center);
	pform<<FormSetOffset(4);
	pform<<FormSetWidth(256);
	pbox = NewBoxFilled(smBlueFrame,512+148+4,95);
	pform<<FormAddField(pbox,0,0);
	szTxt = GetLocalizedFromKey(iszFirstname);
	pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.civic_sz_firstname",szTxt,100,32);
	szTxt = GetLocalizedFromKey(iszNom);
	pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",szTxt,100,62);
	pform<<FormSetLocked(false);
	pform<<FormSetMaJInform(true);
	szTxt = GetLocalizedFromKey(iszRole);
	pform<<FormSetFont(smImpact,smTrebuchet);
	pform<<FormShowListBoxField("DYN_staff.fkIDstaff_role","STA_staff_role.IDstaff_role","STA_staff_role.gene_strID_role",szTxt,100,2);
	StretchTo(pform,512+148,128);

	AddInterface(pform,Gui_iForm_Staff,pdtData);
	return pform;
}


func Gui_Component NewStaffListForm()
{
	var Gui_Component pform;
	var Gui_dtForm_StaffList pdtData;
	var i32x i,iPosX;
	var szx szTxt;


	pdtData = new Gui_dtForm_StaffList;

	// New list form
	pform = NewListForm(DATABASE_CLIENT,"DYN_staff",false);
	pform<<FormSetOffset(4);

	AddInterface(pform,Gui_iForm_StaffList,pdtData);

	return pform;
}
func void StaffListForm_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var i32x i,iPosX;
	var szx szTxt;

	iPosX = 0;
	_pform<<FormSetDecimal(0);
	_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	_pform<<FormSetWidth(128);
	_pform<<FormSetOffset(0);
	_pform<<FormSetLocked(true);

	if(_iIndex==0)
	{
		_pform<<FormSetTitle(true,true);
		szTxt = GetLocalizedFromKey(iszNom);
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname","",iPosX,0);
		_pform<<FormSetTitle(true,false);
		szTxt = GetLocalizedFromKey(iszRole);
		_pform<<FormShowField("DYN_staff.fkIDstaff_role.STA_staff_role.gene_strID_role",szTxt,iPosX,0);
		_pform<<FormSetWidth(76);
		iPosX = iPosX +128;
		_pform<<FormSetFont(smImpact,smTrebuchet);
		szTxt = GetLocalizedFromKey(iszKinesitherapy);
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_kinesitherapy",szTxt,iPosX,0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszManipulation);
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_manipulation",szTxt,iPosX,0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszMassage);
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_massage",szTxt,iPosX,0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszMechanics);
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_mechanics",szTxt,iPosX,0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszMedecine);
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_medecine",szTxt,iPosX,0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszFitness);
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_physical_preparation",szTxt,iPosX,0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszPsychology);
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_psychology",szTxt,iPosX,0);
		iPosX = iPosX +76;
		szTxt = GetLocalizedFromKey(iszTraining);
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_training",szTxt,iPosX,0);
	}
	else
	{
		_pform<<FormSetTitle(false,true);
		szTxt = "";
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.civic_sz_lastname",szTxt,iPosX,0);
		_pform<<FormSetTitle(false,false);
		_pform<<FormShowField("DYN_staff.fkIDstaff_role.STA_staff_role.gene_strID_role",szTxt,iPosX,0);
		_pform<<FormSetWidth(76);
		iPosX = iPosX +128;
		_pform<<FormSetFont(smImpact,smTrebuchet);
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_kinesitherapy",szTxt,iPosX,0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_manipulation",szTxt,iPosX,0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_massage",szTxt,iPosX,0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_mechanics",szTxt,iPosX,0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_medecine",szTxt,iPosX,0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_physical_preparation",szTxt,iPosX,0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_psychology",szTxt,iPosX,0);
		iPosX = iPosX +76;
		_pform<<FormShowField("DYN_staff.fkIDcharacteristic.DYN_characteristic.skill_f_training",szTxt,iPosX,0);
	}
}
/*		iPosX = iPosX +76;
*/