func i32x GetCurrentDayId()
{
	var i32x iDayId;
	iDayId = Database_GetIntData(DATABASE_CLIENT,"GAM_config.fkIDday",ROW_INDEX,0);
	return iDayId;
}
func i32x GetCurrentMonthId()
{
	var i32x iMonthId;
	iMonthId = Database_GetIntData(DATABASE_CLIENT,"GAM_config.fkIDday.DYN_day.fkIDmonth",ROW_INDEX,0);
	return iMonthId;
}

func i32x Season_OnCreate()
{
	var Gui_Component pthis,pcaption,pwindow;
	var Gui_dtPage_Season pdtData;
	var f32x fCenterAxisX,fSelectorCenterAxisY;
	var i32x iStageId;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = new Gui_dtPage_Season;
	SetData(pthis,pdtData);

	pdtData.m_iStageId = GetCurrentStageId();

	// Caption
	pcaption = NewCaption(smBauer,GetLocalizedFromKey(iszCalendrier));
	MountComponent(pthis,pcaption);
	SetColor(pcaption, cPageTitleColor);
	StretchTo(pcaption,g_iScreenWidth,0);
	SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	SetScale(pcaption,1.8*g_fScreenScaleFactor);
	MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

	// Calendar
	pdtData.gcCalendar=Calendar_NewCalendar(33.0*g_fScreenScaleFactor,42.0*g_fScreenScaleFactor,11.0*g_fScreenScaleFactor,12.0*g_fScreenScaleFactor);
	MountComponent(pthis,pdtData.gcCalendar);
	MoveTo(pdtData.gcCalendar,g_iScreenLeftOffset,g_iScreenTopOffset+50.0);
	fCenterAxisX = RelPosX(pdtData.gcCalendar) + SizeX(pdtData.gcCalendar)/2;

	// a form that lists all the months and changes the calendar
	pdtData.gcMonthForm=TrainingSeason_MonthForm();
	MountComponent(pthis,pdtData.gcMonthForm);
	pdtData.gcMonthForm<<GoToRecord(GetCurrentMonthId()-1);
	MoveTo(
		pdtData.gcMonthForm,
		(fCenterAxisX-SizeX(pdtData.gcMonthForm)/2.0),
		g_iScreenTopOffset+10.0
	);
	fSelectorCenterAxisY = g_iScreenTopOffset+10.0+SizeY(pdtData.gcMonthForm)/2;

	// - Next month
	pdtData.gcNextMonthButton = NewButtonDyn(smRightButton); 
	MountComponent(pthis,pdtData.gcNextMonthButton);
	MoveTo(
		pdtData.gcNextMonthButton,
		(fCenterAxisX+SizeX(pdtData.gcMonthForm)/2.0),
		(fSelectorCenterAxisY-SizeY(pdtData.gcNextMonthButton)/2.0)
	);
	// - Previous month
	pdtData.gcPreviousMonthButton = NewButtonDyn(smLeftButton); 
	MountComponent(pthis,pdtData.gcPreviousMonthButton);
	MoveTo(
		pdtData.gcPreviousMonthButton,
		(fCenterAxisX-SizeX(pdtData.gcMonthForm)/2.0-SizeX(pdtData.gcPreviousMonthButton)),
		(fSelectorCenterAxisY-SizeY(pdtData.gcPreviousMonthButton)/2.0)
	);


	// Stage info form
	pdtData.gcStageInfoForm = NewStageInfoForm3DMesh(400.0*g_fScreenScaleFactor,400.0*g_fScreenScaleFactor);
	MountComponent(pthis,pdtData.gcStageInfoForm);
	MoveTo(pdtData.gcStageInfoForm,RelPosX(pdtData.gcCalendar)+SizeX(pdtData.gcCalendar),RelPosY(pdtData.gcCalendar));

	// Stage list form
	pwindow = NewWindow(g_iScreenWidth-g_iScreenLeftOffset-g_iScreenRightOffset - 100,g_iScreenHeight - g_iScreenBottomOffset - RelPosY(pdtData.gcCalendar) -  SizeY(pdtData.gcCalendar) - 5);
	pdtData.gcStageListForm = NewStageListForm();
	pwindow<<WindowMount(pdtData.gcStageListForm);
	MountComponent(pthis,pwindow);
	MoveTo(pwindow,g_iScreenLeftOffset,RelPosY(pdtData.gcCalendar) + SizeY(pdtData.gcCalendar));
	pdtData.gcStageListForm<<FormFilterByIntEqual("STA_stage.fkIDday",GetCurrentDayId());

	// Race info/stage info
	pdtData.gcStageInfo = NewCM2Button(GetLocalizedFromKey(iszEtape));
	MountComponent(pthis,pdtData.gcStageInfo);
	MoveTo(pdtData.gcStageInfo,RelPosX(pdtData.gcStageInfoForm),g_iScreenTopOffset+10.0);

	pdtData.gcRaceInfo = NewCM2Button(GetLocalizedFromKey(iszCourse));
	MountComponent(pthis,pdtData.gcRaceInfo);
	MoveTo(pdtData.gcRaceInfo,RelPosX(pdtData.gcStageInfo)+SizeX(pdtData.gcStageInfo),g_iScreenTopOffset+10.0);

	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	iStageId = Join_GetIntFromIndex(g_oMenuJoins.m_iConfig_iCurrentStageId,0);
	pdtData.gcStageInfoForm<<FormFilterByIntEqual("STA_stage.IDstage",iStageId);

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func i32x  Season_OnDestroy()
{
	// uninit page
}

func void Season_SelectMonth(i32x _iIDMonth)
{
	var Gui_Component pthis;
	var Gui_dtPage_Season pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	pdtData.gcCalendar<<ShowMonth(_iIDMonth);
}

func void Season_OnDaySelected(i32x _iDayId)
{
	var Gui_Component pthis;
	var Gui_dtPage_Season pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	pdtData.gcStageListForm<<FormFilterByIntEqual("STA_stage.fkIDday",_iDayId);
	pdtData.m_iStageId = Join_FindKeyFromIntData(g_oMenuJoins.m_iStage_iDayId, _iDayId);
	if(pdtData.m_iStageId<=0)
		pdtData.m_iStageId = GetCurrentStageId();
}


func void  Season_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_Season pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);
	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		// Click on back button
		pparent = GetParent(pthis);

		// Back
		pparent<<GoBack();
	}
	else if(_pComponent == pdtData.gcNextMonthButton)
	{
		// Go to next month
		pdtData.gcMonthForm<<NextRecord();
	}
	else if(_pComponent == pdtData.gcPreviousMonthButton)
	{
		// Go to previous month
		pdtData.gcMonthForm<<PreviousRecord();
	}
	else if(_pComponent == pdtData.gcStageInfo)
	{
		// Click on back button
		pparent = GetParent(pthis);

		if(pparent)
		{
			pparent<<DisplayPage(g_Page_StageInfo);
			g_stPage[g_Page_StageInfo].gcPage<<SelectStage(pdtData.m_iStageId);
		}

	}
	else if(_pComponent == pdtData.gcRaceInfo)
	{
		// Click on back button
		pparent = GetParent(pthis);

		if(pparent)
			pparent<<DisplayPage(g_Page_RaceInfo);
	}
}
func void Season_OnSelectKey(Gui_Component _pform,i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtPage_Season pdtData;
	var i32x iDBId;

	// get this pointer
	pthis = GetThis();

	// Set Data pointer
	pdtData = GetData(pthis);

	if(_pform == pdtData.gcStageListForm)
	{
		pdtData.m_iStageId = _iKey;
		pdtData.gcStageInfoForm<<FormFilterByIntEqual("STA_stage.IDstage",_iKey);
	}
}

func Gui_Component NewStageListForm()
{
	var Gui_Component pform;
	var Gui_dtForm_StageList pdtData;


	pdtData = new Gui_dtForm_StageList;

	// New list form
	pform = NewListForm(DATABASE_CLIENT,"STA_stage",false);
	pform<<FormSetOffset(2);

	AddInterface(pform,Gui_iForm_StageList,pdtData);

	return pform;
}

func void StageListForm_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var Gui_Component gcGrid;
	var i32x i,iPosX;
	var szx szTxt;

	var i32x iNameColumnWidth;
	var i32x iColumnWidth;
	iNameColumnWidth = 256;
	iColumnWidth = 96;

	iPosX = 0;
	_pform<<FormSetDecimal(0);
	_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	_pform<<FormSetWidth(iNameColumnWidth);
	_pform<<FormSetOffset(10);

	_pform<<FormAddVariable("STA_stage.gene_i_stage_number","VALUE1");
	_pform<<FormAddVariable("STA_stage.fkIDrace.STA_race.gene_i_number_stages","VALUE2");
	_pform<<FormAddVariable("STA_stage.fkIDrace.STA_race.gene_strID_race_name","RACENAME");
	_pform<<FormAddVariable("STA_stage.gene_strID_stage_name","STAGENAME");
	if(_iIndex==0)
	{
		_pform<<FormSetTitle(true,true);
		_pform<<FormShowFormatField("STA_stage.fkIDrace.STA_race.gene_strID_race_name",64,"",iPosX,0);
		_pform<<FormSetTitle(true,false);
		_pform<<FormSetWidth(iColumnWidth);
		_pform<<FormSetFont(smImpact, smTrebuchet);
		szTxt = GetLocalizedFromKey(iszEtape);
		_pform<<FormShowFormatField("STA_stage.gene_i_stage_number",63,szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		szTxt = GetLocalizedFromKey(iszDistance);
		_pform<<FormShowField("STA_stage.gene_f_distance",szTxt,iPosX,0);
	}
	else
	{
		_pform<<FormSetTitle(false,true);
		szTxt = "";
		_pform<<FormShowFormatField("STA_stage.fkIDrace.STA_race.gene_strID_race_name",64,szTxt,iPosX,0);
		_pform<<FormSetTitle(false,false);
		_pform<<FormSetWidth(iColumnWidth);
		_pform<<FormSetFont(smImpact, smTrebuchet);
		_pform<<FormShowFormatField("STA_stage.gene_i_stage_number",63,szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
		_pform<<FormShowField("STA_stage.gene_f_distance",szTxt,iPosX,0);
		iPosX = iPosX + iColumnWidth;
	}
}
