
// creates a new mark to place on the day in order to know
// if there are races planned
func Gui_Component Calendar_NewCalendarDayBox()
{
	var Gui_Component gcBox,gcBackground;
	var i32x iWidth,iHeight;

	iWidth=5.0*g_fScreenScaleFactor;
	iHeight=5.0*g_fScreenScaleFactor;

	gcBox=NewObject(Gui_iCalendarDayBox);

	StretchTo(gcBox,iWidth,iHeight);

	gcBackground=NewBitmap(smWhite, 0);
	SetShadingMode(GetSprite(gcBackground),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	SetAlign(gcBackground, e_GUI_HAlign_Zoom, e_GUI_VAlign_Zoom);
	SetColor(gcBackground,MakeARGB(255,0,0,255));
	MountComponent(gcBox, gcBackground);
	StretchTo(gcBackground,SizeX(gcBox),SizeY(gcBox));

	return(gcBox);
}

// creates a new day : background calendar bitmap + day index caption
func Gui_Component Calendar_NewCalendarDay(i32x _iWidth,i32x _iHeight,i32x _iQuerySubset)
{
	var Gui_Component gcComposite,gcBox;
	var Gui_dtCalendarDay pdtData;

	gcComposite=NewObject(Gui_iCalendarDay);
	SetComponentNumber(gcComposite, 2);

	pdtData=new Gui_dtCalendarDay;
	SetData(gcComposite, pdtData);

	pdtData.iQuerySubset=_iQuerySubset;

	// background bitmap of the day
	pdtData.gcBackground=NewBitmap(smCalendarDay, 0);
	SetBlendingMode(GetSprite(pdtData.gcBackground),DLC_Blend_AlphaBlend);
	SetAlign(pdtData.gcBackground, e_GUI_HAlign_Zoom, e_GUI_VAlign_Zoom);
	MountComponent(gcComposite, pdtData.gcBackground);
	Clip(pdtData.gcBackground);
	StretchTo(pdtData.gcBackground,_iWidth,_iHeight);

	// caption for the index of the day
	pdtData.gcCaption=NewCaption(smBauer, "-");
	SetAlign(pdtData.gcCaption, e_GUI_HAlign_Center, e_GUI_VAlign_Center);
	SetColor(pdtData.gcCaption,MakeARGB(255,0,0,0));
	SetScale(pdtData.gcCaption,(800.0/1024.0)*g_fScreenScaleFactor);
	MountComponent(gcComposite, pdtData.gcCaption);
	StretchTo(pdtData.gcCaption,(9.0*_iWidth)/10.0,_iHeight);

	// creates 3 boxes used for displaying the available stages on that day
	// (assuming that there are less than 4 races)
	var i32x i;
	pdtData.iBoxStartIndex=2;
	i=0;
	while (i<3)
	{
		gcBox=Calendar_NewCalendarDayBox();
		MountComponent(gcComposite,gcBox);
		// all are hidden by default
		gcBox<<Hide();

		i=i+1;
	}

	StretchTo(gcComposite,_iWidth,_iHeight);

	return(gcComposite);

}

// creates a subset used for looking the color to display on day marks
func i32x Calendar_CreateDayStagesQuerySubset()
{
	var i32x iSubset;

	iSubset=Subset_Constructor("SUBSET_DAY_STAGE_QUERY",DATABASE_CLIENT);

	Database_AddTables(iSubset,4);

	Table_SetName(iSubset,0,"STA_stage");
	TableSubset_SelectColumns(iSubset,0,"*");
	Table_SetName(iSubset,1,"STA_race");
	TableSubset_SelectColumns(iSubset,1,"*");
	Table_SetName(iSubset,2,"STA_UCI_class");
	TableSubset_SelectColumns(iSubset,2,"*");
	Table_SetName(iSubset,3,"STA_color");
	TableSubset_SelectColumns(iSubset,3,"*");

	return(iSubset);
}

// creates a calendar component
func Gui_Component Calendar_NewCalendar(i32x _iDayWidth,i32x _iDayHeight,i32x _iDayBorderWidth,i32x _iDayBorderHeight)
{
	var i32x x,y,i,j;
	var Gui_Component gcCalendar,gcDay;
	var Gui_Component gcDayLabel[7];
	var Gui_dtCalendar pdtData;
	var i32x index;
	var i32x iJoinDay;
	var i32x iszLabel;
	var szx szLabel;

	gcCalendar=NewObject(Gui_iCalendar);
	pdtData=new Gui_dtCalendar;
	SetData(gcCalendar,pdtData);
	SetComponentNumber(gcCalendar, 42);

	iJoinDay=Join_Constructor(DATABASE_CLIENT, "STA_day.gene_strID_name");
	j=0;
	while (j<7) // for each day of the week
	{
		// creates the name of the day
		iszLabel=Join_GetIntFromKey(iJoinDay,j+1);
		szLabel=GetLocalizedFromKey(iszLabel);
		gcDayLabel[j]=NewCaption(smImpact,strncpy(szLabel,0,3));
		SetAlign(gcDayLabel[j],e_GUI_HAlign_Center, e_GUI_VAlign_Top);
		StretchTo(gcDayLabel[j],_iDayWidth,SizeY(gcDayLabel[j]));

		j=j+1;
	}
	Join_Destructor(iJoinDay);

	pdtData.iQuerySubset=Calendar_CreateDayStagesQuerySubset();

	index=0;
	pdtData.iTopOffset=SizeY(gcDayLabel[0])+_iDayBorderHeight;
	pdtData.iRowHeight=_iDayHeight;
	pdtData.iDeltaY=_iDayHeight+_iDayBorderHeight;
	y=pdtData.iTopOffset;
	i=0;
	while(i<6) // for each week of the month
	{
		x=0;
		j=0;
		while (j<7) // for each day of the week
		{
			// creating a calendar day component
			gcDay=Calendar_NewCalendarDay(_iDayWidth,_iDayHeight,pdtData.iQuerySubset);
			StretchTo(gcDay,_iDayWidth,_iDayHeight);
			MountComponent(gcCalendar, gcDay);
			MoveTo(gcDay,x,y);

			index=index+1;
			j=j+1;
			x=x+_iDayWidth+_iDayBorderWidth;
		}
		i=i+1;
		y=y+_iDayHeight+_iDayBorderHeight;
	}

	j=0;
	x=0;
	while (j<7) // for each day of the week
	{
		// mounts & places the name component
		MountComponent(gcCalendar, gcDayLabel[j]);
		MoveTo(gcDayLabel[j],x,0);

		j=j+1;
		x=x+_iDayWidth+_iDayBorderWidth;
	}

	StretchTo(gcCalendar,_iDayWidth*7+_iDayBorderWidth*6,_iDayHeight*6+_iDayBorderHeight*6+SizeY(gcDayLabel[0]));

	return(gcCalendar);
}

func void Calendar_OnDestroy()
{
	var Gui_Component pthis;
	var Gui_dtCalendar pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	Subset_Destructor(pdtData.iQuerySubset);
}

func void Calendar_OnShowMonth(i32x _iMonthIndex)
{
	var Gui_Component gcDay,gcParent,pthis;
	var Gui_dtCalendar pdtData;
	var i32x index,i,iWeek,iWeekDay,iTotalMonthDays;
	var i32x iSubsetIndex;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// hiding all the days
	i=0;
	while (i<42)
	{
		gcDay=GetComponent(pthis,i);
		gcDay<<Hide();
		i=i+1;
	}

	// looking for the number of days in the month, and the
	// week index of the first day of the month
	iSubsetIndex=Subset_Constructor("SUBSET_DAY_OF_MONTH",DATABASE_CLIENT);
	Database_AddTables(iSubsetIndex,1);
	Table_SetName(iSubsetIndex, 0, "DYN_day");
	TableSubset_SelectColumns(iSubsetIndex, 0, "*");

	Query_Create(0,iSubsetIndex);
	Query_SelectTable(0,"DYN_day");
	Query_SelectWhereIntEqual(0,"DYN_day.fkIDmonth",_iMonthIndex);
	Query_Execute(0);

	// number of days = number of rows
	iTotalMonthDays=Table_GetNumRows(iSubsetIndex,0);
	iWeekDay=Database_GetIntData(iSubsetIndex,"DYN_day.fkIDday",ROW_INDEX,0)-2;

	if (iWeekDay<0)
		iWeekDay=iWeekDay+7;

	// looking for the start and end week index
	pdtData.iStartWeek=Database_GetIntData(iSubsetIndex,"DYN_day.gene_i_year_week",ROW_INDEX,0);
	pdtData.iWeekNumber=1+Database_GetIntData(iSubsetIndex,"DYN_day.gene_i_year_week",ROW_INDEX,iTotalMonthDays-1)-pdtData.iStartWeek;
	pdtData.iPreviousSelectedWeek=-1;

//	println("month = "+itoa(_iMonthIndex));
//	println("days nb = "+itoa(iTotalMonthDays));
//	println("week day DB = "+itoa(Database_GetIntData(iSubsetIndex,"DYN_day.fkIDday",ROW_INDEX,0)));
//	println("week day = "+itoa(iWeekDay));
//	println("week day = "+itoa(iWeekDay));

	gcParent=GetParent(pthis);

	var i32x iStartYearDay;
	iStartYearDay=Database_GetIntData(iSubsetIndex,"DYN_day.IDday",ROW_INDEX,0);

	Subset_Destructor(iSubsetIndex);

	i=0;
	iWeek=0;
	// displaying the days of the months at the right place
	while (i<iTotalMonthDays)
	{
//		println("\tcomponent index = "+itoa(iWeekDay+iWeek*7));
		gcDay=GetComponent(pthis,iWeekDay+iWeek*7);

		gcDay<<ShowDay(i+1,iStartYearDay+i);

		i=i+1;
		iWeekDay=iWeekDay+1;
		if (iWeekDay==7)
		{
			iWeekDay=0;
			iWeek=iWeek+1;
		}
	}
}

// returns the week that is placed under the cursor 
func i32x Calendar_FindRow(i32x _iX,i32x _iY)
{
	var Gui_Component pthis;
	var Gui_dtCalendar pdtData;

	var i32x iTopOffset;
	var i32x iWeekRow;

	pthis=GetThis();
	pdtData=GetData(pthis);

	//iTopOffset=pdtData.iTopOffset+RelPosY(pthis);
	iTopOffset=pdtData.iTopOffset+AbsPosY(pthis);
	iWeekRow=1+(_iY-iTopOffset)/pdtData.iDeltaY;

	if (((_iY-iTopOffset)%pdtData.iDeltaY)<pdtData.iRowHeight)
	{
		return(iWeekRow);
	}

	return(666);
}

// send a message to the parent, when a week is clicked
func void Calendar_MouseDown(i32x _iX,i32x _iY,i32x _iButton)
{
	var Gui_Component pthis,gcParent;
	var Gui_dtCalendar pdtData;
	var i32x iWeekRow;

	pthis=GetThis();
	pdtData=GetData(pthis);

	iWeekRow=Calendar_FindRow(_iX,_iY);

	// check if the result is valid
	if (iWeekRow<1+pdtData.iWeekNumber)
	{
		gcParent=GetParent(pthis);
		gcParent<<WeekMouseDown(iWeekRow,iWeekRow+pdtData.iStartWeek-1);
		pdtData.iPreviousSelectedWeek=iWeekRow;
	}
}

// send a message to the parent, when a week is focused
func void Calendar_MouseMove(i32x _iX,i32x _iY)
{
	var Gui_Component pthis,gcParent;
	var Gui_dtCalendar pdtData;
	var i32x iWeekRow;

	pthis=GetThis();
	pdtData=GetData(pthis);

	iWeekRow=Calendar_FindRow(_iX,_iY);

	// check if the result is valid and that the week has changed
	if ((iWeekRow<1+pdtData.iWeekNumber) && (iWeekRow!=pdtData.iPreviousSelectedWeek))
	{
		gcParent=GetParent(pthis);
		gcParent<<WeekRollOver(iWeekRow,iWeekRow+pdtData.iStartWeek-1);
		pdtData.iPreviousSelectedWeek=iWeekRow;
	}
}

func void Calendar_SelectionColor(i32x _iColor)
{
	var Gui_Component pthis,gcDay;
	var Gui_dtCalendar pdtData;
	var i32x i;

	pthis=GetThis();
	pdtData=GetData(pthis);

	i=0;
	// sets the color for all the displayable days
	while (i<42)
	{
		gcDay=GetComponent(pthis,i);
		gcDay<<SelectionColor(_iColor);
		i=i+1;
	}
}

func void Calendar_SelectWeek(i32x _iWeekIndex, i32x _iValue)
{
	var Gui_Component pthis,gcDay;
	var Gui_dtCalendar pdtData;
	var i32x i;

	pthis=GetThis();
	pdtData=GetData(pthis);

	i=0;
	// selects all days of a week
	while (i<7)
	{
		gcDay=GetComponent(pthis,i+(_iWeekIndex-1)*7);
		gcDay<<SelectDay(_iValue);
		i=i+1;
	}
}

func void Calendar_LookForAvailableStages()
{
	var Gui_Component pthis,gcBox;
	var Gui_dtCalendarDay pdtData;
	var i32x i,iColor;
	var f32x fX,fY;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// looking for the available stages for this day
	DatabaseSubset_Clear(pdtData.iQuerySubset);

	TableSubset_SelectAllRows(pdtData.iQuerySubset,1);
	TableSubset_SelectAllRows(pdtData.iQuerySubset,2);
	TableSubset_SelectAllRows(pdtData.iQuerySubset,3);

	Query_Create(0,pdtData.iQuerySubset);
	Query_SelectTable(0,"STA_stage");
	Query_SelectWhereIntEqual(0,"STA_stage.fkIDday",pdtData.iIDDay);
	Query_Execute(0);

	// the number of available stages
	pdtData.iAvailableStageNumber=Table_GetNumRows(pdtData.iQuerySubset,0);

	fY=SizeY(pthis)-7.0*g_fScreenScaleFactor;
	fX=4.0*g_fScreenScaleFactor;
	i=0;
	// for each available stage
	while (i<pdtData.iAvailableStageNumber)
	{
		gcBox=GetComponent(pthis,pdtData.iBoxStartIndex+i);
		StretchTo(gcBox,4.0*g_fScreenScaleFactor,4.0*g_fScreenScaleFactor);
		MoveTo(gcBox,fX,fY-SizeY(gcBox));
		gcBox<<Show();

		// gets the color of the small box
		iColor=Database_GetIntData(
			pdtData.iQuerySubset,
			"STA_stage.fkIDrace.STA_race.fkIDUCI_class.STA_UCI_class.fkIDcolor.STA_color.gene_i_color",
			ROW_INDEX,i
		);

		//SetColor(gcBox,iColor);

		fX=fX+SizeX(gcBox)+2.0*g_fScreenScaleFactor;
		i=i+1;
	}
	// hide all the other boxes
	while (i<3)
	{
		gcBox=GetComponent(pthis,pdtData.iBoxStartIndex+i);
		gcBox<<Hide();
		i=i+1;
	}
}

func void Calendar_OnDaySelected(i32x _iDayId)
{
	var Gui_Component pthis,parent;
	var Gui_dtCalendarDay pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// Push same message toi parent
	parent = GetParent(pthis);
	if(parent)
		parent<<DaySelected(_iDayId);
}

// shows the day component
func void CalendarDay_OnShowDay(i32x _iMonthDay,i32x _iIDDay)
{
	var Gui_Component pthis;
	var Gui_dtCalendarDay pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	pdtData.iIDDay=_iIDDay;

	// displays the index of the day in the month
	pdtData.gcCaption<<Caption(itoa(_iMonthDay));
	pthis<<Show();
	pdtData.gcBackground<<Show();
	pdtData.gcCaption<<Show();

	Calendar_LookForAvailableStages();
}

// hides the day component
func void CalendarDay_OnHide()
{
	var Gui_Component pthis;
	var Gui_dtCalendarDay pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	pdtData.gcBackground<<Hide();
	pdtData.gcCaption<<Hide();
}

// changes the selection color
func void CalendarDay_SelectionColor(i32x _iColor)
{
	var Gui_Component pthis;
	var Gui_dtCalendarDay pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	pdtData.iSelectionColor=_iColor;
}

// selects the day (puts the selection color on the caption or not)
func void CalendarDay_SelectDay(i32x _iValue)
{
	var Gui_Component pthis;
	var Gui_dtCalendarDay pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// changing the value:
	if (_iValue)
	{
		// the day is selected
		SetColor(pdtData.gcCaption,pdtData.iSelectionColor);
	}
	else
	{
		// the day isn't selected
		SetColor(pdtData.gcCaption,MakeARGB(255,0,0,0));
	}
}

func void CalendarDay_MouseEnter(i32x _iX,i32x _iY)
{
	var Gui_Component pthis;
	var Gui_dtCalendarDay pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);
}

func void CalendarDay_MouseLeave(i32x _iX,i32x _iY)
{
	var Gui_Component pthis;
	var Gui_dtCalendarDay pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);
}

func void CalendarDay_MouseDown(i32x _iX,i32x _iY,i32x _iButton)
{
	var Gui_Component pthis,parent;
	var Gui_dtCalendarDay pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// Inform parent of day select
	parent = GetParent(pthis);
	if(parent)
		parent<<DaySelected(pdtData.iIDDay);
}
