
func void TrainingWeek_UpdateDisplayedName()
{
	var i32x i;
	var i32x iRowNumber;
	var i32x iStrID;
	var i32x iTrainingWeekTable;
	var szx  szTrainingWeekName;

	iTrainingWeekTable=Table_GetIndexFromName(DATABASE_CLIENT,"DYN_training_week");
	iRowNumber=Table_GetNumRows(DATABASE_CLIENT,iTrainingWeekTable);

	i=0;
	while (i<iRowNumber)
	{
		iStrID=Database_GetIntData(DATABASE_CLIENT,"DYN_training_week.gene_strID_name",ROW_INDEX,i);
		if (iStrID)
		{
			szTrainingWeekName=GetLocalizedFromKey(iStrID);
		}
		else
		{
			szTrainingWeekName=Database_GetStringData(DATABASE_CLIENT,"DYN_training_week.gene_sz_name",ROW_INDEX,i);
		}
		Database_SetStringData(DATABASE_CLIENT,"DYN_training_week.gene_sz_displayed_name",ROW_INDEX,i,szTrainingWeekName);

		i=i+1;
	}
}


func i32x Training_OnCreate()
{
	var Gui_Component pthis,pcaption;
	var Gui_dtPage_Training pdtData;

	// get this pointer
	pthis = GetThis();

	TrainingWeek_UpdateDisplayedName();

	// Set Data pointer
	pdtData = new Gui_dtPage_Training;
	SetData(pthis,pdtData);

	// Sub button
	pdtData.gcSeasonScheduleButton = NewCM2Button(GetLocalizedFromKey(iszTrainingSeason));
	MountComponent(pthis,pdtData.gcSeasonScheduleButton);

	pdtData.gcWeekScheduleButton = NewCM2Button(GetLocalizedFromKey(iszWeekSchedule));
	MountComponent(pthis,pdtData.gcWeekScheduleButton);

	// Move Component
	MoveTo(pdtData.gcSeasonScheduleButton,(g_iScreenWidth/3)-SizeX(pdtData.gcSeasonScheduleButton)/2,g_iScreenHeightDiv2-SizeY(pdtData.gcSeasonScheduleButton)/2);
	MoveTo(pdtData.gcWeekScheduleButton,(2*g_iScreenWidth/3)-SizeX(pdtData.gcWeekScheduleButton)/2,g_iScreenHeightDiv2-SizeY(pdtData.gcWeekScheduleButton)/2);

	// Back button
	pdtData.gcBackButton = NewCM2Button(GetLocalizedFromKey(iszOk));
	MountComponent(pthis,pdtData.gcBackButton);
	MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

	// Stretch page
	StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
}

func i32x  Training_OnDestroy()
{
	// uninit page
}

func void  Training_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_Training pdtData;

	// get this pointer
	pthis = GetThis();

	// Get Data pointer
	pdtData = GetData(pthis);

	// Retrieve parent
	pparent = GetParent(pthis);

	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		pthis<<Hide();
		// Back
		pparent<<GoBack();
	}
	else if(_pComponent == pdtData.gcSeasonScheduleButton)
	{
		pthis<<Hide();
		// Display correspondant page
		pparent<<DisplayPage(g_Page_TrainingSeason); // g_Page_TrainingSeason
	}
	else if(_pComponent == pdtData.gcWeekScheduleButton)
	{
		pthis<<Hide();
		// Display correspondant page
		pparent<<DisplayPage(g_Page_TrainingWeek); // g_Page_TrainingWeek
	}
}

