
include "scripts/pages/training/week/weekdata.cnc"
include "scripts/pages/training/week/weektrainingday.cnc"


// computes the duration of the programs (makes the sum of the duration of the exercices)
func void TrainingWeek_UpdateProgramTotalDuration()
{
	var i32x i,j;
	var i32x iCount;
	var i32x iDuration;
	var i32x iExerciceCount;
	var i32x iDurationJoin;
	var i32x iTableIndex;
	var i32x iProgramKey;
	var i32x iSubset;

	iTableIndex=Table_GetIndexFromName(DATABASE_CLIENT,"DYN_program");

	// creating a subset for the queries
	iSubset=Subset_Constructor("SUBSET_EXERCICE_OF_PROGRAM", DATABASE_CLIENT);

	Database_AddTables(iSubset,2);
	Table_SetName(iSubset, 0, "DYN_program_exercice");
	TableSubset_SelectColumns(iSubset, 0, "*");
	Table_SetName(iSubset, 1, "DYN_exercice");
	TableSubset_SelectColumns(iSubset, 1, "*");

	i=0;
	// the number of programs
	iCount=Table_GetNumRows(DATABASE_CLIENT,iTableIndex);
	while (i<iCount)
	{
		iProgramKey=Database_GetIntData(DATABASE_CLIENT, "DYN_program.IDprogram",ROW_INDEX,i);

		iDuration=Database_GetIntData(DATABASE_CLIENT,"DYN_program.gene_i_total_duration",ROW_INDEX,i);
		if (iDuration==0)
		{
			// looking for all the exercices of each program
			DatabaseSubset_Clear(iSubset);
			Query_Create(0,iSubset);
			Query_SelectTable(0,"DYN_program_exercice");
			Query_SelectWhereIntEqual(0,"DYN_program_exercice.fkIDprogram",iProgramKey);
			Query_Execute(0);

			iExerciceCount=Table_GetNumRows(iSubset,0);
			// for each found exercice...

			iDurationJoin=Join_Constructor(iSubset,"DYN_program_exercice.fkIDexercice.DYN_exercice.gene_i_duration");

			j=0;
			iDuration=0;
			while (j<iExerciceCount)
			{
				// the total duration is computed
				//iDuration=iDuration+Database_GetIntData(iSubset,"DYN_program_exercice.fkIDexercice.DYN_exercice.gene_i_duration",ROW_INDEX,j);
				iDuration=iDuration+Join_GetIntFromIndex(iDurationJoin,j);

				j=j+1;
			}
			// this value is put in the database
			Database_SetIntData(DATABASE_CLIENT,"DYN_program.gene_i_total_duration",ROW_INDEX,i,iDuration);

			Join_Destructor(iDurationJoin);
		}

		i=i+1;
	}

	Subset_Destructor(iSubset);
}

// creates a copy of the data for the page
func i32x TrainingWeek_CreateDatabaseCopy()
{
	var i32x iSubset,iSendSubset;
	var i32x iIDUserTeam;

	iSubset=Subset_Constructor("SUBSET_TRAINING_WEEK",DATABASE_CLIENT);

	Database_AddTables(iSubset,3);
	Table_SetName(iSubset, 0, "DYN_training_week");
	TableSubset_SelectColumns(iSubset, 0, "*");
	Table_SetName(iSubset, 1, "DYN_training_day");
	TableSubset_SelectColumns(iSubset, 1, "*");
	Table_SetName(iSubset, 2, "DYN_training_day_program");
	TableSubset_SelectColumns(iSubset, 2, "*");

	// only the default and "user-created" weeks are displayed
	iIDUserTeam=1;
	TableSubset_SelectAllRows(iSubset, 1);
	TableSubset_SelectAllRows(iSubset, 2);
	// defaults weeks:
	Query_Create(0,iSubset);
	Query_SelectTable(0,"DYN_training_week");
	Query_SelectWhereIntEqual(0,"DYN_training_week.fkIDteam",0);
	Query_Execute(0);
	// user team weeks:
	Query_Create(0,iSubset);
	Query_SelectTable(0,"DYN_training_week");
	Query_SelectWhereIntEqual(0,"DYN_training_week.fkIDteam",iIDUserTeam);
	Query_Execute(0);

	// a copy is used for managing the data...
	iSendSubset=Database_CopyConstructor("SUBSET_SEND_TRAINING_WEEK", iSubset);

	Subset_Destructor(iSubset);

	return(iSendSubset);
}

func void TrainingWeek_OnInitData()
{
	var Gui_Component pthis;
	var Gui_dtPage_TrainingWeek pdtData;

	println("initializing...");

	pthis = GetThis();
	pdtData = new Gui_dtPage_TrainingWeek;

	pdtData.bFirstLoad=true;

	SetData(pthis,pdtData);
}

// --- page creation ---
func i32x TrainingWeek_OnCreate()
{
	var Gui_Component pthis, pcaption, window, gcBox, gcProgramSelector, gcExerciceSelector, gcComponent;
	var Gui_dtPage_TrainingWeek pdtData;

	pthis = GetThis();
	pdtData=GetData(pthis);

	pdtData.iPageSubset=TrainingWeek_CreateDatabaseCopy();



//	Database_HTMLDebugPrint(DATABASE_CLIENT);

	if (pdtData.bFirstLoad)
	{
		TrainingWeek_UpdateProgramTotalDuration();

		gcBox=NewBoxFilled(smBlueFrame,250.0*g_fScreenScaleFactor,390.0*g_fScreenScaleFactor);
		MountComponent(pthis,gcBox);
		MoveTo(gcBox,520.0*g_fScreenScaleFactor,160.0*g_fScreenScaleFactor);

		gcComponent=TrainingWeek_CreateProgramInfo(250.0*g_fScreenScaleFactor,390.0*g_fScreenScaleFactor);
		MountComponent(pthis,gcComponent);
		MoveTo(gcComponent,520.0*g_fScreenScaleFactor,160.0*g_fScreenScaleFactor);


		// Training week days
		pdtData.gcWeekDays=TrainingWeek_CreateDaysOfWeek(gcComponent);
		MountComponent(pthis,pdtData.gcWeekDays);
		MoveTo(pdtData.gcWeekDays,50.0*g_fScreenScaleFactor,150.0*g_fScreenScaleFactor);

		// Training programs list form window
		window = NewWindow(400.0*g_fScreenScaleFactor,100.0*g_fScreenScaleFactor);
		pdtData.pForm = TrainingProgramListForm(pdtData.gcWeekDays);
		window<<WindowMount(pdtData.pForm);
		pdtData.pForm<<FormRazFilter();
		MountComponent(pthis,window);
		MoveTo(window,60.0*g_fScreenScaleFactor,470.0*g_fScreenScaleFactor);
	}

		// Training weeks combo box
		pdtData.gcWeekSelector=TrainingProgramWeekComboBox(pdtData.gcWeekDays,pdtData.iPageSubset);
		MountComponent(pthis,pdtData.gcWeekSelector);
		MoveTo(pdtData.gcWeekSelector,50.0*g_fScreenScaleFactor,100.0*g_fScreenScaleFactor);

	if (pdtData.bFirstLoad)
	{
		// Training exercice type list box
		gcExerciceSelector=TrainingExerciceSelector(pdtData.pForm);//,gcProgramSelector);
		MountComponent(pthis,gcExerciceSelector);
		MoveTo(gcExerciceSelector,260.0*g_fScreenScaleFactor,440.0*g_fScreenScaleFactor);

		// Training program type list box
		gcProgramSelector=TrainingProgramSelector(pdtData.pForm,gcExerciceSelector);
		MountComponent(pthis,gcProgramSelector);
		MoveTo(gcProgramSelector,50.0*g_fScreenScaleFactor,440.0*g_fScreenScaleFactor);

		// Caption
		pcaption = NewCaption(smBauer,"Training Week");
		MountComponent(pthis,pcaption);
		SetColor(pcaption, cPageTitleColor);
		StretchTo(pcaption,g_iScreenWidth,0);
		SetAlign(pcaption,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
		SetScale(pcaption,1.8*g_fScreenScaleFactor);
		MoveTo(pcaption,0,(g_iScreenTopOffset-SizeY(pcaption))/2);

		pdtData.gcBackButton = NewButtonDyn(smBtnCancel);
		MountComponent(pthis,pdtData.gcBackButton);
		MoveTo(pdtData.gcBackButton,g_iScreenWidth-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);

		pdtData.gcSendButton = NewButtonDyn(smBtnValid);
		MountComponent(pthis,pdtData.gcSendButton);
		MoveTo(pdtData.gcSendButton,g_iScreenWidth-SizeX(pdtData.gcSendButton)-5.0*g_fScreenScaleFactor-SizeX(pdtData.gcBackButton)-g_iScreenRightOffset,g_iScreenHeight-SizeY(pdtData.gcBackButton)-g_iScreenBottomOffset);
		pdtData.gcSendButton<<Hide();

		// Stretch page
		StretchTo(pthis,g_iScreenWidth,g_iScreenHeight);
	}

	pdtData.bFirstLoad=false;
}

func void TrainingWeek_OnRelease()
{
	var Gui_Component pthis;
	var Gui_dtPage_TrainingWeek pdtData;

	pthis = GetThis();
	pdtData=GetData(pthis);

	DeleteComponent(pdtData.gcWeekSelector);
	pdtData.gcWeekSelector=NULL;

	Subset_Destructor(pdtData.iPageSubset);
	pdtData.iPageSubset=NULL;
}

func i32x  TrainingWeek_OnDestroy()
{
	// uninit page
}

func void TrainingWeek_DataChanged()
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_TrainingWeek pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	// display the 'send database copy' button
	pdtData.gcSendButton<<Show();
}

func void TrainingWeek_DatabaseSync()
{

}

func void TrainingWeek_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,pback,pparent;
	var Gui_dtPage_TrainingWeek pdtData;

	pthis = GetThis();
	pdtData = GetData(pthis);

	pback = pdtData.gcBackButton;
	if(_pComponent == pback)
	{
		pparent = GetParent(pthis);
		pparent<<GoBack();
	}
	else if (_pComponent == pdtData.gcSendButton)
	{
		// save the currently displayed week to the database
		pdtData.gcWeekSelector<<SaveCurrentWeek();
		// send the database to the server
		Database_Send(pdtData.iPageSubset,"TrainingWeekDB",g_pMenuServerSocket);
	}
}


// creates a panel in order to manage the weeks (select, copy and remove them)
func Gui_Component TrainingProgramWeekComboBox(Gui_Component _gcWeekContainer,i32x _iPageSubset)
{
	var Gui_Component gcWeekSelector,gcComboBox,gcEditBox;
	var Gui_Component gcButton,gcCaption;
	var Gui_dtComponent_TrainingWeekSelector pdtData;
	var i32x iLeftOffset,iRightOffset;

	gcWeekSelector=NewObject(Gui_iTrainingWeekSelector);
	StretchTo(gcWeekSelector,700.0*g_fScreenScaleFactor,30.0*g_fScreenScaleFactor);

	pdtData=new Gui_dtComponent_TrainingWeekSelector;
	pdtData.gcWeekContainer=_gcWeekContainer;
	pdtData.iPageSubset=_iPageSubset;

	iLeftOffset=0;
	iRightOffset=0;

	// the delete button
	gcButton = NewCM2Button(GetLocalizedFromKey(iszEffacer));
	MountComponent(gcWeekSelector,gcButton);
	MoveTo(gcButton,SizeX(gcWeekSelector)-iRightOffset-SizeX(gcButton),(SizeY(gcWeekSelector)-SizeY(gcButton))/2.0);
	iRightOffset=iRightOffset+SizeX(gcButton)+15.0*g_fScreenScaleFactor;
	pdtData.gcDeleteButton=gcButton;

	// the "copy as" button
	gcButton = NewCM2Button(GetLocalizedFromKey(iszCopyAs));
	MountComponent(gcWeekSelector,gcButton);
	MoveTo(gcButton,SizeX(gcWeekSelector)-iRightOffset-SizeX(gcButton),(SizeY(gcWeekSelector)-SizeY(gcButton))/2.0);
	iRightOffset=iRightOffset+SizeX(gcButton)+15.0*g_fScreenScaleFactor;
	pdtData.gcCopyAsButton=gcButton;

	// the week caption
	gcCaption = NewCaption(smBauer,"Week");
	MountComponent(gcWeekSelector, gcCaption);
	MoveTo(gcCaption,iLeftOffset,(SizeY(gcWeekSelector)-SizeY(gcCaption))/2.0);
	iLeftOffset=iLeftOffset+SizeX(gcCaption)+15.0*g_fScreenScaleFactor;

	// the edit box for saving a new week with a different name
	gcEditBox = NewEditBox(smBauer,MakeARGB(32,128,128,255));
	MountComponent(gcWeekSelector, gcEditBox);
	gcEditBox<<EbResize(100.0*g_fScreenScaleFactor, SizeY(gcEditBox));
	MoveTo(gcEditBox,SizeX(gcWeekSelector)-iRightOffset-SizeX(gcEditBox),(SizeY(gcWeekSelector)-SizeY(gcEditBox))/2.0);
	iRightOffset=iRightOffset+SizeX(gcEditBox)+15.0*g_fScreenScaleFactor;
	pdtData.gcWeekNameEditBox=gcEditBox;

	// the list box for selecting a week
	pdtData.iStrIDJoin = Join_Constructor(_iPageSubset, "DYN_training_week.gene_sz_displayed_name");
	pdtData.iIDWeekJoin = Join_Constructor(_iPageSubset, "DYN_training_week.IDtraining_week");
	gcComboBox = NewSelect(smImpact, SizeX(gcWeekSelector)-iLeftOffset-iRightOffset-20.0*g_fScreenScaleFactor, 100.0*g_fScreenScaleFactor, pdtData.iStrIDJoin, pdtData.iIDWeekJoin);
	pdtData.gcWeekListBox=gcComboBox;
	MountComponent(gcWeekSelector, gcComboBox);
	MoveTo(gcComboBox, iLeftOffset+((SizeX(gcWeekSelector)-iLeftOffset-iRightOffset)-(SizeX(gcComboBox)))/2.0, (SizeY(gcWeekSelector)-SizeY(gcComboBox))/2.0);

	AddInterface(gcWeekSelector,Gui_iComponent_TrainingWeekListBox,pdtData);

	// we start by displaying the first week in the table
	gcComboBox<<CellSelect(0);

	return(gcWeekSelector);
}

func void TrainingWeekListBox_OnDestroy()
{
	var Gui_Component pthis;
	var Gui_dtComponent_TrainingWeekSelector pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	Join_Destructor(pdtData.iStrIDJoin);
	Join_Destructor(pdtData.iIDWeekJoin);
}

func void TrainingWeekListBox_SaveCurrentWeek()
{
	var Gui_Component pthis;
	var Gui_dtComponent_TrainingWeekSelector pdtData;
	var i32x iIDTeam;
	var i32x iWeekTeam;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// gets the team ID of the player
	iIDTeam=GetMyTeamId();
	// gets the team ID of the week owner
	iWeekTeam=Database_GetIntData(pdtData.iPageSubset,"DYN_training_week.fkIDteam",ROW_KEY,pdtData.iIDWeek);
	// if the player owns the week
	if (iIDTeam==iWeekTeam)
	{
		// save it
		pdtData.gcWeekContainer<<SaveWeek(pdtData.iIDWeek,pdtData.iPageSubset);
	}
}


func void TrainingWeekListBox_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis;
	var Gui_dtComponent_TrainingWeekSelector pdtData;
	var i32x iIDWeek;

	pthis=GetThis();
	pdtData=GetData(pthis);

	if (_pComponent==pdtData.gcDeleteButton)
	{
		iIDWeek=pdtData.iIDWeek;

		// go to the first row of the table
		// (prevents from crashing when removing the last row)
		pdtData.gcWeekListBox<<CellSelect(0);

		// delete the selected week
		pdtData.gcWeekContainer<<RemoveWeek(iIDWeek,pdtData.iPageSubset);

		// go to the first row of the table
		// (useful to refresh the label when the first row is deleted)
		pdtData.gcWeekListBox<<CellSelect(0);

		//Database_HTMLDebugPrint(pdtData.iPageSubset);
	}
	else if (_pComponent==pdtData.gcCopyAsButton)
	{
		var szx szWeekName;
		// gets the name of the week in the edit box
		szWeekName=EditBox_GetText(pdtData.gcWeekNameEditBox);
		// creates a new week from the currently displayed one
		pdtData.gcWeekContainer<<CopyWeekAs(pdtData.iIDWeek,szWeekName,pdtData.iPageSubset);
	}
}

func void TrainingWeekListBox_ChangeTrainingWeek(Gui_Component _pSender,i32x _iIndex)
{
	var Gui_Component pthis;
	var Gui_dtComponent_TrainingWeekSelector pdtData;
	var i32x iIDTeam,iWeekTeam;

	pthis=GetThis();
	pdtData=GetData(pthis);

	println("selecting week "+itoa(_iIndex));

	// the previous week is saved
	pdtData.gcWeekContainer<<SaveWeek(pdtData.iIDWeek,pdtData.iPageSubset);
	pdtData.iIDWeek=_iIndex;
	// the selected one is displayed
	pdtData.gcWeekContainer<<DisplayWeek(pdtData.iIDWeek,pdtData.iPageSubset);

	//check if the week can be deleted (it must be owned by the team of the user)
	iIDTeam=GetMyTeamId();
	iWeekTeam=Database_GetIntData(pdtData.iPageSubset,"DYN_training_week.fkIDteam",ROW_KEY,pdtData.iIDWeek);
	if (iIDTeam==iWeekTeam)
	{
		// the delete button is enabled
		pdtData.gcDeleteButton<<Show();
		pdtData.gcDeleteButton<<Enable();
		pdtData.gcWeekContainer<<WeekEnable();
	}
	else
	{
		// the delete button is disabled
		pdtData.gcDeleteButton<<Disable();
		pdtData.gcDeleteButton<<Hide();
		pdtData.gcWeekContainer<<WeekDisable();
	}

}

// changes the component size in order to let the list box have the focus
func void TrainingWeekListBox_ToggleComponentSize()
{
	var Gui_Component pthis;
	var Gui_dtComponent_TrainingWeekSelector pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	if (pdtData.iExtended)
	{
		// the parent takes its original size back
		Stretch(pthis,0,-200.0*g_fScreenScaleFactor);
		pdtData.iExtended=false;
	} else {
		// the parent component is resized to allow the list to get the focus
		Stretch(pthis,0,200.0*g_fScreenScaleFactor);
		pdtData.iExtended=true;
	}
}

//func Gui_Component TrainingExerciceSelector(Gui_Component _gcProgramList,Gui_Component _gcProgramTypeList)
func Gui_Component TrainingExerciceSelector(Gui_Component _gcProgramList)
{
	var Gui_Component gcExerciceSelector,gcComboBox;
	var Gui_Component gcField;
	var Gui_dtComponent_TrainingExerciceSelector pdtData;
	var i32x iStrIDJoin,iIDTypeJoin;
	var i32x iRemainingPlace,iLeftOffset;

	gcExerciceSelector=NewObject(Gui_iComponent_ExerciceTypeListBox);
	StretchTo(gcExerciceSelector,210.0*g_fScreenScaleFactor,30.0*g_fScreenScaleFactor);

	iLeftOffset=0.0;
	iRemainingPlace=SizeX(gcExerciceSelector);

	pdtData=new Gui_dtComponent_TrainingExerciceSelector;
	pdtData.gcProgramList=_gcProgramList;

	pdtData.iExerciceSubset=Subset_Constructor("EXERCICE_QUERY",DATABASE_CLIENT);
	Database_AddTables(pdtData.iExerciceSubset,1);
	Table_SetName(pdtData.iExerciceSubset,0,"STA_type_exercice");
	TableSubset_SelectColumns(pdtData.iExerciceSubset,0,"*");
	TableSubset_SelectAllRows(pdtData.iExerciceSubset,0);

	SetData(gcExerciceSelector,pdtData);

/*	gcField=NewCaption(smBauer,"Exercice");
//	println("w="+itoa(SizeX(gcField)/g_fScreenScaleFactor)+" h="+itoa(SizeY(gcField)/g_fScreenScaleFactor));
	StretchTo(gcField,200.0*g_fScreenScaleFactor,15.0*g_fScreenScaleFactor);
	SetAlign(gcField,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	MountComponent(gcExerciceSelector,gcField);
	MoveTo(gcField,0.0,(SizeY(gcExerciceSelector)-SizeY(gcField))/2.0);

	iLeftOffset=SizeX(gcField)+5.0*g_fScreenScaleFactor;
	iRemainingPlace=iRemainingPlace-iLeftOffset;*/

	iStrIDJoin=Join_Constructor(pdtData.iExerciceSubset,"STA_type_exercice.gene_sz_type");
	iIDTypeJoin=Join_Constructor(pdtData.iExerciceSubset,"STA_type_exercice.IDtype_exercice");
	gcComboBox=NewSelect(smImpact,iRemainingPlace-50.0*g_fScreenScaleFactor,100.0*g_fScreenScaleFactor,iStrIDJoin,iIDTypeJoin);
	MountComponent(gcExerciceSelector,gcComboBox);
	MoveTo(gcComboBox,iLeftOffset+(iRemainingPlace-SizeX(gcComboBox))/2.0,(SizeY(gcExerciceSelector)-SizeY(gcComboBox))/2.0);

	pdtData.gcComboBox=gcComboBox;

	return(gcExerciceSelector);
}

func void TrainingExerciceTypeListBox_ChangeTypeExercice(Gui_Component _pSender,i32x _iIndex)
{
	var Gui_Component pthis;
	var Gui_dtComponent_TrainingExerciceSelector pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

//	pdtData.gcProgramTypeList<<ListSelectExerciceType(_iIndex);
	// the program type list box changed the information displayed in the program list form
	pdtData.gcProgramList<<ListSelectExerciceType(_iIndex);
}

func void TrainingExerciceTypeListBox_ToggleComponentSize()
{
	var Gui_Component pthis;
	var Gui_dtComponent_TrainingExerciceSelector pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// the size of the component changes so that the list box can have the focus when opened
	if (pdtData.iExtended)
	{
		Stretch(pthis,0,-200.0*g_fScreenScaleFactor);
		pdtData.iExtended=false;
	} else {
		Stretch(pthis,0,200.0*g_fScreenScaleFactor);
		pdtData.iExtended=true;
	}
}

func void TrainingProgramSelector_ChangeExercice(i32x _iIDExerciceType)
{
	println("changing exercice type");

}

// creates a panel used for selecting the training program type
func Gui_Component TrainingProgramSelector(Gui_Component _gcProgramList,Gui_Component _gcExerciceTypeList)
{
	var Gui_Component gcProgramSelector,gcComboBox;
	var Gui_Component gcField;
	var Gui_dtComponent_TrainingProgramSelector pdtData;
	var i32x iStrIDJoin,iIDTypeJoin;
	var i32x iRemainingPlace,iLeftOffset;

	gcProgramSelector=NewObject(Gui_iComponent_ProgramTypeListBox);
	StretchTo(gcProgramSelector,200.0*g_fScreenScaleFactor,30.0*g_fScreenScaleFactor);

	iLeftOffset=0.0;
	iRemainingPlace=SizeX(gcProgramSelector);

	pdtData=new Gui_dtComponent_TrainingProgramSelector;
	pdtData.gcProgramList=_gcProgramList;
	pdtData.gcExerciceTypeList=_gcExerciceTypeList;

	SetData(gcProgramSelector,pdtData);

/*	gcField=NewCaption(smBauer,"Program");
//	println("w="+itoa(SizeX(gcField)/g_fScreenScaleFactor)+" h="+itoa(SizeY(gcField)/g_fScreenScaleFactor));
	StretchTo(gcField,200.0*g_fScreenScaleFactor,15.0*g_fScreenScaleFactor);
	SetAlign(gcField,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	MountComponent(gcProgramSelector,gcField);
	MoveTo(gcField,0.0,(SizeY(gcProgramSelector)-SizeY(gcField))/2.0);

	iLeftOffset=SizeX(gcField)+5.0*g_fScreenScaleFactor;
	iRemainingPlace=iRemainingPlace-iLeftOffset;*/

	iStrIDJoin=Join_Constructor(DATABASE_CLIENT,"STA_type_program.gene_strID_name");
	iIDTypeJoin=Join_Constructor(DATABASE_CLIENT,"STA_type_program.IDtype_program");
	gcComboBox=NewSelect(smImpact,iRemainingPlace-50.0*g_fScreenScaleFactor,100.0*g_fScreenScaleFactor,iStrIDJoin,iIDTypeJoin);
	MountComponent(gcProgramSelector,gcComboBox);
	MoveTo(gcComboBox,iLeftOffset+(iRemainingPlace-SizeX(gcComboBox))/2.0,(SizeY(gcProgramSelector)-SizeY(gcComboBox))/2.0);

	// to the first row!
	gcComboBox<<CellSelect(0);

	return(gcProgramSelector);
}

func void TrainingProgramTypeListBox_ChangeTypeProgram(Gui_Component _pSender,i32x _iIndex)
{
	var Gui_Component pthis;
	var Gui_dtComponent_TrainingProgramSelector pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// the program type list box changed the information displayed in the program list form
	pdtData.gcProgramList<<ListSelectProgramType(_iIndex);
	pdtData.gcExerciceTypeList<<ListSelectProgramType(_iIndex);
}

func void TrainingExerciceSelector_ChangeProgram(i32x _iIDProgramType)
{
	var Gui_Component pthis;
	var Gui_dtComponent_TrainingExerciceSelector pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	var i32x iQuerySubset;
	var i32x iJoin;
	var i32x i,iNumRows;
	var i32x iExerciceTypeID,iOldExerciceTypeID;

	iQuerySubset=Subset_Constructor("QUERY_EXERCICE_FOR_PROGRAM",DATABASE_CLIENT);
	Database_AddTables(iQuerySubset,3);
	Table_SetName(iQuerySubset,0,"DYN_program_exercice");
	TableSubset_SelectColumns(iQuerySubset,0,"*");
	Table_SetName(iQuerySubset,1,"DYN_program");
	TableSubset_SelectColumns(iQuerySubset,1,"*");
	Table_SetName(iQuerySubset,2,"DYN_exercice");
	TableSubset_SelectColumns(iQuerySubset,2,"*");

	Query_Create(0,iQuerySubset);
	Query_SelectTable(0,"DYN_program_exercice");
	Query_SelectWhereIntEqual(0,"DYN_program_exercice.fkIDprogram.DYN_program.fkIDtype_program",_iIDProgramType);
	Query_Execute(0);

	iJoin=Join_Constructor(iQuerySubset,"DYN_program_exercice.fkIDexercice.DYN_exercice.fkIDtype_exercice");
	Join_Sort(iJoin,1);

	Query_Create(0,pdtData.iExerciceSubset);
	DatabaseSubset_Clear(pdtData.iExerciceSubset);
	Query_SelectTable(0,"STA_type_exercice");

	iOldExerciceTypeID=-1;
	i=0;
	iNumRows=Join_GetNumRows(iJoin);
	while (i<iNumRows)
	{
		iExerciceTypeID=Join_GetIntFromSortedIndex(iJoin,i);

		if (iOldExerciceTypeID!=iExerciceTypeID)
		{
			Query_SelectWhereIntEqual(0,"STA_type_exercice.IDtype_exercice",iExerciceTypeID);
			Query_Execute(0);

			iOldExerciceTypeID=iExerciceTypeID;
		}

		i=i+1;
	}


	Join_Destructor(iJoin);
	Subset_Destructor(iQuerySubset);

	pdtData.gcComboBox<<CellSelect(0);
}

func Gui_Component TrainingProgramListForm(Gui_Component _gcWeekContainer)
{
	var Gui_Component pform;
	var Gui_dtForm_TrainingProgramList pdtData;

	pdtData = new Gui_dtForm_TrainingProgramList;
	pdtData.gcWeekContainer = _gcWeekContainer;

	pform = NewListForm(DATABASE_CLIENT,"DYN_program",false);

	pdtData.iSubset=Form_GetSubsetDb(pform);
	pdtData.iDurationJoin=Join_Constructor(pdtData.iSubset,"DYN_program.gene_i_total_duration");

	AddInterface(pform,Gui_iForm_TrainingProgramList,pdtData);

	return pform;
}

// converts a duration in seconds in a string with hours and minutes
func szx IntToDuration(i32x iTime)
{
	var szx szTime;
	var i32x iPartTime;

	iTime=iTime/60.0;
	iPartTime=iTime%60;
	if (iPartTime<10)
		szTime="0"+itoa(iPartTime)+"min";
	else
		szTime=itoa(iPartTime)+"min";

	iTime=iTime/60.0;
	if (iTime==0)
		return(szTime);
	szTime=itoa(iTime)+"h "+szTime;

	return(szTime);
}

func void TrainingProgramListForm_OnAddForm(Gui_Component _pform,i32x _iIndex)
{
	var i32x iDuration;
	var Gui_Component pthis,gcDuration;
	var Gui_dtField_ProgramDuration pdtCaption;
	var Gui_dtForm_TrainingProgramList pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	SetComponentNumber(_pform,2);

	_pform<<FormSetAlign(e_GUI_HAlign_Center,e_GUI_VAlign_Center);

	gcDuration=NewCaption(smImpact,"---");
	Clip(gcDuration);
	StretchTo(gcDuration,80.0*g_fScreenScaleFactor,SizeY(gcDuration));
	SetAlign(gcDuration,e_GUI_HAlign_Center,e_GUI_VAlign_Center);

	pdtCaption=new Gui_dtField_ProgramDuration;
	pdtCaption.iJoinID=pdtData.iDurationJoin;
	AddInterface(gcDuration,Gui_iField_ProgramDuration,pdtCaption);

	_pform<<FormSetLocked(true);
	if(_iIndex==0)
	{
		_pform<<FormSetTitle(true,false);
		_pform<<FormSetWidth(310*g_fScreenScaleFactor);
		_pform<<FormShowField("DYN_program.gene_sz_description","Description",0,0);
		_pform<<FormSetWidth(80.0*g_fScreenScaleFactor);
		_pform<<FormAddField(gcDuration,300.0*g_fScreenScaleFactor,0);
	}
	else
	{
		_pform<<FormSetTitle(false,false);
		_pform<<FormSetWidth(310*g_fScreenScaleFactor);
		_pform<<FormShowField("DYN_program.gene_sz_description","",0,0);
		_pform<<FormSetWidth(80.0*g_fScreenScaleFactor);
		_pform<<FormAddField(gcDuration,300.0*g_fScreenScaleFactor,0);
	}
}

func void TrainingProgramDuration_OnSelectKey(i32x _iKey)
{
}

func void TrainingProgramDuration_OnSelectIndex(i32x _iIndex)
{
	var Gui_Component pthis;
	var Gui_dtField_ProgramDuration pdtData;
	var i32x iTotalDuration;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// gets the duration corresponding to the selected index
	iTotalDuration=Join_GetIntFromIndex(pdtData.iJoinID,_iIndex);

	pthis<<Caption(IntToDuration(iTotalDuration));
}

func void TrainingProgramDuration_OnSelectSIndex(i32x _iSIndex)
{
	var Gui_Component pthis;
	var Gui_dtField_ProgramDuration pdtData;
	var i32x iTotalDuration;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// gets the duration corresponding to the selected sorted index
	iTotalDuration=Join_GetIntFromSortedIndex(pdtData.iJoinID,_iSIndex);

	pthis<<Caption(IntToDuration(iTotalDuration));
}

func void TrainingProgramListForm_GainFocus(Gui_Component _poForm,i32x _iKey)
{
	var Gui_Component pthis;
	var Gui_dtForm_TrainingProgramList pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// changed the program that will be added
	pdtData.gcWeekContainer<<SelectProgram(_iKey);
}

func void TrainingProgramListForm_ChangeProgramType(i32x _iIDProgramType)
{
	var Gui_Component pthis;
	var Gui_dtForm_TrainingProgramList pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	pdtData.iProgramType=_iIDProgramType;
	if (pdtData.iExerciceType)
	{
		TrainingProgramListForm_UpdateList();
	}
}

func void TrainingProgramListForm_ChangeExerciceType(i32x _iIDExerciceType)
{
	var Gui_Component pthis;
	var Gui_dtForm_TrainingProgramList pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	pdtData.iExerciceType=_iIDExerciceType;
	if (pdtData.iProgramType)
	{
		TrainingProgramListForm_UpdateList();
	}
}

func void TrainingProgramListForm_UpdateList()
{
	var Gui_Component pthis;
	var Gui_dtForm_TrainingProgramList pdtData;

	var i32x i,iNumRows;
	var i32x iQuerySubset;

	var i32x iIDProgram,iIDLastProgram;
	var i32x iProgramExerciceProgramJoin;

	pthis=GetThis();
	pdtData=GetData(pthis);

	DatabaseSubset_Clear(pdtData.iSubset);

	iQuerySubset=Subset_Constructor("PROGRAM_LIST_UPDATE_QUERY_SUBSET",DATABASE_CLIENT);
	
	Database_AddTables(iQuerySubset,2);
	Table_SetName(iQuerySubset,0,"DYN_program_exercice");
	TableSubset_SelectColumns(iQuerySubset,0,"*");
	Table_SetName(iQuerySubset,1,"DYN_exercice");
	TableSubset_SelectColumns(iQuerySubset,1,"*");

	Query_Create(0,iQuerySubset);
	Query_SelectTable(0,"DYN_program_exercice");
	Query_SelectWhereIntEqual(0,"DYN_program_exercice.fkIDexercice.DYN_exercice.fkIDtype_exercice",pdtData.iExerciceType);
	Query_Execute(0);

	Query_Create(1,pdtData.iSubset);
	Query_SelectTable(1,"DYN_program");

	iProgramExerciceProgramJoin=Join_Constructor(iQuerySubset,"DYN_program_exercice.fkIDprogram");

	i=0;
	iNumRows=Table_GetNumRows(iQuerySubset,0);
	iIDLastProgram=-1;
	while (i<iNumRows)
	{
		iIDProgram=Join_GetIntFromIndex(iProgramExerciceProgramJoin,i);
		if (iIDLastProgram!=iIDProgram)
		{
			Query_SelectWhereIntEqual(1,"DYN_program.IDprogram",iIDProgram);
			Query_SelectWhereIntEqual(1,"DYN_program.fkIDtype_program",pdtData.iProgramType);
			Query_Execute(1);

			iIDLastProgram=iIDProgram;
		}
		i=i+1;
	}

	pthis<<FormUpdate();

	Join_Destructor(iProgramExerciceProgramJoin);
	Subset_Destructor(iQuerySubset);

}

func void TrainingProgramTypeListBox_ToggleComponentSize()
{
	var Gui_Component pthis;
	var Gui_dtComponent_TrainingProgramSelector pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// the size of the component changes so that the list box can have the focus when opened
	if (pdtData.iExtended)
	{
		Stretch(pthis,0,-200.0*g_fScreenScaleFactor);
		pdtData.iExtended=false;
	} else {
		Stretch(pthis,0,200.0*g_fScreenScaleFactor);
		pdtData.iExtended=true;
	}
}

func i32x TrainingProgramListForm_OnDestroy()
{
	var Gui_Component pthis;
	var Gui_dtForm_TrainingProgramList pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	Subset_Destructor(pdtData.iSubset);
}

// --- week container ---
func Gui_Component TrainingWeek_CreateDaysOfWeek(Gui_Component _gcProgramInfo)
{
	var Gui_Component gcWeek;
	var Gui_Component gcDay;
	var Gui_Component gcCaption;
	var Gui_Component gcButtonAdd;
	var Gui_Component gcStartListBox;
	var Gui_Component gcCheckBox;
	var Gui_Component gcHorizontalLine;
	var Gui_dtComponent_TrainingWeekContainer pdtData;
	var i32x i,iTopOffset;
	var f32x fCenterAxisX,fWidth;
	var f32x fDayWidth;
	var szx szDayLabel;
	
	gcWeek=NewObject(Gui_iTrainingWeekContainer);
	SetComponentNumber(gcWeek,45);
	StretchTo(gcWeek,420.0*g_fScreenScaleFactor,200.0*g_fScreenScaleFactor);

	pdtData=new Gui_dtComponent_TrainingWeekContainer;
	SetData(gcWeek,pdtData);

	pdtData.gcProgramInfo=_gcProgramInfo;

	fWidth=SizeX(gcWeek)/7.0;
	fDayWidth=36.0*g_fScreenScaleFactor;

	// WARNING!
	// we use multiple iterations because the index of the component in
	// his parent is VERY important!

	// displays the 3 first letters of the label of each day of the week
	i=0;
	while (i<7)
	{
		fCenterAxisX=fWidth/2.0+fWidth*i;

		// gets the 3 first letters
		szDayLabel=GetLocalizedFromKey(Database_GetIntData(DATABASE_CLIENT,"STA_day.gene_strID_name",ROW_KEY,i+1));
		szDayLabel=strncpy(szDayLabel,0,3);

		// displays them in a caption
		gcCaption=NewCaption(smBauer,szDayLabel);
		MountComponent(gcWeek,gcCaption);
		MoveTo(gcCaption,fCenterAxisX-SizeX(gcCaption)/2.0,0);

		i=i+1;
	}
	//iTopOffset=SizeY(gcCaption)+3.0*g_fScreenScaleFactor;
	iTopOffset=SizeY(gcCaption)+3.0*g_fScreenScaleFactor+fDayWidth/2.0;

	// the training takes place from 7h to 22h
	// we draw a line for each hour
	i=0;
	while (i<=15)
	{
		var i32x iY;

		iY=iTopOffset+(170.0*i*g_fScreenScaleFactor)/15.0;

		// creates a new horizontal line
		gcHorizontalLine=NewBitmap(smWhite,0);
		SetAlign(gcHorizontalLine,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
		SetShadingMode(GetSprite(gcHorizontalLine),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
		SetBlendingMode(GetSprite(gcHorizontalLine),DLC_Blend_AlphaBlend);
		SetColor(gcHorizontalLine,MakeARGB(96,255,255,255));
		StretchTo(gcHorizontalLine,SizeX(gcWeek),1);
		MountComponent(gcWeek,gcHorizontalLine);
		MoveTo(gcHorizontalLine,0,iY);

		// creates a new caption with the corresponding hour
		gcCaption=NewCaption(smImpact,itoa(15-i+7)+"h");
		MountComponent(gcWeek,gcCaption);
		MoveTo(gcCaption,SizeX(gcWeek),iY-SizeY(gcCaption)/2.0);

		// creates a new caption with the corresponding hour
		gcCaption=NewCaption(smImpact,itoa(15-i+7)+"h");
		SetAlign(gcCaption,e_GUI_HAlign_Right,e_GUI_VAlign_Center);
		MountComponent(gcWeek,gcCaption);
		MoveTo(gcCaption,-SizeX(gcCaption),iY-SizeY(gcCaption)/2.0);

		i=i+1;
	}

	// for each day
	i=0;
	pdtData.iDayStartIndex=7+3*16;
	while (i<7)
	{
		fCenterAxisX=fWidth/2.0+fWidth*i;

		// puts a new day component
		gcDay=TrainingWeek_NewProgramDay();
		MountComponent(gcWeek,gcDay);
		gcDay<<DayResize(fDayWidth,170.0*g_fScreenScaleFactor);
		MoveTo(gcDay,fCenterAxisX-SizeX(gcDay)/2.0,iTopOffset);

		i=i+1;
	}
	iTopOffset=iTopOffset+SizeY(gcDay)+3.0*g_fScreenScaleFactor;

	// for each day
	i=0;
	pdtData.iCheckBoxStartIndex=pdtData.iDayStartIndex+7;
	while (i<7)
	{
		fCenterAxisX=fWidth/2.0+fWidth*i;

		// put a new caption
		gcCheckBox=NewCheckbox(smLedGreen);
		//SetScale(gcCheckBox,1.28/g_fScreenScaleFactor);
		MountComponent(gcWeek,gcCheckBox);
		MoveTo(gcCheckBox,fCenterAxisX-SizeX(gcCheckBox)/2.0,iTopOffset);

		i=i+1;
	}
	iTopOffset=iTopOffset+SizeY(gcCheckBox)+10.0*g_fScreenScaleFactor;

	// for each day
	i=0;
	pdtData.iButtonStartIndex=pdtData.iCheckBoxStartIndex+7;
	while (i<7)
	{
		fCenterAxisX=fWidth/2.0+fWidth*i;

		// put a new "add program" button
		gcButtonAdd=NewButtonDyn(smPlusButton);
		MountComponent(gcWeek,gcButtonAdd);
		MoveTo(gcButtonAdd,fCenterAxisX-SizeX(gcButtonAdd)/2.0,iTopOffset);

		i=i+1;
	}

	iTopOffset=iTopOffset+SizeY(gcButtonAdd)+3.0*g_fScreenScaleFactor;

	// creates a button that adds the program to all the days of the week
	gcButtonAdd = NewCM2Button(GetLocalizedFromKey(iszAddToAllDays));
	MountComponent(gcWeek,gcButtonAdd);
	MoveTo(gcButtonAdd,(SizeX(gcWeek)-SizeX(gcButtonAdd))/2.0,iTopOffset);
	pdtData.gcAddAllButton=gcButtonAdd;

	iTopOffset=iTopOffset+SizeY(gcButtonAdd);
	StretchTo(gcWeek,SizeX(gcWeek),iTopOffset);

	return(gcWeek);
}

func void WeekContainer_WeekEnable()
{
	var Gui_Component pthis,gcComponent;
	var Gui_dtComponent_TrainingWeekContainer pdtData;
	var i32x i;

	pthis=GetThis();
	pdtData=GetData(pthis);

	i=0;
	while (i<7)
	{
		// display the 'add' button
		gcComponent=GetComponent(pthis,pdtData.iButtonStartIndex+i);
		gcComponent<<Show();
		gcComponent<<Enable();

		// enable the check boxes
		gcComponent=GetComponent(pthis,pdtData.iCheckBoxStartIndex+i);
		gcComponent<<Enable();

		// enable the days
		gcComponent=GetComponent(pthis,pdtData.iDayStartIndex+i);
		gcComponent<<DayEnable();

		i=i+1;
	}

	// display the 'add to all days' button
	pdtData.gcAddAllButton<<Show();
	pdtData.gcAddAllButton<<Enable();
}

func void WeekContainer_WeekDisable()
{
	var Gui_Component pthis,gcComponent;
	var Gui_dtComponent_TrainingWeekContainer pdtData;
	var i32x i;

	pthis=GetThis();
	pdtData=GetData(pthis);

	i=0;
	while (i<7)
	{
		// hide the 'add' button
		gcComponent=GetComponent(pthis,pdtData.iButtonStartIndex+i);
		gcComponent<<Disable();
		gcComponent<<Hide();

		// disable the checkboxes
		gcComponent=GetComponent(pthis,pdtData.iCheckBoxStartIndex+i);
		gcComponent<<Disable();

		// disable the days
		gcComponent=GetComponent(pthis,pdtData.iDayStartIndex+i);
		gcComponent<<DayDisable();

		i=i+1;
	}

	// hide the 'add to all days' button
	pdtData.gcAddAllButton<<Disable();
	pdtData.gcAddAllButton<<Hide();
}

func void WeekContainer_OnCheck(Gui_Component _pComponent)
{
	var Gui_Component pthis,gcDay;
	var Gui_dtComponent_TrainingWeekContainer pdtData;
	var i32x i,iFoundIndex;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// looks for the checked component index
	i=0;
	iFoundIndex=-1;
	while ((i<7) && (iFoundIndex==-1))
	{
		if (_pComponent==GetComponent(pthis,i+pdtData.iCheckBoxStartIndex))
		{
			iFoundIndex=i;
			i=7;
		}
		i=i+1;
	}

	gcDay=GetComponent(pthis,iFoundIndex+pdtData.iDayStartIndex);
	gcDay<<SetDietProgram(true);

	var Gui_Component gcParent;
	gcParent=GetParent(pthis);
	gcParent<<PageDataChanged();
}

func void WeekContainer_OnUncheck(Gui_Component _pComponent)
{
	var Gui_Component pthis,gcDay;
	var Gui_dtComponent_TrainingWeekContainer pdtData;
	var i32x i,iFoundIndex;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// looks for the unchecked component index
	i=0;
	iFoundIndex=-1;
	while ((i<7) && (iFoundIndex==-1))
	{
		if (_pComponent==GetComponent(pthis,i+pdtData.iCheckBoxStartIndex))
		{
			iFoundIndex=i;
			i=7;
		}
		i=i+1;
	}

	gcDay=GetComponent(pthis,iFoundIndex+pdtData.iDayStartIndex);
	gcDay<<SetDietProgram(false);

	var Gui_Component gcParent;
	gcParent=GetParent(pthis);
	// asks the page to display the 'send' button
	gcParent<<PageDataChanged();
}

func void WeekContainer_OnClick(Gui_Component _pComponent)
{
	var Gui_Component pthis,gcButton,gcDay;
	var Gui_dtComponent_TrainingWeekContainer pdtData;
	var i32x i,iFoundIndex=-1;
	var i32x bModified=false;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// looking for the button that has been pressed
	i=0;
	while (i<7)
	{
		gcButton=GetComponent(pthis,i+pdtData.iButtonStartIndex);
		if (gcButton==_pComponent)
		{
			iFoundIndex=i;
			i=7;
		}
		i=i+1;
	}

	bModified=false;
	if (iFoundIndex!=-1)
	{
		// gets the day corresponding to the button and adds the program
		gcDay=GetComponent(pthis,iFoundIndex+pdtData.iDayStartIndex);
		gcDay<<AddProgram(pdtData.iIDProgram);
		bModified=true;
	} else if (_pComponent==pdtData.gcAddAllButton){
		i=0;
		// adds the program to all the days of the week
		while (i<7)
		{
			gcDay=GetComponent(pthis,i+pdtData.iDayStartIndex);
			gcDay<<AddProgram(pdtData.iIDProgram);
			i=i+1;
			bModified=true;
		}
	}

	if (bModified)
	{
		var Gui_Component gcParent;
		gcParent=GetParent(pthis);
		// asks the page to display the 'send' button
		gcParent<<PageDataChanged();
	}
}

func void WeekContainer_SelectProgram(i32x _iIDProgram)
{
	var Gui_Component pthis;
	var Gui_dtComponent_TrainingWeekContainer pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	pdtData.iIDProgram=_iIDProgram;

	pdtData.gcProgramInfo<<SelectProgram(_iIDProgram);
}

func void WeekContainer_ProgramInfo(i32x _iIDProgram)
{
	var Gui_Component pthis;
	var Gui_dtComponent_TrainingWeekContainer pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	pdtData.gcProgramInfo<<SelectProgram(_iIDProgram);
}

func void WeekContainer_DayChanged()
{
	var Gui_Component pthis,gcParent;

	pthis=GetThis();
	gcParent=GetParent(pthis);

	gcParent<<PageDataChanged();
}


func szx ProgramInfo_GetExerciceDescription(i32x _iIDExercice)
{
	var szx szText;

	szText=Database_GetStringData(DATABASE_CLIENT,"DYN_exercice.fkIDtype_exercice.STA_type_exercice.gene_sz_type",ROW_KEY,_iIDExercice);
	//szText=szText+"  "+IntToDuration(Database_GetIntData(DATABASE_CLIENT,"DYN_exercice.gene_i_duration",ROW_KEY,_iIDExercice));
	szText=szText+"  "+itoa(Database_GetIntData(DATABASE_CLIENT,"DYN_exercice.gene_i_duration",ROW_KEY,_iIDExercice))+"s";

	return(szText);
}

func szx ProgramInfo_FindExerciceSequence(i32x _iIDProgram)
{
	var i32x iSubset;
	var i32x iIDExercice;
	var i32x iNextRow,iStartRow;
	var i32x i,iNumRows;
	var i32x iSequenceLength;
	var i32x bSequenceOk;
	var i32x iSequenceRows;
	var szx szText;

	iSubset=Subset_Constructor("EXERCICE_SEQUENCE",DATABASE_CLIENT);

	Database_AddTables(iSubset,2);
	Table_SetName(iSubset, 0, "DYN_program_exercice");
	TableSubset_SelectColumns(iSubset, 0, "*");
	Table_SetName(iSubset, 1, "DYN_exercice");
	TableSubset_SelectColumns(iSubset, 1, "*");
	TableSubset_SelectAllRows(iSubset, 1);

	// gets all the exercices of the program (-> should sort by gene_i_order)
	Query_Create(0,iSubset);
	Query_SelectTable(0,"DYN_program_exercice");
	Query_SelectWhereIntEqual(0,"DYN_program_exercice.fkIDprogram",_iIDProgram);
	Query_Execute(0);


	iNumRows=Table_GetNumRows(iSubset,0);
	if (iNumRows>1)
		iIDExercice=Database_GetIntData(iSubset,"DYN_program_exercice.fkIDexercice",ROW_INDEX,1);
	iStartRow=2;
	iNextRow=-1;
	i=iStartRow;
	// looking for the sequencec length

	while (iNumRows>1 && i<iNumRows && iNextRow==-1)
	{
		if (iIDExercice==Database_GetIntData(iSubset,"DYN_program_exercice.fkIDexercice",ROW_INDEX,i))
		{
			iNextRow=i;
		}
		i=i+1;
	}
	iSequenceLength=1+iNextRow-iStartRow;

	i=1+iSequenceLength;
	if (iNumRows>1 && iNextRow!=-1 && iSequenceLength>1)
		bSequenceOk=true;
	else
		bSequenceOk=false;
	while ((i<iNumRows-1) && bSequenceOk)
	{
		// checking if row at i and row at i-iSequenceLength are the same
		iIDExercice=Database_GetIntData(iSubset,"DYN_program_exercice.fkIDexercice",ROW_INDEX,i);
		if (iIDExercice!=Database_GetIntData(iSubset,"DYN_program_exercice.fkIDexercice",ROW_INDEX,i-iSequenceLength))
		{
			// this is not a sequence: the rows are different
			bSequenceOk=false;
		}
		i=i+1;
	}

	szText="";
	// if a sequence exists
	if (bSequenceOk)
	{
		iSequenceRows=iNumRows-2;

		// checks if there is a pre-exercice...
		iIDExercice=Database_GetIntData(iSubset,"DYN_program_exercice.fkIDexercice",ROW_INDEX,0);
		if (iIDExercice==Database_GetIntData(iSubset,"DYN_program_exercice.fkIDexercice",ROW_INDEX,iSequenceLength))
		{
			iSequenceRows=iSequenceRows+1;
			iStartRow=0;
		}
		else
		{
			iStartRow=1;
		}

		// puts the description of the exercices of the sequence
		i=iStartRow;
		while (i<iStartRow+iSequenceLength)
		{
			szText=szText+ProgramInfo_GetExerciceDescription(Database_GetIntData(iSubset,"DYN_program_exercice.fkIDexercice",ROW_INDEX,i))+"\n";
			i=i+1;
		}

		// check if there is a post-exercice
		iIDExercice=Database_GetIntData(iSubset,"DYN_program_exercice.fkIDexercice",ROW_INDEX,iNumRows-1);
		if (iIDExercice==Database_GetIntData(iSubset,"DYN_program_exercice.fkIDexercice",ROW_INDEX,iNumRows-1-iSequenceLength))
		{
			iSequenceRows=iSequenceRows+1;
		}
		else
		{
			szText=szText+"\n"+ProgramInfo_GetExerciceDescription(Database_GetIntData(iSubset,"DYN_program_exercice.fkIDexercice",ROW_INDEX,iNumRows-1));
		}

		// puts the number of repetitions
		szText=itoa(iSequenceRows/iSequenceLength)+" repetitions:\n"+szText;

		// puts the pre-exercice description
		if (iStartRow==1)
		{
			szText=ProgramInfo_GetExerciceDescription(Database_GetIntData(iSubset,"DYN_program_exercice.fkIDexercice",ROW_INDEX,0))+"\n\n"+szText;
		}
	}
	else
	{
		szText="";
		//szText="no repetitions...";
	}

	szText=GetLocalizedFromKey(Database_GetIntData(DATABASE_CLIENT,"DYN_program.fkIDtype_program.STA_type_program.gene_strID_name",ROW_KEY,_iIDProgram))+"\n\n"+szText;

	Subset_Destructor(iSubset);

	return(szText);
}

func Gui_Component TrainingWeek_CreateProgramInfo(i32x _iWidth,i32x _iHeight)
{
	var Gui_Component gcProgramInfo,gcTitle;
	var Gui_dtComponent_ProgramInfo pdtData;

	gcProgramInfo=NewObject(Gui_iComponent_ProgramInfo);

	pdtData=new Gui_dtComponent_ProgramInfo;
	pdtData.iIDProgram=0;
	SetData(gcProgramInfo,pdtData);

	gcTitle=NewCaption(smBauer,"Description");
	StretchTo(gcTitle,_iWidth,2.0*SizeY(gcTitle));
	SetAlign(gcTitle,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	MountComponent(gcProgramInfo,gcTitle);
	MoveTo(gcTitle,0.0*g_fScreenScaleFactor,0.0*g_fScreenScaleFactor);

	pdtData.gcDescription=NewCaption(smImpact,"-");
	StretchTo(pdtData.gcDescription,_iWidth,_iHeight/2.0-SizeY(gcTitle));
	SetAlign(pdtData.gcDescription,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	SetScale(pdtData.gcDescription,g_fScreenScaleFactor);
	MountComponent(gcProgramInfo,pdtData.gcDescription);
	MoveTo(pdtData.gcDescription,0.0*g_fScreenScaleFactor,SizeY(gcTitle));

	gcTitle=NewCaption(smBauer,"---");
	StretchTo(gcTitle,_iWidth,2.0*SizeY(gcTitle));
	SetAlign(gcTitle,e_GUI_HAlign_Center,e_GUI_VAlign_Center);
	MountComponent(gcProgramInfo,gcTitle);
	MoveTo(gcTitle,0.0*g_fScreenScaleFactor,_iHeight/2.0);

	/*pdtData.gcDescription=NewCaption(smBauer,"-");
	StretchTo(pdtData.gcDescription,_iWidth,_iHeight/2.0-SizeY(gcTitle));
	SetAlign(pdtData.gcDescription,e_GUI_HAlign_Center,e_GUI_VAlign_Top);
	MountComponent(gcProgramInfo,pdtData.gcDescription);
	MoveTo(pdtData.gcDescription,0.0*g_fScreenScaleFactor,_iHeight/2.0+SizeY(gcTitle));*/

	StretchTo(gcProgramInfo,_iWidth,_iHeight);

	return(gcProgramInfo);
}

func void ProgramInfo_DisplayProgram(i32x _iIDProgram)
{
	var Gui_Component pthis;
	var Gui_dtComponent_ProgramInfo pdtData;
	var szx szProgramInfo;

	pthis=GetThis();
	pdtData=GetData(pthis);

	if (pdtData.iIDProgram!=_iIDProgram)
	{
		szProgramInfo=ProgramInfo_FindExerciceSequence(_iIDProgram);
		pdtData.gcDescription<<Caption("(ID="+itoa(_iIDProgram)+")\n"+szProgramInfo);
		
		_iIDProgram=pdtData.iIDProgram;
	}
}
