
func Gui_Component TrainingWeek_NewProgram(i32x _iProgramIndex)
{
	var Gui_Component gcProgram;
	var Gui_dtTrainingProgram pdtData;

	gcProgram=NewObject(Gui_iTrainingProgram);

	pdtData=new Gui_dtTrainingProgram;
	// the default program ID is 0
	pdtData.iIDProgram=0;
	// the program contain information about his place in the parent (to send the remove message)
	pdtData.iProgramIndex=_iProgramIndex;
	SetData(gcProgram,pdtData);

	// the background
	pdtData.gcFlatBackground=NewBitmap(smWhite,0);
	SetShadingMode(GetSprite(pdtData.gcFlatBackground),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	SetBlendingMode(GetSprite(pdtData.gcFlatBackground),DLC_Blend_AlphaBlend);
	SetAlign(pdtData.gcFlatBackground,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	Clip(pdtData.gcFlatBackground);
	MountComponent(gcProgram,pdtData.gcFlatBackground);
	MoveTo(pdtData.gcFlatBackground,0,0);

	pdtData.gcBackground=NewBitmap(smTrainingDayGaugeGrad,0);
	SetShadingMode(GetSprite(pdtData.gcBackground),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	SetAlign(pdtData.gcBackground,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	Clip(pdtData.gcBackground);
	MountComponent(gcProgram,pdtData.gcBackground);
	MoveTo(pdtData.gcBackground,0,0);

	// the separator (a transparent white line)
	pdtData.gcTopSeparator=NewBitmap(smWhite,0);
	SetAlign(pdtData.gcTopSeparator,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	SetShadingMode(GetSprite(pdtData.gcTopSeparator),DLC_GouraudMode_ModulateDiffuse,DLC_GouraudMode_ModulateDiffuse);
	SetBlendingMode(GetSprite(pdtData.gcTopSeparator),DLC_Blend_AlphaBlend);
	SetColor(pdtData.gcTopSeparator,MakeARGB(96,255,255,255));
	MountComponent(gcProgram,pdtData.gcTopSeparator);
	MoveTo(pdtData.gcTopSeparator,0,0);

	// default color
	gcProgram<<ProgramColor(MakeARGB(128,255,255,255));

	Clip(gcProgram);

	return(gcProgram);
}

func Gui_Component TrainingWeek_NewProgramDay()
{
	var Gui_Component gcProgramDay,gcProgram;
	var Gui_Component gcBackground,gcTop,gcBottom;
	var Gui_dtTrainingProgramDay pdtData;
	var i32x i;

	gcProgramDay=NewObject(Gui_iTrainingProgramDay);

	pdtData=new Gui_dtTrainingProgramDay;
	pdtData.iTotalDuration=0;
	pdtData.iMaxDuration=15*3600;
	SetData(gcProgramDay,pdtData);

	// create a background bitmap
	gcBackground=NewBitmap(smTrainingDayGauge,1);
	SetAlign(gcBackground,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(gcProgramDay,gcBackground);

	// create a top bitmap
	gcTop=NewBitmap(smTrainingDayGauge,0);
	SetAlign(gcTop,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(gcProgramDay,gcTop);

	// create a bottom bitmap
	gcBottom=NewBitmap(smTrainingDayGauge,2);
	SetAlign(gcBottom,e_GUI_HAlign_Zoom,e_GUI_VAlign_Zoom);
	MountComponent(gcProgramDay,gcBottom);

	// creates a list of hidden program component
	// (a program component is shown each time a new program is added)
	pdtData.iStartIndex=3;
	pdtData.iProgramsNumber=0;
	pdtData.iMaxProgramsPerDay=30;
	SetComponentNumber(gcProgramDay,pdtData.iMaxProgramsPerDay);
	i=0;
	while (i<pdtData.iMaxProgramsPerDay)
	{
		gcProgram=TrainingWeek_NewProgram(i);
		MountComponent(gcProgramDay,gcProgram);
		gcProgram<<Hide();

		i=i+1;
	}

	Clip(gcProgramDay);

	return(gcProgramDay);
}

func void TrainingProgram_MouseEnter(i32x _iX,i32x _iY)
{
	var Gui_Component pthis,gcParent;
	var Gui_dtTrainingProgram pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	gcParent=GetParent(pthis);
	gcParent=GetParent(gcParent);
	gcParent<<ProgramRollOver(pdtData.iIDProgram);
}

func void TrainingProgram_MouseLeave(i32x _iX,i32x _iY)
{
}

func void TrainingProgram_MouseMove(i32x _iX,i32x _iY)
{
}

func void TrainingProgram_MouseClick(i32x _iX,i32x _iY,i32x _iButton)
{
	var Gui_Component pthis,gcParent;
	var Gui_dtTrainingProgram pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// the programs asks his parent to remove it
	gcParent=GetParent(pthis);
	gcParent<<RemoveProgram(pdtData.iProgramIndex);

	gcParent=GetParent(gcParent);
	gcParent<<ProgramRemoved();
}

func void TrainingProgram_OnDayResize(f32x _fWidth, i32x _fHeight)
{
	var Gui_Component pthis;
	var Gui_dtTrainingProgram pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// resizes the background
	StretchTo(pdtData.gcBackground,_fWidth,1);
	StretchTo(pdtData.gcFlatBackground,(8.0*_fWidth/10.0)+0.5,1);
	MoveTo(pdtData.gcFlatBackground,(_fWidth/10.0)+0.5,0);

	// resizes the separator (the separator is smaller than the day width)
	StretchTo(pdtData.gcTopSeparator,(8.0*_fWidth/10.0)+0.5,1);
	MoveTo(pdtData.gcTopSeparator,(_fWidth/10.0)+0.5,0);
}

func void TrainingProgram_OnMove(f32x _fY)
{
	var Gui_Component pthis;
	var Gui_dtTrainingProgram pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	MoveTo(pthis,0,_fY);
}

func void TrainingProgram_OnResize(f32x _fWidth,f32x _fHeight)
{
	var Gui_Component pthis;
	var Gui_dtTrainingProgram pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// resizes the component ans its background
	StretchTo(pthis,_fWidth,_fHeight);
	StretchTo(pdtData.gcBackground,_fWidth,_fHeight);
	StretchTo(pdtData.gcFlatBackground,(8.0*_fWidth/10.0)+0.5,_fHeight);
	//StretchTo(pdtData.gcTopSeparator,(8.0*_fWidth/10.0)+0.5,1);
}

func void TrainingProgram_SetColor(i32x _iColor)
{
	var Gui_Component pthis;
	var Gui_dtTrainingProgram pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	pdtData.iProgramColor=_iColor;
	SetColor(pdtData.gcBackground,_iColor);
	// sets the alpha to 160
	_iColor=(_iColor&MakeARGB(0,255,255,255))|MakeARGB(160,0,0,0);
	SetColor(pdtData.gcFlatBackground,_iColor);
}

func void TrainingProgramDay_OnEnable()
{
	var Gui_Component pthis,gcProgram;
	var Gui_dtTrainingProgramDay pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	pdtData.bEnable=true;
}

func void TrainingProgramDay_OnDisable()
{
	var Gui_Component pthis,gcProgram;
	var Gui_dtTrainingProgramDay pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	pdtData.bEnable=false;
}

func void TrainingProgramDay_OnResize(f32x _fWidth, f32x _fHeight)
{
	var Gui_Component pthis;
	var Gui_Component pcomponent;
	var Gui_dtTrainingProgramDay pdtData;
	var i32x i;

	pthis=GetThis();
	pdtData=GetData(pthis);

	StretchTo(pthis,_fWidth,_fHeight);

	pcomponent=GetComponent(pthis,0);
	StretchTo(pcomponent,_fWidth,_fHeight);

	// the top and bottom are round so the height must
	// be equal to width/2
	pcomponent=GetComponent(pthis,1);
	StretchTo(pcomponent,_fWidth,_fWidth/2.0);
	MoveTo(pcomponent,0,-SizeY(pcomponent));
	pcomponent=GetComponent(pthis,2);
	StretchTo(pcomponent,_fWidth,_fWidth/2.0);
	MoveTo(pcomponent,0,_fHeight);

	// resizes all the contained programs
	i=0;
	while (i<pdtData.iMaxProgramsPerDay)
	{
		pcomponent=GetComponent(pthis,pdtData.iStartIndex+i);
		pcomponent<<DayResize(_fWidth,_fHeight);

		i=i+1;
	}
}

func i32x TrainingProgramDay_FindProgramDuration(i32x _iIDProgram)
{
	return(Database_GetIntData(DATABASE_CLIENT,"DYN_program.gene_i_total_duration",ROW_KEY,_iIDProgram));
}

func i32x TrainingProgramDay_FindProgramColor(i32x _iIDProgram)
{
	return(Database_GetIntData(DATABASE_CLIENT,"DYN_program.fkIDtype_program.STA_type_program.fkIDcolor.STA_color.gene_i_color",ROW_KEY,_iIDProgram));

/*	var i32x TempColorTab[6];

//	TempColorTab[0]=MakeARGB(192,198,231,248);
//	TempColorTab[1]=MakeARGB(192,59,187,253);
//	TempColorTab[2]=MakeARGB(192,106,142,161);
//	TempColorTab[3]=MakeARGB(192,14,97,140);
//	TempColorTab[4]=MakeARGB(192,32,55,120);
//	TempColorTab[5]=MakeARGB(192,63,71,95);

	TempColorTab[0]=MakeARGB(255,255,0,0);
	TempColorTab[1]=MakeARGB(255,0,255,0);
	TempColorTab[2]=MakeARGB(255,0,0,255);
	TempColorTab[3]=MakeARGB(255,0,255,255);
	TempColorTab[4]=MakeARGB(255,255,0,255);
	TempColorTab[5]=MakeARGB(255,255,255,0);

	return(TempColorTab[_iIDProgram%6]);*/
}

func void TrainingProgramDay_SetDietProgram(i32x _bDietFirst)
{
	var Gui_Component pthis,gcProgram;
	var Gui_dtTrainingProgramDay pdtData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	pdtData.bDietFirst=_bDietFirst;
}

func void TrainingProgramDay_OnAddProgram(i32x _iIDProgram)
{
	var Gui_Component pthis,gcProgram;
	var Gui_dtTrainingProgramDay pdtData;
	var Gui_dtTrainingProgram pdtProgram;
	var i32x y,iDuration;
	var f32x fSizeY;

	pthis=GetThis();
	pdtData=GetData(pthis);

	// gets the duration of the added program
	iDuration=TrainingProgramDay_FindProgramDuration(_iIDProgram);

	// if there's enough place to add it...
	if ((pdtData.iProgramsNumber<pdtData.iMaxProgramsPerDay) && ((pdtData.iTotalDuration+iDuration)<=pdtData.iMaxDuration))
	{
		pdtData.iTotalDuration=pdtData.iTotalDuration+iDuration;

		gcProgram=GetComponent(pthis,pdtData.iStartIndex+pdtData.iProgramsNumber);

		// sets the value of the program
		pdtProgram=GetData(gcProgram);
		pdtProgram.iIDProgram=_iIDProgram;
		pdtProgram.iProgramDuration=iDuration;
		gcProgram<<ProgramColor(TrainingProgramDay_FindProgramColor(_iIDProgram));

		var f32x fNum;
		var f32x fDenom;
		fNum=pdtData.iTotalDuration*SizeY(pthis);
		fDenom=pdtData.iMaxDuration;
		y=SizeY(pthis)-(fNum/fDenom+0.5);
		gcProgram<<ProgramMove(y);

		//fSizeY=fNum/fDenom+0.5;
		if (pdtData.iProgramsNumber>0)
		{
			var Gui_Component gcPreviousProgram;
			gcPreviousProgram=GetComponent(pthis,pdtData.iStartIndex+pdtData.iProgramsNumber-1);
			fSizeY=RelPosY(gcPreviousProgram)-y;
		}
		else
		{
			fSizeY=SizeY(pthis)-y;
		}

		gcProgram<<ProgramResize(SizeX(pthis),fSizeY);

		// show it
		gcProgram<<Show();

		pdtData.iProgramsNumber=pdtData.iProgramsNumber+1;
	}
}

func void TrainingProgramDay_OnRemoveProgram(i32x _iProgramIndex)
{
	var Gui_Component pthis,gcProgram,gcNextProgram;
	var Gui_dtTrainingProgramDay pdtData;
	var Gui_dtTrainingProgram pdtProgramData,pdtNextProgramData;

	pthis=GetThis();
	pdtData=GetData(pthis);

	if ((pdtData.bEnable) && (_iProgramIndex<pdtData.iProgramsNumber))
	{
		var i32x i,iDeltaY,iDuration;

		i=_iProgramIndex;
		iDeltaY=0;

		gcProgram=GetComponent(pthis,pdtData.iStartIndex+_iProgramIndex);
		pdtProgramData=GetData(gcProgram);
		iDuration=pdtProgramData.iProgramDuration;

		pdtData.iTotalDuration=pdtData.iTotalDuration-iDuration;

		// for all the following programs...
		while (i<pdtData.iProgramsNumber-1)
		{
			gcNextProgram=GetComponent(pthis,pdtData.iStartIndex+i+1);
			gcProgram=GetComponent(pthis,pdtData.iStartIndex+i);

			pdtProgramData=GetData(gcProgram);
			pdtNextProgramData=GetData(gcNextProgram);

			// sets the same data
			pdtProgramData.iIDProgram=pdtNextProgramData.iIDProgram;
			gcProgram<<ProgramColor(pdtNextProgramData.iProgramColor);
			pdtProgramData.iProgramDuration=pdtNextProgramData.iProgramDuration;

			iDeltaY=iDeltaY-SizeY(gcNextProgram)+SizeY(gcProgram);

			// move and stretch them as if they were like the previous one
			//Move(gcProgram,0,iDeltaY);
			gcProgram<<ProgramResize(SizeX(gcNextProgram),SizeY(gcNextProgram));
			gcProgram<<ProgramMove(RelPosY(gcProgram)+iDeltaY);

			i=i+1;
		}
		pdtData.iProgramsNumber=pdtData.iProgramsNumber-1;
		gcProgram=GetComponent(pthis,pdtData.iStartIndex+pdtData.iProgramsNumber);
		// hide the last one
		gcProgram<<Hide();
	}
}
